/*
    Génération de feuille de personnage complète AD&D 1 et 2
    Génération aléatoire de personnage

    Copyright (C) 2011 Bernard SIAUD

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "include.h"

void verif_ali(gpointer param);
void compt_vol_fix(signed short * comp, gpointer param);

liste_classe * trouve_liste_classe( gpointer param)
{
    liste_classe * l_c, * sortie=NULL;
    struct_classe * classe;
    unsigned short cl;

    for(cl=0;cl<((unsigned short **)param)[M_NB_CLASSE][0];cl++)
    {
        l_c=(liste_classe *)malloc(sizeof(liste_classe));
        l_c->suiv=NULL;
        classe=((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE]+gtk_combo_box_get_active (GTK_COMBO_BOX (((GtkWidget ***)param)[M_PC_CLASSE][cl]));
        if (classe->add1.nom!=NULL)
            l_c->nom=classe->add1.nom;
        else
            l_c->nom=classe->add2.nom;
        sortie=range_l_cl(sortie, l_c);
    }
    return sortie;
}

void verif_pan(GtkWidget *wid, gpointer param)
{
  aff_pan(((GtkListStore **)param)[M_MOD_DIEU],(((GtkWidget **)param)[M_DIEU]),gtk_combo_box_get_active(GTK_COMBO_BOX(((GtkWidget **)param)[M_PANTHEON])));
  if (wid!=NULL) modif_c(wid,param);
}

void verif_dieu(GtkWidget *wid, gpointer param)
{
  verif_ali(param);
  (void)wid;
}

void modif_c(GtkWidget *wid, gpointer param)
{
   ((unsigned short **)param)[M_MODIF][0]=1;

   (void)wid;
}


void modif_force(GtkWidget *wid, gpointer param)
{
   unsigned short force=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_ENTREE][FORCE]));
   // unsigned short pourcentage=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_ENTREE][POURCENTAGE])); pas pris en compte
   struct_classe * sc;
   unsigned short version_=gtk_combo_box_get_active(GTK_COMBO_BOX(((GtkWidget **)param)[M_VERSION]));
   struct_race * sr= ((struct_race ****)param)[M_MEMO][MENU][MAIN_RACE]+gtk_combo_box_get_active (GTK_COMBO_BOX (((GtkWidget **)param)[M_RACE]));
   unsigned short cl;
   GdkColor color;
    color.pixel = 32;
    color.red = 65535;
    color.green = 65535;
    color.blue = 65535;

   for(cl=0;cl<((unsigned short **)param)[M_NB_CLASSE][0];cl++)
   {
       sc = ((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE]+gtk_combo_box_get_active (GTK_COMBO_BOX (((GtkWidget ***)param)[M_PC_CLASSE][cl]));
       if (version_==ADD1 || sc->add2.nom==NULL)
       {
            if (force<sc->add1.min_f || force>sc->add1.max_f)
            {
                color.green = 10000;
                color.blue = 10000;
            }
       }
       else
       {
            if (force<sc->add2.min_f || force>sc->add2.max_f)
            {
                color.green = 10000;
                color.blue = 10000;
            }
       }
   }

   if (version_==ADD1 || sr->add2.nom==NULL)
   {
       if (gtk_combo_box_get_active(GTK_COMBO_BOX (((GtkWidget **)param)[M_SEXE]))==HOMME)
       {
        if (force<sr->add1.min_f || force>sr->add1.max_f)
        {
            color.green = 10000;
            color.blue = 10000;
        }
       }
       else
       {
        if (force<sr->add1.min_f_f || force>sr->add1.max_f_f)
        {
            color.green = 10000;
            color.blue = 10000;
        }
       }
   }
   else
   {
       if (gtk_combo_box_get_active(GTK_COMBO_BOX (((GtkWidget **)param)[M_SEXE]))==HOMME)
       {
        if (force<sr->add2.min_f || force>sr->add2.max_f)
        {
            color.green = 10000;
            color.blue = 10000;
        }
       }
       else
       {
        if (force<sr->add2.min_f_f || force>sr->add2.max_f_f)
        {
            color.green = 10000;
            color.blue = 10000;
        }
       }
   }

   gtk_widget_modify_bg (GTK_WIDGET(((GtkWidget ***)param)[M_ENTREE][FORCE]),GTK_STATE_NORMAL,&color);

   ((unsigned short **)param)[M_MODIF][0]=1;
   (void)wid;
}

void modif_intelligence(GtkWidget *wid, gpointer param)
{
   unsigned short force=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_ENTREE][INTELLIGENCE]));
   struct_classe * sc;
   unsigned short version_=gtk_combo_box_get_active(GTK_COMBO_BOX(((GtkWidget **)param)[M_VERSION]));
   struct_race * sr= ((struct_race ****)param)[M_MEMO][MENU][MAIN_RACE]+gtk_combo_box_get_active (GTK_COMBO_BOX (((GtkWidget **)param)[M_RACE]));
   unsigned short cl;
   GdkColor color;
    color.pixel = 32;
    color.red = 65535;
    color.green = 65535;
    color.blue = 65535;

   for(cl=0;cl<((unsigned short **)param)[M_NB_CLASSE][0];cl++)
   {
       sc = ((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE]+gtk_combo_box_get_active (GTK_COMBO_BOX (((GtkWidget ***)param)[M_PC_CLASSE][cl]));
       if (version_==ADD1 || sc->add2.nom==NULL)
       {
            if (force<sc->add1.min_i || force>sc->add1.max_i)
            {
                color.green = 10000;
                color.blue = 10000;
            }
       }
       else
       {
            if (force<sc->add2.min_i || force>sc->add2.max_i)
            {
                color.green = 10000;
                color.blue = 10000;
            }
       }
   }

   if (version_==ADD1 || sr->add2.nom==NULL)
   {
       if (gtk_combo_box_get_active(GTK_COMBO_BOX (((GtkWidget **)param)[M_SEXE]))==HOMME)
       {
        if (force<sr->add1.min_i || force>sr->add1.max_i)
        {
            color.green = 10000;
            color.blue = 10000;
        }
       }
       else
       {
        if (force<sr->add1.min_i_f || force>sr->add1.max_i_f)
        {
            color.green = 10000;
            color.blue = 10000;
        }
       }
   }
   else
   {
       if (gtk_combo_box_get_active(GTK_COMBO_BOX (((GtkWidget **)param)[M_SEXE]))==HOMME)
       {
        if (force<sr->add2.min_i || force>sr->add2.max_i)
        {
            color.green = 10000;
            color.blue = 10000;
        }
       }
       else
       {
        if (force<sr->add2.min_i_f || force>sr->add2.max_i_f)
        {
            color.green = 10000;
            color.blue = 10000;
        }
       }
   }

   gtk_widget_modify_bg (GTK_WIDGET(((GtkWidget ***)param)[M_ENTREE][INTELLIGENCE]),GTK_STATE_NORMAL,&color);

   ((unsigned short **)param)[M_MODIF][0]=1;
   verif_compt(wid,param);

   (void)wid;
}

void modif_sagesse(GtkWidget *wid, gpointer param)
{
   unsigned short force=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_ENTREE][SAGESSE]));
   struct_classe * sc;
   unsigned short version_=gtk_combo_box_get_active(GTK_COMBO_BOX(((GtkWidget **)param)[M_VERSION]));
   struct_race * sr= ((struct_race ****)param)[M_MEMO][MENU][MAIN_RACE]+gtk_combo_box_get_active (GTK_COMBO_BOX (((GtkWidget **)param)[M_RACE]));
   unsigned short cl;
   GdkColor color;
    color.pixel = 32;
    color.red = 65535;
    color.green = 65535;
    color.blue = 65535;

   for(cl=0;cl<((unsigned short **)param)[M_NB_CLASSE][0];cl++)
   {
       sc = ((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE]+gtk_combo_box_get_active (GTK_COMBO_BOX (((GtkWidget ***)param)[M_PC_CLASSE][cl]));
       if (version_==ADD1 || sc->add2.nom==NULL)
       {
            if (force<sc->add1.min_s || force>sc->add1.max_s)
            {
                color.green = 10000;
                color.blue = 10000;
            }
       }
       else
       {
            if (force<sc->add2.min_s || force>sc->add2.max_s)
            {
                color.green = 10000;
                color.blue = 10000;
            }
       }
   }

   if (version_==ADD1 || sr->add2.nom==NULL)
   {
       if (gtk_combo_box_get_active(GTK_COMBO_BOX (((GtkWidget **)param)[M_SEXE]))==HOMME)
       {
        if (force<sr->add1.min_s || force>sr->add1.max_s)
        {
            color.green = 10000;
            color.blue = 10000;
        }
       }
       else
       {
        if (force<sr->add1.min_s_f || force>sr->add1.max_s_f)
        {
            color.green = 10000;
            color.blue = 10000;
        }
       }
   }
   else
   {
       if (gtk_combo_box_get_active(GTK_COMBO_BOX (((GtkWidget **)param)[M_SEXE]))==HOMME)
       {
        if (force<sr->add2.min_s || force>sr->add2.max_s)
        {
            color.green = 10000;
            color.blue = 10000;
        }
       }
       else
       {
        if (force<sr->add2.min_s_f || force>sr->add2.max_s_f)
        {
            color.green = 10000;
            color.blue = 10000;
        }
       }
   }

   gtk_widget_modify_bg (GTK_WIDGET(((GtkWidget ***)param)[M_ENTREE][SAGESSE]),GTK_STATE_NORMAL,&color);

   ((unsigned short **)param)[M_MODIF][0]=1;

   (void)wid;
}

void modif_constitution(GtkWidget *wid, gpointer param)
{
   unsigned short force=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_ENTREE][CONSTITUTION]));
   struct_classe * sc;
   unsigned short version_=gtk_combo_box_get_active(GTK_COMBO_BOX(((GtkWidget **)param)[M_VERSION]));
   struct_race * sr= ((struct_race ****)param)[M_MEMO][MENU][MAIN_RACE]+gtk_combo_box_get_active (GTK_COMBO_BOX (((GtkWidget **)param)[M_RACE]));
   unsigned short cl;
   GdkColor color;
    color.pixel = 32;
    color.red = 65535;
    color.green = 65535;
    color.blue = 65535;

   for(cl=0;cl<((unsigned short **)param)[M_NB_CLASSE][0];cl++)
   {
       sc = ((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE]+gtk_combo_box_get_active (GTK_COMBO_BOX (((GtkWidget ***)param)[M_PC_CLASSE][cl]));
       if (version_==ADD1 || sc->add2.nom==NULL)
       {
            if (force<sc->add1.min_co || force>sc->add1.max_co)
            {
                color.green = 10000;
                color.blue = 10000;
            }
       }
       else
       {
            if (force<sc->add2.min_co || force>sc->add2.max_co)
            {
                color.green = 10000;
                color.blue = 10000;
            }
       }
   }

   if (version_==ADD1 || sr->add2.nom==NULL)
   {
       if (gtk_combo_box_get_active(GTK_COMBO_BOX (((GtkWidget **)param)[M_SEXE]))==HOMME)
       {
        if (force<sr->add1.min_co || force>sr->add1.max_co)
        {
            color.green = 10000;
            color.blue = 10000;
        }
       }
       else
       {
        if (force<sr->add1.min_co_f || force>sr->add1.max_co_f)
        {
            color.green = 10000;
            color.blue = 10000;
        }
       }
   }
   else
   {
       if (gtk_combo_box_get_active(GTK_COMBO_BOX (((GtkWidget **)param)[M_SEXE]))==HOMME)
       {
        if (force<sr->add2.min_co || force>sr->add2.max_co)
        {
            color.green = 10000;
            color.blue = 10000;
        }
       }
       else
       {
        if (force<sr->add2.min_co_f || force>sr->add2.max_co_f)
        {
            color.green = 10000;
            color.blue = 10000;
        }
       }
   }

   gtk_widget_modify_bg (GTK_WIDGET(((GtkWidget ***)param)[M_ENTREE][CONSTITUTION]),GTK_STATE_NORMAL,&color);

   ((unsigned short **)param)[M_MODIF][0]=1;
   verif_pdv(wid,param);

   (void)wid;
}
void modif_dexterite(GtkWidget *wid, gpointer param)
{
   unsigned short force=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_ENTREE][DEXTERITE]));
   struct_classe * sc;
   unsigned short version_=gtk_combo_box_get_active(GTK_COMBO_BOX(((GtkWidget **)param)[M_VERSION]));
   struct_race * sr= ((struct_race ****)param)[M_MEMO][MENU][MAIN_RACE]+gtk_combo_box_get_active (GTK_COMBO_BOX (((GtkWidget **)param)[M_RACE]));
   unsigned short cl;
   GdkColor color;
    color.pixel = 32;
    color.red = 65535;
    color.green = 65535;
    color.blue = 65535;

   for(cl=0;cl<((unsigned short **)param)[M_NB_CLASSE][0];cl++)
   {
       sc = ((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE]+gtk_combo_box_get_active (GTK_COMBO_BOX (((GtkWidget ***)param)[M_PC_CLASSE][cl]));
       if (version_==ADD1 || sc->add2.nom==NULL)
       {
            if (force<sc->add1.min_d || force>sc->add1.max_d)
            {
                color.green = 10000;
                color.blue = 10000;
            }
       }
       else
       {
            if (force<sc->add2.min_d || force>sc->add2.max_d)
            {
                color.green = 10000;
                color.blue = 10000;
            }
       }
   }

   if (version_==ADD1 || sr->add2.nom==NULL)
   {
       if (gtk_combo_box_get_active(GTK_COMBO_BOX (((GtkWidget **)param)[M_SEXE]))==HOMME)
       {
        if (force<sr->add1.min_d || force>sr->add1.max_d)
        {
            color.green = 10000;
            color.blue = 10000;
        }
       }
       else
       {
        if (force<sr->add1.min_d_f || force>sr->add1.max_d_f)
        {
            color.green = 10000;
            color.blue = 10000;
        }
       }
   }
   else
   {
       if (gtk_combo_box_get_active(GTK_COMBO_BOX (((GtkWidget **)param)[M_SEXE]))==HOMME)
       {
        if (force<sr->add2.min_d || force>sr->add2.max_d)
        {
            color.green = 10000;
            color.blue = 10000;
        }
       }
       else
       {
        if (force<sr->add2.min_d_f || force>sr->add2.max_d_f)
        {
            color.green = 10000;
            color.blue = 10000;
        }
       }
   }

   gtk_widget_modify_bg (GTK_WIDGET(((GtkWidget ***)param)[M_ENTREE][DEXTERITE]),GTK_STATE_NORMAL,&color);

   ((unsigned short **)param)[M_MODIF][0]=1;
   compt_vol2(wid,param);

   (void)wid;
}
void modif_charisme(GtkWidget *wid, gpointer param)
{
   unsigned short force=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_ENTREE][INTELLIGENCE]));
   struct_classe * sc;
   unsigned short version_=gtk_combo_box_get_active(GTK_COMBO_BOX(((GtkWidget **)param)[M_VERSION]));
   struct_race * sr= ((struct_race ****)param)[M_MEMO][MENU][MAIN_RACE]+gtk_combo_box_get_active (GTK_COMBO_BOX (((GtkWidget **)param)[M_RACE]));
   unsigned short cl;
   GdkColor color;
    color.pixel = 32;
    color.red = 65535;
    color.green = 65535;
    color.blue = 65535;

   for(cl=0;cl<((unsigned short **)param)[M_NB_CLASSE][0];cl++)
   {
       sc = ((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE]+gtk_combo_box_get_active (GTK_COMBO_BOX (((GtkWidget ***)param)[M_PC_CLASSE][cl]));
       if (version_==ADD1 || sc->add2.nom==NULL)
       {
            if (force<sc->add1.min_ch || force>sc->add1.max_ch)
            {
                color.green = 10000;
                color.blue = 10000;
            }
       }
       else
       {
            if (force<sc->add2.min_ch || force>sc->add2.max_ch)
            {
                color.green = 10000;
                color.blue = 10000;
            }
       }
   }

   if (version_==ADD1 || sr->add2.nom==NULL)
   {
       if (gtk_combo_box_get_active(GTK_COMBO_BOX (((GtkWidget **)param)[M_SEXE]))==HOMME)
       {
        if (force<sr->add1.min_ch || force>sr->add1.max_ch)
        {
            color.green = 10000;
            color.blue = 10000;
        }
       }
       else
       {
        if (force<sr->add1.min_ch_f || force>sr->add1.max_ch_f)
        {
            color.green = 10000;
            color.blue = 10000;
        }
       }
   }
   else
   {
       if (gtk_combo_box_get_active(GTK_COMBO_BOX (((GtkWidget **)param)[M_SEXE]))==HOMME)
       {
        if (force<sr->add2.min_ch || force>sr->add2.max_ch)
        {
            color.green = 10000;
            color.blue = 10000;
        }
       }
       else
       {
        if (force<sr->add2.min_ch_f || force>sr->add2.max_ch_f)
        {
            color.green = 10000;
            color.blue = 10000;
        }
       }
   }

   gtk_widget_modify_bg (GTK_WIDGET(((GtkWidget ***)param)[M_ENTREE][CHARISME]),GTK_STATE_NORMAL,&color);

   ((unsigned short **)param)[M_MODIF][0]=1;

   (void)wid;
}

void modif_xp(GtkWidget *wid, gpointer param)
{
    unsigned short cl,niv=0;
    GdkColor color;
    color.pixel = 32;


    for(cl=0;cl<((unsigned short **)param)[M_NB_CLASSE][0];cl++)
    {
        niv=trouve_niveau_xp(((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE]+gtk_combo_box_get_active (GTK_COMBO_BOX (((GtkWidget ***)param)[M_PC_CLASSE][cl])),gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_XP_CLASSE][cl])),gtk_combo_box_get_active(GTK_COMBO_BOX(((GtkWidget **)param)[M_VERSION])));
        if (niv==gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_NV_CLASSE][cl])))
        {
            color.red = 65535;
            color.green = 65535;
            color.blue = 65535;
        }
        else if (niv<gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_NV_CLASSE][cl])))
        {
            color.red = 65535;
            color.green = 0;
            color.blue = 0;
        }
        else
        {
            color.red = 65535;
            color.green = 65535;
            color.blue = 0;
        }
        gtk_widget_modify_bg (GTK_WIDGET(((GtkWidget ***)param)[M_NV_CLASSE][cl]),GTK_STATE_NORMAL,&color);
        //gtk_widget_modify_base (GTK_WIDGET(((GtkWidget ***)param)[M_XP_CLASSE][cl]),GTK_STATE_NORMAL,&color);
    }

    (void) param;
    (void) wid;
}

void modif_classe(GtkWidget *wid, gpointer param)
{
    compt_vol2(wid,param);
    verif_pdv(wid,param);
    verif_compt(wid,param);
    verif_armes(wid,param);
    verif_classe(wid,param);
    modif_xp(wid,param);
    modif_force(wid,param);
    modif_sagesse(wid,param);
    modif_intelligence(wid,param);
    modif_dexterite(wid,param);
    modif_constitution(wid,param);
    modif_charisme(wid,param);
    if (wid!=NULL) modif_c(wid,param);
}

void modif_race(GtkWidget *wid, gpointer param)
{
    compt_vol2(wid,param);
    verif_classe(wid,param);
    modif_force(wid,param);
    modif_sagesse(wid,param);
    modif_intelligence(wid,param);
    modif_dexterite(wid,param);
    modif_constitution(wid,param);
    modif_charisme(wid,param);
    modif_taille(wid,param);
    if (wid!=NULL) modif_c(wid,param);
}

void verif_classe(GtkWidget *wid, gpointer param)
{
  unsigned short race,classe_OK=0;
  GdkColor color;
  color.pixel = 32;
  liste_classe * l_c;
  liste_classe_race * l_c_r, * tmp_lcr;

  if (wid!=NULL) modif_c(wid,param);
  race=gtk_combo_box_get_active(GTK_COMBO_BOX(((GtkWidget **)param)[M_RACE]));

  if (gtk_combo_box_get_active(GTK_COMBO_BOX(((GtkWidget **)param)[M_VERSION]))==ADD1 || ((struct_race ****)param)[M_MEMO][MENU][MAIN_RACE][race].add2.nom==NULL)
        l_c_r=((struct_race ****)param)[M_MEMO][MENU][MAIN_RACE][race].add1.liste_classe;
  else
        l_c_r=((struct_race ****)param)[M_MEMO][MENU][MAIN_RACE][race].add2.liste_classe;
  l_c=trouve_liste_classe(param);



  for (tmp_lcr=l_c_r;tmp_lcr!=NULL;tmp_lcr=tmp_lcr->suiv)
    if (compare_liste_classe(tmp_lcr->classe,l_c)==0)
        classe_OK=1;

  if (classe_OK==1)
  {
    color.red = 60000;
    color.green = 65000;
    color.blue = 65000;
  }
  else
  {
    color.red = 65535;
    color.green = 0;
    color.blue = 0;
  }
  gtk_widget_modify_bg (((GtkWidget **)param)[M_EB_CLASSE], GTK_STATE_NORMAL, &color);
  verif_ali(param);

  (void)wid;
}





void verif_armes(GtkWidget *wid, gpointer param)
{
  unsigned short classe,k,niv,compt_tot=0,compt_max=0,drap=0,compt=0,version_,arme_OK=0,i;
  signed short arme;
  char ch[LONG], ** liste_armes=NULL,**pt;
  GdkColor color,fond;
  color.pixel = 32;
  fond.pixel = 32;
  const gchar *color_ =  "#FF0000";
  unsigned short unefois[MAX_ARMES],nb_armes_liste=0;

  if (wid!=NULL) modif_c(wid,param);
  for (i=0;i<MAX_ARMES;i++) unefois[i]=0;

  version_=gtk_combo_box_get_active(GTK_COMBO_BOX(((GtkWidget **)param)[M_VERSION]));

  if (version_==ADD2)
  {
      for(k=0;k<((unsigned short **)param)[M_NB_CLASSE][0];k++)
      {

          classe = gtk_combo_box_get_active (GTK_COMBO_BOX (((GtkWidget ***)param)[M_PC_CLASSE][k]));
          niv=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_NV_CLASSE][k]));
          if (((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][classe].add2.nom!=NULL)
          {
            compt=((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][classe].add2.nb_arme[0]+(niv-1)/((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][classe].add2.nb_arme[2];
            compt_tot=max(compt_tot,compt);
            compt_max+=compt;
            if (compare_sans_casse("guerrier",((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][classe].add2.nom)!=0) drap=1;
            for(pt=((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][classe].add2.armes;*pt!=NULL;pt++)
            {
                nb_armes_liste++;
                liste_armes=(char**)realloc(liste_armes,nb_armes_liste*sizeof(char**));
                liste_armes[nb_armes_liste-1]=g_strdup(*pt);
            }
          }
          else  /* MÊME SI C'EST OFFICIELLEMENT add2, C'EST PEUT-ÊTRE UNIQUEMENT UNE CLASSE ADD1 */
          {
            compt=((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][classe].add1.nb_arme[0]+(niv-1)/((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][classe].add1.nb_arme[2];
            compt_tot=max(compt_tot,compt);
            compt_max+=compt;
            for(pt=((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][classe].add1.armes;*pt!=NULL;pt++)
            {
                nb_armes_liste++;
                liste_armes=(char**)realloc(liste_armes,nb_armes_liste*sizeof(char**));
                liste_armes[nb_armes_liste-1]=g_strdup(*pt);
            }
          }
      }
  }
  else
  {
      for(k=0;k<((unsigned short **)param)[M_NB_CLASSE][0];k++)
      {   /* parcours des classes */
          classe = gtk_combo_box_get_active (GTK_COMBO_BOX (((GtkWidget ***)param)[M_PC_CLASSE][k]));
          niv=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_NV_CLASSE][k]));
          if (((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][classe].add1.nom!=NULL)
          {
            compt=((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][classe].add1.nb_arme[0]+(niv-1)/((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][classe].add1.nb_arme[2];
            compt_tot=max(compt_tot,compt);
            compt_max+=compt;
            if (compare_sans_casse("guerrier",((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][classe].add2.nom)!=0) drap=1; /* seul les guerriers purs peuvent se spécialiser */
            for(pt=((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][classe].add1.armes;*pt!=NULL;pt++)
            {
                nb_armes_liste++;
                liste_armes=(char**)realloc(liste_armes,nb_armes_liste*sizeof(char**));
                liste_armes[nb_armes_liste-1]=g_strdup(*pt);
            }
          }
          else  /* MÊME SI C'EST OFFICIELLEMENT add1, C'EST PEUT-ÊTRE UNIQUEMENT UNE CLASSE ADD2 */
          {
            compt=((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][classe].add2.nb_arme[0]+(niv-1)/((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][classe].add2.nb_arme[2];
            compt_tot=max(compt_tot,compt);
            compt_max+=compt;
            for(pt=((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][classe].add2.armes;*pt!=NULL;pt++)
            {
                nb_armes_liste++;
                liste_armes=(char**)realloc(liste_armes,nb_armes_liste*sizeof(char**));
                liste_armes[nb_armes_liste-1]=g_strdup(*pt);
            }
          }
      }
  }
  compt=0;
  for (k=0;k<((unsigned short **)param)[M_NB_ARMES][0];k++)
  {
      arme=gtk_combo_box_get_active (GTK_COMBO_BOX (((GtkWidget ***)param)[M_PC_ARMES][k])); /* vérifier si on a le droit */
      if (arme>=0)
      {
          if (unefois[arme]!=0) /* on ne retient que la première fois non nulle */
            gtk_spin_button_set_value(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_NV_ARMES][k]),unefois[arme]);
          else
          {
              unefois[arme]=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_NV_ARMES][k]));
              compt+=unefois[arme];
          }
          color.red = 0;
          color.green = 0;
          color.blue = 0;
          fond.red=65535;
          fond.green=65535;
          fond.blue=65535;
          if (gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_NV_ARMES][k]))>1)
          {
              if (drap) /* seul les guerriers purs peuvent se spécialiser */
              { /* fond rouge */
                /* texte vert */
                color.red = 0;
                color.green = 65535;
                color.blue = 10000;
                fond.red=65535;
                fond.green=0;
                fond.blue=0;
              }
          }
          gtk_widget_modify_text((((GtkWidget ***)param)[M_NV_ARMES][k]), GTK_STATE_NORMAL, &color);
          gtk_widget_modify_base (GTK_WIDGET(((GtkWidget ***)param)[M_NV_ARMES][k]),GTK_STATE_NORMAL,&fond);
          arme_OK=0;

          /* vérifier la validité de l'arme */

          for(i=0;i<nb_armes_liste;i++)
          {
              if (compare_sans_casse(liste_armes[i],"TOUT")==0)
              {
                  arme_OK=1;
                  i=nb_armes_liste;
              }
              else if (compare_sans_casse(liste_armes[i],armes[arme].nom)==0)
              {
                  arme_OK=1;
                  i=nb_armes_liste;
              }
          }
          if (arme_OK==1)
            color_ = NULL;
          else
            color_ =  "#FF0000";

          g_object_set((((GtkWidget ***)param)[M_CE_ARMES][k]), "cell_background", color_,NULL);
          gtk_widget_hide(((GtkWidget ***)param)[M_PC_ARMES][k]); /* il faut effacer puis                   */
          gtk_widget_show_all(((GtkWidget ***)param)[M_PC_ARMES][k]); /* remettre pour voir la nouvelle couleur */
      }
  }
  if (compt>compt_max && compt_tot!=compt_max)
    sprintf(ch,"Il y a %hu armes en trop.\nEn elever %hu semblerait indispensable.",compt-compt_tot,compt-compt_max);

  else if (compt>compt_tot)
    sprintf(ch,"\nIl y a %hu armes en trop.",compt-compt_tot);
  else if (compt==compt_tot)
    sprintf(ch,"\nLe bon nombre d'armes est attribué");
  else
    sprintf(ch,"\nIl reste %hu armes à répartir",compt_tot-compt);

  gtk_label_set_text(GTK_LABEL(((GtkWidget **)param)[M_LA_ARMES]),ch);

  (void)wid;
}

void verif_compt(GtkWidget *wid, gpointer param)
{
  unsigned short classe,k,i,inte=0,niv,compt_tot=0,compt_max=0,drap=0,compt=0;
  char ch[LONG];

  if (wid!=NULL) modif_c(wid,param);
  inte=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_ENTREE][INTELLIGENCE]));
  if (gtk_combo_box_get_active(GTK_COMBO_BOX(((GtkWidget **)param)[M_VERSION]))==ADD1)
    sscanf(tabl_inte1[inte-1][0],"%hd",&inte);
  else
    sscanf(tabl_inte2[inte-1][0],"%hd",&inte);

  for(k=0;k<((unsigned short **)param)[M_NB_CLASSE][0];k++)
  {   /* parcours des classes */
      classe = gtk_combo_box_get_active (GTK_COMBO_BOX (((GtkWidget ***)param)[M_PC_CLASSE][k]));
      niv=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_NV_CLASSE][k]));
      if (((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][classe].add2.nom!=NULL)
      {
        compt=((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][classe].add2.progression_competances[0]+niv/((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][classe].add2.progression_competances[1];
        compt_max=max(compt_max,compt);
        compt_tot+=compt;
        for (i=0;((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][classe].add2.liste_competances[i]!=NULL;i++)
        {
            if      (compare_sans_casse(((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][classe].add2.liste_competances[i],"Général")==0) drap=drap|COMPT_TOUS;
            else if (compare_sans_casse(((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][classe].add2.liste_competances[i],"Combattant")==0) drap=drap|COMPT_COMB;
            else if (compare_sans_casse(((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][classe].add2.liste_competances[i],"Voleur")==0) drap=drap|COMPT_LARRON;
            else if (compare_sans_casse(((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][classe].add2.liste_competances[i],"Magicien")==0) drap=drap|COMPT_MAGO;
            else if (compare_sans_casse(((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][classe].add2.liste_competances[i],"Clerc")==0) drap=drap|COMPT_CLERC;
        }
      }
  }
  compt_tot+=inte*((unsigned short **)param)[M_NB_CLASSE][0];
  compt_max+=inte;
  compt=0;
  for (k=0;k<((unsigned short **)param)[M_NB_COMP][0];k++)
  {
      /* revoir ce décompte ! */
      classe = gtk_combo_box_get_active (GTK_COMBO_BOX (((GtkWidget ***)param)[M_PC_COMP][k]));
      compt+=competences[classe].unite*gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_NV_COMP][k]));
      if ((competences[classe].classe&drap)==0)
        compt+=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_NV_COMP][k]));
  }
  if (compt>compt_tot && compt_tot!=compt_max)
    sprintf(ch,"Il y a %hu compétences en trop.\nEn elever %hu semblerait indispensable.",compt-compt_max,compt-compt_tot);
  else if (compt>compt_max)
    sprintf(ch,"\nIl y a %hu compétences en trop.\n",compt-compt_max);
  else if (compt==compt_max)
    sprintf(ch,"\nLe bon nombre de compétances est attribué");
  else
    sprintf(ch,"\nIl reste %hu compétences à répartir",compt_max-compt);

  gtk_label_set_text(GTK_LABEL(((GtkWidget **)param)[M_LA_COMP]),ch);

  (void)wid;
}

void verif_pdv(GtkWidget *wid, gpointer param)
{
  unsigned short k,constit=0,constitg,niv,versi,pdv_tot=0,pdv_max=0,pdv_min=0,min_tot=0,bonus,classe;
  char * ch_pdv,c,bc=0;
  unsigned short a,b,nb;
  GdkColor color,fond;
  color.pixel = 32;
  fond.pixel = 32;

  if (wid!=NULL) modif_c(wid,param);
  versi=gtk_combo_box_get_active(GTK_COMBO_BOX(((GtkWidget **)param)[M_VERSION]));

  constitg=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_ENTREE][CONSTITUTION]));
  if (constitg>16)
  {
      sscanf(tabl_constit[constitg-1][0],"+2(%hd)",&constitg); /* si pas de sortie alors 0 */
      constit=2;
  }
  else
  {
      sscanf(tabl_constit[constitg-1][0],"%hd",&constit);
      constitg=constit;
  }

  for(niv=0;niv<((unsigned short **)param)[M_NB_PDV][0];niv++)
  {
      pdv_max=0;
      pdv_tot=0;
      min_tot=0;
      pdv_min=0;
      niv++; /* on compte les niveaux à partir de 1 - attention, après on décrémente*/
      bonus=0;
      for(k=0;k<((unsigned short **)param)[M_NB_CLASSE][0];k++)
      {   /* parcours des classes */
          classe = gtk_combo_box_get_active (GTK_COMBO_BOX (((GtkWidget ***)param)[M_PC_CLASSE][k]));
          ch_pdv=pdv_classe(((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE]+classe,niv,versi);
          bc=0;
          nb=sscanf(ch_pdv,"%hu%c%hu+%c",&a,&c,&b,&bc);
          if (nb>2)
          {
              min_tot+=a;
              pdv_tot+=a*b;
              if (nb==4)
              {
                  if (versi==ADD1)
                  {
                      if (bc=='g')
                      {
                          pdv_max=max(pdv_max,a*b+constitg);
                          pdv_min=pdv_min==0?a:min_(pdv_min,a+constitg);
                          min_tot+=constitg;
                          pdv_tot+=constitg;
                      }
                      else if (bc=='b') /* le barbare double les bonus */
                      {
                          pdv_max=max(pdv_max,a*b+constitg*2);
                          pdv_min=pdv_min==0?a:min_(pdv_min,a+constitg*2);
                          min_tot+=constitg*2;
                          pdv_tot+=constitg*2;
                      }
                      else
                      {
                          pdv_max=max(pdv_max,a*b+constit);
                          pdv_min=pdv_min==0?a:min_(pdv_min,a+constit);
                          min_tot+=constit;
                          pdv_tot+=constit;
                      }
                  }
                  else
                  {
                      if (bc=='g')
                        bonus=2;
                      else
                        bonus=max(bonus,1);
                      pdv_max=max(pdv_max,a*b);
                      pdv_min=pdv_min==0?a:min_(pdv_min,a);
                  }
              }
              else
              {
                  pdv_max=max(pdv_max,a*b);
                  pdv_min=pdv_min==0?a:min_(pdv_min,a);
              }
          }
          else if (nb>0)
          {
              pdv_max=max(pdv_max,a);
              pdv_min=min_(pdv_min,a);
              min_tot+=a;
              pdv_tot+=a;
          }
      }
      niv--; /* retour tableau origine 0 */
      pdv_tot+=(((unsigned short **)param)[M_NB_CLASSE][0]/2); /* pour gérer l'arrondi */
      pdv_tot/=((unsigned short **)param)[M_NB_CLASSE][0];
      min_tot+=(((unsigned short **)param)[M_NB_CLASSE][0]/2);
      min_tot/=((unsigned short **)param)[M_NB_CLASSE][0];
      if (versi==ADD2)
      {
          if (bonus==2)
          {
              pdv_tot+=constitg;
              pdv_min+=constitg;
              pdv_max+=constitg;
              min_tot+=constitg;
          }
          else if (bonus==1)
          {
              pdv_tot+=constit;
              pdv_min+=constit;
              pdv_max+=constit;
              min_tot+=constit;
          }
      }
      if (gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_NV_PDV][niv]))>pdv_max || gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_NV_PDV][niv]))<pdv_min)
      {
        color.red = 50000;
        color.green = 0000;
        color.blue = 0000;
        fond.red=0;
        fond.green=65535;
        fond.blue=0;
      }
      else if (gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_NV_PDV][niv]))>pdv_tot || gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_NV_PDV][niv]))<min_tot)
      {
        color.red = 0000;
        color.green = 50000;
        color.blue = 50000;
        fond.red=0;
        fond.green=0;
        fond.blue=65535;
      }
      else
      {
        color.red = 65535;
        color.green = 65535;
        color.blue = 65535;
        fond.red=0;
        fond.green=0;
        fond.blue=0;
      }
      gtk_widget_modify_text(((GtkWidget ***)param)[M_NV_PDV][niv], GTK_STATE_NORMAL, &fond);
      gtk_widget_modify_base (GTK_WIDGET(((GtkWidget ***)param)[M_NV_PDV][niv]),GTK_STATE_NORMAL,&color);
      gtk_widget_modify_bg (GTK_WIDGET(((GtkWidget ***)param)[M_NV_PDV][niv]),GTK_STATE_NORMAL,&color);
  }

  (void)wid;
}

void compt_vol_fix(signed short * comp, gpointer param)
{
  signed short race,classe,k,niv,dext,versi=gtk_combo_box_get_active(GTK_COMBO_BOX(((GtkWidget **)param)[M_VERSION]));
  race = gtk_combo_box_get_active (GTK_COMBO_BOX (((GtkWidget **)param)[M_RACE]));
  dext=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_ENTREE][DEXTERITE]));

  for(k=0;k<((unsigned short **)param)[M_NB_CLASSE][0];k++)
  {
      classe = gtk_combo_box_get_active (GTK_COMBO_BOX (((GtkWidget ***)param)[M_PC_CLASSE][k]));
      niv=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_NV_CLASSE][k]));
      cal_caract_voleur(comp,dext,((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE]+classe,niv,((struct_race ****)param)[M_MEMO][MENU][MAIN_RACE]+race,versi);
  }
}

void compt_vol2(GtkWidget *wid, gpointer param)
{
  signed short var=0,total=0,race,classe,k,i,niv,dext,versi=gtk_combo_box_get_active(GTK_COMBO_BOX(((GtkWidget **)param)[M_VERSION]));
  signed short comp[FEUILLE_LAR_VOL],comp_s_t[FEUILLE_LAR_VOL];
  char ch[LONG]={0};
  char ch2[LONG]={0};
  race = gtk_combo_box_get_active (GTK_COMBO_BOX (((GtkWidget **)param)[M_RACE]));
  dext=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_ENTREE][DEXTERITE]));

  for(i=0;i<FEUILLE_LAR_VOL;i++)
  {
      comp[i]=0;
      comp_s_t[i]=0;
  }

  compt_vol_fix(comp,param);
  if (versi==ADD2)
  for(k=0;k<((unsigned short **)param)[M_NB_CLASSE][0];k++)
  {
      classe = gtk_combo_box_get_active (GTK_COMBO_BOX (((GtkWidget ***)param)[M_PC_CLASSE][k]));
      niv=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_NV_CLASSE][k]));
      if (((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][classe].add2.nom!=NULL)
      {
            if (((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][classe].add2.voleur!=NULL && strcmp("OK",((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][classe].add2.voleur)==0)
            {
            }
            else
            {
                if (((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][classe].add2.voleur!=NULL)
                {
                    for(i=0;i<FEUILLE_LAR_VOL;i++)
                    {
                        comp_s_t[i]=max(comp_s_t[i],((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][classe].add2.tab_voleur[0][i]);
                        if (comp_s_t[i]>0) var=1;
                    }
                    total=max(total,((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][classe].add2.tab_voleur[1][0]+(niv-1)*((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][classe].add2.tab_voleur[1][1]);
                }
            }
      }
  }

  /* gestion de la race */
   if (versi==ADD2)
   {
       if (((struct_race ****)param)[M_MEMO][MENU][MAIN_RACE][race].add2.nom!=NULL)
           for(i=0;i<FEUILLE_LAR_VOL;i++)
           {
                if (comp_s_t[i]>0)
                {
                    comp_s_t[i]+=((struct_race ****)param)[M_MEMO][MENU][MAIN_RACE][race].add2.tab_voleur[0][i];
                }
           }
   }

  dext=min_(dext,19);
  dext=(max(dext,9))-9;

   /* gestion de la dextérité */
   for (i=0;i<8;i++)
   {
        if (comp_s_t[i]>0)
        {
            comp_s_t[i]+=fac_vol_caract[dext][i];
        }
   }

  for (i=0;i<8;i++)
  {
    niv=gtk_spin_button_get_value(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_CA_VOL][i]));
    total+=comp_s_t[i]-niv;
    if (var==0 || comp[i]!=0) comp[i]-=niv;
    if (comp[i]!=0)
    {
        if (ch[0]==0)
            sprintf(ch,"Compétences fixes : ");
        if (comp[i]<0)
            sprintf(ch,"%s %hd en trop pour \"%s\";",ch,-comp[i],nom_fac_voleur[i]);
        else
            sprintf(ch,"%s %hd manque pour \"%s\";",ch,comp[i],nom_fac_voleur[i]);
    }
    if (comp_s_t[i]>niv)
    {
        if (ch2[0]==0)
            sprintf(ch2,"Compétences variables : ");
        sprintf(ch2,"%s %hd manque pour \"%s\";",ch2,comp_s_t[i]-niv,nom_fac_voleur[i]);

    }
  }
  if (var==1 && total!=0)
  {
      if (ch2[0]!=0)
            sprintf(ch2,"%s\n et ",ch2);
      else
            sprintf(ch2,"Compétences variables : ");
      if (total<0)
            sprintf(ch2,"%s %hd points sont attribués en trop",ch2,-total);
      else
            sprintf(ch2,"%s %hd points sont manquants",ch2,total);
  }

  if (*ch2!=0 && *ch!=0 ) sprintf(ch,"%s\n%s",ch,ch2);
  else if (*ch2!=0)  sprintf(ch,"%s",ch2);

  gtk_label_set_text(GTK_LABEL(((GtkWidget **)param)[M_LA_VOL]),ch);
  (void)wid;
}

void initialise_vol(GtkWidget *wid, gpointer param)
{
  unsigned short i;
  signed short comp[FEUILLE_LAR_VOL];

  if (wid!=NULL) modif_c(wid,param);
  for(i=0;i<8;i++)
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_CA_VOL][i]),0);

  for(i=0;i<FEUILLE_LAR_VOL;i++)
  {
      comp[i]=0;
  }
  compt_vol_fix(comp,param);

  for(i=0;i<8;i++)
  {
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_CA_VOL][i]),comp[i]);
  }
  compt_vol2(wid,param);
}


void cal_caract_voleur(signed short * comp,unsigned short dext,struct_classe * classe, unsigned short niv,struct_race * race,unsigned short versi)
{
  signed short i,j;

  for(j=0;j<8;j++) comp[j]=0; /* initialisation */

  dext=min_(dext,19);
  dext=(max(dext,9))-9;

  if (versi==ADD1)
  {
    if (classe->add1.nom!=NULL)
    {
            for (j=0;j<niv && classe->add1.tab_voleur[j]!=NULL;j++);
            if (j>0) j--;
            if (classe->add1.tab_voleur[j]!=NULL)
                for(i=0;i<FEUILLE_LAR_VOL;i++)
                    comp[i]=max(comp[i],classe->add1.tab_voleur[j][i]);
    }
  }
  else if (versi==ADD2)
  {
    if (classe->add2.nom!=NULL)
    {
        if (classe->add2.voleur!=NULL && strcmp("OK",classe->add2.voleur)==0)
        {
            for (j=0;j<niv && classe->add2.tab_voleur[j]!=NULL;j++);
            if (j>0) j--;
            if (classe->add2.tab_voleur[j]!=NULL)
                for(i=0;i<FEUILLE_LAR_VOL;i++)
                    comp[i]=max(comp[i],classe->add2.tab_voleur[j][i]);
        }
    }
  }
  /* gestion de la race */
   if (versi==ADD2)
   {
       if (race->add2.nom!=NULL)
           for(i=0;i<FEUILLE_LAR_VOL;i++)
           {
                if (comp[i]>0)
                {
                    comp[i]+=race->add2.tab_voleur[0][i];
                }
           }
   }
   else
   {
       if (race->add1.nom!=NULL)
           for(i=0;i<FEUILLE_LAR_VOL;i++)
                if (comp[i]>0)
                    comp[i]+=race->add1.tab_voleur[0][i];
   }

   /* gestion de la dextérité */
   for (i=0;i<8;i++)
   {
        if (comp[i]>0)
        {
            comp[i]+=fac_vol_caract[dext][i];
        }
   }
}


void moins_c_pdv(GtkWidget *wid, gpointer param)
{
  if (((unsigned short **)param)[M_NB_PDV][0]>1)
  {
      ((unsigned short **)param)[M_NB_PDV][0]--;
      gtk_widget_hide(((GtkWidget ***)param)[M_NV_PDV][((unsigned short **)param)[M_NB_PDV][0]]);
  }
  verif_pdv(wid,param);

  (void)wid;
}

void moins(unsigned short offset,gpointer param)
{
  if (((unsigned short **)param)[M_NB_CLASSE+offset][0]>1)
  {
      ((unsigned short **)param)[M_NB_CLASSE+offset][0]--;
      gtk_widget_hide( ((GtkWidget ***)param)[M_HB_CLASSE+offset][((unsigned short **)param)[M_NB_CLASSE+offset][0]]);
  }
}

void moins_c_c(GtkWidget *wid, gpointer param)
{
  moins(12,param);
  verif_compt(wid,param);
  (void)wid;
}

void moins_c_a(GtkWidget *wid, gpointer param)
{
  moins(6,param);
  verif_armes(wid,param);
  (void)wid;
}

void moins_c(GtkWidget *wid, gpointer param)
{
   moins(0,param);
   modif_classe(wid,param);
  (void)wid;
}
void plus_c_pdv(GtkWidget *wid, gpointer param)
{
  if (((unsigned short **)param)[M_NB_PDV][1]<=((unsigned short **)param)[M_NB_PDV][0])
  {
      ((unsigned short **)param)[M_NB_PDV][1]++;
      ((GtkWidget ***)param)[M_NV_PDV]=(GtkWidget **)realloc(((GtkWidget ***)param)[M_NV_PDV],((unsigned short **)param)[M_NB_PDV][1]*sizeof(GtkWidget *));
      ((GtkWidget ***)param)[M_NV_PDV][((unsigned short **)param)[M_NB_PDV][0]]=gtk_spin_button_new_with_range(0, 99, 1);
      gtk_box_pack_start (GTK_BOX (((GtkWidget  **)param)[M_VB_PDV]), ((GtkWidget ***)param)[M_NV_PDV][((unsigned short **)param)[M_NB_PDV][0]], TRUE,TRUE, 0);
      g_signal_connect   (G_OBJECT (((GtkWidget ***)param)[M_NV_PDV][((unsigned short **)param)[M_NB_PDV][0]]), "changed", G_CALLBACK (verif_pdv), (gpointer) param);
  }
  gtk_widget_show_all(((GtkWidget ***)param)[M_NV_PDV][((unsigned short **)param)[M_NB_PDV][0]]);
  ((unsigned short **)param)[M_NB_PDV][0]++;
  verif_pdv(wid,param);

  (void)wid;
}


void plus(unsigned short offset, gpointer param)
{
  GtkCellRenderer * p_cell = NULL;

  if (((unsigned short **)param)[M_NB_CLASSE+offset][1]<=((unsigned short **)param)[M_NB_CLASSE+offset][0])
  {
      ((unsigned short **)param)[M_NB_CLASSE+offset][1]++;
      ((GtkWidget ***)param)[M_NV_CLASSE+offset]=(GtkWidget **)realloc(((GtkWidget ***)param)[M_NV_CLASSE+offset],((unsigned short **)param)[M_NB_CLASSE+offset][1]*sizeof(GtkWidget *));
      ((GtkWidget ***)param)[M_PC_CLASSE+offset]=(GtkWidget **)realloc(((GtkWidget ***)param)[M_PC_CLASSE+offset],((unsigned short **)param)[M_NB_CLASSE+offset][1]*sizeof(GtkWidget *));
      ((GtkWidget ***)param)[M_HB_CLASSE+offset]=(GtkWidget **)realloc(((GtkWidget ***)param)[M_HB_CLASSE+offset],((unsigned short **)param)[M_NB_CLASSE+offset][1]*sizeof(GtkWidget *));
      ((GtkWidget ***)param)[M_NV_CLASSE+offset][((unsigned short **)param)[M_NB_CLASSE+offset][0]]=gtk_spin_button_new_with_range(offset==12?1:0, offset==6?3:99,1); /* premier cas : compétence, second : armes */
      ((GtkWidget ***)param)[M_PC_CLASSE+offset][((unsigned short **)param)[M_NB_CLASSE+offset][0]]=gtk_combo_box_new_with_model (GTK_TREE_MODEL (((GtkListStore **)param)[12+offset]));
      ((GtkWidget ***)param)[M_HB_CLASSE+offset][((unsigned short **)param)[M_NB_CLASSE+offset][0]] = gtk_hbox_new(FALSE, 6); /* FALSE : limite la taille des boutons */
      gtk_box_pack_start (GTK_BOX (((GtkWidget  **)param)[M_VB_CLASSE+offset]), ((GtkWidget ***)param)[M_HB_CLASSE+offset][((unsigned short **)param)[M_NB_CLASSE+offset][0]], TRUE,TRUE, 0);
      gtk_box_pack_start (GTK_BOX (((GtkWidget ***)param)[M_HB_CLASSE+offset][((unsigned short **)param)[M_NB_CLASSE+offset][0]]), ((GtkWidget ***)param)[M_PC_CLASSE+offset][((unsigned short **)param)[M_NB_CLASSE+offset][0]], TRUE,TRUE, 0);
      gtk_box_pack_start (GTK_BOX (((GtkWidget ***)param)[M_HB_CLASSE+offset][((unsigned short **)param)[M_NB_CLASSE+offset][0]]), ((GtkWidget ***)param)[M_NV_CLASSE+offset][((unsigned short **)param)[M_NB_CLASSE+offset][0]], TRUE,TRUE, 0);
      p_cell = gtk_cell_renderer_text_new ();
      gtk_cell_layout_pack_start     (GTK_CELL_LAYOUT (((GtkWidget ***)param)[M_PC_CLASSE+offset][((unsigned short **)param)[M_NB_CLASSE+offset][0]]),p_cell, FALSE);
      gtk_cell_layout_set_attributes (GTK_CELL_LAYOUT (((GtkWidget ***)param)[M_PC_CLASSE+offset][((unsigned short **)param)[M_NB_CLASSE+offset][0]]),p_cell, "text", 0,NULL);
      gtk_combo_box_set_active(GTK_COMBO_BOX (((GtkWidget ***)param)[M_PC_CLASSE+offset][((unsigned short **)param)[M_NB_CLASSE+offset][0]]),10);
      if (offset==0) /* classes */
      {
          g_signal_connect (G_OBJECT (((GtkWidget ***)param)[M_PC_CLASSE][((unsigned short **)param)[M_NB_CLASSE+offset][0]]), "changed", G_CALLBACK (modif_classe), (gpointer) param);
          g_signal_connect (G_OBJECT (((GtkWidget ***)param)[M_NV_CLASSE][((unsigned short **)param)[M_NB_CLASSE+offset][0]]), "value_changed", G_CALLBACK (modif_classe), (gpointer) param);
      }
      else if (offset==12)
      { /* compétences */
          g_signal_connect (G_OBJECT (((GtkWidget ***)param)[M_PC_COMP][((unsigned short **)param)[M_NB_CLASSE+offset][0]]), "changed", G_CALLBACK (verif_compt), (gpointer) param);
          g_signal_connect (G_OBJECT (((GtkWidget ***)param)[M_NV_COMP][((unsigned short **)param)[M_NB_CLASSE+offset][0]]), "value_changed", G_CALLBACK (verif_compt), (gpointer) param);
      }
      else if (offset==6)
      { /* armes */
          g_signal_connect (G_OBJECT (((GtkWidget ***)param)[M_PC_ARMES][((unsigned short **)param)[M_NB_CLASSE+offset][0]]), "changed", G_CALLBACK (verif_armes), (gpointer) param);
          g_signal_connect (G_OBJECT (((GtkWidget ***)param)[M_NV_ARMES][((unsigned short **)param)[M_NB_CLASSE+offset][0]]), "value_changed", G_CALLBACK (verif_armes), (gpointer) param);
          /* pour la gestion de la couleur du menu afin de mettre en relief les armes indésirables */
          ((GtkCellRenderer ***)param)[M_CE_ARMES]=(GtkCellRenderer **)realloc(((GtkCellRenderer **)param)[M_CE_ARMES],((unsigned short **)param)[M_NB_ARMES][1]*sizeof(GtkCellRenderer *));
          ((GtkCellRenderer ***)param)[M_CE_ARMES][((unsigned short **)param)[M_NB_ARMES][1]-1]=p_cell;
      }
      if (offset!=12)
      {
          ((GtkWidget ***)param)[M_XP_CLASSE+offset]=(GtkWidget **)realloc(((GtkWidget ***)param)[M_XP_CLASSE+offset],((unsigned short **)param)[M_NB_CLASSE+offset][1]*sizeof(GtkWidget *));
          ((GtkWidget ***)param)[M_XP_CLASSE+offset][((unsigned short **)param)[M_NB_CLASSE+offset][0]]=gtk_spin_button_new_with_range(offset==0?0:-5,offset==0?99999999:5,1);
          gtk_box_pack_start (GTK_BOX (((GtkWidget ***)param)[M_HB_CLASSE+offset][((unsigned short **)param)[M_NB_CLASSE+offset][0]]), ((GtkWidget ***)param)[M_XP_CLASSE+offset][((unsigned short **)param)[M_NB_CLASSE+offset][0]], TRUE,TRUE, 0);
          if (offset==0)
            g_signal_connect (G_OBJECT (((GtkWidget ***)param)[M_XP_CLASSE+offset][((unsigned short **)param)[M_NB_CLASSE+offset][0]]), "value_changed", G_CALLBACK (modif_classe),(gpointer)param);
          else
            gtk_spin_button_set_value(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_XP_CLASSE+offset][((unsigned short **)param)[M_NB_CLASSE+offset][0]]),0);
      }

  }
  gtk_widget_show_all( ((GtkWidget ***)param)[M_HB_CLASSE+offset][((unsigned short **)param)[M_NB_CLASSE+offset][0]]);
  ((unsigned short **)param)[M_NB_CLASSE+offset][0]++;
}

void plus_c_c(GtkWidget *wid, gpointer param)
{
  plus(12,param);
  verif_compt(wid,param);
  (void)wid;
}

void plus_c(GtkWidget *wid, gpointer param)
{
  unsigned short i=((unsigned short **)param)[M_NB_CLASSE][0];

  if (((unsigned short **)param)[M_NB_CLASSE][1]>i) i=0; /* vérification si la case existe déjà */

  plus(0,param);

  modif_classe(wid,param);

  (void)wid;
}

void plus_c_a(GtkWidget *wid, gpointer param)
{
  plus(6,param);
  verif_armes(wid,param);
  (void)wid;
}

void valide_c(GtkWidget *wid, gpointer param)
{
  unsigned short * caract=((unsigned short **)param)[M_CARACT];
  GtkWidget ** entree=((GtkWidget ***)param)[M_ENTREE];
  unsigned short i,j,k,l,m,nb_tot_cl=((unsigned short ****)param)[M_MEMO][MENU][MAIN_NB_CLASSE][0];
  unsigned char * classe,arme[MAX_ARMES],competence[MAX_COMPETENCE];
  char ch[LONG];

  GMarkupDomNode * node1=g_markup_dom_new(chemin_dieux(ch),NULL);
  GMarkupDomNode * node=g_markup_dom_node(node1,"document");
  GtkTextIter debut, fin;
  GtkTextBuffer * texte;
  liste_classe * l_c;

  ((signed short ***)param)[M_MEMO][MODIF][0]=1;
  classe=(unsigned char *)malloc(nb_tot_cl*sizeof(char));
  for (i=0;i<MAX_ARMES;i++) arme[i]=0;
  for (i=0;i<nb_tot_cl;i++) classe[i]=0;
  for (i=0;i<MAX_COMPETENCE;i++) competence[i]=0;
  for(i=0;i<9;i++)
  {
      caract[i]=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(entree[i]));
  }

  i = gtk_combo_box_get_active (GTK_COMBO_BOX (((GtkWidget **)param)[M_VERSION]));
  ((unsigned short ***)param)[M_MEMO][VERSION][0]=i;

  i = gtk_combo_box_get_active (GTK_COMBO_BOX (((GtkWidget **)param)[M_RACE]));
  ((unsigned short ***)param)[M_MEMO][RACE][0]=i;

  i = gtk_combo_box_get_active (GTK_COMBO_BOX (((GtkWidget **)param)[M_SEXE]));
  ((unsigned short ***)param)[M_MEMO][SEXE][0]=i;

  free_metier(((liste_classe ***)param)[M_MEMO][METIER]);
  ((liste_classe ***)param)[M_MEMO][METIER]=NULL;

  for(k=0;k<((unsigned short **)param)[M_NB_CLASSE][0];k++)
  {
      i = gtk_combo_box_get_active (GTK_COMBO_BOX (((GtkWidget ***)param)[M_PC_CLASSE][k]));
      {
          if (classe[i]==0) /* pas deux fois la même classe */
          {
              l_c=(liste_classe *)malloc(sizeof(liste_classe));
              l_c->niveau=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_NV_CLASSE][k]));
              l_c->xp=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_XP_CLASSE][k]));
              l_c->suiv=NULL;
              if (((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][i].add1.nom!=NULL)
                l_c->nom=g_strdup(((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][i].add1.nom);
              else
                l_c->nom=g_strdup(((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][i].add2.nom);
              ((liste_classe ***)param)[M_MEMO][METIER]=range_l_cl(((liste_classe ***)param)[M_MEMO][METIER],l_c);
          }
      }
  }

  j=0;
  ((unsigned short ***)param)[M_MEMO][NB_ARMES][0]=0;
  for(k=0;k<((unsigned short **)param)[M_NB_ARMES][0];k++)
  {
      if ((i = gtk_combo_box_get_active (GTK_COMBO_BOX (((GtkWidget ***)param)[M_PC_ARMES][k]))))
      {
          if (arme[i]==0)
          {
              arme[i]=1;
              j++;
              //if (((unsigned short ***)param)[M_MEMO][NB_ARMES][0]<j)
              {
                  ((unsigned short ***)param)[M_MEMO][NV_ARMES]=(unsigned short *)realloc(((unsigned short ***)param)[M_MEMO][NV_ARMES],j*sizeof(unsigned short));
                  ((unsigned short ***)param)[M_MEMO][ARMES]=(unsigned short *)realloc(((unsigned short ***)param)[M_MEMO][ARMES],j*sizeof(unsigned short));
                  ((unsigned short ***)param)[M_MEMO][MAG_ARMES]=(unsigned short *)realloc(((unsigned short ***)param)[M_MEMO][MAG_ARMES],j*sizeof(unsigned short));
                  ((unsigned short ***)param)[M_MEMO][NB_ARMES][0]++;
              }
              ((unsigned short ***)param)[M_MEMO][NV_ARMES][j-1]=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_NV_ARMES][k]));
              ((unsigned short ***)param)[M_MEMO][MAG_ARMES][j-1]=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_MAG_ARMES][k]));
              ((unsigned short ***)param)[M_MEMO][ARMES][j-1]=i;
          }
      }
  }
  j=0;
  ((unsigned short ***)param)[M_MEMO][NB_COMP][0]=0;
  for(k=0;k<((unsigned short **)param)[M_NB_COMP][0];k++)
  {

          if ((i = gtk_combo_box_get_active (GTK_COMBO_BOX (((GtkWidget ***)param)[M_PC_COMP][k]))))
          {
              if (competence[i]==0) /* pas deux fois la même compétance */
              {
                  competence[i]=1;
                  j++;
                  if (((unsigned short ***)param)[M_MEMO][NB_COMP][0]<j)
                  {
                      ((unsigned short ***)param)[M_MEMO][NV_COMP]=(unsigned short *)realloc(((unsigned short ***)param)[M_MEMO][NV_COMP],j*sizeof(unsigned short));
                      ((unsigned short ***)param)[M_MEMO][COMP]=(unsigned short *)realloc(((unsigned short ***)param)[M_MEMO][COMP],j*sizeof(unsigned short));
                      ((unsigned short ***)param)[M_MEMO][NB_COMP][0]++;
                  }
                  ((unsigned short ***)param)[M_MEMO][NV_COMP][j-1]=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_NV_COMP][k]));
                  ((unsigned short ***)param)[M_MEMO][COMP][j-1]=i;
              }
          }
  }

  ((unsigned short ***)param)[M_MEMO][NB_PDV][0]=((unsigned short **)param)[M_NB_PDV][0];
  ((unsigned short ***)param)[M_MEMO][PDV]=(unsigned short *)realloc(((unsigned short ***)param)[M_MEMO][PDV],((unsigned short ***)param)[M_MEMO][NB_PDV][0]*sizeof(unsigned short));
  for(k=0;k<((unsigned short **)param)[M_NB_PDV][0];k++)
  {
                  ((unsigned short ***)param)[M_MEMO][PDV][k]=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_NV_PDV][k]));
  }
  for (k=0;k<8;k++)
   ((unsigned short ***)param)[M_MEMO][C_VOLEUR][k]=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_CA_VOL][k]));

  if (((char ****)param)[M_MEMO][PANTHEON][0]) free(((char ****)param)[M_MEMO][PANTHEON][0]);
  ((char ****)param)[M_MEMO][PANTHEON][0]=NULL;
  if (((char ****)param)[M_MEMO][DIEU][0]) free(((char ****)param)[M_MEMO][DIEU][0]);
  ((char ****)param)[M_MEMO][DIEU    ][0]=NULL;
  k=gtk_combo_box_get_active(GTK_COMBO_BOX(((GtkWidget **)param)[M_PANTHEON]));
  if (k<node->fils)
  {
      ((char ****)param)[M_MEMO][PANTHEON][0]=g_strdup(node->child[k].content->texte);
      i=gtk_combo_box_get_active(GTK_COMBO_BOX(((GtkWidget **)param)[M_DIEU    ]))-1;
      if (i<node->child[k].fils)
        ((char ****)param)[M_MEMO][DIEU    ][0]=g_strdup(node->child[k].child[i].content->texte);
  }
  for (l=0;l<9;l++)
        if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(((GtkWidget ***)param)[M_ALIGNEMENT][l])))
            ((unsigned short ***)param)[M_MEMO][ALIGNEMENT][0]=l;


  texte=gtk_text_view_get_buffer(GTK_TEXT_VIEW(((GtkWidget **)param)[M_TEXTE]));
  gtk_text_buffer_get_start_iter(texte,&debut);
  gtk_text_buffer_get_end_iter(texte,&fin);
  if (((unsigned short ***)param)[M_MEMO][TEXTE_COM]) free(((unsigned short ***)param)[M_MEMO][TEXTE_COM]);
  ((char ***)param)[M_MEMO][TEXTE_COM]=gtk_text_buffer_get_text(texte,&debut,&fin,TRUE);

  for(i=0;i<9;i++)
  {
       if (((char *****)param)[M_MEMO][SORT_MAG][i])
       {
           free(((char *****)param)[M_MEMO][SORT_MAG][i]);
           free(((char ****)param)[M_MEMO][SORT_MAG_MAIT][i]);
       }
       for (k=0,j=0;j<((unsigned short **)param)[M_NB_SORT_MAG][i];j++)
       {
            if (!(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(((GtkWidget *****)param)[M_SORT_MAG][i][j][0])))) k++;
       }
       ((unsigned short ***)param)[M_MEMO][NB_SORT_MAG_NIV][i]=k;
       if (k>0)
       {
           ((char ****)param)[M_MEMO][SORT_MAG_MAIT][i]=(char *)malloc(k*sizeof(char));
           ((char *****)param)[M_MEMO][SORT_MAG][i]=(char **)malloc(k*sizeof(char *));
           for (k=0,j=0,m=0;j<NB_SORT_MAG;j++)
           { /* m : numéro du bouton, j numéro du sort dans le tableau des sorts , k nombre de sort pris dans ce niveau */
                if (sortileges_mag[j].niveau==(i+1))
                {
                    if (!gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(((GtkWidget *****)param)[M_SORT_MAG][i][m][0])))
                    {
                        ((char *****)param)[M_MEMO][SORT_MAG][i][k]=g_strdup(sortileges_mag[j].nom);
                        for (l=1;l<4;l++)
                            if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(((GtkWidget *****)param)[M_SORT_MAG][i][m][l])))
                                ((char ****)param)[M_MEMO][SORT_MAG_MAIT][i][k]=l;
                        k++;
                    }
                    m++;
                }
           }
       }
       else
       {
           ((char ****)param)[M_MEMO][SORT_MAG_MAIT][i]=NULL;
           ((char *****)param)[M_MEMO][SORT_MAG][i]=NULL;
       }
  }

  ((unsigned short ***)param)[M_MEMO][TAILLE][0]=gtk_spin_button_get_value(GTK_SPIN_BUTTON(((GtkWidget **)param)[M_C_TAILLE]));
  ((unsigned short ***)param)[M_MEMO][POIDS][0]=gtk_spin_button_get_value(GTK_SPIN_BUTTON(((GtkWidget **)param)[M_C_POIDS]));

  if (((char ***)param)[M_MEMO][PERSO]) free(((char ***)param)[M_MEMO][PERSO]);
    ((char ***)param)[M_MEMO][PERSO]=g_strdup(gtk_entry_get_text(((GtkEntry **)param)[M_NOM_PERSO]));
  if (((char ***)param)[M_MEMO][JOUEUR]) free(((char ***)param)[M_MEMO][JOUEUR]);
    ((char ***)param)[M_MEMO][JOUEUR]=g_strdup(gtk_entry_get_text(((GtkEntry **)param)[M_NOM_JOUEUR]));
  if (((char ***)param)[M_MEMO][CLASSE_SOCIALE]) free(((char ***)param)[M_MEMO][CLASSE_SOCIALE]);
    ((char ***)param)[M_MEMO][CLASSE_SOCIALE]=g_strdup(gtk_entry_get_text(((GtkEntry **)param)[M_CLASS_SOCIAL]));
  if (((char ***)param)[M_MEMO][COULEUR_YEUX]) free(((char ***)param)[M_MEMO][COULEUR_YEUX]);
    ((char ***)param)[M_MEMO][COULEUR_YEUX]=g_strdup(gtk_entry_get_text(((GtkEntry **)param)[M_COUL_YEUX]));
  if (((char ***)param)[M_MEMO][COULEUR_PEAU]) free(((char ***)param)[M_MEMO][COULEUR_PEAU]);
    ((char ***)param)[M_MEMO][COULEUR_PEAU]=g_strdup(gtk_entry_get_text(((GtkEntry **)param)[M_COUL_PEAU]));
  if (((char ***)param)[M_MEMO][COULEUR_CHEVEUX]) free(((char ***)param)[M_MEMO][COULEUR_CHEVEUX]);
    ((char ***)param)[M_MEMO][COULEUR_CHEVEUX]=g_strdup(gtk_entry_get_text(((GtkEntry **)param)[M_COUL_CHEVEUX]));
  if (((char ***)param)[M_MEMO][AGE]) free(((char ***)param)[M_MEMO][AGE]);
    ((char ***)param)[M_MEMO][AGE]=g_strdup(gtk_entry_get_text(((GtkEntry **)param)[M_AGE]));

  if (((char ***)param)[M_MEMO][ARMURE1]) free(((char ***)param)[M_MEMO][ARMURE1]);
    ((char ***)param)[M_MEMO][ARMURE1]=g_strdup(armures[gtk_combo_box_get_active(GTK_COMBO_BOX(((GtkWidget **)param)[M_ARMURE1]))].nom);
  if (((char ***)param)[M_MEMO][ARMURE2]) free(((char ***)param)[M_MEMO][ARMURE2]);
    ((char ***)param)[M_MEMO][ARMURE2]=g_strdup(armures[gtk_combo_box_get_active(GTK_COMBO_BOX(((GtkWidget **)param)[M_ARMURE2]))].nom);
  ((signed short ***)param)[M_MEMO][MAG_ARMURE1][0]=gtk_spin_button_get_value(GTK_SPIN_BUTTON(((GtkWidget **)param)[M_MAG_ARMURE1]));
  ((signed short ***)param)[M_MEMO][MAG_ARMURE2][0]=gtk_spin_button_get_value(GTK_SPIN_BUTTON(((GtkWidget **)param)[M_MAG_ARMURE2]));
  ((signed short ***)param)[M_MEMO][BOUCLIER][0]=gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(((GtkWidget **)param)[M_BOUCLIER]));
  ((signed short ***)param)[M_MEMO][MAG_BOUCLIER][0]=gtk_spin_button_get_value(GTK_SPIN_BUTTON(((GtkWidget **)param)[M_MAG_BOUCLIER]));
  ((signed short ***)param)[M_MEMO][BONUS_CA][0]=gtk_spin_button_get_value(GTK_SPIN_BUTTON(((GtkWidget **)param)[M_BONUS_CA]));

  ((unsigned short **)param)[M_MODIF][0]=0; /* marqueur pour la sauvegarde */

  caract_label(((gpointer *)param)[M_MEMO]);
  initialise_classes(param);
  initialise_armes(param);
  initialise_comp(param);
  init_taille(param);
  g_markup_dom_free(node1);

  (void)wid;
}

void initialise_classes(gpointer param)
{
  unsigned char i,j;
  liste_classe * l_c;
  unsigned char nb_classe=0;

  for (j=0,l_c=((liste_classe ***)param)[M_MEMO][METIER];l_c!=NULL;l_c=l_c->suiv,j++)
  {
      nb_classe++;
      for(i=0;i<((unsigned short ****)param)[M_MEMO][MENU][MAIN_NB_CLASSE][0];i++)
      {
          if (((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][i].add1.nom!=NULL)
          {
              if (compare_sans_casse(l_c->nom,((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][i].add1.nom)==0)
              {
                gtk_combo_box_set_active (GTK_COMBO_BOX (((GtkWidget ***)param)[M_PC_CLASSE][j]),i);
                i= ((unsigned short ****)param)[M_MEMO][MENU][MAIN_NB_CLASSE][0];
              }
          }
          else
          {
              if (compare_sans_casse(l_c->nom,((struct_classe ****)param)[M_MEMO][MENU][MAIN_CLASSE][i].add2.nom)==0)
              {
                gtk_combo_box_set_active (GTK_COMBO_BOX (((GtkWidget ***)param)[M_PC_CLASSE][j]),i);
                i= ((unsigned short ****)param)[M_MEMO][MENU][MAIN_NB_CLASSE][0];
              }
          }
      }
      gtk_spin_button_set_value(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_NV_CLASSE][j]),l_c->niveau);
  }


  for(i=0;i<((unsigned short **)param)[M_NB_CLASSE][1];i++) /* parcours sur les cases aui ont été initialisées */
  {
      if (i<nb_classe && i<((unsigned short **)param)[M_NB_CLASSE][0])
      { /* deux plus petits : rien à faire : laisser afficher */
      }
      else if (i>=nb_classe && i>=((unsigned short **)param)[M_NB_CLASSE][0])
      { /* deux plus grands : rien à faire : laisser effacer */
      }
      else if (i<nb_classe && i>=((unsigned short **)param)[M_NB_CLASSE][0])
      { /* afficher alors qu'il ne l'est pas */
          gtk_container_add(GTK_CONTAINER(((GtkWidget **)param)[M_VB_CLASSE]),((GtkWidget ***)param)[M_HB_CLASSE][i]);
          g_object_unref (((GtkWidget ***)param)[M_HB_CLASSE][i]);
      }
      else
      { /* ne pas afficher alors qu'il est prévu de l'être */
           g_object_ref (((GtkWidget ***)param)[M_HB_CLASSE][i]);
           gtk_container_remove(GTK_CONTAINER(((GtkWidget  **)param)[M_VB_CLASSE]),((GtkWidget ***)param)[M_HB_CLASSE][i]);
      }
  }
  //((unsigned short **)param)[M_NB_CLASSE][0]=((unsigned short ****)param)[M_MEMO][MENU][MAIN_NB_CLASSE][0];
}

void initialise_armes(gpointer param)
{
  unsigned char i;

  for(i=0;i<((unsigned short ***)param)[M_MEMO][NB_ARMES][0];i++)
  {
      gtk_combo_box_set_active (GTK_COMBO_BOX (((GtkWidget ***)param)[M_PC_ARMES][i]), ((unsigned short ***)param)[M_MEMO][ARMES][i]);
      gtk_spin_button_set_value(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_NV_ARMES][i]),((unsigned short ***)param)[M_MEMO][NV_ARMES][i]);
  }


  for(i=0;i<((unsigned short **)param)[M_NB_ARMES][1];i++)
  {
      if (i<((unsigned short ***)param)[M_MEMO][NB_ARMES][0] && i<((unsigned short **)param)[M_NB_ARMES][0])
      { /* deux plus petits : rien à faire : laisser afficher */
      }
      else if (i>=((unsigned short ***)param)[M_MEMO][NB_ARMES][0] && i>=((unsigned short **)param)[M_NB_ARMES][0])
      { /* deux plus grands : rien à faire : laisser effacer */
      }
      else if (i<((unsigned short ***)param)[M_MEMO][NB_ARMES][0] && i>=((unsigned short **)param)[M_NB_ARMES][0])
      { /* afficher alors qu'il ne l'est pas */
          gtk_container_add(GTK_CONTAINER(((GtkWidget **)param)[M_VB_ARMES]),((GtkWidget ***)param)[M_HB_ARMES][i]);
          g_object_unref (((GtkWidget ***)param)[M_HB_ARMES][i]);
      }
      else
      { /* ne pas afficher alors qu'il est prévu de l'être */
           g_object_ref (((GtkWidget ***)param)[M_HB_ARMES][i]);
           gtk_container_remove(GTK_CONTAINER(((GtkWidget  **)param)[M_VB_ARMES]),((GtkWidget ***)param)[M_HB_ARMES][i]);
      }
  }
  ((unsigned short **)param)[M_NB_ARMES][0]=((unsigned short ***)param)[M_MEMO][NB_ARMES][0];
}

void initialise_comp(gpointer param)
{
  unsigned char i;

  for(i=0;i<((unsigned short ***)param)[M_MEMO][NB_COMP][0];i++)
  {
      gtk_combo_box_set_active (GTK_COMBO_BOX (((GtkWidget ***)param)[M_PC_COMP][i]), ((unsigned short ***)param)[M_MEMO][COMP][i]);
      gtk_spin_button_set_value(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_NV_COMP][i]),((unsigned short ***)param)[M_MEMO][NV_COMP][i]);
  }


  for(i=0;i<((unsigned short **)param)[M_NB_COMP][1];i++)
  {
      if (i<((unsigned short ***)param)[M_MEMO][NB_COMP][0] && i<((unsigned short **)param)[M_NB_COMP][0])
      { /* deux plus petits : rien à faire : laisser afficher */
      }
      else if (i>=((unsigned short ***)param)[M_MEMO][NB_COMP][0] && i>=((unsigned short **)param)[M_NB_COMP][0])
      { /* deux plus grands : rien à faire : laisser effacer */
      }
      else if (i<((unsigned short ***)param)[M_MEMO][NB_COMP][0] && i>=((unsigned short **)param)[M_NB_COMP][0])
      { /* afficher alors qu'il ne l'est pas */
          gtk_container_add(GTK_CONTAINER(((GtkWidget **)param)[M_VB_COMP]),((GtkWidget ***)param)[M_HB_COMP][i]);
          g_object_unref (((GtkWidget ***)param)[M_HB_COMP][i]);
      }
      else
      { /* ne pas afficher alors qu'il est prévu de l'être */
           g_object_ref (((GtkWidget ***)param)[M_HB_COMP][i]);
           gtk_container_remove(GTK_CONTAINER(((GtkWidget  **)param)[M_VB_COMP]),((GtkWidget ***)param)[M_HB_COMP][i]);
      }
  }
  ((unsigned short **)param)[M_NB_COMP][0]=((unsigned short ***)param)[M_MEMO][NB_COMP][0];
}

void initialise_pdv(gpointer param)
{
  unsigned char i;

  for(i=0;i<((unsigned short ***)param)[M_MEMO][NB_PDV][0];i++)
  {
      gtk_spin_button_set_value(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_NV_PDV][i]),((unsigned short ***)param)[M_MEMO][PDV][i]);
  }


  for(i=0;i<((unsigned short **)param)[M_NB_PDV][1];i++)
  {
      if (i<((unsigned short ***)param)[M_MEMO][NB_PDV][0] && i<((unsigned short **)param)[M_NB_PDV][0])
      { /* deux plus petits : rien à faire : laisser afficher */
      }
      else if (i>=((unsigned short ***)param)[M_MEMO][NB_PDV][0] && i>=((unsigned short **)param)[M_NB_PDV][0])
      { /* deux plus grands : rien à faire : laisser effacer */
      }
      else if (i<((unsigned short ***)param)[M_MEMO][NB_PDV][0] && i>=((unsigned short **)param)[M_NB_PDV][0])
      { /* afficher alors qu'il ne l'est pas */
          gtk_widget_show_all(((GtkWidget ***)param)[M_NV_PDV][i]);
      }
      else
      { /* ne pas afficher alors qu'il est prévu de l'être */
	   gtk_widget_hide(((GtkWidget ***)param)[M_NV_PDV][i]);
      }
  }
  ((unsigned short **)param)[M_NB_PDV][0]=((unsigned short ***)param)[M_MEMO][NB_PDV][0];
}

void initialise_mag(gpointer param)
{
    unsigned short i,j,niv[9]={0,0,0,0,0,0,0,0},k[9]={0,0,0,0,0,0,0,0};

    init_mag(NULL,param);
    for(i=0;i<NB_SORT_MAG;i++)
    {
        for (j=0;j<((unsigned short ***)param)[M_MEMO][NB_SORT_MAG_NIV][sortileges_mag[i].niveau-1];j++)
        {                               /* param géné  nb_sort_niv        le niveau de ce sort     */
            if (k[sortileges_mag[i].niveau-1]<((unsigned short ***)param)[M_MEMO][NB_SORT_MAG_NIV][sortileges_mag[i].niveau-1] && strcmp(sortileges_mag[i].nom,((char *****)param)[M_MEMO][SORT_MAG][sortileges_mag[i].niveau-1][k[sortileges_mag[i].niveau-1]])==0)
            {                                              /* param géné  nom_du sort niveau du sort           n° du sort de ce niveau         */
                 gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(((GtkWidget *****)param)[M_SORT_MAG][sortileges_mag[i].niveau-1][niv[sortileges_mag[i].niveau-1]][((unsigned char ****)param)[M_MEMO][SORT_MAG_MAIT][sortileges_mag[i].niveau-1][k[sortileges_mag[i].niveau-1]]]),TRUE);
                 k[sortileges_mag[i].niveau-1]++;                                    /* bouton_sort    niveau du sort            n° du sort de ce niveau           Niv de maîtricer du sort */                     /*   niveau du sort            num de sort déjà pris en compte */
            }
        }
        niv[sortileges_mag[i].niveau-1]++; /* nombre de sort de ce niveau de passé */
    }
}

void initialise_c(GtkWidget *wid, gpointer param)
{
  unsigned short * caract=((unsigned short **)param)[M_CARACT];
  GtkWidget ** entree=((GtkWidget ***)param)[M_ENTREE];
  unsigned char i,pan;
  char ch[LONG];

  GMarkupDomNode * node1=g_markup_dom_new(chemin_dieux(ch),NULL);

  GMarkupDomNode * node=g_markup_dom_node(node1,"document");
  if (((char ****)param)[M_MEMO][PANTHEON][0])
  {
      for(pan=1;pan<node->fils && compare(node->child[pan].content->texte,((char ****)param)[M_MEMO][PANTHEON][0])==0;pan++);
      if (pan<node->fils)
      {
          gtk_combo_box_set_active (GTK_COMBO_BOX (((GtkWidget **)param)[M_PANTHEON]),pan);
          if (((char ****)param)[M_MEMO][DIEU][0])
          {
              for(i=0;i<node->child[pan].fils && compare(node->child[pan].child[i].content->texte,((char ****)param)[M_MEMO][DIEU][0])==0;i++);
              if (i<node->child[pan].fils)
              {
               gtk_combo_box_set_active (GTK_COMBO_BOX (((GtkWidget **)param)[M_DIEU]),i+1);
              }
              else
               gtk_combo_box_set_active (GTK_COMBO_BOX (((GtkWidget **)param)[M_DIEU]),0);
          }
      }
      else
       gtk_combo_box_set_active (GTK_COMBO_BOX (((GtkWidget **)param)[M_PANTHEON]),0);
  }

  if (((char ***)param)[M_MEMO][TEXTE_COM]) /* la zone texte */
  {
      gtk_text_buffer_set_text(gtk_text_view_get_buffer(GTK_TEXT_VIEW(((GtkTextBuffer **)param)[M_TEXTE])),((gchar ***)param)[M_MEMO][TEXTE_COM],-1);
  }

  initialise_mag(param);
  initialise_classes(param);
  initialise_armes(param);
  initialise_comp(param);
  initialise_pdv(param);
  init_taille(param);

  for(i=0;i<9;i++)
  {
      gtk_spin_button_set_value(GTK_SPIN_BUTTON(entree[i]),caract[i]);
  }

  if (((char ***)param)[M_MEMO][PERSO]!=NULL)
     gtk_entry_set_text(GTK_ENTRY(((GtkWidget **)param)[M_NOM_PERSO]),((char ***)param)[M_MEMO][PERSO]);
  if (((char ***)param)[M_MEMO][JOUEUR]!=NULL)
     gtk_entry_set_text(GTK_ENTRY(((GtkWidget **)param)[M_NOM_JOUEUR]),((char ***)param)[M_MEMO][JOUEUR]);
  if (((char ***)param)[M_MEMO][CLASSE_SOCIALE]!=NULL)
     gtk_entry_set_text(GTK_ENTRY(((GtkWidget **)param)[M_CLASS_SOCIAL]),((char ***)param)[M_MEMO][CLASSE_SOCIALE]);
  if (((char ***)param)[M_MEMO][COULEUR_CHEVEUX]!=NULL)
     gtk_entry_set_text(GTK_ENTRY(((GtkWidget **)param)[M_COUL_CHEVEUX]),((char ***)param)[M_MEMO][COULEUR_CHEVEUX]);
  if (((char ***)param)[M_MEMO][COULEUR_PEAU]!=NULL)
     gtk_entry_set_text(GTK_ENTRY(((GtkWidget **)param)[M_COUL_PEAU]),((char ***)param)[M_MEMO][COULEUR_PEAU]);
  if (((char ***)param)[M_MEMO][COULEUR_YEUX]!=NULL)
     gtk_entry_set_text(GTK_ENTRY(((GtkWidget **)param)[M_COUL_YEUX]),((char ***)param)[M_MEMO][COULEUR_YEUX]);
  if (((char ***)param)[M_MEMO][AGE]!=NULL)
     gtk_entry_set_text(GTK_ENTRY(((GtkWidget **)param)[M_AGE]),((char ***)param)[M_MEMO][AGE]);
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(((GtkWidget ***)param)[M_ALIGNEMENT][((unsigned short ***)param)[M_MEMO][ALIGNEMENT][0]]),TRUE);
   gtk_combo_box_set_active (GTK_COMBO_BOX (((GtkWidget **)param)[M_ARMURE1]),18); /* aucune armure */
   gtk_combo_box_set_active (GTK_COMBO_BOX (((GtkWidget **)param)[M_ARMURE2]),18);
   if (((char ***)param)[M_MEMO][ARMURE1]!=NULL)
       for(i=0;i<MAX_ARMURE;i++)
       {
           if (strcmp(((char ***)param)[M_MEMO][ARMURE1],armures[i].nom)==0)
            gtk_combo_box_set_active (GTK_COMBO_BOX (((GtkWidget **)param)[M_ARMURE1]),i);
       }
   if (((char ***)param)[M_MEMO][ARMURE2]!=NULL)
       for(i=0;i<MAX_ARMURE;i++)
       {
           if (strcmp(((char ***)param)[M_MEMO][ARMURE2],armures[i].nom)==0)
            gtk_combo_box_set_active (GTK_COMBO_BOX (((GtkWidget **)param)[M_ARMURE2]),i);
       }
   gtk_spin_button_set_value(GTK_SPIN_BUTTON(((GtkWidget **)param)[M_MAG_ARMURE1]),((signed short ***)param)[M_MEMO][MAG_ARMURE1][0]);
   gtk_spin_button_set_value(GTK_SPIN_BUTTON(((GtkWidget **)param)[M_MAG_ARMURE2]),((signed short ***)param)[M_MEMO][MAG_ARMURE2][0]);
   gtk_spin_button_set_value(GTK_SPIN_BUTTON(((GtkWidget **)param)[M_MAG_BOUCLIER]),((signed short ***)param)[M_MEMO][MAG_BOUCLIER][0]);
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(((GtkWidget **)param)[M_BOUCLIER]),((signed short ***)param)[M_MEMO][BOUCLIER][0]);
   gtk_spin_button_set_value(GTK_SPIN_BUTTON(((GtkWidget **)param)[M_BONUS_CA]),((signed short ***)param)[M_MEMO][BONUS_CA][0]);
  ((signed short **)param)[M_MODIF][0]=0;

  g_markup_dom_free(node1);
  (void)wid;
}

void annule_c(GtkWidget *wid, gpointer param)
{
  gtk_widget_destroy(((GtkWidget **)param)[M_FENETRE]);

  (void)wid;
}

gchar * nb_texte(gchar * ch,unsigned short nb)
{
 if (nb>99)
 {
     ch[0]='0'+nb/100;
     ch[1]='0'+nb/10%10;
     ch[2]='0'+nb%10;
     ch[3]=0;

 }
 else if (nb>9)
 {
     ch[0]='0'+nb/10;
     ch[1]='0'+nb%10;
     ch[2]=0;
 }
 else
 {
     ch[0]='0'+nb;
     ch[1]=0;
 }

 return ch;
}


void caract_label(gpointer param)
{
  unsigned short * caract=((unsigned short **)param)[CARACT];
  gchar affichage[LONG]={0},ch[LONG]={0}, *s;
  unsigned short i,pdv;
  liste_classe * l_c;

        for(l_c=((liste_classe **)param)[METIER];l_c!=NULL;l_c=l_c->suiv)
        {
            sprintf(affichage,"%s niveau %hu\n",l_c->nom,l_c->niveau);
            strncat(ch,affichage,LONG-strlen(ch));
        }

        s=((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add1.nom;
        if (caract[0]==18)
            sprintf(affichage,"%s\nVersion : %s\nSexe : %s\nRace : %s\n\n%s %hu %hu\n",ch,vers[((unsigned short **)param)[VERSION][0]],nom_sexe(((unsigned short **)param)[SEXE][0]),s,nom[0],caract[0],caract[POURCENTAGE]);
        else
            sprintf(affichage,"%s\nVersion : %s\nSexe : %s\nRace : %s\n\n%s : %hu\n",ch,vers[((unsigned short **)param)[VERSION][0]],nom_sexe(((unsigned short **)param)[SEXE][0]),s,nom[0],caract[0]);
        for (i=1;i<8;i++)
        {
          sprintf(ch,"%s : %hu\n",nom[i],caract[i]);
          strncat(affichage,ch,LONG-strlen(affichage));
        }
        gtk_label_set_text(GTK_LABEL(((GtkWidget ***)param)[TEXTE][0]),affichage);

        affichage[0]=0;
        pdv=((unsigned short **)param)[PDV][0];
        sprintf(ch,"PDV\n%d",pdv);
        for (i=1;i<((unsigned short **)param)[NB_PDV][0];i++)
        {
            sprintf(affichage,"+%d",((unsigned short **)param)[PDV][i]);
            strncat(ch,affichage,LONG-strlen(ch));
            pdv+=((unsigned short **)param)[PDV][i];
        }
        sprintf(affichage,"=%d\n\nCOMPÉTENCES DIVERSES\n",pdv);
        strncat(ch,affichage,LONG-strlen(ch));
        for (i=0;i<((unsigned short **)param)[NB_COMP][0];i++)
        {
            sprintf(affichage,"%s : %d\n",competences[((unsigned short **)param)[COMP][i]].nom,((unsigned short **)param)[NV_COMP][i]);
            strncat(ch,affichage,LONG-strlen(ch));
            pdv+=((unsigned short **)param)[PDV][i];
        }
        sprintf(affichage,"\n\nCOMPÉTENCES MARTIALES\n");
        strncat(ch,affichage,LONG-strlen(ch));
        for (i=0;i<((unsigned short **)param)[NB_ARMES][0];i++)
        {
            sprintf(affichage,"%s \t %s\n",armes[((unsigned short **)param)[ARMES][i]].nom,maitrise_arme(((unsigned short **)param)[NV_ARMES][i]));
            strncat(ch,affichage,LONG-strlen(ch));
        }
        sprintf(affichage,"\ntaille : %hu\n poids : %hu",((unsigned short **)param)[TAILLE][0],((unsigned short **)param)[POIDS][0]);
        strncat(ch,affichage,LONG-strlen(ch));

        gtk_label_set_text(GTK_LABEL(((GtkWidget ***)param)[TEXTE][1]),ch);

        sprintf(ch,"Caractéristiques\nde Voleurs\n");
        for (i=0;i<8;i++)
        {
            sprintf(affichage,"\n%s\n%hd",nom_fac_voleur[i],((unsigned short **)param)[C_VOLEUR][i]);
            strncat(ch,affichage,LONG-strlen(ch));
        }
        gtk_label_set_text(GTK_LABEL(((GtkWidget ***)param)[TEXTE][2]),ch);
}

void affiche_caract(GMarkupDomNode *node,gpointer param)
{
  guint i,j,k,nb_metier;
  GMarkupDomNode * tmp,*tmp1;
  unsigned short * caract=((unsigned short **)param)[M_CARACT],n;
  char ch[LONG];
  liste_classe * l_c;

  if (((char **)param)[NOM]!=NULL)
    gtk_window_set_title (GTK_WINDOW (((GtkWidget **)param)[FENETRE]),((char **)param)[NOM]);
  else if (((char **)param)[CHEMIN]!=NULL)
    gtk_window_set_title (GTK_WINDOW (((GtkWidget **)param)[FENETRE]),((char **)param)[CHEMIN]);

    for (i=0;i<9;i++)
    {
        tmp=g_markup_dom_nom (node,nom_min[i],"name");
        sscanf(tmp->content[0].texte,"%hu",caract+i);
    }
    if ((tmp=g_markup_dom_node (node,"race")))
    {
        for (i=0;i<((unsigned short ***)param)[MENU][MAIN_NB_RACE][0] && compare_sans_casse(tmp->content[0].texte,((struct_race ***)param)[MENU][MAIN_RACE][i].add1.nom);i++);
        ((unsigned short **)param)[RACE][0]=i;
    }
    if ((tmp=g_markup_dom_node (node,"version")))
    {
        for (i=0;i<3 && strcmp(tmp->content[0].texte,vers[i]);i++);
        ((unsigned short **)param)[VERSION][0]=i;
    }
    if ((tmp=g_markup_dom_node (node,"alignement")))
    {
        for (i=0;i<9 && strcmp(tmp->content[0].texte,algnm[i]);i++);
        if (i<9) ((unsigned short **)param)[ALIGNEMENT][0]=i;
    }
    if ((tmp=g_markup_dom_node (node,"sexe")))
    {
        if (strcmp(tmp->content[0].texte,"Masculin")==0)
            ((unsigned short **)param)[SEXE][0]=0;
        else
            ((unsigned short **)param)[SEXE][0]=1;
    }
    if ((tmp=g_markup_dom_node (node,"profession")))
    {
        nb_metier=tmp->fils;
        free_metier(((liste_classe **)param)[METIER]);
        l_c=(liste_classe *)malloc(sizeof(liste_classe));
        l_c->suiv=NULL;
        ((liste_classe **)param)[METIER]=l_c;
        i=0;
        do
        {
          l_c->xp=0;
          l_c->niveau=0;
          l_c->nom=g_strdup(tmp->child[i].content[0].texte);
          for (j=0;j<tmp->child[i].nb_att;j++)
           if (strcmp(tmp->child[i].attributs[j].name,"niv")==0)
            sscanf(tmp->child[i].attributs[j].value,"%hu",&(l_c->niveau));
           else if (strcmp(tmp->child[i].attributs[j].name,"xp")==0)
            sscanf(tmp->child[i].attributs[j].value,"%lu",&(l_c->xp));
          i++;
          if (i<nb_metier)
          {
            l_c->suiv=(liste_classe *)malloc(sizeof(liste_classe));
            l_c=l_c->suiv;
            l_c->suiv=NULL;
          }
        } while(i<nb_metier);
    }

    if ((tmp=g_markup_dom_node (node,"armes")))
    {
        ((unsigned short **)param)[NB_ARMES][0]=tmp->fils;
        free(((unsigned short **)param)[ARMES]);
        ((unsigned short **)param)[ARMES]=(unsigned short *)malloc(tmp->fils*sizeof(unsigned short));
        free(((unsigned short **)param)[NV_ARMES]);
        ((unsigned short **)param)[NV_ARMES]=(unsigned short *)malloc(tmp->fils*sizeof(unsigned short));
        free(((signed short **)param)[MAG_ARMES]);
        ((signed short **)param)[MAG_ARMES]=(signed short *)malloc(tmp->fils*sizeof(signed short));
        for(i=0;i<tmp->fils;i++)
        {
          for (j=0;j<MAX_ARMES && strcmp(tmp->child[i].content[0].texte,armes[j].nom)!=0;j++);
          ((unsigned short **)param)[ARMES][i]=j;
          for (j=0;j<tmp->child[i].nb_att && strcmp(tmp->child[i].attributs[j].name,"niv")!=0;j++);
          if (j<tmp->child[i].nb_att)
            sscanf(tmp->child[i].attributs[j].value,"%hu",((unsigned short **)param)[NV_ARMES]+i);
          else
            ((unsigned short **)param)[NV_ARMES][i]=0;
          for (j=0;j<tmp->child[i].nb_att && strcmp(tmp->child[i].attributs[j].name,"mag")!=0;j++);
          if (j<tmp->child[i].nb_att)
            sscanf(tmp->child[i].attributs[j].value,"%hd",((signed short **)param)[MAG_ARMES]+i);
          else
            ((signed short **)param)[MAG_ARMES][i]=0;
        }
    }
    if ((tmp=g_markup_dom_node (node,"pdv")))
    {
        ((unsigned short **)param)[NB_PDV][0]=tmp->fils;
        free(((unsigned short **)param)[PDV]);
        ((unsigned short **)param)[PDV]=(unsigned short *)malloc(tmp->fils*sizeof(unsigned short));
        for(i=0;i<tmp->fils;i++)
        {
            sprintf(ch,"%hu",i+1);
            tmp1=g_markup_dom_nom (tmp,ch,"niv");
            if (tmp1!=NULL) sscanf(tmp1->content[0].texte,"%hu",((unsigned short **)param)[PDV]+i);
        }
    }
    if ((tmp=g_markup_dom_node (node,"competence")))
    {
        ((unsigned short **)param)[NB_COMP][0]=tmp->fils;
        free(((unsigned short **)param)[COMP]);
        ((unsigned short **)param)[COMP]=(unsigned short *)malloc(tmp->fils*sizeof(unsigned short));
        free(((unsigned short **)param)[NV_COMP]);
        ((unsigned short **)param)[NV_COMP]=(unsigned short *)malloc(tmp->fils*sizeof(unsigned short));
        for(i=0;i<tmp->fils;i++)
        {
          for (j=0;j<MAX_COMPETENCE && strcmp(tmp->child[i].content[0].texte,competences[j].nom)!=0;j++);
          ((unsigned short **)param)[COMP][i]=j;
          for (j=0;j<tmp->child[i].nb_att && strcmp(tmp->child[i].attributs[j].name,"niv")!=0;j++);
          if (j<tmp->child[i].nb_att)
            sscanf(tmp->child[i].attributs[j].value,"%hu",((unsigned short **)param)[NV_COMP]+i);
        }
    }
    if ((tmp=g_markup_dom_node (node,"voleur")))
    {
        for(i=0;i<8;i++)
        {
            sscanf(tmp->child[i].content[0].texte,"%hu",((unsigned short **)param)[C_VOLEUR]+i);
        }
    }
    if ((tmp=g_markup_dom_node (node,"pantheon")))
    {
        if (tmp->texte>0)
        {
            ((char ***)param)[PANTHEON][0]=g_strdup(tmp->content->texte);
            if (tmp->fils>0 && tmp->child->texte>0 )
                ((char ***)param)[DIEU][0]=g_strdup(tmp->child->content->texte);
        }
    }
    if ((tmp=g_markup_dom_node (node,"com")))
    {
       if (((char **)param)[TEXTE_COM]) free(((char **)param)[TEXTE_COM]);
       if (tmp->texte>0) ((char **)param)[TEXTE_COM]=g_strdup(tmp->content->texte);
    }
    if ((tmp=g_markup_dom_node (node,"mag")))
    {
       for(i=0;i<9;i++)
       {
           if (((char *****)param)[SORT_MAG][i])
           {
               free(((char ****)param)[SORT_MAG][i]);
               free(((char ***)param)[SORT_MAG_MAIT][i]);
               ((char ***)param)[SORT_MAG_MAIT][i]=NULL;
               ((char ****)param)[SORT_MAG][i]=NULL;
               ((unsigned short **)param)[NB_SORT_MAG_NIV][i]=0;
           }
       }
       for (j=0;j<tmp->fils;j++)
       { /* les enfants sont obligatoirement des niv */
           n=0;
           for (k=0;k<tmp->child[j].nb_att;k++)
            if (strcmp(tmp->child[j].attributs[k].name,"niv")==0)
             if (tmp->child[j].attributs[k].value[1]==0)
              n=tmp->child[j].attributs[k].value[0]-'0'; /* chaine composée que d'un seul caractère : le nombre qu'on cherche */
           if (n!=0 && n<10)
           { /* si le niveau existe et est plus petit que 10 */
               ((unsigned short **)param)[NB_SORT_MAG_NIV][n-1]=tmp->child[j].fils;
               ((char ****)param)[SORT_MAG][n-1]=(char **)malloc(tmp->child[j].fils*sizeof(char *));
               ((char ***)param)[SORT_MAG_MAIT][n-1]=(char *)malloc(tmp->child[j].fils*sizeof(char));
               for (k=0;k<tmp->child[j].fils;k++)
               { /* les enfants sont obligatoirement des sorts avec uniquement un texte */
                   ((char ****)param)[SORT_MAG][n-1][k]=g_strdup(tmp->child[j].child[k].content->texte);
                   ((char ***)param)[SORT_MAG_MAIT][n-1][k]=tmp->child[j].child[k].attributs->value[0]-'0';
               }
           }
       }

    }
    if ((tmp=g_markup_dom_node (node,"taille")))
    {
        if (tmp->texte>0)
          sscanf(tmp->content->texte,"%hu",((unsigned short **)param)[TAILLE]);
    }
    if ((tmp=g_markup_dom_node (node,"poids")))
    {
        if (tmp->texte>0)
          sscanf(tmp->content->texte,"%hu",((unsigned short **)param)[POIDS]);
    }
    if ((tmp=g_markup_dom_node (node,"nom")))
    {
        if ((tmp1=g_markup_dom_node (tmp,"perso")))
            if (tmp1->texte>0)
            {
                ((char **)param)[PERSO]=g_strdup(tmp1->content->texte);
            }
        if ((tmp1=g_markup_dom_node (tmp,"joueur")))
            if (tmp1->texte>0)
                ((char **)param)[JOUEUR]=g_strdup(tmp1->content->texte);
    }
    if ((tmp=g_markup_dom_node (node,"couleur")))
    {
        if ((tmp1=g_markup_dom_node (tmp,"peau")))
            if (tmp1->texte>0)
                ((char **)param)[COULEUR_PEAU]=g_strdup(tmp1->content->texte);
        if ((tmp1=g_markup_dom_node (tmp,"yeux")))
            if (tmp1->texte>0)
                ((char **)param)[COULEUR_YEUX]=g_strdup(tmp1->content->texte);
        if ((tmp1=g_markup_dom_node (tmp,"cheveux")))
            if (tmp1->texte>0)
                ((char **)param)[COULEUR_CHEVEUX]=g_strdup(tmp1->content->texte);
    }
    if ((tmp=g_markup_dom_node (node,"classoc")))
    {
        if (tmp->texte>0)
            ((char **)param)[CLASSE_SOCIALE]=g_strdup(tmp->content->texte);
    }
    if ((tmp=g_markup_dom_node (node,"age")))
    {
        if (tmp->texte>0)
            ((char **)param)[AGE]=g_strdup(tmp->content->texte);
    }
    if ((tmp=g_markup_dom_node (node,"armure")))
    {
        if ((tmp=g_markup_dom_node (node,"armure1")))
        {
            if (tmp->texte>0)
            {
                ((char **)param)[ARMURE1]=g_strdup(tmp->content->texte);
                for(i=0;i<tmp->nb_att;i++)
                {
                    if (strcmp("mag",tmp->attributs[i].name)==0)
                        sscanf(tmp->attributs[i].value,"%hu",((unsigned short **)param)[MAG_ARMURE1]);
                }
            }
        }
        if ((tmp=g_markup_dom_node (node,"armure2")))
        {
            if (tmp->texte>0)
            {
                ((char **)param)[ARMURE2]=g_strdup(tmp->content->texte);
                for(i=0;i<tmp->nb_att;i++)
                {
                    if (strcmp("mag",tmp->attributs[i].name)==0)
                        sscanf(tmp->attributs[i].value,"%hu",((unsigned short **)param)[MAG_ARMURE2]);
                }
            }
        }
        if ((tmp=g_markup_dom_node (node,"bague")))
        {
            for(i=0;i<tmp->nb_att;i++)
            {
                if (strcmp("mag",tmp->attributs[i].name)==0)
                    sscanf(tmp->attributs[i].value,"%hu",((unsigned short **)param)[BONUS_CA]);
            }
        }
        if ((tmp=g_markup_dom_node (node,"bouclier")))
        {
            ((unsigned short **)param)[BOUCLIER][0]=1;
            for(i=0;i<tmp->nb_att;i++)
            {
                if (strcmp("mag",tmp->attributs[i].name)==0)
                    sscanf(tmp->attributs[i].value,"%hu",((unsigned short **)param)[MAG_BOUCLIER]);
            }
        }
        else
            ((unsigned short **)param)[BOUCLIER][0]=0;
    }

    caract_label(param);
}

void tire_taille_poids(GtkWidget *wid, gpointer param)
{
    unsigned short race=gtk_combo_box_get_active(GTK_COMBO_BOX (((GtkWidget **)param)[M_RACE])),sexe=gtk_combo_box_get_active(GTK_COMBO_BOX (((GtkWidget **)param)[M_SEXE]));
    unsigned short i,t,v;

    if (((struct_race ****)param)[M_MEMO][MENU][MAIN_RACE][race].add1.nom!=NULL)
        v=compare_sans_casse(((struct_race ****)param)[M_MEMO][MENU][MAIN_RACE][race].add1.nom,"humain")==0?4:3;
    else
        v=3;

    srand((unsigned int)time(0));

    t=rand()%1000;
    for(i=0;i<8 && t>v_poids_taille[i];i++);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(((GtkWidget ***)param)[M_D_TAILLE][i]),TRUE);

    if      (i<4) gtk_spin_button_set_value(GTK_SPIN_BUTTON(((GtkWidget **)param)[M_DV_TAILLE]),-v*(4-i)+rand()%v);
    else if (i>4) gtk_spin_button_set_value(GTK_SPIN_BUTTON(((GtkWidget **)param)[M_DV_TAILLE]),v*(i-5)+1+rand()%v);

    t=rand()%1000;
    for(i=0;i<8 && t>v_poids_taille[i];i++);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(((GtkWidget ***)param)[M_D_POIDS][i]),TRUE);

    v*=2;
    if      (i<4) gtk_spin_button_set_value(GTK_SPIN_BUTTON(((GtkWidget **)param)[M_DV_POIDS]),-v*(4-i)+rand()%v);
    else if (i>4) gtk_spin_button_set_value(GTK_SPIN_BUTTON(((GtkWidget **)param)[M_DV_POIDS]),v*(i-5)+1+rand()%v);

    gtk_spin_button_set_value(GTK_SPIN_BUTTON(((GtkWidget **)param)[M_TAILLE_RACE]),taille_race[race][sexe*2]+rand()%(taille_race[race][sexe*2+1]-taille_race[race][sexe*2]+1));

    calc_taille_poids(wid,param);
}

void adapte_taille(GtkWidget *wid,gpointer param)
{
    unsigned short i,race=gtk_combo_box_get_active(GTK_COMBO_BOX (((GtkWidget **)param)[M_RACE]));
    unsigned short t;

    if (((struct_race ****)param)[M_MEMO][MENU][MAIN_RACE][race].add1.nom!=NULL)
        t=compare_sans_casse(((struct_race ****)param)[M_MEMO][MENU][MAIN_RACE][race].add1.nom,"humain")==0?4:3;
    else
        t=3;

    for(i=0;i<8 && !gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(((GtkWidget ***)param)[M_D_TAILLE][i]));i++);
    if (i<4) gtk_spin_button_set_range(GTK_SPIN_BUTTON(((GtkWidget **)param)[M_DV_TAILLE]),-t*(4-i),-t*(3-i)-1);
    else if (i==4) gtk_spin_button_set_range(GTK_SPIN_BUTTON(((GtkWidget **)param)[M_DV_TAILLE]),0,0);
    else gtk_spin_button_set_range(GTK_SPIN_BUTTON(((GtkWidget **)param)[M_DV_TAILLE]),t*(i-5)+1,t*(i-4));

    (void)wid;
}

void adapte_poids(GtkWidget *wid, gpointer param)
{
    unsigned short i,t,race=gtk_combo_box_get_active(GTK_COMBO_BOX (((GtkWidget **)param)[M_RACE]));

    if (((struct_race ****)param)[M_MEMO][MENU][MAIN_RACE][race].add1.nom!=NULL)
        t=compare_sans_casse(((struct_race ****)param)[M_MEMO][MENU][MAIN_RACE][race].add1.nom,"humain")==0?8:6;
    else
        t=6;


    for(i=0;i<8 && !gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(((GtkWidget ***)param)[M_D_POIDS][i]));i++);
    if (i<4) gtk_spin_button_set_range(GTK_SPIN_BUTTON(((GtkWidget **)param)[M_DV_POIDS]),-t*(4-i),-t*(3-i)-1);
    else if (i==4) gtk_spin_button_set_range(GTK_SPIN_BUTTON(((GtkWidget **)param)[M_DV_POIDS]),0,0);
    else gtk_spin_button_set_range(GTK_SPIN_BUTTON(((GtkWidget **)param)[M_DV_POIDS]),t*(i-5)+1,t*(i-4));

    (void)wid;
}

void modif_taille(GtkWidget *wid, gpointer param)
{
    unsigned short race=gtk_combo_box_get_active(GTK_COMBO_BOX (((GtkWidget **)param)[M_RACE]));
    unsigned short sexe=gtk_combo_box_get_active(GTK_COMBO_BOX (((GtkWidget **)param)[M_SEXE]));

    //if (race>=AUTRE) race=HUMAIN;
    gtk_spin_button_set_range(GTK_SPIN_BUTTON(((GtkWidget **)param)[M_TAILLE_RACE]),taille_race[race][sexe*2],taille_race[race][sexe*2+1]);

    (void)wid;
}


void init_taille(gpointer param)
{
    modif_taille(NULL,param);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(((GtkWidget **)param)[M_C_TAILLE]),((unsigned short ***)param)[M_MEMO][TAILLE][0]);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(((GtkWidget **)param)[M_C_POIDS]),((unsigned short ***)param)[M_MEMO][POIDS][0]);

}



void calc_taille_poids(GtkWidget *wid, gpointer param)
{
    float poids,taille=gtk_spin_button_get_value(GTK_SPIN_BUTTON(((GtkWidget **)param)[M_TAILLE_RACE]))*(1+0.01*gtk_spin_button_get_value(GTK_SPIN_BUTTON(((GtkWidget **)param)[M_DV_TAILLE])));
    unsigned short force=gtk_spin_button_get_value(GTK_SPIN_BUTTON(((GtkWidget ***)param)[M_ENTREE][FORCE])),i;
    char ch[LONG];

    if (force<4) force=0;
    else
    {
        force-=3;
        if (force>15) force=15;
    }
    taille*=(1+force_taille[force]);

    for (i=0;i<80 && taille<c_poids_taille[i][0];i++);
    if (i==0)
    {
        poids=c_poids_taille[0][1]/c_poids_taille[0][0]*taille;
    }
    else if (i==80)
    {
        poids=c_poids_taille[79][1]/c_poids_taille[79][0]*taille;
    }
    else
        poids=c_poids_taille[i][1];

    poids*=(poids_race[gtk_combo_box_get_active(GTK_COMBO_BOX (((GtkWidget **)param)[M_RACE]))]*(1+0.01*gtk_spin_button_get_value(GTK_SPIN_BUTTON(((GtkWidget **)param)[M_DV_POIDS])))*(1+force_poids[force]));
    sprintf(ch,"Taille = %.2f pieds\nPoids = %.2f livres",taille,poids);
    gtk_label_set_text(GTK_LABEL(((GtkWidget **)param)[M_LABEL_TAILLE]),ch);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(((GtkWidget **)param)[M_C_TAILLE]),taille*2.54);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(((GtkWidget **)param)[M_C_POIDS]),poids*.42);

    (void)wid;
}

void verif_ali(gpointer param)
{
    liste_classe * l_c=trouve_liste_classe(param);
    signed short i,j;
    char * ali=NULL;
    char ch[LONG];
    GtkWidget * pWindow;
    signed short version_=gtk_combo_box_get_active(GTK_COMBO_BOX(((GtkWidget **)param)[M_VERSION]));
    struct_classe * s_c;

    GMarkupDomNode * node1=g_markup_dom_new(chemin_dieux(ch),NULL),* node;
    if (node1==NULL || (node=g_markup_dom_node (node1,"document"))==NULL || g_markup_dom_node (node,"pan")==NULL)
    {
        pWindow = gtk_message_dialog_new (GTK_WINDOW(((GtkWidget **)param)[M_FENETRE]),GTK_DIALOG_MODAL,GTK_MESSAGE_INFO,GTK_BUTTONS_CLOSE,"le fichier dieux.add\n ne correspond pas à un fichier xml de dieux");
        gtk_dialog_run(GTK_DIALOG(pWindow));
        gtk_widget_destroy(pWindow);

        i=gtk_combo_box_get_active(GTK_COMBO_BOX(((GtkWidget **)param)[M_PANTHEON]));
        if (i>0)
        {
            gtk_combo_box_get_active(GTK_COMBO_BOX(((GtkWidget **)param)[M_DIEU]));
            if ((unsigned short)i<node->fils)
            {
                node=node->child+i;
                i=gtk_combo_box_get_active(GTK_COMBO_BOX(((GtkWidget **)param)[M_DIEU])); /* il n'y a pas la présence d'une entrée inutile */
                if (i>0) /* retour de -1 si problème => non initialisé */
                {
                    i--;
                    if ((unsigned short)i<node->fils)
                    {
                        node=g_markup_dom_node (node->child+i,"alignement");
                        if (node!=NULL && node->texte>0)
                        {
                            ali=tabl_algt_s(node->content[0].texte);
                        }
                    }
                    else
                    {
                         pWindow = gtk_message_dialog_new (GTK_WINDOW(((GtkWidget **)param)[M_FENETRE]),GTK_DIALOG_MODAL,GTK_MESSAGE_INFO,GTK_BUTTONS_CLOSE,"Erreur ! Le dieu choisi n'existe pas !");
                         gtk_dialog_run(GTK_DIALOG(pWindow));
                         gtk_widget_destroy(pWindow);
                    }
                }
            }
            else
            {
                 pWindow = gtk_message_dialog_new (GTK_WINDOW(((GtkWidget **)param)[M_FENETRE]),GTK_DIALOG_MODAL,GTK_MESSAGE_INFO,GTK_BUTTONS_CLOSE,"Erreur ! Le panthéon choisi n'existe pas !");
                 gtk_dialog_run(GTK_DIALOG(pWindow));
                 gtk_widget_destroy(pWindow);
            }
        }
    }

    for (;l_c!=NULL;l_c=l_c->suiv)
    {
        if (ali==NULL)
        {   /* pas de passage par les dieux => tous les alignements sont valables */
            ali=(char *)malloc(9*sizeof(char));
            for(i=0;i<9;i++)
                ali[i]=1;
        }
        s_c=trouve_classe(l_c->nom,((struct_classe****)param)[M_MEMO][MENU][MAIN_CLASSE]);
        if (version_==ADD1 || s_c->add2.nom==NULL)
        {
            for(i=0;i<9;i++)
            {
                if ((s_c->add1.alignement & (1<<i))==0)
                    ali[i]=0;
            }
        }
        else
        {
            for(i=0;i<9;i++)
            {
                if ((s_c->add2.alignement&(1<<i))==0)
                    ali[i]=0;
            }
        }
    }

  j=0;
  for (i=0;i<9;i++)
    if (ali[i]==1)
        j++;

  if (j==0)
  { /* la configuration implique qu'aucun alignement n'est possible */
         pWindow = gtk_message_dialog_new (GTK_WINDOW(((GtkWidget **)param)[M_FENETRE]),GTK_DIALOG_MODAL,GTK_MESSAGE_INFO,GTK_BUTTONS_CLOSE,"Le choix classes/dieu est incompatible d'un point de vu alignement");
         gtk_dialog_run(GTK_DIALOG(pWindow));
         gtk_widget_destroy(pWindow);
  }
  else
  {
    for (i=0;i<9;i++)
        if (ali[i]!=0)
            gtk_toggle_button_set_inconsistent(GTK_TOGGLE_BUTTON(((GtkWidget ***)param)[M_ALIGNEMENT][i]),0);
        else
            gtk_toggle_button_set_inconsistent(GTK_TOGGLE_BUTTON(((GtkWidget ***)param)[M_ALIGNEMENT][i]),1);
    for (i=0;i<9;i++)
        if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(((GtkWidget ***)param)[M_ALIGNEMENT][i])))
        {
            if (ali[i]==0)
            {   /* si l'alignement sélectionné n'est pas bon */
                pWindow = gtk_message_dialog_new (GTK_WINDOW(((GtkWidget **)param)[M_FENETRE]),GTK_DIALOG_MODAL,GTK_MESSAGE_INFO,GTK_BUTTONS_CLOSE,"Alignement non compatible avec le choix classes/dieu\nAffectation d'un alignement convenable");
                gtk_dialog_run(GTK_DIALOG(pWindow));
                gtk_widget_destroy(pWindow);
                j=(j+1)/2;
                for (i=0;i<9 && j>0;i++)
                { /* on impose un alignement médian parmi les alignements possibles*/
                    if (ali[i]==1)
                        j--;
                }
                gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(((GtkWidget ***)param)[M_ALIGNEMENT][i-1]),1);
            }
            i=9; /* sortie de boucle */
        }

  }


  if (ali!=NULL) free(ali);
}

void verif_aligt(GtkWidget *wid,gpointer param)
{
    verif_ali(param); /* on n'appelle pas les fonctions générique à partir du click d'un bouton */

    (void)wid;
}

