/*
    Génération de feuille de personnage complète AD&D 1 et 2
    Génération aléatoire de personnage

    Copyright (C) 2011 Bernard SIAUD

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    a1024 with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifdef __linux__
#include <sys/types.h> /* pour le répertoire vers l'exécutable */
#define HOME     "HOME"
#define MEM_PROG "HOME"
#define TMP      "TMP"
#else
#include <Windows.h> /* pour le répertoire vers l'exécutable */
#include <process.h>
#include <direct.h>

#define HOME     "HOMEPATH"
#define MEM_PROG "APPDATA"
#define TMP      "TMP"

#define mkdir(a,b) _mkdir(a)

#endif

#include <string.h>
#include <sys/stat.h>
#include "include.h" /* ici LONG sera défini par windows.h :( */

char * chemin_dieux(char * ch)
{
  char * chemin;
  FILE * fp;

  chemin=getenv(MEM_PROG);

  sprintf(ch,"%s%c.perso.add%cdieux.add",chemin,SEPARATEUR,SEPARATEUR);
  fp = fopen(ch, "rb");
  if (fp == NULL)
  {
        /* L'ouverture du fichier ch a echoue => le fichier n'existe pas. */
        chemin=chemin_exe(); /* le fichier dieux.add général */
        sprintf(ch,"%s%cdieux.add",chemin,SEPARATEUR);
        free(chemin);
  }
  else
   fclose(fp);

  return ch;
}

char * chemin_dieux_libre(char * ch)
{
  char * chemin;

  chemin=getenv(MEM_PROG); /* dès la première sauvegarde, on passe sur le fichier perso */
  sprintf(ch,"%s%c.perso.add%cdieux.add",chemin,SEPARATEUR,SEPARATEUR);

  return ch;
}

char * chemin_exe()
{
#ifdef __linux__

 char *tmp,* tmp1=NULL;
 char chemin[1024],ch[1024];

	  sprintf(ch,"/proc/%d/exe",getpid());
	  memset(chemin,0,1024);
      if (readlink(ch,chemin,1023)<0)
        return NULL;
	  for(tmp=chemin;*tmp!=0;tmp++)
	  {
	    if (*tmp==SEPARATEUR) tmp1=tmp;
	  }
	  if (tmp1!=NULL) *tmp1=0;

 return g_strdup(chemin);

#else

 char ch[1024],* tmp,*tmp1=NULL;
 if (!( GetModuleFileName( NULL, ch, 1023) ))
    return NULL;
 else
 {
    for (tmp=ch;*tmp!=0;tmp++)
        if (*tmp==SEPARATEUR) tmp1=tmp;
    if (tmp1!=NULL) *tmp1=0;
    return g_strdup(ch);
 }

#endif
}


char * envp_init(gpointer param)
{
        char * ch1, aff[1024],ch[1024],*ch2;
        unsigned short i,j;
        FILE * fp;
        char chemin[1024];

        GList * p_action=((GList **)param)[8];

        getcwd(chemin,1023);
        ch1=getenv(MEM_PROG);

        sprintf(aff,"%s%c.perso.add",ch1,SEPARATEUR);

        if (chdir(aff)!=0)
        {
            mkdir(aff,0755);
        }

        sprintf(aff,"%s%c.perso.add%chome",ch1,SEPARATEUR,SEPARATEUR);
        fp = fopen(aff, "rb");
        if (fp==NULL)
        {
         fp = fopen(aff, "w");
         fprintf(fp,getenv(HOME));
         fclose(fp);
        }
        else
         fclose(fp);

        sprintf(aff,"%s%c.perso.add%chist",ch1,SEPARATEUR,SEPARATEUR);
        fp = fopen(aff, "r");
        if (fp==NULL)
        {
         fp = fopen(aff, "w");
         fclose(fp);
        }
        else
        {
            for (i=0;i<MEM_FICH_MAX;i++)
            {
                ch2=fgets(aff,1024-1,fp);
                sprintf(ch,"vide%hu",i+1);
                if (aff!=NULL && ch2!=NULL)
                {
                    for(j=0;aff[j]!='\n' && aff[j]!=0;j++);
                    aff[j]=0;
                    if (change_entree_menu(p_action,ch,aff))
                    {
                            //sprintf(ch,"/menubar/FichierMenuAction/hist/vide%hu",i+1);
                            cree_entree_menu(ch,aff,((GtkUIManager **)param)[2],i,"/menubar/FichierMenuAction/hist",((struct_param_nb **)param)[MAIN_PARAM_HIST]+i,menu_va_hist);
                    }
                }
                else
                {
                    change_entree_menu(p_action,ch,"");
                }
            }
            fclose(fp);
        }
        chdir(chemin);

        return ch1;
}

char * envp_donne_home()
{
        char * ch, aff[1024];
        FILE * fp;

        ch=getenv(MEM_PROG);

        sprintf(aff,"%s%c.perso.add%chome",ch,SEPARATEUR,SEPARATEUR);
        fp = fopen(aff, "r");
        fgets(aff,1024-1,fp); /* 1024 est assez grand pour mémoriser le chemin => sinon plantage pas la suite dans le programme ! */

    return g_strdup(aff);
}

void envp_mem_home(char * chemin)
{
        char * ch, aff[1024];
        FILE * fp;

        ch=getenv(MEM_PROG);

        sprintf(aff,"%s%c.perso.add%chome",ch,SEPARATEUR,SEPARATEUR);
        fp = fopen(aff, "w");
        fprintf(fp,"%s",chemin);
        fclose(fp);
}

void envp_mem_hist(char * chemin)
{
        char ** ch=(char **)malloc(MEM_FICH_MAX*sizeof(char *)), aff[1024],* ch1;
        FILE * fp;
        unsigned short i,j;

        ch1=getenv(MEM_PROG);
        sprintf(aff,"%s%c.perso.add%chist",ch1,SEPARATEUR,SEPARATEUR);

        fp = fopen(aff, "r");
        if (fp!=NULL)
        {
            for (i=0;i<MEM_FICH_MAX-1;i++)
            {
                ch1=fgets(aff,1024-1,fp);
                if (aff!=NULL && ch1!=NULL)
                {
                    for(j=0;aff[j]!='\n' && aff[j]!=0;j++);
                    aff[j]=0;
                    if (strcmp(aff,chemin)==0)
                    {
                        i--;
                    }
                    else
                    {
                        ch[i]=g_strdup(aff);
                    }
                }
                else
                {
                    ch[i]=NULL;
                    i=MEM_FICH_MAX;
                }

            }
            fclose(fp);
        }
        else ch[0]=NULL;

        ch1=getenv(MEM_PROG);
        sprintf(aff,"%s%c.perso.add%chist",ch1,SEPARATEUR,SEPARATEUR);
        fp = fopen(aff, "w");
        fprintf(fp,"%s\n",chemin);
        for (i=0;i<MEM_FICH_MAX-1;i++)
        {
            if (ch[i]!=NULL)
                fprintf(fp,"%s\n",ch[i]);
            else
                i=MEM_FICH_MAX;
        }
        fclose(fp);

        free(ch);
}


char * windows_home(char * chemin) /* uniquement pour windows */
{
    char ch[1024];

    if (chemin[0]==SEPARATEUR)
    {
        sprintf(ch,"%s%s",getenv("HOMEDRIVE"),chemin);
        free(chemin);
        chemin=g_strdup(ch);
    }

    return chemin;
}

char * rep_tmp()
{
  return g_strdup(getenv(TMP));
}

void  menu_va_hist(GtkWidget *wid, gpointer * param_nb)
{
        unsigned short num=((struct_param_nb *)param_nb)->nb;

        char aff[1024],* ch1;
        FILE * fp;
        unsigned short i,j;

        ch1=getenv(MEM_PROG);
        sprintf(aff,"%s%c.perso.add%chist",ch1,SEPARATEUR,SEPARATEUR);
        fp = fopen(aff, "r");
        if (fp!=NULL)
        {
            for (i=0;i<MEM_FICH_MAX;i++)
            {
                ch1=fgets(aff,1024-1,fp);
                if (ch1!=NULL)
                {
                 if  (i+1==num)
                 {
                        for(j=0;aff[j]!='\n' && aff[j]!=0;j++);
                        aff[j]=0;
                        ouvre_fichier(wid,((struct_param_nb *)param_nb)->param,aff,0);
                        i=MEM_FICH_MAX;
                 }
                }
                else
                {
                    i=MEM_FICH_MAX;
                }

            }
            fclose(fp);
        }
}


void ouvre_fichier(GtkWidget *wid, gpointer * param,char * aff,char eff)
{
        GMarkupDomNode * node=NULL,* node1=NULL;

        param[0]=(gpointer *)wid;
        node = g_markup_dom_new (aff, NULL);
        if (node!=NULL)
        {
            node1=g_markup_dom_node (node,"document");
            if (node1!=NULL)
            {
             if (node1->nb_att!=0 && strcmp(node1->attributs->value,"groupe")==0)
             { /* on ouvre un groupe */
                    param[4]=(gpointer *)aff;
                    ouvrir_groupe (NULL,param);
             }
             else
             { /* on ouvre un perso */
                if (g_markup_dom_node (node1,"pantheon")!=NULL)
                {
                    param[9]=(gpointer *)aff;
                    nouv_ouv(wid,param,OUV_HIST);
                }
                /* nom vraimant particulier => trouver une erreur dans le fichier pers */
             }
            }
        }
        g_markup_dom_free(node);

        if (eff==1) free(aff);
}

GtkWidget * deja_edite(char * nom_de_fichier)
{
    char ch[1024];
    FILE * fp;
    signed long pid;
    GtkWidget * win=NULL;

    sprintf(ch,"%s.lock",nom_de_fichier);
    fp = fopen(ch, "rb");
    if (fp == NULL)
    {
    /* L'ouverture du fichier "fichier.txt" a echoue => le fichier "fichier.txt" n'existe pas. */
        return NULL;
    }
    /* Le fichier a pu etre ouvert => le fichier existe. */
    if (fscanf(fp,"%ld %p",&pid,&win)!=2)
    {
        fclose(fp);
        return NULL;
    }
    if (pid!=getpid())
    {
        fclose(fp);
        return NULL;
    }
    fclose(fp);
    gtk_window_present (GTK_WINDOW(win));

    return win;
}

