/*
    Génération de feuille de personnage complète AD&D 1 et 2
    Génération aléatoire de personnage

    Copyright (C) 2011 Bernard SIAUD

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/* fichier de lecture/écriture et interprétation des feuilles de classe et de race */

#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "include.h"

char * lecture_case(char * coordonnees,GMarkupDomNode * ooo);
char * lecture_case_up(char * coordonnees,GMarkupDomNode * ooo);
GMarkupDomNode * donne_case_A1(char * coordonnees,GMarkupDomNode * ooo);
GMarkupDomNode * donne_case_ij(unsigned long i, unsigned long j,GMarkupDomNode * ooo); /* la première case est la case (0,0) */
signed short feuille_lire_case_m(char * coord,GMarkupDomNode * node,signed short min);
void feuille_pdv(char ** pdv,GMarkupDomNode * node);
void feuille_lire_race_save(char * coordonnees,char ** sortie,GMarkupDomNode * node);
char ** feuille_lire_ligne(char * coordonnees,GMarkupDomNode * node);
signed short * feuille_lire_ligne_nb(char * coordonnees,GMarkupDomNode * node);
signed long * feuille_lire_colonne_nbl(char * coordonnees,GMarkupDomNode * node);
unsigned short feuille_lire_alignement(GMarkupDomNode * node);
struct bonus_armes * feuille_lire_race_b_arme(char * coordonnees,GMarkupDomNode * node);
signed short ** feuille_lire_voleur(char * coordonnees,GMarkupDomNode * node);
liste_classe_race * feuille_lire_classe_race(char * coordonnees,GMarkupDomNode * node);
so_add * lecture_case_sort(char * coordonnees,gpointer param,GMarkupDomNode * ooo,unsigned short version);
struct sv_add * lecture_case_save(char * coordonnees,gpointer param,GMarkupDomNode * ooo,unsigned short version);




void feuille_aff_min_max_caract(GtkWidget * pere,char * caract, unsigned char mi, unsigned char ma, signed char modif,GtkWidget ** mi_wi,GtkWidget ** ma_wi,GtkWidget ** mo_wi);
void feuille_aff_pdv(GtkWidget * pere,char ** pdv, GtkWidget ** info);
void feuille_aff_arme(GtkWidget * pere,signed char * arm, GtkWidget ** info);
GtkWidget ** feuille_aff_ligne(GtkWidget * pere,char ** ch,char * nom);
GtkWidget ** feuille_aff_race_save(GtkWidget * pere,char ** ch);
GtkWidget ** feuille_aff_ligne_nb(GtkWidget * pere,signed short * nb,char * nom);
GtkWidget ** feuille_aff_ligne_nbl(GtkWidget * pere,signed long * nb,char * nom);
void feuille_aff_alignement(GtkWidget * pere,unsigned short alignement, GtkWidget ** info);
GtkWidget * feuille_aff_1_entree(GtkWidget * pere,char * ch,char * aff);
GtkWidget ** feuille_aff_race_arme(GtkWidget * pere,struct bonus_armes * b_arme);
GtkWidget * feuille_aff_sort(GtkWidget * pere,unsigned short magie,so_add * liste,struct_sort * sort,unsigned short nb_struct_sort);
GtkWidget * feuille_aff_save(GtkWidget * pere,struct sv_add * liste,struct_save * save,unsigned short nb_struct_save);
GtkWidget *** feuille_aff_liste_classe(GtkWidget * pere,liste_classe_race * liste);

liste_classe_race * range_l_cl_r(liste_classe_race * depart, liste_classe_race * nv);

/* ooo pointe sur la feuille ADD1 ou ADD2 utilisée en fonction de la version étudiée */

unsigned short trouve_niveau_xp(struct_classe * classe,signed long pt_xp,unsigned short versi)
{
    unsigned short i;

    if (versi==ADD1 && classe->add2.nom==NULL)
    {
        for(i=0;classe->add1.XP[i]<pt_xp && classe->add1.XP[i]!=FIN;i++);
        if (classe->add1.XP[i]==FIN)
        {
            if (classe->add1.pdv[19]==NULL) /* avec un maximum */
                return i+1;
            else
                return i+pt_xp/classe->add1.XP[i]+1;
        }
        else
            return i+1;
    }
    else
    {
        for(i=0;classe->add2.XP[i]<pt_xp && classe->add2.XP[i]!=FIN;i++);
        if (classe->add2.XP[i]==FIN)
        {
            if (classe->add2.pdv[19]==NULL) /* avec un maximum */
                return i+1;
            else
                return i+pt_xp/classe->add2.XP[i]+1;
        }
        else
            return i+1;
    }
}

char * pdv_classe(struct_classe * classe,unsigned short niv,unsigned short versi)
{
    if (niv>20) niv=20;
    if (versi==ADD1 || classe->add2.nom==NULL)
        return classe->add1.pdv[niv-1];
    else
        return classe->add2.pdv[niv-1];
}


void free_metier(liste_classe * l_c)
{
    if (l_c==NULL) return;
    if (l_c->suiv!=NULL)
        free_metier(l_c->suiv);
    free(l_c->nom);
    free(l_c);
    l_c=NULL;
}

unsigned short trouve_num_metier(char * nom_,gpointer param)
{
    unsigned short i=0;


    for (i=0;i<((unsigned short **)param)[MAIN_NB_CLASSE][0];i++)
    {
        if (((struct_classe **)param)[MAIN_CLASSE][i].add1.nom!=NULL)
        {
            if (compare_sans_casse(nom_,((struct_classe **)param)[MAIN_CLASSE][i].add1.nom)==0)
                return i;
        }
        else
        {
            if (compare_sans_casse(nom_,((struct_classe **)param)[MAIN_CLASSE][i].add2.nom)==0)
                return i;
        }
    }
    return i;
}

struct_classe * trouve_classe(char * nom_,struct_classe * l_c)
{
    signed short j=0,i=0;

    while (1)
    {
        if (l_c[j].add1.nom!=NULL)
            i=compare_sans_casse(nom_,l_c[j].add1.nom);
        else
            i=compare_sans_casse(nom_,l_c[j].add2.nom);
        if (i==0)
            return l_c+j;
        if (i<0)
            return NULL;
        j++;
    }
}


liste_classe * range_l_cl(liste_classe * depart, liste_classe * nv)
{
     liste_classe * tmp;

     if (depart==nv || depart==NULL) return nv;
     if (compare_sans_casse(depart->nom,nv->nom)<0)
     {
       tmp=depart;
       while (tmp->suiv!=NULL && compare_sans_casse(tmp->suiv->nom,nv->nom)<0)
       {
           tmp=tmp->suiv;
       }
       nv->suiv=tmp->suiv;
       tmp->suiv=nv;
       return depart;
     }
     nv->suiv=depart;
     return nv;

}

liste_classe_race * range_l_cl_r(liste_classe_race * depart, liste_classe_race * nv)
{
     liste_classe_race * tmp;

     if (depart==nv || depart==NULL) return nv;
     if (compare_liste_classe(depart->classe,nv->classe)<0)
     {
       tmp=depart;
       while (tmp->suiv!=NULL && compare_liste_classe(tmp->suiv->classe,nv->classe)<0)
       {
           tmp=tmp->suiv;
       }
       nv->suiv=tmp->suiv;
       tmp->suiv=nv;
       return depart;
     }
     nv->suiv=depart;
     return nv;

}

signed char compare_liste_classe(liste_classe * depart, liste_classe * nv)
{
    if (depart==NULL && nv==NULL) return 0;
    if (depart==NULL) return -1;
    if (nv==NULL)     return  1;
    if (compare_sans_casse(depart->nom,nv->nom)!=0)
        return compare_sans_casse(depart->nom,nv->nom);
    return compare_liste_classe(depart->suiv,nv->suiv);
}

signed char compare_sans_casse(char * s1,char * s2)
{
    if (s1==NULL && s2==NULL) return 0;
    if (s1==NULL) return -1;
    if (s2==NULL) return  1;
    while(*s1!=0 && *s2!=0 && toupper(*s1)==toupper(*s2))
    {
        s1++;
        s2++;
    }
    if (*s1==0 && *s2==0)
        return 0;
    if (*s1==0)
        return -1;
    if (*s2==0)
        return 1;
    return toupper(*s1)-toupper(*s2);
}

signed short feuille_lire_case_m(char * coord,GMarkupDomNode * node,signed short min)
{
    signed short entier;
    char * tmp;

    if ((tmp=lecture_case(coord,node)))
    {
        if (sscanf(tmp,"%hd",&entier)!=1) return min;
        else return entier;
    }
    else return min;
}

GMarkupDomNode * donne_case_A1(char * coordonnees,GMarkupDomNode * ooo)
{
    unsigned long i,j,c;

    for (i=0,j=0;*(coordonnees+j)>='A' && *(coordonnees+j)<='Z';j++)
        i=i*26+*(coordonnees+j)-'A'+1;
    if (j==0) return NULL; /* aucune lettre devant */
    c=sscanf(coordonnees+j,"%lu",&j);
    if (c!=1) return NULL;
    /* passage des coordonnées humaines aux coordonnées informatiques */
    return donne_case_ij(j-1,i-1,ooo);
}

GMarkupDomNode * donne_case_ij(unsigned long i, unsigned long j,GMarkupDomNode * ooo)
{
    unsigned long x,y,ii,jj;
    GMarkupDomNode * node, *tmp;

    /* première ligne pas dans le tableau */
    /* recherche de la colonne */
    for (x=0,ii=0;x<=i && ii<ooo->fils;x++,ii++)
    {
        tmp=ooo->child+ii;
        if (strcmp(tmp->name,"table:table-row")!=0)
         i++;
        for (jj=0;jj<tmp->nb_att;jj++)
        {
            if (strcmp(tmp->attributs[jj].name,"table:number-rows-repeated")==0)
            {
                if (sscanf(tmp->attributs[jj].value,"%lu",&y) == 1) x+=(y-1);
            }
        }
    }
    if (x>i) ii--;              /* attention, si une case se répète.... */
    if (ii>=ooo->fils) return NULL; /* la case était vide => on est trop loin ! */
    node=ooo->child+ii;
    for (x=0,ii=0;x<=j && ii<node->fils;x++,ii++)
    {
        tmp=node->child+ii;
        if (strcmp(tmp->name,"table:table-cell")!=0)
         j++;
        for (jj=0;jj<tmp->nb_att;jj++)
        {
            if (strcmp(tmp->attributs[jj].name,"table:number-columns-repeated")==0)
            {
                if (sscanf(tmp->attributs[jj].value,"%lu",&y) == 1) x+=(y-1);
            }
        }
    }
    if (x>j) ii--;
    if (ii>=node->fils) return NULL; /* la case était vide => on est trop loin ! */
    node=node->child+ii;
    if (node->fils==0) return NULL; /* case vide */
    return node->child; /* donne texte dans la case */
}

char * lecture_case(char * coordonnees,GMarkupDomNode * ooo)
{
    GMarkupDomNode * info;


    info=donne_case_A1(coordonnees,ooo);
    if (info==NULL) return NULL;
    if (info->texte==0) return NULL; /* pas de texte */
    return info->content->texte;
}

char * lecture_case_up(char * coordonnees,GMarkupDomNode * ooo)
{
    GMarkupDomNode * info;

    info=donne_case_A1(coordonnees,ooo);
    if (info==NULL) return NULL;
    if (info->texte==0) return NULL; /* pas de texte */
    return g_strdup(info->content->texte);
}

void feuille_pdv(char ** pdv,GMarkupDomNode * node)
{
    GMarkupDomNode * info;
    unsigned long i,j,c;
    char *coordonnees=FEUILLE_PDV;

    for (i=0,j=0;*(coordonnees+j)>='A' && *(coordonnees+j)<='Z';j++)
        i=i*26+*(coordonnees+j)-'A'+1;
    if (j==0) for (c=0;c<20;c++) pdv[c]=NULL; /* aucune lettre devant */
    else
    {
        c=sscanf(coordonnees+j,"%lu",&j);
        if (c!=1) for (c=0;c<20;c++) pdv[c]=NULL; /* pas d'entier */
        else
        {
            for (c=0;c<20;c++)
            {
                info=donne_case_ij(j-1,i-1+c,node);
                if (info==NULL) pdv[c]=NULL; /* pas la case */
                else if (info->texte==0) pdv[c]=NULL; /* pas de texte */
                else pdv[c]=g_strdup(info->content->texte);
            }
        }
    }
}

char ** feuille_lire_ligne(char * coordonnees,GMarkupDomNode * node)
{
    unsigned long i,j,c;
    GMarkupDomNode * info;
    char ** sortie=NULL;

    for (i=0,j=0;*(coordonnees+j)>='A' && *(coordonnees+j)<='Z';j++)
        i=i*26+*(coordonnees+j)-'A'+1;
    if (j==0) return NULL; /* aucune lettre devant */
    c=sscanf(coordonnees+j,"%lu",&j);
    if (c!=1) return NULL;
    /* passage des coordonnées humaines aux coordonnées informatiques */

    for(c=0;(info=donne_case_ij(j-1,i-1+c,node)) && info->texte!=0;c++)
    {   /* tant qu'il y a des cases, on lit le contenu */
        sortie=(char **)realloc(sortie,(c+1)*sizeof(char *));
        sortie[c]=g_strdup(info->content->texte);
    }
    sortie=(char **)realloc(sortie,(c+1)*sizeof(char *));
    sortie[c]=NULL;

    return sortie;
}

void feuille_lire_race_save(char * coordonnees,char ** sortie,GMarkupDomNode * node)
{
    unsigned long i,j,c;
    GMarkupDomNode * info;

    for (i=0,j=0;*(coordonnees+j)>='A' && *(coordonnees+j)<='Z';j++)
        i=i*26+*(coordonnees+j)-'A'+1;
    if (j==0) {for(i=0;i<5;i++) sortie[i]=NULL; return; } /* aucune lettre devant */
    c=sscanf(coordonnees+j,"%lu",&j);
    if (c!=1) {for(i=0;i<5;i++) sortie[i]=NULL; return; }
    /* passage des coordonnées humaines aux coordonnées informatiques */


    for(c=0;c<5;c++)
    {   /* tant qu'il y a des cases, on lit le contenu */
        if ((info=donne_case_ij(j-1,i-1+c,node)) && info->texte!=0) sortie[c]=g_strdup(info->content->texte);
        else                                                        sortie[c]=NULL;
    }
}



struct bonus_armes * feuille_lire_race_b_arme(char * coordonnees,GMarkupDomNode * node)
{
    unsigned long i,j,c;
    GMarkupDomNode * info;
    struct bonus_armes * sortie=NULL;

    for (i=0,j=0;*(coordonnees+j)>='A' && *(coordonnees+j)<='Z';j++)
        i=i*26+*(coordonnees+j)-'A'+1;
    if (j==0) return NULL; /* aucune lettre devant */
    c=sscanf(coordonnees+j,"%lu",&j);
    if (c!=1) return NULL;
    /* passage des coordonnées humaines aux coordonnées informatiques */


    for(c=0;(info=donne_case_ij(j-1,i-1+c,node)) && info->texte!=0;c++)
    {   /* tant qu'il y a des cases, on lit le contenu */
        sortie=(struct bonus_armes *)realloc(sortie,(c+1)*sizeof(struct bonus_armes));
        sortie[c].arme=g_strdup(info->content->texte);
        if ((info=donne_case_ij(j,i-1+c,node))!=NULL && info->texte>0)
            sscanf(info->content->texte,"%hd",&(sortie[c].bonus));
    }
    sortie=(struct bonus_armes *)realloc(sortie,(c+1)*sizeof(struct bonus_armes));
    sortie[c].arme=NULL;

    return sortie;
}

signed short * feuille_lire_ligne_nb(char * coordonnees,GMarkupDomNode * node)
{
    signed long i,j,c;
    GMarkupDomNode * info;
    signed short * sortie=NULL;

    for (i=0,j=0;*(coordonnees+j)>='A' && *(coordonnees+j)<='Z';j++)
        i=i*26+*(coordonnees+j)-'A'+1;
    if (j==0) return NULL; /* aucune lettre devant */
    c=sscanf(coordonnees+j,"%ld",&j);
    if (c!=1) return NULL;
    /* passage des coordonnées humaines aux coordonnées informatiques */


    for(c=0;(info=donne_case_ij(j-1,i-1+c,node)) && info->texte!=0;c++)
    {   /* tant qu'il y a des cases, on lit le contenu */
        sortie=(signed short *)realloc(sortie,(c+1)*sizeof(signed short));
        sortie[c]=0;
        sscanf(info->content->texte,"%hu",sortie+c);
    }
    sortie=(signed short *)realloc(sortie,(c+1)*sizeof(signed short));
    sortie[c]=FIN;

    return sortie;
}

signed long * feuille_lire_colonne_nbl(char * coordonnees,GMarkupDomNode * node)
{
    signed long i,j,c;
    GMarkupDomNode * info;
    signed long * sortie=NULL;

    for (i=0,j=0;*(coordonnees+j)>='A' && *(coordonnees+j)<='Z';j++)
        i=i*26+*(coordonnees+j)-'A'+1;
    if (j==0) return NULL; /* aucune lettre devant */
    c=sscanf(coordonnees+j,"%ld",&j);
    if (c!=1) return NULL;
    /* passage des coordonnées humaines aux coordonnées informatiques */


    for(c=0;(info=donne_case_ij(j-1+c,i-1,node)) && info->texte!=0;c++)
    {   /* tant qu'il y a des cases, on lit le contenu */
        sortie=(signed long *)realloc(sortie,(c+1)*sizeof(signed long));
        sortie[c]=0;
        sscanf(info->content->texte,"%ld",sortie+c);
    }
    sortie=(signed long *)realloc(sortie,(c+1)*sizeof(signed long));
    sortie[c]=FIN;

    return sortie;
}

unsigned short feuille_lire_alignement(GMarkupDomNode * node)
{
    unsigned long i,j,c;
    GMarkupDomNode * info;
    unsigned short sortie=0;
    char * coordonnees=FEUILLE_ALIGNEMENT;

    for (i=0,j=0;*(coordonnees+j)>='A' && *(coordonnees+j)<='Z';j++)
        i=i*26+*(coordonnees+j)-'A'+1;
    if (j==0) return 0; /* aucune lettre devant */
    c=sscanf(coordonnees+j,"%lu",&j);
    if (c!=1) return 0;
    /* passage des coordonnées humaines aux coordonnées informatiques */


    for(c=0;(info=donne_case_ij(j-1,i-1+c,node)) && info->texte!=0;c++)
    {   /* tant qu'il y a des cases, on lit le contenu */
        if       (strcmp(info->content->texte,"BL")==0) sortie=sortie|BL;
        else if (strcmp(info->content->texte,"BN")==0) sortie=sortie|BN;
        else if (strcmp(info->content->texte,"BC")==0) sortie=sortie|BC;
        else if (strcmp(info->content->texte,"NL")==0) sortie=sortie|NL;
        else if (strcmp(info->content->texte,"NN")==0) sortie=sortie|NN;
        else if (strcmp(info->content->texte,"NC")==0) sortie=sortie|NC;
        else if (strcmp(info->content->texte,"ML")==0) sortie=sortie|ML;
        else if (strcmp(info->content->texte,"MN")==0) sortie=sortie|MN;
        else if (strcmp(info->content->texte,"MC")==0) sortie=sortie|MC;
    }

    return sortie;
}

signed short ** feuille_lire_voleur(char * coordonnees,GMarkupDomNode * node)
{
    signed long i,j,c,k,l;
    GMarkupDomNode * info;
    signed short ** sortie=NULL;


    for (i=0,j=0;*(coordonnees+j)>='A' && *(coordonnees+j)<='Z';j++)
        i=i*26+*(coordonnees+j)-'A'+1;
    if (j==0) return NULL; /* aucune lettre devant */
    c=sscanf(coordonnees+j,"%lu",&j);
    if (c!=1) return NULL;

    for (c=0;donne_case_ij(j-1+c,i-1,node) || donne_case_ij(j-1+c,i,node);c++);
    sortie=(signed short **)malloc((c+1)*sizeof(signed short *));
    for (k=0;k<c;k++)
    {
        sortie[k]=(signed short *)malloc((FEUILLE_LAR_VOL+1)*sizeof(signed short));
        sortie[k][FEUILLE_LAR_VOL]=FIN;
        for(l=0;l<FEUILLE_LAR_VOL;l++)
        {
            info=donne_case_ij(j-1+k,i+l,node);
            if (info==NULL || info->texte==0 || sscanf(info->content->texte,"%hd",sortie[k]+l)==0)
                sortie[k][l]=-1; /* case vide => impossible de le monter */
        }
    }
    sortie[c]=NULL;

    return sortie;
}


so_add * lecture_case_sort(char * coordonnees,gpointer param,GMarkupDomNode * ooo,unsigned short version_)
{
    GMarkupDomNode * info;
    unsigned short i;


    info=donne_case_A1(coordonnees,ooo);
    if (info==NULL) return NULL;
    if (info->texte==0) return NULL; /* pas de texte */
    if (version_==ADD1)
    {
        for (i=0;i<((unsigned short **)param)[MAIN_NB_SORT][0];i++)
        {
            if (((struct_sort **)param)[MAIN_SORT][i].add1.nom!=NULL && compare_sans_casse(((struct_sort **)param)[MAIN_SORT][i].add1.nom,info->content->texte)==0)
                return &(((struct_sort **)param)[MAIN_SORT][i].add1);
        }
    }
    else
    {
        for (i=0;i<((unsigned short **)param)[MAIN_NB_SORT][0];i++)
        {
            if (((struct_sort **)param)[MAIN_SORT][i].add2.nom!=NULL && compare_sans_casse(((struct_sort **)param)[MAIN_SORT][i].add2.nom,info->content->texte)==0)
                return &(((struct_sort **)param)[MAIN_SORT][i].add2);
        }
    }
    return NULL;
}

struct sv_add * lecture_case_save(char * coordonnees,gpointer param,GMarkupDomNode * ooo,unsigned short version_)
{
    GMarkupDomNode * info;
    unsigned short i;

    info=donne_case_A1(coordonnees,ooo);
    if (info==NULL) return NULL;
    if (info->texte==0) return NULL; /* pas de texte */
    if (version_==ADD1)
    {
        for (i=0;i<((unsigned short **)param)[MAIN_NB_SAVE][0];i++)
        {
            if (((struct_save **)param)[MAIN_SAVE][i].add1.nom!=NULL && compare_sans_casse(((struct_save **)param)[MAIN_SAVE][i].add1.nom,info->content->texte)==0)
                return &(((struct_save **)param)[MAIN_SAVE][i].add1);
        }
    }
    else
    {
        for (i=0;i<((unsigned short **)param)[MAIN_NB_SAVE][0];i++)
        {
            if (((struct_save **)param)[MAIN_SAVE][i].add2.nom!=NULL && compare_sans_casse(((struct_save **)param)[MAIN_SAVE][i].add2.nom,info->content->texte)==0)
                return &(((struct_save **)param)[MAIN_SAVE][i].add2);
        }
    }
    return NULL;
}

 /* param[MAIN_SAVE]=(void *)save;
 param[MAIN_NB_SAVE]=(void *)nb_save;
 param[MAIN_SORT]=(void *)sort;
 param[MAIN_NB_SORT]=(void *)nb_sort; */


liste_classe_race * feuille_lire_classe_race(char * coordonnees,GMarkupDomNode * node)
{
    unsigned long i,j,c;
    GMarkupDomNode * info;
    liste_classe_race * sortie=NULL,* tmp_cr;
    liste_classe * tmp_c;
    char * ch, *pt,*tmp;

    i=sizeof(liste_classe_race);
    i=sizeof(liste_classe);
    for (i=0,j=0;*(coordonnees+j)>='A' && *(coordonnees+j)<='Z';j++)
        i=i*26+*(coordonnees+j)-'A'+1;
    if (j==0) return NULL; /* aucune lettre devant */
    c=sscanf(coordonnees+j,"%lu",&j);
    if (c!=1) return NULL;
    /* passage des coordonnées humaines aux coordonnées informatiques */


    for(c=0;(info=donne_case_ij(j-1,i-1+c,node)) && info->texte!=0;c++)
    {   /* tant qu'il y a des cases, on lit le contenu */
        tmp_cr=(liste_classe_race *)malloc(sizeof(liste_classe_race));
        tmp_cr->suiv=NULL;
        tmp_cr->classe=NULL;
        ch=info->content->texte;
        for (pt=ch;*pt!=0;pt++)
        {
            if (*pt=='/')
            {
                *pt=0;
                tmp_c=(liste_classe *)malloc(sizeof(liste_classe));
                tmp_c->suiv=NULL;
                tmp=g_strdup(ch);
                tmp_c->nom=g_strdup(mintexte(tmp));
                free(tmp);
                ch=pt+1;
                *pt='/';
                tmp_cr->classe=range_l_cl(tmp_cr->classe,tmp_c);
            }
        }
        tmp_c=(liste_classe *)malloc(sizeof(liste_classe));
        tmp_c->suiv=NULL;
        tmp_c->nom=g_strdup(ch);
        if ((info=donne_case_ij(j,i-1+c,node)))
            tmp_cr->age=g_strdup(info->content->texte);
        else
            tmp_cr->age=NULL;
        tmp_cr->classe=range_l_cl(tmp_cr->classe,tmp_c);
        sortie=range_l_cl_r(sortie,tmp_cr);
    }

    return sortie;
}

void feuille_aff_min_max_caract(GtkWidget * pere,char * caract, unsigned char mi, unsigned char ma, signed char modif,GtkWidget ** mi_wi,GtkWidget ** ma_wi,GtkWidget ** mo_wi)
{
    GtkWidget * hbox, *label;

    hbox=gtk_hbox_new(FALSE, 6);
    gtk_box_pack_start(GTK_BOX(pere), hbox, TRUE, TRUE, 0);
    label=gtk_label_new(caract);
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);

    label=gtk_label_new("min");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    *mi_wi=gtk_spin_button_new_with_range(0, 25, 1);
    gtk_box_pack_start(GTK_BOX(hbox), *mi_wi, TRUE, TRUE, 0);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(*mi_wi),mi);
    label=gtk_label_new("max");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    *ma_wi=gtk_spin_button_new_with_range(0, 25, 1);
    gtk_box_pack_start(GTK_BOX(hbox), *ma_wi, TRUE, TRUE, 0);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(*ma_wi),ma);
    if (modif!=TROP)
    {
        label=gtk_label_new("modif");
        gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
        *mo_wi=gtk_spin_button_new_with_range(-25, 25, 1);
        gtk_box_pack_start(GTK_BOX(hbox), *mo_wi, TRUE, TRUE, 0);
        gtk_spin_button_set_value(GTK_SPIN_BUTTON(*mo_wi),modif);
    }
}

void feuille_aff_pdv(GtkWidget * pere,char ** pdv, GtkWidget ** info)
{
    GtkWidget * hbox, *label;
    gint i;

    hbox=gtk_hbox_new(FALSE, 6);
    gtk_box_pack_start(GTK_BOX(pere), hbox, TRUE, TRUE, 0);
    label=gtk_label_new("PDV : ");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    for(i=0;i<20;i++)
    {
        if (i%11==10)
        {
            hbox=gtk_hbox_new(FALSE, 6);
            gtk_box_pack_start(GTK_BOX(pere), hbox, TRUE, TRUE, 0);
        }
        info[i]=gtk_entry_new();
        if (pdv[i]!=NULL) gtk_entry_set_text(GTK_ENTRY(info[i]),pdv[i]);
        gtk_entry_set_width_chars(GTK_ENTRY(info[i]),4);
        gtk_box_pack_start(GTK_BOX(hbox), info[i], TRUE, TRUE, 0);
    }
}

void  feuille_aff_arme(GtkWidget * pere,signed char * arm, GtkWidget ** info)
{
    GtkWidget * hbox, *label;

    hbox=gtk_hbox_new(FALSE, 6);
    gtk_box_pack_start(GTK_BOX(pere), hbox, TRUE, TRUE, 0);

    label=gtk_label_new("début : ");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    info[0]=gtk_spin_button_new_with_range(-9, 9, 1);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(info[0]),arm[0]);
    gtk_box_pack_start(GTK_BOX(hbox), info[0], TRUE, TRUE, 0);

    label=gtk_label_new("pénalité : ");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    info[1]=gtk_spin_button_new_with_range(-9, 9, 1);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(info[1]),arm[1]);
    gtk_box_pack_start(GTK_BOX(hbox), info[1], TRUE, TRUE, 0);

    label=gtk_label_new("progression : ");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    info[2]=gtk_spin_button_new_with_range(-9, 9, 1);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(info[2]),arm[2]);
    gtk_box_pack_start(GTK_BOX(hbox), info[2], TRUE, TRUE, 0);
}

GtkWidget *** feuille_aff_liste_classe(GtkWidget * pere,liste_classe_race * liste)
{
    GtkWidget *** sortie=NULL;
    GtkWidget * hbox, *label;
    gint i,j=0,k=0;
    liste_classe * tmp;

    hbox=gtk_hbox_new(FALSE, 6);
    gtk_box_pack_start(GTK_BOX(pere), hbox, TRUE, TRUE, 0);
    label=gtk_label_new("Classe ");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    if (liste==NULL) return NULL;
    i=1;
    do
    {
        sortie=(GtkWidget ***)realloc(sortie,(j+1)*sizeof(GtkWidget **));
        if (i>4)
        {
            hbox=gtk_hbox_new(FALSE, 6);
            gtk_box_pack_start(GTK_BOX(pere), hbox, TRUE, TRUE, 0);
            i=0;
        }
        sortie[j]=NULL;
        k=0;
        tmp=liste->classe;
        if (j!=0)
        {
            label=gtk_label_new(" |O| ");
            gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
        }
        while (tmp!=NULL)
        {
            sortie[j]=(GtkWidget **)realloc(sortie[j],(k+3)*sizeof(GtkWidget *)); /* une place pour la fin */
            sortie[j][k]=gtk_entry_new();
            gtk_entry_set_text(GTK_ENTRY(sortie[j][k]),tmp->nom);
            gtk_entry_set_width_chars(GTK_ENTRY(sortie[j][k]),5);
            gtk_box_pack_start(GTK_BOX(hbox), sortie[j][k], TRUE, TRUE, 0);
            i++;
            k++;
            tmp=tmp->suiv;
        }
        label=gtk_label_new(" > ");
        gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
        sortie[j][k]=gtk_entry_new();
        if (liste->age!=NULL) gtk_entry_set_text(GTK_ENTRY(sortie[j][k]),liste->age);
        gtk_entry_set_width_chars(GTK_ENTRY(sortie[j][k]),5);
        gtk_box_pack_start(GTK_BOX(hbox), sortie[j][k], TRUE, TRUE, 0);
        sortie[j][k+1]=NULL;
        j++;
    }
    while((liste=liste->suiv)!=NULL);
    sortie=(GtkWidget ***)realloc(sortie,(j+1)*sizeof(GtkWidget **));
    sortie[j]=NULL;
    return sortie;
}

GtkWidget ** feuille_aff_ligne(GtkWidget * pere,char ** arme,char * aff)
{
    GtkWidget ** sortie=NULL;
    GtkWidget * hbox, *label;
    gint i;


    hbox=gtk_hbox_new(FALSE, 6);
    gtk_box_pack_start(GTK_BOX(pere), hbox, TRUE, TRUE, 0);
    label=gtk_label_new(aff);
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    for(i=0;arme[i]!=NULL;i++)
    {
        sortie=(GtkWidget **)realloc(sortie,(i+1)*sizeof(GtkWidget *));
        if (i%6==7)
        {
            hbox=gtk_hbox_new(FALSE, 6);
            gtk_box_pack_start(GTK_BOX(pere), hbox, TRUE, TRUE, 0);
        }
        sortie[i]=gtk_entry_new();
        gtk_entry_set_text(GTK_ENTRY(sortie[i]),arme[i]);
        gtk_entry_set_width_chars(GTK_ENTRY(sortie[i]),5);
        gtk_box_pack_start(GTK_BOX(hbox), sortie[i], TRUE, TRUE, 0);
    }

    return sortie;
}

GtkWidget ** feuille_aff_ligne_nb(GtkWidget * pere,signed short * nb,char * aff)
{
    GtkWidget ** sortie=NULL;
    GtkWidget * hbox, *label;
    gint i;


    hbox=gtk_hbox_new(FALSE, 6);
    gtk_box_pack_start(GTK_BOX(pere), hbox, TRUE, TRUE, 0);
    label=gtk_label_new(aff);
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    for(i=0;nb[i]!=FIN;i++)
    {
        sortie=(GtkWidget **)realloc(sortie,(i+1)*sizeof(GtkWidget *));
        /*if (i%10==9)
        {
            hbox=gtk_hbox_new(FALSE, 6);
            gtk_box_pack_start(GTK_BOX(pere), hbox, TRUE, TRUE, 0);
        }*/
        sortie[i]=gtk_spin_button_new_with_range(-999,9999, 1);
        gtk_spin_button_set_value(GTK_SPIN_BUTTON(sortie[i]),nb[i]);
        gtk_box_pack_start(GTK_BOX(hbox), sortie[i], TRUE, TRUE, 0);
    }

    return sortie;
}

GtkWidget ** feuille_aff_ligne_nbl(GtkWidget * pere,signed long * nb,char * aff)
{
    GtkWidget ** sortie=NULL;
    GtkWidget * hbox, *label;
    gint i;


    hbox=gtk_hbox_new(FALSE, 6);
    gtk_box_pack_start(GTK_BOX(pere), hbox, TRUE, TRUE, 0);
    label=gtk_label_new(aff);
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    for(i=0;nb[i]!=FIN;i++)
    {
        sortie=(GtkWidget **)realloc(sortie,(i+1)*sizeof(GtkWidget *));
        if (i%10==8)
        {
            hbox=gtk_hbox_new(FALSE, 6);
            gtk_box_pack_start(GTK_BOX(pere), hbox, TRUE, TRUE, 0);
        }
        sortie[i]=gtk_spin_button_new_with_range(-999,99999999, 1);
        gtk_spin_button_set_value(GTK_SPIN_BUTTON(sortie[i]),nb[i]);
        gtk_box_pack_start(GTK_BOX(hbox), sortie[i], TRUE, TRUE, 0);
    }

    return sortie;
}

GtkWidget * feuille_aff_1_entree(GtkWidget * pere,char * ch,char * aff)
{
    GtkWidget * sortie=gtk_entry_new();
    GtkWidget * hbox, *label;

    hbox=gtk_hbox_new(FALSE, 6);
    gtk_box_pack_start(GTK_BOX(pere), hbox, TRUE, TRUE, 0);
    label=gtk_label_new(ch);
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    if (aff!=NULL) gtk_entry_set_text(GTK_ENTRY(sortie),aff);
    gtk_box_pack_start(GTK_BOX(hbox),sortie,TRUE, TRUE, 0);

    return sortie;
}

GtkWidget ** feuille_aff_race_arme(GtkWidget * pere,struct bonus_armes * b_arme)
{
    GtkWidget ** sortie=NULL;
    GtkWidget * hbox, *vbox;
    gint i;

    for(i=0;b_arme[i].arme!=NULL;i++)
    {
        sortie=(GtkWidget **)realloc(sortie,(2*i+2)*sizeof(GtkWidget *));
        if (i%4==0)
        {
            hbox=gtk_hbox_new(FALSE, 6);
            gtk_box_pack_start(GTK_BOX(pere), hbox, TRUE, TRUE, 0);
        }
        vbox=gtk_vbox_new(FALSE, 6);
        gtk_box_pack_start(GTK_BOX(hbox), vbox, TRUE, TRUE, 0);
        sortie[2*i]=gtk_entry_new();
        gtk_entry_set_text(GTK_ENTRY(sortie[2*i]),b_arme[i].arme);
        gtk_entry_set_width_chars(GTK_ENTRY(sortie[2*i]),5);
        gtk_box_pack_start(GTK_BOX(vbox), sortie[2*i], TRUE, TRUE, 0);
        sortie[2*i+1]=gtk_spin_button_new_with_range(0,9999, 1);
        gtk_spin_button_set_value(GTK_SPIN_BUTTON(sortie[2*i+1]),b_arme[i].bonus);
        gtk_box_pack_start(GTK_BOX(vbox), sortie[2*i+1], TRUE, TRUE, 0);
    }

    return sortie;
}

GtkWidget * feuille_aff_sort(GtkWidget * pere,unsigned short magie,so_add * liste,struct_sort * sort,unsigned short nb_struct_sort)
{
    //GtkListStore * p_model_sort = gtk_list_store_new (1, G_TYPE_STRING);
    GtkWidget * sortie=gtk_combo_box_text_new(); //gtk_combo_box_new_with_model (GTK_TREE_MODEL (p_model_sort));
    //GtkCellRenderer * p_cell_sort=gtk_cell_renderer_text_new ();
    GtkWidget *label;
    //GtkTreeIter  iter;
    char * sorte;
    unsigned short i,choix=0,j=0;
    gpointer * param=(gpointer *)malloc(4*sizeof(gpointer));

    switch (magie)
    {
        case MAGICIEN    :
                label=gtk_button_new_with_label("Magie");
                sorte="mago";
                break;
        case ILLUSIONNISTE :
                label=gtk_button_new_with_label("Illusion");
                sorte="illu";
                break;
        case PRETRE   :
                label=gtk_button_new_with_label("Prêtre");
                sorte="clerc";
                break;
        case DRUIDE   :
                label=gtk_button_new_with_label("Druide");
                sorte="druide";
                break;
        default :
                label=gtk_button_new_with_label("Erreur");
                sorte="";
                break;
    }

     g_signal_connect (G_OBJECT (label), "clicked", G_CALLBACK (affiche_sort), (gpointer) param);
     gtk_box_pack_start (GTK_BOX (pere), label, FALSE,TRUE, 0);
     //gtk_cell_layout_pack_start (GTK_CELL_LAYOUT (sortie), p_cell_sort, FALSE);
     //gtk_cell_layout_set_attributes (GTK_CELL_LAYOUT (sortie),p_cell_sort, "text", 0,NULL);
     //gtk_list_store_append (p_model_sort, & iter);
     gtk_combo_box_text_append_text(GTK_COMBO_BOX_TEXT(sortie),"--------------");//gtk_list_store_set (p_model_sort, & iter,0,"--------",-1);
     if (liste) for(i=0;i<nb_struct_sort;i++)
     {
         if (strcmp(sorte,sort[i].type)==0)
         {
              j++;
              //gtk_list_store_append (p_model_sort, & iter);
              if (sort[i].add1.nom!=NULL)
              {
                  gtk_combo_box_text_append_text(GTK_COMBO_BOX_TEXT(sortie),sort[i].add1.nom);//gtk_list_store_set (p_model_sort, & iter,0, sort[i].add1.nom,-1);
                  if (liste && compare_sans_casse(liste->nom,sort[i].add1.nom)==0) choix=j;
              }
              else
              {
                  gtk_combo_box_text_append_text(GTK_COMBO_BOX_TEXT(sortie),sort[i].add2.nom);//gtk_list_store_set (p_model_sort, & iter,0, sort[i].add2.nom,-1);
                  if (liste && compare_sans_casse(liste->nom,sort[i].add2.nom)==0) choix=j;
              }
         }
     }
     gtk_combo_box_set_active (GTK_COMBO_BOX (sortie), choix);
     //g_signal_connect (G_OBJECT (p_combo_sort), "changed", G_CALLBACK (modif_sort), (gpointer) tparam);
     gtk_box_pack_start (GTK_BOX (pere), sortie, FALSE,TRUE, 0);
     param[3]=(gpointer)g_strdup(sorte);
     param[1]=(gpointer)sortie;
     param[2]=(gpointer)malloc(sizeof(unsigned short));
     param[0]=(gpointer)sort;
     ((unsigned short **)param)[2][0]=nb_struct_sort;

     return sortie;
}

GtkWidget * feuille_aff_save(GtkWidget * pere,struct sv_add * liste,struct_save * save,unsigned short nb_struct_save)
{
    GtkWidget * sortie=gtk_combo_box_text_new(), * vbox=gtk_hbox_new(FALSE, 6);; //gtk_combo_box_new_with_model (GTK_TREE_MODEL (p_model_save));
    GtkWidget *label;
    unsigned short i,choix=0,j=0;
    gpointer * param=(gpointer *)malloc(3*sizeof(gpointer));


     gtk_box_pack_start (GTK_BOX (pere), vbox, FALSE,TRUE, 0);

    label=gtk_button_new_with_label("Save : ");

     g_signal_connect (G_OBJECT (label), "clicked", G_CALLBACK (affiche_save), (gpointer) param);
     gtk_box_pack_start (GTK_BOX (vbox), label, FALSE,TRUE, 0);
     gtk_combo_box_text_append_text(GTK_COMBO_BOX_TEXT(sortie),"--------------");//gtk_list_store_set (p_model_save, & iter,0,"--------",-1);
     for(i=0;i<nb_struct_save;i++)
     {
          j++;
          if (save[i].add1.nom!=NULL)
          {
              gtk_combo_box_text_append_text(GTK_COMBO_BOX_TEXT(sortie),save[i].add1.nom);//gtk_list_store_set (p_model_save, & iter,0, save[i].add1.nom,-1);
              if (liste && compare_sans_casse(liste->nom,save[i].add1.nom)==0) choix=j;
          }
          else
          {
              gtk_combo_box_text_append_text(GTK_COMBO_BOX_TEXT(sortie),save[i].add2.nom);//gtk_list_store_set (p_model_save, & iter,0, save[i].add2.nom,-1);
              if (liste && compare_sans_casse(liste->nom,save[i].add2.nom)==0) choix=j;
          }
     }
     gtk_combo_box_set_active (GTK_COMBO_BOX (sortie), choix);
     gtk_box_pack_start (GTK_BOX (vbox), sortie, FALSE,TRUE, 0);
     param[1]=(gpointer)sortie;
     param[2]=(gpointer)malloc(sizeof(unsigned short));
     param[0]=(gpointer)save;
     ((unsigned short **)param)[2][0]=nb_struct_save;

     return sortie;
}

GtkWidget ** feuille_aff_race_save(GtkWidget * pere,char ** ch)
{
    GtkWidget ** sortie=(GtkWidget **)malloc(5*sizeof(GtkWidget *));
    GtkWidget * hbox, *vbox, * label;
    gint i;

    hbox=gtk_hbox_new(FALSE, 6);
    gtk_box_pack_start(GTK_BOX(pere), hbox, TRUE, TRUE, 0);
    for(i=0;i<5;i++)
    {
        vbox=gtk_vbox_new(FALSE, 6);
        gtk_box_pack_start(GTK_BOX(hbox), vbox, TRUE, TRUE, 0);
        sortie[i]=gtk_entry_new();
        switch (i)
        {
            case 0 : label=gtk_label_new("pmp" );break;
            case 1 : label=gtk_label_new("pp"  );break;
            case 2 : label=gtk_label_new("bbm" );break;
            case 3 : label=gtk_label_new("sou" );break;
            case 4 : label=gtk_label_new("sort");break;
            default : printf("ERREUR");
        }
        gtk_box_pack_start(GTK_BOX(vbox), label, TRUE, TRUE, 0);
        sortie[i]=gtk_entry_new();
        if (ch[i]!=NULL)
            gtk_entry_set_text(GTK_ENTRY(sortie[i]),ch[i]);
        gtk_entry_set_width_chars(GTK_ENTRY(sortie[i]),5);
        gtk_box_pack_start(GTK_BOX(vbox), sortie[i], TRUE, TRUE, 0);;
    }

    return sortie;
}


void feuille_aff_alignement(GtkWidget * pere,unsigned short alignement, GtkWidget ** info)
{
    GtkWidget * hbox, *label;

    hbox=gtk_hbox_new(FALSE, 6);
    gtk_box_pack_start(GTK_BOX(pere), hbox, TRUE, TRUE, 0);
    label=gtk_label_new("ALIGNEMENT ");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);

    info[0]=gtk_check_button_new_with_label("BL");
    gtk_box_pack_start(GTK_BOX(hbox), info[0], TRUE, TRUE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(info[0]),alignement&BL);
    info[1]=gtk_check_button_new_with_label("BN");
    gtk_box_pack_start(GTK_BOX(hbox), info[1], TRUE, TRUE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(info[1]),alignement&BN);
    info[2]=gtk_check_button_new_with_label("BC");
    gtk_box_pack_start(GTK_BOX(hbox), info[2], TRUE, TRUE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(info[2]),alignement&BC);
    info[3]=gtk_check_button_new_with_label("NL");
    gtk_box_pack_start(GTK_BOX(hbox), info[3], TRUE, TRUE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(info[3]),alignement&NL);
    info[4]=gtk_check_button_new_with_label("NN");
    gtk_box_pack_start(GTK_BOX(hbox), info[4], TRUE, TRUE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(info[4]),alignement&NN);
    info[5]=gtk_check_button_new_with_label("NC");
    gtk_box_pack_start(GTK_BOX(hbox), info[5], TRUE, TRUE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(info[5]),alignement&NC);
    info[6]=gtk_check_button_new_with_label("ML");
    gtk_box_pack_start(GTK_BOX(hbox), info[6], TRUE, TRUE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(info[6]),alignement&ML);
    info[7]=gtk_check_button_new_with_label("MN");
    gtk_box_pack_start(GTK_BOX(hbox), info[7], TRUE, TRUE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(info[7]),alignement&MN);
    info[8]=gtk_check_button_new_with_label("MC");
    gtk_box_pack_start(GTK_BOX(hbox), info[8], TRUE, TRUE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(info[8]),alignement&MC);
}

/* un pointeur sur la classe + le nom du fichier de travail */
void retourne_classe(struct_classe * classe, char * fichier, gpointer param)
{
    GMarkupDomNode * node,* ooo;
    char * tmp, *tmp1;

    if (classe->add1.nom!=NULL)
    {
        free(classe->add1.nom);
        classe->add1.nom=NULL;
    }
    if (classe->add2.nom!=NULL)
    {
        free(classe->add2.nom);
        classe->add2.nom=NULL;
    }

    if ((ooo = g_markup_dom_new (fichier, NULL)))
    {
        if ((node=g_markup_dom_nom (ooo,"ADD1","table:name")))
        { /* sinon, la version ADD1 de la classe n'existe pas */
            if ((tmp=lecture_case(FEUILLE_NOM,node)))
            {
                classe->add1.nom=g_strdup(tmp);
                classe->add1.min_f =feuille_lire_case_m(FEUILLE_MIN_F_H ,node,0);
                classe->add1.min_i =feuille_lire_case_m(FEUILLE_MIN_I_H ,node,0);
                classe->add1.min_s =feuille_lire_case_m(FEUILLE_MIN_S_H ,node,0);
                classe->add1.min_d =feuille_lire_case_m(FEUILLE_MIN_D_H ,node,0);
                classe->add1.min_co=feuille_lire_case_m(FEUILLE_MIN_Co_H,node,0);
                classe->add1.min_ch=feuille_lire_case_m(FEUILLE_MIN_Ch_H,node,0);
                classe->add1.max_f =feuille_lire_case_m(FEUILLE_MAX_F_H ,node,25);
                classe->add1.max_i =feuille_lire_case_m(FEUILLE_MAX_I_H ,node,25);
                classe->add1.max_s =feuille_lire_case_m(FEUILLE_MAX_S_H ,node,25);
                classe->add1.max_d =feuille_lire_case_m(FEUILLE_MAX_D_H ,node,25);
                classe->add1.max_co=feuille_lire_case_m(FEUILLE_MAX_Co_H,node,25);
                classe->add1.max_ch=feuille_lire_case_m(FEUILLE_MAX_Ch_H,node,25);
                classe->add1.dix_f =feuille_lire_case_m(FEUILLE_MOD_F ,node,0);
                classe->add1.dix_i =feuille_lire_case_m(FEUILLE_MOD_I ,node,0);
                classe->add1.dix_s =feuille_lire_case_m(FEUILLE_MOD_S ,node,0);
                classe->add1.dix_d =feuille_lire_case_m(FEUILLE_MOD_D ,node,0);
                classe->add1.dix_co=feuille_lire_case_m(FEUILLE_MOD_Co,node,0);
                classe->add1.dix_ch=feuille_lire_case_m(FEUILLE_MOD_Ch,node,0);

                feuille_pdv(classe->add1.pdv,node);
                classe->add1.armes=feuille_lire_ligne(FEUILLE_ARME,node);

                classe->add1.nb_arme[0]=feuille_lire_case_m(FEUILLE_MAIT_ARME_D,node,0);
                classe->add1.nb_arme[1]=feuille_lire_case_m(FEUILLE_MAIT_ARM_PE,node,0);
                classe->add1.nb_arme[2]=feuille_lire_case_m(FEUILLE_MAIT_ARM_PR,node,0);

                classe->add1.ac=feuille_lire_ligne_nb(FEUILLE_AC,node);
                classe->add1.armures=feuille_lire_ligne(FEUILLE_ARMURES,node);
                classe->add1.bouclier=feuille_lire_ligne(FEUILLE_BOUCLIER,node);
                classe->add1.special=feuille_lire_ligne(FEUILLE_SPECIAL,node);
                classe->add1.alignement=feuille_lire_alignement(node);

                classe->add1.tacO[0]=feuille_lire_ligne_nb(FEUILLE_TACO_D,node);
                classe->add1.tacO[1]=feuille_lire_ligne_nb(FEUILLE_TACO  ,node);

                classe->add1.save=lecture_case_save(FEUILLE_SAVE,param,node,ADD1);
                classe->add1.sort_mago=lecture_case_sort(FEUILLE_SORT_M,param,node,ADD1);
                classe->add1.sort_illus=lecture_case_sort(FEUILLE_SORT_M_S,param,node,ADD1);
                classe->add1.sort_clerc=lecture_case_sort(FEUILLE_SORT_C,param,node,ADD1);
                classe->add1.vade_retro=feuille_lire_case_m(FEUILLE_VADE_RETRO,node,NON);
                if (lecture_case(FEUILLE_SORT_C_B,node)!=NULL) classe->add1.bonus_clerc=*(lecture_case(FEUILLE_SORT_C_B,node));
                else                                           classe->add1.bonus_clerc=0;
                classe->add1.sort_druide=lecture_case_sort(FEUILLE_SORT_C_S,param,node,ADD1);
                if (lecture_case(FEUILLE_SORT_D_B,node)!=NULL)
                    classe->add1.bonus_druide=*(lecture_case(FEUILLE_SORT_D_B,node));
                else
                    classe->add1.bonus_druide=0;
                classe->add1.voleur=lecture_case_up(FEUILLE_VOLEUR,node);
                classe->add1.tab_voleur=feuille_lire_voleur(FEUILLE_VOL_TABLE,node);
                classe->add1.backstab=feuille_lire_ligne_nb(FEUILLE_BACK_STAB,node);
                classe->add1.XP=feuille_lire_colonne_nbl(FEUILLE_XP,node);
            }
            else classe->add1.nom=NULL;
        }
        else classe->add1.nom=NULL;
        if ((node=g_markup_dom_nom (ooo,"ADD2","table:name")))
        {
            if ((tmp=lecture_case(FEUILLE_NOM,node)))
            {
                classe->add2.nom=g_strdup(tmp);
                classe->add2.min_f =feuille_lire_case_m(FEUILLE_MIN_F_H ,node,0);
                classe->add2.min_i =feuille_lire_case_m(FEUILLE_MIN_I_H ,node,0);
                classe->add2.min_s =feuille_lire_case_m(FEUILLE_MIN_S_H ,node,0);
                classe->add2.min_d =feuille_lire_case_m(FEUILLE_MIN_D_H ,node,0);
                classe->add2.min_co=feuille_lire_case_m(FEUILLE_MIN_Co_H,node,0);
                classe->add2.min_ch=feuille_lire_case_m(FEUILLE_MIN_Ch_H,node,0);
                classe->add2.max_f =feuille_lire_case_m(FEUILLE_MAX_F_H ,node,25);
                classe->add2.max_i =feuille_lire_case_m(FEUILLE_MAX_I_H ,node,25);
                classe->add2.max_s =feuille_lire_case_m(FEUILLE_MAX_S_H ,node,25);
                classe->add2.max_d =feuille_lire_case_m(FEUILLE_MAX_D_H ,node,25);
                classe->add2.max_co=feuille_lire_case_m(FEUILLE_MAX_Co_H,node,25);
                classe->add2.max_ch=feuille_lire_case_m(FEUILLE_MAX_Ch_H,node,25);
                classe->add2.dix_f =feuille_lire_case_m(FEUILLE_MOD_F ,node,0);
                classe->add2.dix_i =feuille_lire_case_m(FEUILLE_MOD_I ,node,0);
                classe->add2.dix_s =feuille_lire_case_m(FEUILLE_MOD_S ,node,0);
                classe->add2.dix_d =feuille_lire_case_m(FEUILLE_MOD_D ,node,0);
                classe->add2.dix_co=feuille_lire_case_m(FEUILLE_MOD_Co,node,0);
                classe->add2.dix_ch=feuille_lire_case_m(FEUILLE_MOD_Ch,node,0);

                feuille_pdv(classe->add2.pdv,node);
                classe->add2.armes=feuille_lire_ligne(FEUILLE_ARME,node);

                classe->add2.nb_arme[0]=feuille_lire_case_m(FEUILLE_MAIT_ARME_D,node,0);
                classe->add2.nb_arme[1]=feuille_lire_case_m(FEUILLE_MAIT_ARM_PE,node,0);
                classe->add2.nb_arme[2]=feuille_lire_case_m(FEUILLE_MAIT_ARM_PR,node,0);

                classe->add2.ac=feuille_lire_ligne_nb(FEUILLE_AC,node);
                classe->add2.armures=feuille_lire_ligne(FEUILLE_ARMURES,node);
                classe->add2.bouclier=feuille_lire_ligne(FEUILLE_BOUCLIER,node);
                classe->add2.special=feuille_lire_ligne(FEUILLE_SPECIAL,node);
                classe->add2.alignement=feuille_lire_alignement(node);

                classe->add2.tacO[0]=feuille_lire_case_m(FEUILLE_TACO_D,node,20);
                if ((tmp1=lecture_case(FEUILLE_TACO_A,node)))
                {
                    if (sscanf(tmp1,"%hu/%hu",classe->add2.tacO+1,classe->add2.tacO+2)!=2)
                    {
                        printf("Erreur lecture TacO de %s : %s => %hu/%hu\n", tmp,tmp1,classe->add2.tacO[1],classe->add2.tacO[2]);
                        classe->add2.tacO[1]=0;
                        classe->add2.tacO[2]=1;
                    }
                }
                else /* en cas de problème de lecture : le tacO ne progresse pas */
                {
                    classe->add2.tacO[1]=0;
                    classe->add2.tacO[2]=1;
                    printf("Erreur lecture TacO de %s\n", tmp);
                }
                classe->add2.save=lecture_case_save(FEUILLE_SAVE,param,node,ADD2);
                classe->add2.sort_mago=lecture_case_sort(FEUILLE_SORT_M,param,node,ADD2);
                classe->add2.sort_mago_ecole=feuille_lire_ligne(FEUILLE_SORT_M_S,node);
                classe->add2.sort_clerc=lecture_case_sort(FEUILLE_SORT_C,param,node,ADD2);
                classe->add2.sort_clerc_sphere=feuille_lire_ligne(FEUILLE_SORT_C_S,node);
                classe->add2.vade_retro=feuille_lire_case_m(FEUILLE_VADE_RETRO,node,NON);
                if (lecture_case(FEUILLE_SORT_C_B,node)!=NULL) classe->add2.bonus_clerc=*(lecture_case(FEUILLE_SORT_C_B,node));
                else                                           classe->add2.bonus_clerc=0;
                classe->add2.voleur=lecture_case_up(FEUILLE_VOLEUR,node);
                classe->add2.tab_voleur=feuille_lire_voleur(FEUILLE_VOL_TABLE,node);
                classe->add2.backstab=feuille_lire_ligne_nb(FEUILLE_BACK_STAB,node);
                classe->add2.liste_competances=feuille_lire_ligne(FEUILLE_COMP_C1,node);
                classe->add2.progression_competances[0]=feuille_lire_case_m(FEUILLE_COMP_I ,node,0);
                classe->add2.progression_competances[1]=feuille_lire_case_m(FEUILLE_COMP_N ,node,0);

                classe->add2.XP=feuille_lire_colonne_nbl(FEUILLE_XP,node);
            }
            else classe->add2.nom=NULL;
        }
        else classe->add2.nom=NULL;
        g_markup_dom_free(ooo);
    }
    else
    {
        classe->add1.nom=NULL;
        classe->add2.nom=NULL;
    }
}

void aff_classe(GtkWidget *wid, gpointer * param_nb)
{
    struct_classe * classe=((struct_classe **)(((struct_param_nb *)param_nb)->param))[MAIN_CLASSE]+((struct_param_nb *)param_nb)->nb;
    gpointer * info=(gpointer *)malloc(200*sizeof(gpointer)) ;
    GtkWidget * vbox, *win, * onglet, *label, *hbox, * scroll;
    char * tmpo, affichage[LONG];
    GError * error;
    unsigned short i;

    win = gtk_window_new (GTK_WINDOW_TOPLEVEL); /* déclaration d'une fenêtre complète */
    gtk_window_set_position (GTK_WINDOW (win), GTK_WIN_POS_MOUSE); /* aucune position */
    gtk_container_set_border_width (GTK_CONTAINER (win), 8);
    if (classe->add1.nom)
        gtk_window_set_title (GTK_WINDOW (win),classe->add1.nom);
    else if (classe->add2.nom)
        gtk_window_set_title (GTK_WINDOW (win),classe->add2.nom);
    else return;
    gtk_widget_realize (win);
    g_signal_connect(G_OBJECT(win), "destroy", G_CALLBACK(fin_feuille), info);

    /* icone */
    tmpo=chemin_exe();
    sprintf(affichage,"%s%cfeuille.png",tmpo,SEPARATEUR);
    free(tmpo);
    if (!gtk_window_set_icon_from_file(GTK_WINDOW (win),affichage,&error))
    {                                                                  /* met une icone à la fenêtre */
        traite_erreur(error);
        g_error_free(error);
    }

    onglet = gtk_notebook_new();
    gtk_container_add(GTK_CONTAINER(win), onglet);


    //gtk_notebook_set_scrollable(GTK_NOTEBOOK(onglet), TRUE);
    /* le premier onglet ADD1*/
    vbox=gtk_vbox_new(FALSE, 6);
    label=gtk_label_new("AD&D1");

    scroll=gtk_scrolled_window_new (NULL, NULL);
    gtk_notebook_append_page(GTK_NOTEBOOK(onglet), scroll, label);
    gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scroll) ,GTK_WIDGET(vbox));
    gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scroll), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
    gtk_widget_set_size_request(scroll,700,600);
    //gtk_notebook_append_page(GTK_NOTEBOOK(onglet), vbox, label);

    if (classe->add1.nom)
    {
        feuille_aff_min_max_caract(vbox,"Force       ", classe->add1.min_f ,classe->add1.max_f ,classe->add1.dix_f ,((GtkWidget **)info)+0 ,((GtkWidget **)info)+1 ,((GtkWidget **)info)+12);
        feuille_aff_min_max_caract(vbox,"Intelligence", classe->add1.min_i ,classe->add1.max_i ,classe->add1.dix_i ,((GtkWidget **)info)+2 ,((GtkWidget **)info)+3 ,((GtkWidget **)info)+13);
        feuille_aff_min_max_caract(vbox,"Sagesse     ", classe->add1.min_s ,classe->add1.max_s ,classe->add1.dix_s ,((GtkWidget **)info)+4 ,((GtkWidget **)info)+5 ,((GtkWidget **)info)+14);
        feuille_aff_min_max_caract(vbox,"Dextérité   ", classe->add1.min_d ,classe->add1.max_d ,classe->add1.dix_d ,((GtkWidget **)info)+6 ,((GtkWidget **)info)+7 ,((GtkWidget **)info)+15);
        feuille_aff_min_max_caract(vbox,"Constitution", classe->add1.min_co,classe->add1.max_co,classe->add1.dix_co,((GtkWidget **)info)+8 ,((GtkWidget **)info)+9 ,((GtkWidget **)info)+16);
        feuille_aff_min_max_caract(vbox,"Charisme    ", classe->add1.min_ch,classe->add1.max_ch,classe->add1.dix_ch,((GtkWidget **)info)+10,((GtkWidget **)info)+11,((GtkWidget **)info)+17);
        feuille_aff_pdv(vbox,classe->add1.pdv,((GtkWidget **)info)+18); /* info pris jusqu'à  37 */
        *(((GtkWidget ***)info)+38)=feuille_aff_ligne(vbox,classe->add1.armes,"ARMES : ");
        feuille_aff_arme(vbox,classe->add1.nb_arme,((GtkWidget **)info)+39);
        *(((GtkWidget ***)info)+40)=feuille_aff_ligne(vbox,classe->add1.armures,"ARMURES : ");
        *(((GtkWidget ***)info)+41)=feuille_aff_ligne(vbox,classe->add1.bouclier,"BOUCLIERS : ");
        *(((GtkWidget ***)info)+53)=feuille_aff_ligne_nb(vbox,classe->add1.ac," AC : ");
        *(((GtkWidget ***)info)+42)=feuille_aff_ligne(vbox,classe->add1.special,"SPECIAL : ");
        feuille_aff_alignement(vbox,classe->add1.alignement,((GtkWidget **)info)+43); /* info pris jusqu'à  37 */

        *(((GtkWidget ***)info)+43)=feuille_aff_ligne_nb(vbox,classe->add1.tacO[0]," TacO : ");
        *(((GtkWidget ***)info)+44)=feuille_aff_ligne_nb(vbox,classe->add1.tacO[1],"Niveau ");

        *(((GtkWidget ** )info)+52)=feuille_aff_save(vbox,classe->add1.save ,((struct_save **)(((struct_param_nb *)param_nb)->param))[MAIN_SAVE],((unsigned short **)(((struct_param_nb *)param_nb)->param))[MAIN_NB_SAVE][0]);

        hbox=gtk_hbox_new(FALSE, 6);
        gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);
        *(((GtkWidget ** )info)+46)=feuille_aff_sort(hbox,MAGICIEN     ,classe->add1.sort_mago  ,((struct_sort **)(((struct_param_nb *)param_nb)->param))[MAIN_SORT],((unsigned short **)(((struct_param_nb *)param_nb)->param))[MAIN_NB_SORT][0]);
        *(((GtkWidget ** )info)+47)=feuille_aff_sort(hbox,ILLUSIONNISTE,classe->add1.sort_illus ,((struct_sort **)(((struct_param_nb *)param_nb)->param))[MAIN_SORT],((unsigned short **)(((struct_param_nb *)param_nb)->param))[MAIN_NB_SORT][0]);
        *(((GtkWidget ** )info)+48)=feuille_aff_sort(hbox,PRETRE       ,classe->add1.sort_clerc ,((struct_sort **)(((struct_param_nb *)param_nb)->param))[MAIN_SORT],((unsigned short **)(((struct_param_nb *)param_nb)->param))[MAIN_NB_SORT][0]);
        *(((GtkWidget ** )info)+49)=feuille_aff_sort(hbox,DRUIDE       ,classe->add1.sort_druide,((struct_sort **)(((struct_param_nb *)param_nb)->param))[MAIN_SORT],((unsigned short **)(((struct_param_nb *)param_nb)->param))[MAIN_NB_SORT][0]);

        hbox=gtk_hbox_new(FALSE, 6);
        gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);
        *(((GtkWidget ** )info)+50)=feuille_aff_1_entree(hbox,"voleur : ",classe->add1.voleur);
        if (classe->add1.voleur!=NULL)
        {
            for(i=0;classe->add1.tab_voleur[i]!=NULL;i++);
             *(((GtkWidget ****)info)+51)=(GtkWidget ***)malloc(i*sizeof(GtkWidget **));
            for(i=0;classe->add1.tab_voleur[i]!=NULL;i++)
            {
                sprintf(affichage,"Niv %2hu : ",i+1);
                ((GtkWidget ****)info)[51][i]=feuille_aff_ligne_nb(vbox,classe->add1.tab_voleur[i],affichage);
            }
        }
        *(((GtkWidget ***)info)+54)=feuille_aff_ligne_nb(vbox,classe->add1.backstab," Backstab : ");
        *(((GtkWidget ***)info)+52)=feuille_aff_ligne_nbl(vbox,classe->add1.XP," XP : ");
    }

    /* le second onglet ADD2*/
    vbox=gtk_vbox_new(FALSE, 6);
    label=gtk_label_new("AD&D2");
    scroll=gtk_scrolled_window_new (NULL, NULL);
    gtk_notebook_append_page(GTK_NOTEBOOK(onglet), scroll, label);
    gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scroll) ,GTK_WIDGET(vbox));
    gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scroll), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
//    gtk_notebook_append_page(GTK_NOTEBOOK(onglet), vbox, label);

    if (classe->add2.nom)
    {
        feuille_aff_min_max_caract(vbox,"Force       ", classe->add2.min_f ,classe->add2.max_f ,classe->add2.dix_f ,((GtkWidget **)info)+100,((GtkWidget **)info)+101,((GtkWidget **)info)+112);
        feuille_aff_min_max_caract(vbox,"Intelligence", classe->add2.min_i ,classe->add2.max_i ,classe->add2.dix_i ,((GtkWidget **)info)+102,((GtkWidget **)info)+103,((GtkWidget **)info)+113);
        feuille_aff_min_max_caract(vbox,"Sagesse     ", classe->add2.min_s ,classe->add2.max_s ,classe->add2.dix_s ,((GtkWidget **)info)+104,((GtkWidget **)info)+105,((GtkWidget **)info)+114);
        feuille_aff_min_max_caract(vbox,"Dextérité   ", classe->add2.min_d ,classe->add2.max_d ,classe->add2.dix_d ,((GtkWidget **)info)+106,((GtkWidget **)info)+107,((GtkWidget **)info)+115);
        feuille_aff_min_max_caract(vbox,"Constitution", classe->add2.min_co,classe->add2.max_co,classe->add2.dix_co,((GtkWidget **)info)+108,((GtkWidget **)info)+109,((GtkWidget **)info)+116);
        feuille_aff_min_max_caract(vbox,"Charisme    ", classe->add2.min_ch,classe->add2.max_ch,classe->add2.dix_ch,((GtkWidget **)info)+110,((GtkWidget **)info)+111,((GtkWidget **)info)+117);
        feuille_aff_pdv(vbox,classe->add2.pdv,((GtkWidget **)info)+118); /* info pris jusqu'à 137 */
        *(((GtkWidget ***)info)+138)=feuille_aff_ligne(vbox,classe->add2.armes,"ARMES : ");
        feuille_aff_arme(vbox,classe->add2.nb_arme,((GtkWidget **)info)+139); /* info pris jusqu'à  37 */
        *(((GtkWidget ***)info)+140)=feuille_aff_ligne(vbox,classe->add2.armures,"ARMURES : ");
        *(((GtkWidget ***)info)+141)=feuille_aff_ligne(vbox,classe->add2.bouclier,"BOUCLIERS : ");
        *(((GtkWidget ***)info)+142)=feuille_aff_ligne(vbox,classe->add2.special,"SPECIAL : ");
        feuille_aff_alignement(vbox,classe->add2.alignement,((GtkWidget **)info)+143); /* info pris jusqu'à  37 */
        *(((GtkWidget ***)info)+153)=feuille_aff_ligne_nb(vbox,classe->add2.ac," AC : ");

        hbox=gtk_hbox_new(FALSE, 6);
        gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);
        label=gtk_label_new("TacO");
        gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
        *(((GtkWidget ** )info)+143)=gtk_spin_button_new_with_range(0,20, 1);
        gtk_spin_button_set_value(GTK_SPIN_BUTTON(*(((GtkWidget ** )info)+143)),classe->add2.tacO[0]);
        gtk_box_pack_start(GTK_BOX(hbox),*(((GtkWidget ** )info)+143) , TRUE, TRUE, 0);
        label=gtk_label_new(" - ");
        gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
        *(((GtkWidget ** )info)+144)=gtk_spin_button_new_with_range(0,20, 1);
        gtk_spin_button_set_value(GTK_SPIN_BUTTON(*(((GtkWidget ** )info)+144)),classe->add2.tacO[1]);
        gtk_box_pack_start(GTK_BOX(hbox),*(((GtkWidget ** )info)+144) , TRUE, TRUE, 0);
        label=gtk_label_new("/");
        gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
        *(((GtkWidget ** )info)+145)=gtk_spin_button_new_with_range(0,20, 1);
        gtk_spin_button_set_value(GTK_SPIN_BUTTON(*(((GtkWidget ** )info)+145)),classe->add2.tacO[2]);
        gtk_box_pack_start(GTK_BOX(hbox),*(((GtkWidget ** )info)+145) , TRUE, TRUE, 0);

        *(((GtkWidget ** )info)+152)=feuille_aff_save(vbox,classe->add2.save ,((struct_save **)(((struct_param_nb *)param_nb)->param))[MAIN_SAVE],((unsigned short **)(((struct_param_nb *)param_nb)->param))[MAIN_NB_SAVE][0]);

        hbox=gtk_hbox_new(FALSE, 6);

        gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);
        *(((GtkWidget ** )info)+146)=feuille_aff_sort(hbox,MAGICIEN     ,classe->add2.sort_mago ,((struct_sort **)(((struct_param_nb *)param_nb)->param))[MAIN_SORT],((unsigned short **)(((struct_param_nb *)param_nb)->param))[MAIN_NB_SORT][0]);
        *(((GtkWidget *** )info)+147)=feuille_aff_ligne(hbox,classe->add2.sort_mago_ecole,"écoles : ");
        hbox=gtk_hbox_new(FALSE, 6);
        gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);
        *(((GtkWidget ** )info)+148)=feuille_aff_sort(hbox,PRETRE       ,classe->add2.sort_clerc,((struct_sort **)(((struct_param_nb *)param_nb)->param))[MAIN_SORT],((unsigned short **)(((struct_param_nb *)param_nb)->param))[MAIN_NB_SORT][0]);
        *(((GtkWidget *** )info)+149)=feuille_aff_ligne(hbox,classe->add2.sort_clerc_sphere,"sphère : ");

        hbox=gtk_hbox_new(FALSE, 6);
        gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);
        label=gtk_label_new("Compétences : ");
        gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
        *(((GtkWidget ** )info)+197)=gtk_spin_button_new_with_range(0,20, 1);
        gtk_spin_button_set_value(GTK_SPIN_BUTTON(*(((GtkWidget ** )info)+197)),classe->add2.progression_competances[0]);
        gtk_box_pack_start(GTK_BOX(hbox),*(((GtkWidget ** )info)+197) , TRUE, TRUE, 0);
        label=gtk_label_new(" + 1 tous les  ");
        gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
        *(((GtkWidget ** )info)+198)=gtk_spin_button_new_with_range(0,20, 1);
        gtk_spin_button_set_value(GTK_SPIN_BUTTON(*(((GtkWidget ** )info)+198)),classe->add2.progression_competances[1]);
        gtk_box_pack_start(GTK_BOX(hbox),*(((GtkWidget ** )info)+198) , TRUE, TRUE, 0);
        label=gtk_label_new(" niveaux.");
        gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
        *(((GtkWidget ***)info)+199)=feuille_aff_ligne(vbox,classe->add2.liste_competances,"COMPÉTANCES : ");

        hbox=gtk_hbox_new(FALSE, 6);
        gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);
        *(((GtkWidget ** )info)+150)=feuille_aff_1_entree(hbox,"voleur : ",classe->add2.voleur);
        if (classe->add2.voleur!=NULL)
        {
            if (strcmp("OK",classe->add2.voleur)==0)
            {
                for(i=0;classe->add2.tab_voleur[i]!=NULL;i++);
                 *(((GtkWidget ****)info)+151)=(GtkWidget ***)malloc(i*sizeof(GtkWidget **));
                for(i=0;classe->add2.tab_voleur[i]!=NULL;i++)
                {
                    sprintf(affichage,"Niv %2hu : ",i+1);
                    ((GtkWidget ****)info)[151][i]=feuille_aff_ligne_nb(vbox,classe->add2.tab_voleur[i],affichage);
                }
            }
            else
            {
                 *(((GtkWidget ****)info)+151)=(GtkWidget ***)malloc(2*sizeof(GtkWidget **));
                 ((GtkWidget ****)info)[151][0]=feuille_aff_ligne_nb(vbox,classe->add2.tab_voleur[0],"départ :");
                 ((GtkWidget ****)info)[151][1]=(GtkWidget **)malloc(2*sizeof(GtkWidget *));
                 hbox=gtk_hbox_new(FALSE, 6);
                 gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);
                 label=gtk_label_new("niveau 1 : ");
                 gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
                 ((GtkWidget ****)info)[151][1][0]=gtk_spin_button_new_with_range(-99, 99, 1);
                 gtk_spin_button_set_value(GTK_SPIN_BUTTON(((GtkWidget ****)info)[151][1][0]),classe->add2.tab_voleur[1][1]);
                 gtk_box_pack_start(GTK_BOX(hbox), ((GtkWidget ****)info)[151][1][0], TRUE, TRUE, 0);
                 label=gtk_label_new("suvant : ");
                 gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
                 ((GtkWidget ****)info)[151][1][1]=gtk_spin_button_new_with_range(-99, 99, 1);
                 gtk_spin_button_set_value(GTK_SPIN_BUTTON(((GtkWidget ****)info)[151][1][1]),classe->add2.tab_voleur[1][2]);
                 gtk_box_pack_start(GTK_BOX(hbox), ((GtkWidget ****)info)[151][1][1], TRUE, TRUE, 0);
            }
        }
        *(((GtkWidget ***)info)+154)=feuille_aff_ligne_nb(vbox,classe->add2.backstab," Backstab : ");
        *(((GtkWidget ***)info)+152)=feuille_aff_ligne_nbl(vbox,classe->add2.XP," XP : ");
    }

    gtk_widget_show_all (win);
    (void)wid;
}

void retourne_race(struct_race * race, char * fichier)
{
    GMarkupDomNode * node,* ooo;
    char * tmp;

    if (race->add1.nom!=NULL)
    {
        free(race->add1.nom);
        race->add1.nom=NULL;
    }
    if (race->add2.nom!=NULL)
    {
        free(race->add2.nom);
        race->add2.nom=NULL;
    }

   if ((ooo = g_markup_dom_new (fichier, NULL)))
    {
        if ((node=g_markup_dom_nom (ooo,"ADD1","table:name")))
        { /* sinon, la version ADD1 de la classe n'existe pas */
            if ((tmp=lecture_case(FEUILLE_NOM,node)))
            {
                race->add1.nom=g_strdup(tmp);

                race->add1.min_f =feuille_lire_case_m(FEUILLE_MIN_F_H ,node,0);
                race->add1.min_i =feuille_lire_case_m(FEUILLE_MIN_I_H ,node,0);
                race->add1.min_s =feuille_lire_case_m(FEUILLE_MIN_S_H ,node,0);
                race->add1.min_d =feuille_lire_case_m(FEUILLE_MIN_D_H ,node,0);
                race->add1.min_co=feuille_lire_case_m(FEUILLE_MIN_Co_H,node,0);
                race->add1.min_ch=feuille_lire_case_m(FEUILLE_MIN_Ch_H,node,0);
                race->add1.max_f =feuille_lire_case_m(FEUILLE_MAX_F_H ,node,25);
                race->add1.max_i =feuille_lire_case_m(FEUILLE_MAX_I_H ,node,25);
                race->add1.max_s =feuille_lire_case_m(FEUILLE_MAX_S_H ,node,25);
                race->add1.max_d =feuille_lire_case_m(FEUILLE_MAX_D_H ,node,25);
                race->add1.max_co=feuille_lire_case_m(FEUILLE_MAX_Co_H,node,25);
                race->add1.max_ch=feuille_lire_case_m(FEUILLE_MAX_Ch_H,node,25);
                race->add1.min_f_f =feuille_lire_case_m(FEUILLE_MIN_F_F ,node,0);
                race->add1.min_i_f =feuille_lire_case_m(FEUILLE_MIN_I_F ,node,0);
                race->add1.min_s_f =feuille_lire_case_m(FEUILLE_MIN_S_F ,node,0);
                race->add1.min_d_f =feuille_lire_case_m(FEUILLE_MIN_D_F ,node,0);
                race->add1.min_co_f=feuille_lire_case_m(FEUILLE_MIN_Co_F,node,0);
                race->add1.min_ch_f=feuille_lire_case_m(FEUILLE_MIN_Ch_F,node,0);
                race->add1.max_f_f =feuille_lire_case_m(FEUILLE_MAX_F_F ,node,25);
                race->add1.max_i_f =feuille_lire_case_m(FEUILLE_MAX_I_F ,node,25);
                race->add1.max_s_f =feuille_lire_case_m(FEUILLE_MAX_S_F ,node,25);
                race->add1.max_d_f =feuille_lire_case_m(FEUILLE_MAX_D_F ,node,25);
                race->add1.max_co_f=feuille_lire_case_m(FEUILLE_MAX_Co_F,node,25);
                race->add1.max_ch_f=feuille_lire_case_m(FEUILLE_MAX_Ch_F,node,25);
                race->add1.modif_f =feuille_lire_case_m(FEUILLE_MOD_F ,node,0);
                race->add1.modif_i =feuille_lire_case_m(FEUILLE_MOD_I ,node,0);
                race->add1.modif_s =feuille_lire_case_m(FEUILLE_MOD_S ,node,0);
                race->add1.modif_d =feuille_lire_case_m(FEUILLE_MOD_D ,node,0);
                race->add1.modif_co=feuille_lire_case_m(FEUILLE_MOD_Co,node,0);
                race->add1.modif_ch=feuille_lire_case_m(FEUILLE_MOD_Ch,node,0);

                race->add1.liste_classe=feuille_lire_classe_race(FEUILLE_CLASSE,node);
                race->add1.tranche_age=feuille_lire_ligne_nb(FEUILLE_TRANCH_AGE1,node);
                if ((tmp=lecture_case(FEUILLE_VISION,node)))        race->add1.vision=g_strdup(tmp);
                else                                                race->add1.vision=NULL;
                if ((tmp=lecture_case(FEUILLE_ECOUTE,node)))        race->add1.ecoute=g_strdup(tmp);
                else                                                race->add1.ecoute=NULL;
                if ((tmp=lecture_case(FEUILLE_RESISTANCE,node)))    race->add1.resistance=g_strdup(tmp);
                else                                                race->add1.resistance=NULL;
                race->add1.bonus_arme=feuille_lire_race_b_arme(FEUILLE_BONUS_ARME,node);
                feuille_lire_race_save(FEUILLE_SAVE_RACE,race->add1.save,node);
                race->add1.langue=feuille_lire_ligne(FEUILLE_LANGUE,node);
                race->add1.detection=feuille_lire_ligne(FEUILLE_DETECTION,node);
                race->add1.tab_voleur=feuille_lire_voleur(FEUILLE_VOL_TABLE,node);
                if ((tmp=lecture_case(FEUILLE_SURPRENDRE,node)))        race->add1.surprendre=g_strdup(tmp);
                else                                                    race->add1.surprendre=NULL;
                if ((tmp=lecture_case(FEUILLE_SE_FAIRE_SU,node)))       race->add1.sefairesurprendre=g_strdup(tmp);
                else                                                    race->add1.sefairesurprendre=NULL;
            }
            else race->add1.nom=NULL;
        }
        else race->add1.nom=NULL;
        if ((node=g_markup_dom_nom (ooo,"ADD2","table:name")))
        { /* sinon, la version ADD1 de la classe n'existe pas */
            if ((tmp=lecture_case(FEUILLE_NOM,node)))
            {
                race->add2.nom=g_strdup(tmp);

                race->add2.min_f =feuille_lire_case_m(FEUILLE_MIN_F_H ,node,0);
                race->add2.min_i =feuille_lire_case_m(FEUILLE_MIN_I_H ,node,0);
                race->add2.min_s =feuille_lire_case_m(FEUILLE_MIN_S_H ,node,0);
                race->add2.min_d =feuille_lire_case_m(FEUILLE_MIN_D_H ,node,0);
                race->add2.min_co=feuille_lire_case_m(FEUILLE_MIN_Co_H,node,0);
                race->add2.min_ch=feuille_lire_case_m(FEUILLE_MIN_Ch_H,node,0);
                race->add2.max_f =feuille_lire_case_m(FEUILLE_MAX_F_H ,node,25);
                race->add2.max_i =feuille_lire_case_m(FEUILLE_MAX_I_H ,node,25);
                race->add2.max_s =feuille_lire_case_m(FEUILLE_MAX_S_H ,node,25);
                race->add2.max_d =feuille_lire_case_m(FEUILLE_MAX_D_H ,node,25);
                race->add2.max_co=feuille_lire_case_m(FEUILLE_MAX_Co_H,node,25);
                race->add2.max_ch=feuille_lire_case_m(FEUILLE_MAX_Ch_H,node,25);
                race->add2.min_f_f =feuille_lire_case_m(FEUILLE_MIN_F_F ,node,0);
                race->add2.min_i_f =feuille_lire_case_m(FEUILLE_MIN_I_F ,node,0);
                race->add2.min_s_f =feuille_lire_case_m(FEUILLE_MIN_S_F ,node,0);
                race->add2.min_d_f =feuille_lire_case_m(FEUILLE_MIN_D_F ,node,0);
                race->add2.min_co_f=feuille_lire_case_m(FEUILLE_MIN_Co_F,node,0);
                race->add2.min_ch_f=feuille_lire_case_m(FEUILLE_MIN_Ch_F,node,0);
                race->add2.max_f_f =feuille_lire_case_m(FEUILLE_MAX_F_F ,node,25);
                race->add2.max_i_f =feuille_lire_case_m(FEUILLE_MAX_I_F ,node,25);
                race->add2.max_s_f =feuille_lire_case_m(FEUILLE_MAX_S_F ,node,25);
                race->add2.max_d_f =feuille_lire_case_m(FEUILLE_MAX_D_F ,node,25);
                race->add2.max_co_f=feuille_lire_case_m(FEUILLE_MAX_Co_F,node,25);
                race->add2.max_ch_f=feuille_lire_case_m(FEUILLE_MAX_Ch_F,node,25);
                race->add2.modif_f =feuille_lire_case_m(FEUILLE_MOD_F ,node,0);
                race->add2.modif_i =feuille_lire_case_m(FEUILLE_MOD_I ,node,0);
                race->add2.modif_s =feuille_lire_case_m(FEUILLE_MOD_S ,node,0);
                race->add2.modif_d =feuille_lire_case_m(FEUILLE_MOD_D ,node,0);
                race->add2.modif_co=feuille_lire_case_m(FEUILLE_MOD_Co,node,0);
                race->add2.modif_ch=feuille_lire_case_m(FEUILLE_MOD_Ch,node,0);

                race->add2.liste_classe=feuille_lire_classe_race(FEUILLE_CLASSE,node);
                race->add2.tranche_age=feuille_lire_ligne_nb(FEUILLE_TRANCH_AGE2,node);
                if ((tmp=lecture_case(FEUILLE_VISION,node)))        race->add2.vision=g_strdup(tmp);
                else                                                race->add2.vision=NULL;
                if ((tmp=lecture_case(FEUILLE_ECOUTE,node)))        race->add2.ecoute=g_strdup(tmp);
                else                                                race->add2.ecoute=NULL;
                if ((tmp=lecture_case(FEUILLE_RESISTANCE,node)))    race->add2.resistance=g_strdup(tmp);
                else                                                race->add2.resistance=NULL;
                race->add2.bonus_arme=feuille_lire_race_b_arme(FEUILLE_BONUS_ARME,node);
                race->add2.bonus_arme=feuille_lire_race_b_arme(FEUILLE_BONUS_ARME,node);
                feuille_lire_race_save(FEUILLE_SAVE_RACE,race->add2.save,node);
                race->add2.langue=feuille_lire_ligne(FEUILLE_LANGUE,node);
                race->add2.detection=feuille_lire_ligne(FEUILLE_DETECTION,node);
                race->add2.tab_voleur=feuille_lire_voleur(FEUILLE_VOL_TABLE,node);
                if ((tmp=lecture_case(FEUILLE_SURPRENDRE,node)))        race->add2.surprendre=g_strdup(tmp);
                else                                                    race->add2.surprendre=NULL;
                if ((tmp=lecture_case(FEUILLE_SE_FAIRE_SU,node)))       race->add2.sefairesurprendre=g_strdup(tmp);
                else                                                    race->add2.sefairesurprendre=NULL;
                race->add2.competence=feuille_lire_ligne(FEUILLE_RACE_COMP,node);


            }
            else race->add2.nom=NULL;
        }
        else race->add2.nom=NULL;
        g_markup_dom_free(ooo);
    }
    else
    {
        race->add1.nom=NULL;
        race->add2.nom=NULL;
    }
}

void aff_race(GtkWidget *wid, gpointer * param_nb)
{
    struct_race * race=((struct_race **)(((struct_param_nb *)param_nb)->param))[MAIN_RACE]+((struct_param_nb *)param_nb)->nb;

    gpointer * info=(gpointer *)malloc(200*sizeof(gpointer)) ;
    GtkWidget * vbox, *win, * onglet, *label, * hbox, * vbox1, * scroll;
    char * tmpo, affichage[LONG];
    GError * error;

    win = gtk_window_new (GTK_WINDOW_TOPLEVEL); /* déclaration d'une fenêtre complète */
    gtk_window_set_position (GTK_WINDOW (win), GTK_WIN_POS_MOUSE); /* aucune position */
    gtk_container_set_border_width (GTK_CONTAINER (win), 8);
    if (race->add1.nom)
        gtk_window_set_title (GTK_WINDOW (win),race->add1.nom);
    else if (race->add2.nom)
        gtk_window_set_title (GTK_WINDOW (win),race->add2.nom);
    else return;
    gtk_window_set_position (GTK_WINDOW (win), GTK_WIN_POS_NONE);
    gtk_widget_realize (win);
    g_signal_connect(G_OBJECT(win), "destroy", G_CALLBACK(fin_feuille), info);

    /* icone */
    tmpo=chemin_exe();
    sprintf(affichage,"%s%cfeuille.png",tmpo,SEPARATEUR);
    free(tmpo);
    if (!gtk_window_set_icon_from_file(GTK_WINDOW (win),affichage,&error))
    {                                                                  /* met une icone à la fenêtre */
        traite_erreur(error);
        g_error_free(error);
    }

    onglet = gtk_notebook_new();
    gtk_container_add(GTK_CONTAINER(win), onglet);

    gtk_notebook_set_scrollable(GTK_NOTEBOOK(onglet), TRUE);
    /* le premier onglet ADD1*/
    vbox=gtk_vbox_new(FALSE, 6);
    label=gtk_label_new("AD&D1");

    scroll=gtk_scrolled_window_new (NULL, NULL);
    gtk_notebook_append_page(GTK_NOTEBOOK(onglet), scroll, label);
    gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scroll) ,GTK_WIDGET(vbox));
    gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scroll), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
    gtk_widget_set_size_request(scroll,700,700);
    if (race->add1.nom)
    {
        hbox=gtk_hbox_new(FALSE, 6);
        gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);
        vbox1=gtk_vbox_new(FALSE, 6);
        gtk_box_pack_start(GTK_BOX(hbox), vbox1, TRUE, TRUE, 0);

        label=gtk_label_new("Homme");
        gtk_box_pack_start(GTK_BOX(vbox1), label, TRUE, TRUE, 0);
        feuille_aff_min_max_caract(vbox1,"Force       ", race->add1.min_f ,race->add1.max_f ,race->add1.modif_f ,((GtkWidget **)info)+  0,((GtkWidget **)info)+  1,((GtkWidget **)info)+ 12);
        feuille_aff_min_max_caract(vbox1,"Intelligence", race->add1.min_i ,race->add1.max_i ,race->add1.modif_i ,((GtkWidget **)info)+  2,((GtkWidget **)info)+  3,((GtkWidget **)info)+ 13);
        feuille_aff_min_max_caract(vbox1,"Sagesse     ", race->add1.min_s ,race->add1.max_s ,race->add1.modif_s ,((GtkWidget **)info)+  4,((GtkWidget **)info)+  5,((GtkWidget **)info)+ 14);
        feuille_aff_min_max_caract(vbox1,"Dextérité   ", race->add1.min_d ,race->add1.max_d ,race->add1.modif_d ,((GtkWidget **)info)+  6,((GtkWidget **)info)+  7,((GtkWidget **)info)+ 15);
        feuille_aff_min_max_caract(vbox1,"Constitution", race->add1.min_co,race->add1.max_co,race->add1.modif_co,((GtkWidget **)info)+  8,((GtkWidget **)info)+  9,((GtkWidget **)info)+ 16);
        feuille_aff_min_max_caract(vbox1,"Charisme    ", race->add1.min_ch,race->add1.max_ch,race->add1.modif_ch,((GtkWidget **)info)+ 10,((GtkWidget **)info)+ 11,((GtkWidget **)info)+ 17);

        vbox1=gtk_vbox_new(FALSE, 6);
        gtk_box_pack_start(GTK_BOX(hbox), vbox1, TRUE, TRUE, 0);
        label=gtk_label_new("Femme");
        gtk_box_pack_start(GTK_BOX(vbox1), label, TRUE, TRUE, 0);
        feuille_aff_min_max_caract(vbox1,"Force       ", race->add1.min_f_f ,race->add1.max_f_f ,TROP,((GtkWidget **)info)+ 18,((GtkWidget **)info)+ 19,NULL);
        feuille_aff_min_max_caract(vbox1,"Intelligence", race->add1.min_i_f ,race->add1.max_i_f ,TROP,((GtkWidget **)info)+ 20,((GtkWidget **)info)+ 21,NULL);
        feuille_aff_min_max_caract(vbox1,"Sagesse     ", race->add1.min_s_f ,race->add1.max_s_f ,TROP,((GtkWidget **)info)+ 22,((GtkWidget **)info)+ 23,NULL);
        feuille_aff_min_max_caract(vbox1,"Dextérité   ", race->add1.min_d_f ,race->add1.max_d_f ,TROP,((GtkWidget **)info)+ 24,((GtkWidget **)info)+ 25,NULL);
        feuille_aff_min_max_caract(vbox1,"Constitution", race->add1.min_co_f,race->add1.max_co_f,TROP,((GtkWidget **)info)+ 26,((GtkWidget **)info)+ 27,NULL);
        feuille_aff_min_max_caract(vbox1,"Charisme    ", race->add1.min_ch_f,race->add1.max_ch_f,TROP,((GtkWidget **)info)+ 28,((GtkWidget **)info)+ 29,NULL);

        *(((GtkWidget ****)info)+30)=feuille_aff_liste_classe(vbox,race->add1.liste_classe);
        *(((GtkWidget ***)info)+32)=feuille_aff_ligne_nb(vbox,race->add1.tranche_age,"TRANCHE D'ÂGE : ");

        hbox=gtk_hbox_new(FALSE, 6);
        gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);
        *(((GtkWidget ** )info)+33)=feuille_aff_1_entree(hbox,"Vision",race->add1.vision);
        *(((GtkWidget ** )info)+152)=feuille_aff_1_entree(hbox,"Écoute",race->add1.ecoute);
        *(((GtkWidget ** )info)+34)=feuille_aff_1_entree(hbox,"Résistance",race->add1.resistance);

        *(((GtkWidget ***)info)+35)=feuille_aff_race_arme(vbox,race->add1.bonus_arme);
        *(((GtkWidget ***)info)+36)=feuille_aff_race_save(vbox,race->add1.save);
        *(((GtkWidget ***)info)+37)=feuille_aff_ligne(vbox,race->add1.langue,"LANGUES : ");
        *(((GtkWidget ***)info)+38)=feuille_aff_ligne(vbox,race->add1.detection,"DÉTECTION : ");
        hbox=gtk_hbox_new(FALSE, 6);
        gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);
        *(((GtkWidget ** )info)+39)=feuille_aff_1_entree(hbox,"Surprendre",race->add1.surprendre);
        *(((GtkWidget ** )info)+40)=feuille_aff_1_entree(hbox,"Se faire surprendre",race->add1.sefairesurprendre);
        *(((GtkWidget ***)info)+51)=feuille_aff_ligne_nb(vbox,race->add1.tab_voleur[0],"Voleur :");
    }
    /* le second onglet ADD2*/
    vbox=gtk_vbox_new(FALSE, 6);
    label=gtk_label_new("AD&D2");
    scroll=gtk_scrolled_window_new (NULL, NULL);
    gtk_notebook_append_page(GTK_NOTEBOOK(onglet), scroll, label);
    gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scroll) ,GTK_WIDGET(vbox));
    gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scroll), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);

    if (race->add2.nom)
    {
        hbox=gtk_hbox_new(FALSE, 6);
        gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);
        vbox1=gtk_vbox_new(FALSE, 6);
        gtk_box_pack_start(GTK_BOX(hbox), vbox1, TRUE, TRUE, 0);

        label=gtk_label_new("Homme");
        gtk_box_pack_start(GTK_BOX(vbox1), label, TRUE, TRUE, 0);
        feuille_aff_min_max_caract(vbox1,"Force       ", race->add2.min_f ,race->add2.max_f ,race->add2.modif_f ,((GtkWidget **)info)+100,((GtkWidget **)info)+101,((GtkWidget **)info)+112);
        feuille_aff_min_max_caract(vbox1,"Intelligence", race->add2.min_i ,race->add2.max_i ,race->add2.modif_i ,((GtkWidget **)info)+102,((GtkWidget **)info)+103,((GtkWidget **)info)+113);
        feuille_aff_min_max_caract(vbox1,"Sagesse     ", race->add2.min_s ,race->add2.max_s ,race->add2.modif_s ,((GtkWidget **)info)+104,((GtkWidget **)info)+105,((GtkWidget **)info)+114);
        feuille_aff_min_max_caract(vbox1,"Dextérité   ", race->add2.min_d ,race->add2.max_d ,race->add2.modif_d ,((GtkWidget **)info)+106,((GtkWidget **)info)+107,((GtkWidget **)info)+115);
        feuille_aff_min_max_caract(vbox1,"Constitution", race->add2.min_co,race->add2.max_co,race->add2.modif_co,((GtkWidget **)info)+108,((GtkWidget **)info)+109,((GtkWidget **)info)+116);
        feuille_aff_min_max_caract(vbox1,"Charisme    ", race->add2.min_ch,race->add2.max_ch,race->add2.modif_ch,((GtkWidget **)info)+110,((GtkWidget **)info)+111,((GtkWidget **)info)+117);

        vbox1=gtk_vbox_new(FALSE, 6);
        gtk_box_pack_start(GTK_BOX(hbox), vbox1, TRUE, TRUE, 0);
        label=gtk_label_new("Femme");
        gtk_box_pack_start(GTK_BOX(vbox1), label, TRUE, TRUE, 0);
        feuille_aff_min_max_caract(vbox1,"Force       ", race->add2.min_f_f ,race->add2.max_f_f ,TROP,((GtkWidget **)info)+118,((GtkWidget **)info)+119,NULL);
        feuille_aff_min_max_caract(vbox1,"Intelligence", race->add2.min_i_f ,race->add2.max_i_f ,TROP,((GtkWidget **)info)+120,((GtkWidget **)info)+121,NULL);
        feuille_aff_min_max_caract(vbox1,"Sagesse     ", race->add2.min_s_f ,race->add2.max_s_f ,TROP,((GtkWidget **)info)+122,((GtkWidget **)info)+123,NULL);
        feuille_aff_min_max_caract(vbox1,"Dextérité   ", race->add2.min_d_f ,race->add2.max_d_f ,TROP,((GtkWidget **)info)+124,((GtkWidget **)info)+125,NULL);
        feuille_aff_min_max_caract(vbox1,"Constitution", race->add2.min_co_f,race->add2.max_co_f,TROP,((GtkWidget **)info)+126,((GtkWidget **)info)+127,NULL);
        feuille_aff_min_max_caract(vbox1,"Charisme    ", race->add2.min_ch_f,race->add2.max_ch_f,TROP,((GtkWidget **)info)+128,((GtkWidget **)info)+129,NULL);

        *(((GtkWidget ****)info)+130)=feuille_aff_liste_classe(vbox,race->add2.liste_classe);
        *(((GtkWidget ***)info)+132)=feuille_aff_ligne_nb(vbox,race->add2.tranche_age,"TRANCHE D'ÂGE : ");

        *(((GtkWidget ** )info)+133)=feuille_aff_1_entree(vbox,"Vision",race->add2.vision);
        *(((GtkWidget ** )info)+134)=feuille_aff_1_entree(vbox,"Résistance",race->add2.resistance);
        *(((GtkWidget ***)info)+135)=feuille_aff_race_arme(vbox,race->add2.bonus_arme);

        hbox=gtk_hbox_new(FALSE, 6);
        gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);
        *(((GtkWidget ** )info)+133)=feuille_aff_1_entree(hbox,"Vision",race->add2.vision);
        *(((GtkWidget ** )info)+152)=feuille_aff_1_entree(hbox,"Écoute",race->add2.ecoute);
        *(((GtkWidget ** )info)+134)=feuille_aff_1_entree(hbox,"Résistance",race->add2.resistance);

        *(((GtkWidget ***)info)+135)=feuille_aff_race_arme(vbox,race->add2.bonus_arme);
        *(((GtkWidget ***)info)+136)=feuille_aff_race_save(vbox,race->add2.save);
        *(((GtkWidget ***)info)+137)=feuille_aff_ligne(vbox,race->add2.langue,"LANGUES : ");
        *(((GtkWidget ***)info)+138)=feuille_aff_ligne(vbox,race->add2.detection,"DÉTECTION : ");
        hbox=gtk_hbox_new(FALSE, 6);
        gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);
        *(((GtkWidget ** )info)+139)=feuille_aff_1_entree(hbox,"Surprendre",race->add2.surprendre);
        *(((GtkWidget ** )info)+140)=feuille_aff_1_entree(hbox,"Se faire surprendre",race->add2.sefairesurprendre);
        *(((GtkWidget ***)info)+141)=feuille_aff_ligne(vbox,race->add2.competence,"Competences : ");
        *(((GtkWidget ***)info)+151)=feuille_aff_ligne_nb(vbox,race->add2.tab_voleur[0],"Voleur :");
    }
    gtk_widget_show_all (win);
    (void) wid;
}


void retourne_save(struct_save * save, char * fichier)
{
    GMarkupDomNode * node,* ooo,* node_t;
    char * tmp;
    unsigned short i,j;
    signed short dpt;

    if ((ooo = g_markup_dom_new (fichier, NULL)))
    {
        if (save->add1.save!=NULL)
        {
            free(save->add1.save);
            save->add1.save=NULL;
        }
        if (save->add2.save!=NULL)
        {
            free(save->add2.save);
            save->add2.save=NULL;
        }
        if (save->add1.nom!=NULL)
        {
            free(save->add1.nom);
            save->add1.nom=NULL;
        }
        if (save->add2.nom!=NULL)
        {
            free(save->add2.nom);
            save->add2.nom=NULL;
        }
        if ((node=g_markup_dom_nom (ooo,"ADD1","table:name")))
        { /* sinon, la version ADD1 de la classe n'existe pas */
            if ((tmp=lecture_case(FEUILLE_NOM,node)))
            {
                save->add1.nom=g_strdup(tmp);
                i=1;
                dpt=feuille_lire_case_m(FEUILLE_DEPART_SAVE ,node,-1);
                if (dpt==-1) /* la case est vide : un gros problème */
                    return;
                if (dpt==0) i++; /* pour le cas du guerrier 0 qui est en fait un perso sans classe */
                while(donne_case_ij(i,0,node)!=NULL)
                {
                    save->add1.save=(unsigned short **)realloc(save->add1.save,(i+dpt-1)*sizeof(unsigned short *));
                    save->add1.save[i+dpt-2]=(unsigned short *)malloc(5*sizeof(unsigned short ));
                    for(j=1;j<=5;j++)
                    {
                        node_t=donne_case_ij(i,j,node);
                        if (node_t!=NULL && node_t->texte!=0 && sscanf(node_t->content->texte,"%hu",save->add1.save[i+dpt-2]+j-1)==0)
                          save->add1.save[i+dpt-2][j-1]=0;
                    }
                    i++;
                }
                save->add1.save=(unsigned short **)realloc(save->add1.save,(i+dpt-1)*sizeof(unsigned short *));
                save->add1.save[i+dpt-2]=NULL;
            }
            else save->add1.nom=NULL;
        }
        else save->add1.nom=NULL;
        if ((node=g_markup_dom_nom (ooo,"ADD2","table:name")))
        { /* sinon, la version ADD1 de la classe n'existe pas */
            if ((tmp=lecture_case(FEUILLE_NOM,node)))
            {
                save->add2.nom=g_strdup(tmp);
                i=1;
                dpt=feuille_lire_case_m(FEUILLE_DEPART_SAVE ,node,-1);
                if (dpt==-1) /* la case est vide : un gros problème */
                    return;
                if (dpt==0) i++; /* pour le cas du guerrier 0 qui est en fait un perso sans classe */
                while(donne_case_ij(i,0,node)!=NULL)
                {
                    save->add2.save=(unsigned short **)realloc(save->add2.save,(i+dpt-1)*sizeof(unsigned short *));
                    save->add2.save[i+dpt-2]=(unsigned short *)malloc(5*sizeof(unsigned short ));
                    for(j=1;j<=5;j++)
                    {
                        node_t=donne_case_ij(i,j,node);
                        if (node_t!=NULL && node_t->texte!=0 && sscanf(node_t->content->texte,"%hu",save->add2.save[i+dpt-2]+j-1)==0)
                          save->add2.save[i+dpt-2][j-1]=0;
                    }
                    i++;
                }
                save->add2.save=(unsigned short **)realloc(save->add2.save,(i+dpt-1)*sizeof(unsigned short *));
                save->add2.save[i+dpt-2]=NULL;

            }
            else save->add2.nom=NULL;
        }
        else save->add2.nom=NULL;
        g_markup_dom_free(ooo);
    }
    else
    {
        save->add1.nom=NULL;
        save->add2.nom=NULL;
    }
}

void  affiche_save(GtkWidget *wid, gpointer * param)
{
    gpointer * info=(gpointer *)malloc(200*sizeof(gpointer)) ;
    GtkWidget * vbox, *win, * onglet, *label, * hbox, * sortie;
    char * tmpo, affichage[LONG];
    GError * error;
    unsigned short i,j;
    struct_save * save;

    char * choix=gtk_combo_box_text_get_active_text(GTK_COMBO_BOX_TEXT(((GtkWidget **)param)[1]));

    for(i=0;i<((unsigned short **)param)[2][0] && !((compare_sans_casse(choix,((struct_save **)param)[0][i].add1.nom)==0) ||( compare_sans_casse(choix,((struct_save **)param)[0][i].add2.nom)==0));i++);
    if (i>=((unsigned short **)param)[2][0]) return;
    save=((struct_save **)param)[0]+i;

    win = gtk_window_new (GTK_WINDOW_TOPLEVEL); /* déclaration d'une fenêtre complète */
    gtk_window_set_position (GTK_WINDOW (win), GTK_WIN_POS_MOUSE); /* aucune position */
    gtk_container_set_border_width (GTK_CONTAINER (win), 8);
    if (save->add1.nom)
        gtk_window_set_title (GTK_WINDOW (win),save->add1.nom);
    else if (save->add2.nom)
        gtk_window_set_title (GTK_WINDOW (win),save->add2.nom);
    else return;
    gtk_window_set_position (GTK_WINDOW (win), GTK_WIN_POS_NONE);
    gtk_widget_realize (win);
    g_signal_connect(G_OBJECT(win), "destroy", G_CALLBACK(fin_feuille), info);

    /* icone */
    tmpo=chemin_exe();
    sprintf(affichage,"%s%cfeuille.png",tmpo,SEPARATEUR);
    free(tmpo);
    if (!gtk_window_set_icon_from_file(GTK_WINDOW (win),affichage,&error))
    {                                                                  /* met une icone à la fenêtre */
        traite_erreur(error);
        g_error_free(error);
    }

    onglet = gtk_notebook_new();
    gtk_container_add(GTK_CONTAINER(win), onglet);

    gtk_notebook_set_scrollable(GTK_NOTEBOOK(onglet), TRUE);
    /* le premier onglet ADD1*/
    vbox=gtk_vbox_new(FALSE, 6);
    label=gtk_label_new("AD&D1");
    gtk_notebook_append_page(GTK_NOTEBOOK(onglet), vbox, label);
    if (save->add1.nom)
    {
        if (save->add1.save!=NULL)
        {
            for(i=0;save->add1.save[i]!=NULL;i++)
            {
                hbox=gtk_hbox_new(FALSE, 6);
                gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);
                sprintf(affichage,"niveau : %hu",i+1);
                label=gtk_label_new(affichage);
                gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
                for(j=0;j<5;j++)
                {
                    sortie=gtk_spin_button_new_with_range(0,20, 1);
                    gtk_spin_button_set_value(GTK_SPIN_BUTTON(sortie),save->add1.save[i][j]);
                    gtk_box_pack_start(GTK_BOX(hbox), sortie, TRUE, TRUE, 0);
                }
            }
        }
    }
    /* le second onglet ADD2*/
    vbox=gtk_vbox_new(FALSE, 6);
    label=gtk_label_new("AD&D2");
    gtk_notebook_append_page(GTK_NOTEBOOK(onglet), vbox, label);

    if (save->add2.nom)
    {
        if (save->add2.save!=NULL)
        {
            for(i=0;save->add2.save[i]!=NULL;i++)
            {
                hbox=gtk_hbox_new(FALSE, 6);
                gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);
                sprintf(affichage,"niveau : %hu",i+1);
                label=gtk_label_new(affichage);
                gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
                for(j=0;j<5;j++)
                {
                    sortie=gtk_spin_button_new_with_range(0,20, 1);
                    gtk_spin_button_set_value(GTK_SPIN_BUTTON(sortie),save->add2.save[i][j]);
                    gtk_box_pack_start(GTK_BOX(hbox), sortie, TRUE, TRUE, 0);
                }
            }
        }

    }
    gtk_widget_show_all (win);
    (void) wid;
}

void retourne_sort(struct_sort * sort, char * fichier)
{
    GMarkupDomNode * node,* ooo;
    char * tmp;
    signed short i,j,k;
    GMarkupDomNode * info;
    so_add * etude;


    ooo = g_markup_dom_new (fichier, NULL);
    if (sort->type!=NULL)
    {
        free(sort->type);
        sort->type=NULL;
    }
    k=0;
    for(j=0;fichier[j]!=0;j++)
        if (fichier[j]==SEPARATEUR || fichier[j]=='/') k=j;
    if (fichier[k]==SEPARATEUR || fichier[k]=='/') k++;
    for(i=k;fichier[i]!='_' && fichier[i]!=0;i++);
    sort->type=(char *)malloc(i-k+1);
    strncpy(sort->type,fichier+k,i-k);
    sort->type[i-k]=0;

    for (k=0;k<2;k++) /* pour une fois, les structures pour ADD1 et ADD2 sont semblables ! */
    {
        switch(k)
        {
            case 0 :
                    etude=&(sort->add1);
                    break;
            default :
                    etude=&(sort->add2);
                    break;

        }
        if (etude->nb!=NULL)
        {
            for(i=0;etude->nb[i]!=NULL;i++)
                free(etude->nb[i]);
            free(etude->nb);
            etude->nb=NULL;
        }
    }
    if (ooo)
    {
        for (k=0;k<2;k++) /* pour une fois, les structures pour ADD1 et ADD2 sont semblables ! */
        {
            switch(k)
            {
                case 0 :
                        etude=&(sort->add1);
                        node=g_markup_dom_nom (ooo,"ADD1","table:name");
                        break;
                default :
                        etude=&(sort->add2);
                        node=g_markup_dom_nom (ooo,"ADD2","table:name");
                        break;

            }
            if (node)
            {
             if ((tmp=lecture_case(FEUILLE_NOM,node)))
             {
                etude->nom=g_strdup(tmp);

                for(i=0;(info=donne_case_ij(1+i,0,node)) && info->texte!=0;i++);
                etude->nb=(signed short **)malloc((i+1)*sizeof(signed short *));
                etude->nb[i]=NULL;
                for(i--;i>=0;i--)
                {   /* tant qu'il y a des cases, on lit le contenu */
                    for(j=0;(info=donne_case_ij(1+i,j,node)) && info->texte!=0;j++);
                    etude->nb[i]=(signed short *)malloc((j)*sizeof(signed short));
                    j--;
                    etude->nb[i][j]=-1;
                    for(j--;j>=0;j--)
                    {
                        info=donne_case_ij(1+i,j+1,node);
                        etude->nb[i][j]=0;
                        sscanf(info->content->texte,"%hu",etude->nb[i]+j);
                    }
                }
             }
            }
        }
    }
}

void  affiche_sort(GtkWidget *wid, gpointer * param)
{
    gpointer * info=(gpointer *)malloc(200*sizeof(gpointer)) ;
    GtkWidget * vbox, *win, * onglet, *label, * hbox, * sortie;
    char * tmpo, affichage[LONG];
    GError * error;
    unsigned short i,j,k;
    so_add * etude;
    char aff[LONG];
    struct_sort * sort;
    char * choix=gtk_combo_box_text_get_active_text(GTK_COMBO_BOX_TEXT(((GtkWidget **)param)[1]));

    for(i=0;i<((unsigned short **)param)[2][0] && !(strcmp(((char **)param)[3],((struct_sort **)param)[0][i].type)==0 && ((compare_sans_casse(choix,((struct_sort **)param)[0][i].add1.nom)==0) ||( compare_sans_casse(choix,((struct_sort **)param)[0][i].add2.nom)==0)));i++);
    if (i>=((unsigned short **)param)[2][0]) return;
    sort=((struct_sort **)param)[0]+i;

    win = gtk_window_new (GTK_WINDOW_TOPLEVEL); /* déclaration d'une fenêtre complète */
    gtk_window_set_position (GTK_WINDOW (win), GTK_WIN_POS_MOUSE); /* aucune position */
    gtk_container_set_border_width (GTK_CONTAINER (win), 8);
    sprintf(aff,"%s : ",sort->type);
    if (sort->add1.nom)
        strcat(aff,sort->add1.nom);
    else if (sort->add2.nom)
        strcat(aff,sort->add2.nom);
    else return;
    gtk_window_set_title (GTK_WINDOW (win),aff);
    gtk_window_set_position (GTK_WINDOW (win), GTK_WIN_POS_NONE);
    gtk_widget_realize (win);
    g_signal_connect(G_OBJECT(win), "destroy", G_CALLBACK(fin_feuille), info);

    /* icone */
    tmpo=chemin_exe();
    sprintf(affichage,"%s%cfeuille.png",tmpo,SEPARATEUR);
    free(tmpo);
    if (!gtk_window_set_icon_from_file(GTK_WINDOW (win),affichage,&error))
    {                                                                  /* met une icone à la fenêtre */
        traite_erreur(error);
        g_error_free(error);
    }

    onglet = gtk_notebook_new();
    gtk_container_add(GTK_CONTAINER(win), onglet);

    gtk_notebook_set_scrollable(GTK_NOTEBOOK(onglet), TRUE);
    /* le premier onglet ADD1*/
    for (k=0;k<2;k++)
    {
        vbox=gtk_vbox_new(FALSE, 6);
        switch(k)
        {
            case 0 :
                    etude=&(sort->add1);
                    label=gtk_label_new("AD&D1");
                    break;
            default :
                    etude=&(sort->add2);
                    label=gtk_label_new("AD&D2");
                    break;

        }

        gtk_notebook_append_page(GTK_NOTEBOOK(onglet), vbox, label);
        if (etude->nom)
        {
            if (etude->nb!=NULL)
            {
                for(i=0;etude->nb[i]!=NULL;i++)
                {
                    hbox=gtk_hbox_new(FALSE, 6);
                    gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);
                    sprintf(affichage,"niveau : %hu",i+1);
                    label=gtk_label_new(affichage);
                    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
                    for(j=0;etude->nb[i][j]!=-1;j++)
                    {
                        sortie=gtk_spin_button_new_with_range(0,20, 1);
                        gtk_spin_button_set_value(GTK_SPIN_BUTTON(sortie),etude->nb[i][j]);
                        gtk_box_pack_start(GTK_BOX(hbox), sortie, TRUE, TRUE, 0);
                    }
                }
            }
        }
    }
    gtk_widget_show_all (win);

    (void) wid;
}
