/*
    Génération de feuille de personnage complète AD&D 1 et 2
    Génération aléatoire de personnage

    Copyright (C) 2011 Bernard SIAUD

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/* MERCI À Seldnor de http://dnd.ezael.net pour les caractéristiques de AD&D1 */

#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#ifdef __linux__
#include <zip.h>
#endif
#include "include.h"

void force_xml(GMarkupDomNode * ooo,gchar * ch2,gchar * ch3,gchar * ch4,gchar * ch5,gchar * ch6);
void intelligence_xml(GMarkupDomNode * ooo,unsigned short inte,unsigned short version_);
void sagesse_xml(GMarkupDomNode * ooo,unsigned short sage);
void dexterite_xml(GMarkupDomNode * ooo,gchar * ch2,gchar * ch3,gchar * ch4);
void constitution_xml(GMarkupDomNode * ooo,unsigned short constit);
void charisme_xml(GMarkupDomNode * ooo,gchar * ch2,gchar * ch3,gchar * ch4);
void vade_retro(signed short niv, signed short vers_, GMarkupDomNode * ooo );
void xml_ecrit_dernier_texte_f(GMarkupDomNode * node,gchar * ch); /* Gestion des sauts de ligne dans un texte */
void sauvegarde_ (gpointer param);
void trouve_modif(char * ch,unsigned short * car ,float * coef);
signed long but_xp_classe(struct_classe * s_c,unsigned short niv,unsigned short version_t);


enum
{
    M_FILE_OK,
    M_FILE_ARGUMENT_ERR,
    M_FILE_INPUT_FILE_ERR,
    M_FILE_OUTPUT_FILE_ERR,
    M_FILE_READ_ERR,
    M_FILE_WRITE_ERR,
    M_FILE_NB
};

signed long but_xp_classe(struct_classe * s_c,unsigned short niv,unsigned short version_t)
{
    unsigned short i;
    signed long * s_l;

    if (s_c->add2.nom==NULL || version_t==ADD1)
    {
        s_l=s_c->add1.XP;
        if (niv<20 && s_c->add1.pdv[niv-1]==NULL)
            return 0; /* niveau suppérieur non ateignable */
    }
    else
    {
        s_l=s_c->add2.XP;
        if (niv<20 && s_c->add2.pdv[niv-1]==NULL)
            return 0; /* niveau suppérieur non ateignable */
    }

    for (i=0;i<niv-1 && s_l[i]!=FIN;i++);
    if (s_l[i]!=FIN) return s_l[i]; /* CAS DANS LA TABLE */
    /* maintenant, on est dans la progression arithmétique */
    return (niv-i+2)*s_l[i-1];
}

void trouve_modif(char * ch,unsigned short * car ,float * coef)
{
    unsigned short i,j=0,k;

    for (i=0;ch[i]!='/' && ch[i]!=0;i++);
    if (ch[i]!=0)
    {
        j=sscanf(ch+i+1,"%f",coef);
    }
    if (j==0) *coef=1;
    j=ch[i];
    ch[i]=0;

    for (k=0;k<8;k++)
        if (compare_sans_casse(nom[k],ch)==0)
            *car=k;
    ch[i]=j;
}


void xml_ecrit_dernier_texte_f(GMarkupDomNode * node,gchar * ch) /* Gestion des sauts de ligne dans un texte */
{
    char * pt=ch;

    if (!(*ch)) return; /* texte vide => ne rien écrire */
    while (* pt)
    {
        if (*pt=='\n')
        {
            *pt=0;
            xml_ajoute_fin(node,"text:line-break");
            //if (ch+1!=pt)
            {
                xml_ajoute_fin_texte(node);
                xml_ecrit_dernier_texte(node,ch);
            }
            ch=pt+1;
            *pt='\n';
        }
        pt++;
    }
    if (ch!=pt)
    {
            xml_ajoute_fin(node,"text:line-break");
            xml_ajoute_fin_texte(node);
            xml_ecrit_dernier_texte(node,ch);
    }
}


void vade_retro(signed short niv, signed short vers_, GMarkupDomNode * ooo )
{
    gchar ch[8];
    unsigned short i,j=40;
    if (niv<=0) return;

    GMarkupDomNode * node=g_markup_dom_nom (ooo,"vd1","name");

    niv=min_(13,niv);

    if (node->texte>0)
    {
        if (sscanf(node->content[0].texte,"%hu",&i)==1)
        { /* en cas de multiples classes avec vade_retro, on ne garde que la meilleure */
            if (vers_==ADD1)
            {
                if (sscanf(vd_add1[0][niv-1],"%hu",&j)==0) j=0;
            } /* 0 car c'est une lettre donc mieux que le chiffre de i */
            else
            {
                if (sscanf(vd_add2[0][niv-1],"%hu",&j)==0) j=0;
            }
            if (j>=i) return;
        }
        else
        {
            node=g_markup_dom_nom (ooo,"vd10","name");
            if (node->texte>0) /* comme i était une lettre on regarde les chiffres de la fin */
            {
                if (sscanf(node->content[0].texte,"%hu",&i)==1)
                { /* en cas de multiples classes avec vade_retro, on ne garde que la meilleure */
                    if (vers_==ADD1)
                    {
                        if (sscanf(vd_add1[9][niv-1],"%hu",&j)==0) j=-1;
                    }
                    else
                    {
                        if (sscanf(vd_add2[9][niv-1],"%hu",&j)==0) j=-1;
                    }
                    if (j>=i) return;
                }
            }

        }
    }

    /* Vade retro */
    if (vers_==ADD1)
    {
        for (i=0;i<13;i++)
        {
            sprintf(ch,"vd%hu",i+1);
            modif_xml(g_markup_dom_nom (ooo,ch,"name"),vd_add1[i][niv-1]);
        }
    }
    else
    {
        for (i=0;i<13;i++)
        {
            sprintf(ch,"vd%hu",i+1);
            modif_xml(g_markup_dom_nom (ooo,ch,"name"),vd_add2[i][niv-1]);
        }
    }
}

int copie_fichier(char const *path_dest, char const *path_src)
{
    int err = M_FILE_OK;

    /* -tc- Validation des arguments */
    if (path_dest != NULL && path_src != NULL)
    {
        /* -tc- Si path_dest et path_src sont identiques, il n'y a rien a copier. */
        if (strcmp(path_dest, path_src) != 0)
        {
            FILE *src = NULL;
            FILE *dest = NULL;

            src = fopen(path_src, "rb");
            if (src != NULL)
            {
                dest = fopen(path_dest, "wb");
                if (dest != NULL)
                {
                    unsigned char buffer;

                    while (err == M_FILE_OK &&
                            fread(&buffer, sizeof buffer, 1, src) == 1)
                    {
                        if (fwrite(&buffer, sizeof buffer, 1, dest) != 1)
                        {
                            /* -tc- Erreur lors de l'ecriture */
                            err = M_FILE_WRITE_ERR;
                        }
                    }

                    if (feof(src) == 0)
                    {
                        /* Erreur lors de la lecture */
                        err = M_FILE_READ_ERR;
                    }

                    fclose(dest), dest = NULL;
                }
                else
                {
                    /* -tc- Erreur: impossible d'ouvrir le fichier de destination
                       en ecriture */
                    err = M_FILE_OUTPUT_FILE_ERR;
                }

                fclose(src), src = NULL;
            }
            else
            {
                /* -tc- Erreur: impossible d'ouvrir le fichier en lecture */
                err = M_FILE_INPUT_FILE_ERR;
            }
        }
    }
    else
    {
        /* -tc- Erreur: argument invalide */
        err = M_FILE_ARGUMENT_ERR;
    }

    return err;
}



void force_xml(GMarkupDomNode * ooo,gchar * ch2,gchar * ch3,gchar * ch4,gchar * ch5,gchar * ch6)
{
            modif_xml(g_markup_dom_nom (ooo,"force2","name"),ch2);
            modif_xml(g_markup_dom_nom (ooo,"force3","name"),ch3);
            modif_xml(g_markup_dom_nom (ooo,"force4","name"),ch4);
            modif_xml(g_markup_dom_nom (ooo,"force5","name"),ch5);
            modif_xml(g_markup_dom_nom (ooo,"force6","name"),ch6);
}

void intelligence_xml(GMarkupDomNode * ooo,unsigned short inte,unsigned short version_)
{
            inte--;
            if (version_==ADD1)
            {
                /*if (tabl_inte1[inte][0][1]==0 && tabl_inte1[inte][0][0]>'1')
                    modif_xml(g_markup_dom_nom (ooo,"nb_lang_int","name"),"Nombre de langues");*/
                modif_xml(g_markup_dom_nom (ooo,"intelligence2","name"),tabl_inte1[inte][0]);
                modif_xml(g_markup_dom_nom (ooo,"intelligence3","name"),tabl_inte1[inte][1]);
                modif_xml(g_markup_dom_nom (ooo,"intelligence4","name"),tabl_inte1[inte][2]);
                modif_xml(g_markup_dom_nom (ooo,"intelligence5","name"),tabl_inte1[inte][3]);
                modif_xml(g_markup_dom_nom (ooo,"intelligence6","name"),tabl_inte1[inte][4]);
                modif_xml(g_markup_dom_nom (ooo,"intelligence6_com","name"),"nb min sort");
            }
            else
            {
                /*if (tabl_inte1[inte][0][1]==1 && tabl_inte2[inte][0][0]>'1')
                    modif_xml(g_markup_dom_nom (ooo,"nb_lang_int","name"),"Nombre de langues");*/
                modif_xml(g_markup_dom_nom (ooo,"intelligence2","name"),tabl_inte2[inte][0]);
                modif_xml(g_markup_dom_nom (ooo,"intelligence3","name"),tabl_inte2[inte][1]);
                modif_xml(g_markup_dom_nom (ooo,"intelligence4","name"),tabl_inte2[inte][2]);
                modif_xml(g_markup_dom_nom (ooo,"intelligence5","name"),tabl_inte2[inte][3]);
                modif_xml(g_markup_dom_nom (ooo,"intelligence6","name"),tabl_inte2[inte][4]);
            }
}

void sagesse_xml(GMarkupDomNode * ooo,unsigned short sage)
{
            char ch[LONG];

           sage--;
            modif_xml(g_markup_dom_nom (ooo,"sagesse2","name"),tabl_sagesse[sage][0]);
            modif_xml(g_markup_dom_nom (ooo,"ssag","name"),tabl_sagesse[sage][0]);
            modif_xml(g_markup_dom_nom (ooo,"sagesse3","name"),tabl_sagesse[sage][1]);
            modif_xml(g_markup_dom_nom (ooo,"sagesse4","name"),tabl_sagesse[sage][2]);
            modif_xml(g_markup_dom_nom (ooo,"sagesse5","name"),tabl_sagesse[sage][3]);
            if (tabl_sagesse[sage][5][0]==0 || tabl_sagesse[sage][5][0]=='0')
                modif_xml(g_markup_dom_nom (ooo,"sagesse6","name"),tabl_sagesse[sage][4]);
            else
            {
                if (tabl_sagesse[sage][6][0]==0 || tabl_sagesse[sage][6][0]=='0')
                    sprintf(ch,"%s+%s",tabl_sagesse[sage][4],tabl_sagesse[sage][5]);
                else if (tabl_sagesse[sage][7][0]==0 || tabl_sagesse[sage][7][0]=='0')
                    sprintf(ch,"%s+%s+%s",tabl_sagesse[sage][4],tabl_sagesse[sage][5],tabl_sagesse[sage][6]);
                else
                    sprintf(ch,"%s+%s+%s+%s",tabl_sagesse[sage][4],tabl_sagesse[sage][5],tabl_sagesse[sage][6],tabl_sagesse[sage][7]);
                modif_xml(g_markup_dom_nom (ooo,"sagesse6","name"),ch);
            }
            modif_xml(g_markup_dom_nom (ooo,"sagesse7","name"),tabl_sagesse[sage][8]);
            modif_xml(g_markup_dom_nom (ooo,"sagesse8","name"),tabl_sagesse[sage][9]);
}

void dexterite_xml(GMarkupDomNode * ooo,gchar * ch2,gchar * ch3,gchar * ch4)
{
            gchar ch[32]="Dextérité : ";

            modif_xml(g_markup_dom_nom (ooo,"dexterite2","name"),ch2);
            modif_xml(g_markup_dom_nom (ooo,"dexterite3","name"),ch3);
            modif_xml(g_markup_dom_nom (ooo,"dexterite4","name"),ch4);
            modif_xml(g_markup_dom_nom (ooo,"sdext","name"),ch4);
            strcat(ch,ch4);
            //modif_xml(g_markup_dom_nom (ooo,"ca_dext","name"),ch);
            modif_xml(g_markup_dom_nom (ooo,"dext1","name"),ch4);
            modif_xml(g_markup_dom_nom (ooo,"dext2","name"),ch4);
}

void constitution_xml(GMarkupDomNode * ooo,unsigned short constit)
{
            constit--;
            modif_xml(g_markup_dom_nom (ooo,"constitution2","name"),tabl_constit[constit][0]);
            modif_xml(g_markup_dom_nom (ooo,"constitution3","name"),tabl_constit[constit][1]);
            modif_xml(g_markup_dom_nom (ooo,"constitution4","name"),tabl_constit[constit][2]);
            modif_xml(g_markup_dom_nom (ooo,"constitution5","name"),tabl_constit[constit][3]);
            modif_xml(g_markup_dom_nom (ooo,"constitution6","name"),tabl_constit[constit][4]);
}

void charisme_xml(GMarkupDomNode * ooo,gchar * ch2,gchar * ch3,gchar * ch4)
{
            modif_xml(g_markup_dom_nom (ooo,"charisme2","name"),ch2);
            modif_xml(g_markup_dom_nom (ooo,"charisme3","name"),ch3);
            modif_xml(g_markup_dom_nom (ooo,"charisme4","name"),ch4);
}



void sauvegarde_perso (GtkWidget *wid, gpointer param)
{
  if (((char **)param)[NOM]!=NULL && ((char **)param)[NOM][0]!=0 )
  {
        sauvegarde_ (param);
  }
  else
    sauvegarde_perso_sous(wid,param);
}

void sauvegarde_perso_sous (GtkWidget *wid, gpointer param)
{
  GtkWidget *p_dialog = NULL;
  char * nom_de_fichier=NULL, *tmp=NULL,*tmp1=NULL, ch[LONG];
  GtkFileFilter * filtre= gtk_file_filter_new();
  FILE * fp;
  p_dialog = gtk_file_chooser_dialog_new ("Sauvegarder dans le fichier", NULL,
                                          GTK_FILE_CHOOSER_ACTION_SAVE,
                                          GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
                                          GTK_STOCK_SAVE_AS, GTK_RESPONSE_ACCEPT,
                                          NULL);

  if (((char **)param)[NOM]!=NULL && ((char **)param)[NOM][0]!=0)
  {
       sprintf(ch,"%s.pers",((char **)param)[NOM]);
       gtk_file_chooser_set_filename (GTK_FILE_CHOOSER(p_dialog),ch);
  }
  tmp=envp_donne_home();
  gtk_file_chooser_set_current_folder (GTK_FILE_CHOOSER(p_dialog),tmp);
  free(tmp);

  gtk_file_filter_add_pattern (filtre,"*.pers");
  gtk_file_chooser_set_filter(GTK_FILE_CHOOSER(p_dialog),filtre);

  if (gtk_dialog_run (GTK_DIALOG (p_dialog)) == GTK_RESPONSE_ACCEPT)
  {
    nom_de_fichier = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (p_dialog));
    gtk_widget_destroy(p_dialog);
    fp = fopen(nom_de_fichier, "rb");
    if (fp!=NULL) /* Le fichier existe déjà */
    {
        fclose(fp);
        sprintf(ch,"Écraser le fichier\n%s",nom_de_fichier);
        p_dialog = gtk_message_dialog_new (GTK_WINDOW(((GtkWindow **)param)[4] ),GTK_DIALOG_MODAL,GTK_MESSAGE_QUESTION,GTK_BUTTONS_YES_NO,ch);
        switch(gtk_dialog_run(GTK_DIALOG(p_dialog)))
        {
            case GTK_RESPONSE_NO:
                gtk_widget_destroy(p_dialog);
                return ; /* on sort du programme */
            default :
                gtk_widget_destroy(p_dialog);
                break;
        }
    }
    for(tmp=nom_de_fichier;*tmp;tmp++);
    for(;*tmp!=SEPARATEUR && tmp!=nom_de_fichier;tmp--) if (*tmp=='.') tmp1=tmp;
    if (tmp && tmp!=nom_de_fichier) *tmp=0;
    ((char **)param)[CHEMIN]=g_strdup(nom_de_fichier);
    envp_mem_home(nom_de_fichier);
    if (tmp1)
    {
        *tmp1=0;
        ((char **)param)[NOM]=g_strdup(tmp+1);
    }
    else
    {
        ((char **)param)[NOM]=g_strdup(tmp+1);
    }
    sauvegarde_ (param);
  }
  else
    gtk_widget_destroy (p_dialog);
 (void)wid;
}


void sauvegarde_ (gpointer param)
{
  GtkWidget *p_dialog = NULL;
  char * nom_de_fichier=NULL;
  FILE * fichier;
  unsigned short * caract=NULL;
  gchar * sexe;
  signed short niv,mag=0,clerc=0;
  guint i,k,l;
  gint j;
  gchar ch[LONG],affichage[LONG],aff[LONG],*tmp,*tmp1;
  char * chemin;
  chemin=chemin_exe();
  sprintf(ch,"%s%cLibO%csortie.xml",chemin,SEPARATEUR,SEPARATEUR);
  free(chemin);
  GMarkupDomNode * ooo=g_markup_dom_new(ch,NULL),* tmp_node, *tmp1_node,* node;
  unsigned short version_t=((unsigned short **)param)[VERSION][0];
  signed short bonus=0,taco=20,taco_lan,spmp=20,spp=20,sbb=20,ssou=20,ssor=20,nm=-5,bt=1,initiative=-1,taco_tmp=20,bt_tmp=1;
  signed short ca1=0,ca2=0;
  char but_xp[LONG]={0};
  char actu_xp[LONG]={0};
  char ** save_race;
  unsigned short car;
  float coef;
  liste_classe * l_c;
  struct_classe * s_c;
  unsigned short vdr=0;
  GMarkupDomNode * noded=g_markup_dom_new(chemin_dieux(ch),NULL);

/*  gchar * ici=g_get_current_dir();*/
#ifdef __linux__
  struct zip * f_zip=NULL;
  struct zip_source * n_zip=NULL;
#endif

    /* sauvegarde des fichiers qui vont être effacés s'il y a */
    sprintf(ch,"%s%c%s.pers",((char **)param)[CHEMIN],SEPARATEUR,((char **)param)[NOM]);
    envp_mem_hist(ch);
    envp_init(((gpointer **)param)[MENU]);
    fichier = fopen(ch, "rb");
    if (fichier!=NULL) /* Le fichier existe déjà */
    {
        fclose(fichier);
        sprintf(aff,"%s~",ch);
        copie_fichier(aff,ch);
    }
    sprintf(ch,"%s%c%s.odt",((char **)param)[CHEMIN],SEPARATEUR,((char **)param)[NOM]);
    fichier = fopen(ch, "rb");
    if (fichier!=NULL) /* Le fichier existe déjà */
    {
        fclose(fichier);
        sprintf(aff,"%s~",ch);
        copie_fichier(aff,ch);
    }

  if (((unsigned short **)param)[SEXE][0]==0)
   sexe="Masculin";
  else
   sexe="Féminin";
  caract=*((unsigned short **)(param)+CARACT);

  if (g_markup_dom_nom (ooo,"actu_xp","name")==NULL)
  {
     p_dialog = gtk_message_dialog_new (GTK_WINDOW(((GtkWindow **)param)[FENETRE] ),GTK_DIALOG_MODAL,GTK_MESSAGE_INFO,GTK_BUTTONS_CLOSE,"Erreur système :\n fichier sortie.xml corrompu");
     gtk_dialog_run(GTK_DIALOG(p_dialog));
     gtk_widget_destroy(p_dialog);
     return;
  }  /* dernier nom => trouver une erreur dans le fichier xml */

    sprintf(affichage,"Chemin : %s\nFichier xml : %s.pers\nFichier LibO : %s.odt",((char **)param)[CHEMIN],((char **)param)[NOM],((char **)param)[NOM]);
    p_dialog = gtk_message_dialog_new (GTK_WINDOW(((GtkWindow **)param)[FENETRE] ),GTK_DIALOG_MODAL,GTK_MESSAGE_QUESTION,GTK_BUTTONS_YES_NO,affichage);
    switch(gtk_dialog_run(GTK_DIALOG(p_dialog)))
    {
        case GTK_RESPONSE_NO:
            gtk_widget_destroy(p_dialog);
            return ; /* on sort du programme */
        default :
            gtk_widget_destroy(p_dialog);
            break;
    }

    if (((GtkWidget**)param)[FILS]!=NULL)
    {
        sprintf(ch,"Modification de %s",((char **)param)[NOM]);
        gtk_window_set_title(GTK_WINDOW(((GtkWidget**)param)[FILS]), ch);
    }
    ((unsigned short **)param)[MODIF][0]=0;
    sprintf(affichage,"%s%c%s.pers",((char **)param)[CHEMIN],SEPARATEUR,((char **)param)[NOM]);
    fichier=fopen(affichage,"w");
    fprintf(fichier,"<document type=\"perso\">\n<caracteristique>\n");
    for (i=0;i<9;i++)
    {
        fprintf(fichier," <c name=\"%s\">%hu</c>\n",nom_min[i],caract[i]);
    }
    if (version_t==ADD1 || ((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add2.nom==NULL)
        fprintf(fichier,"</caracteristique>\n<race>%s</race>\n",((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add1.nom);
    else
        fprintf(fichier,"</caracteristique>\n<race>%s</race>\n",((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add2.nom);


    aff[0]=0;
    affichage[0]=0;
    fprintf(fichier,"<sexe>%s</sexe>\n",sexe);
    fprintf(fichier,"<version>%s</version>\n",vers[version_t]);
    fprintf(fichier,"<profession>\n");
    affichage[0]=0;
    aff[0]=0;

    for (i=0,l_c=((liste_classe **)param)[METIER];l_c!=NULL;l_c=l_c->suiv,i++)
    {
        s_c=trouve_classe(l_c->nom,((struct_classe***)param)[MENU][MAIN_CLASSE]);
        if (affichage[0])
        {
            sprintf(ch,", %s",l_c->nom);
            strcat(affichage,ch);
            sprintf(ch,", %hu",l_c->niveau);
            strcat(aff,ch);
        }
        else
        {
            strcpy(affichage,"Classe : ");
            sprintf(aff,"Niveau : ");
            strcat(affichage,l_c->nom);
            sprintf(ch,"%hu",l_c->niveau);
            strcat(aff,ch);
        }
        fprintf(fichier," <p niv=\"%hu\" xp=\"%lu\">%s</p>\n",l_c->niveau,l_c->xp,l_c->nom);
        aff_nb_sort(g_markup_dom_nom (ooo,"section_sorts","name"),s_c,&clerc,&mag,caract[SAGESSE],caract[INTELLIGENCE],l_c->niveau,version_t);

        if (i!=0)
        {
            but_xp[strlen(but_xp)+1]=0;
            but_xp[strlen(but_xp)]='-';
            actu_xp[strlen(actu_xp)+1]=0;
            actu_xp[strlen(actu_xp)]='-';
        }
        sprintf(but_xp, "%s%ld",but_xp ,but_xp_classe(s_c,l_c->niveau,version_t));
        sprintf(actu_xp,"%s%lu",actu_xp,l_c->xp);

         /* calcul des save et taco */
        if (s_c->add2.nom==NULL || version_t==ADD1)
        {
            for(niv=0;niv<l_c->niveau && s_c->add1.save->save[niv]!=NULL;niv++);
            niv--; /* pour ceux qui ont des niveaux tropélevés */
            spmp=min_(spmp,s_c->add1.save->save[niv][0]);
            sbb=min_(sbb,s_c->add1.save->save[niv][2]);
            ssou=min_(ssou,s_c->add1.save->save[niv][3]);
            ssor=min_(ssor,s_c->add1.save->save[niv][4]);
            spp=min_(spp,s_c->add1.save->save[niv][1]);
            nm=max(nm,s_c->add1.nb_arme[1]);
            for(niv=0;s_c->add1.tacO[0][niv]<=l_c->niveau && s_c->add1.tacO[0][niv]!=FIN;niv++);
            niv--;
            taco=min_(taco,s_c->add1.tacO[1][niv]);
            for(niv=0;niv<l_c->niveau && s_c->add1.backstab[niv]!=FIN;niv++);
            niv--;
            bt_tmp=s_c->add1.backstab[niv];
        }
        else
        {
            for(niv=0;niv<l_c->niveau && s_c->add2.save->save[niv]!=NULL;niv++);
            niv--;
            spmp=min_(spmp,s_c->add2.save->save[niv][0]);
            sbb=min_(sbb,s_c->add2.save->save[niv][1]);
            ssou=min_(ssou,s_c->add2.save->save[niv][3]);
            ssor=min_(ssor,s_c->add2.save->save[niv][4]);
            spp=min_(spp,s_c->add2.save->save[niv][2]);
            nm=max(nm,s_c->add2.nb_arme[1]);
            taco=min_(taco,(s_c->add2.tacO[0]-(l_c->niveau-1)*s_c->add2.tacO[1]/s_c->add2.tacO[2]));
            for(niv=0;niv<l_c->niveau && s_c->add2.backstab[niv]!=FIN;niv++);
            niv--;
            bt_tmp=s_c->add2.backstab[niv];
        }
        bt=max(bt,bt_tmp); /* backstab */
        if (((s_c->add2.nom==NULL || version_t==ADD1) && s_c->add1.vade_retro!=NON) || ((s_c->add1.nom==NULL || version_t==ADD2) && s_c->add2.vade_retro!=NON))
        {
            if (s_c->add2.nom==NULL || version_t==ADD1)
                vade_retro(l_c->niveau+s_c->add1.vade_retro,ADD1,ooo);
            else
                vade_retro(l_c->niveau+s_c->add2.vade_retro,ADD2,ooo);
            vdr++;
        }

    }

    taco_tmp=taco;
    /* on repère si on a affiché des sorts */
    if (mag==0 && clerc==0)
        xml_sup_node(g_markup_dom_nom(ooo,"section_sorts","name"));
    else if (mag==0)
    {
        xml_sup_node(g_markup_dom_nom(ooo,"suppr_mag0","name"));
        xml_sup_node(g_markup_dom_nom(ooo,"suppr_mag1","name"));
    }
    else if (clerc==0)
    {
        xml_sup_node(g_markup_dom_nom(ooo,"suppr_clerc0","name"));
        xml_sup_node(g_markup_dom_nom(ooo,"suppr_clerc1","name"));
    }


    modif_xml(g_markup_dom_nom (ooo,"classe","name"),affichage);
    modif_xml(g_markup_dom_nom (ooo,"niveau","name"),aff);
    fprintf(fichier,"</profession>\n");
    if (vdr==0)
    {/* pas de vaderetro affiché */
            niv=min_(niv,14)-1;
            tmp_node=g_markup_dom_nom (ooo,"dern_sect","name");
            tmp1_node=g_markup_dom_nom (ooo,"traiVD","name");
            for(i=0;i<tmp_node->fils;i++)
            {
                if (tmp_node->child+i==tmp1_node)
                {
                    supprime_node(tmp_node,i);
                    i=tmp_node->fils;
                }
            }
            tmp1_node=g_markup_dom_nom (ooo,"texteVD","name");
            for(i=0;i<tmp_node->fils;i++)
            {
                if (tmp_node->child+i==tmp1_node)
                {
                    supprime_node(tmp_node,i);
                    i=tmp_node->fils;
                }
            }
            tmp1_node=g_markup_dom_nom (ooo,"tableVD","name");
            for(i=0;i<tmp_node->fils;i++)
            {
                if (tmp_node->child+i==tmp1_node)
                {
                    supprime_node(tmp_node,i);
                    i=tmp_node->fils;
                }
            }
    }


    if (caract[FORCE]!=18) modif_xml(g_markup_dom_nom (ooo,"force1","name"),nb_texte(ch,caract[FORCE]));
    else
    {
        strcpy(ch,"18 ");
        nb_texte(ch+3,caract[POURCENTAGE]);
        modif_xml(g_markup_dom_nom (ooo,"force1","name"),ch);
    }
    if (version_t==ADD1)
    {
       switch(caract[FORCE])
       {
            case 1  : force_xml(ooo,"-5","-4","-450","1","0%");taco_tmp=taco+5;bonus=-4;break;
            case 2  : force_xml(ooo,"-3","-2","-400","1","0%");taco_tmp=taco+4;bonus=-2;break;
            case 3  : force_xml(ooo,"-3","-1","-350","2","0%");taco_tmp=taco+3;bonus=-1;break;
            case 4  :
            case 5  : force_xml(ooo,"-2","-1","-250","2","0%");taco_tmp=taco+2;bonus=-1;break;
            case 6  :
            case 7  : force_xml(ooo,"-1","","-150","2","0%");taco_tmp=taco+1;break;
            case 8  :
            case 9  : force_xml(ooo,"","","","2","1%");break;
            case 10 :
            case 11 : force_xml(ooo,"","","","2","2%");break;
            case 12 :
            case 13 : force_xml(ooo,"","","+100","2","4%");break;
            case 14 :
            case 15 : force_xml(ooo,"","","+200","2","7%");break;
            case 16 : force_xml(ooo,"","+1","+350","3","10%");bonus=+1;break;
            case 17 : force_xml(ooo,"+1","+1","+500","3","13%");taco_tmp=taco-1;bonus=+1;break;
            case 18 : if (caract[POURCENTAGE]==0)
                               {force_xml(ooo,"+1","+2","+750","3","16%");taco_tmp=taco-1;bonus=+2;}
                      else if (caract[POURCENTAGE]<51)
                               {force_xml(ooo,"+1","+3","1000","3","20%");taco_tmp=taco-1;bonus=+3;}
                      else if (caract[POURCENTAGE]<76)
                               {force_xml(ooo,"+2","+3","+1250","4","25%");taco_tmp=taco-2;bonus=+3;}
                      else if (caract[POURCENTAGE]<91)
                               {force_xml(ooo,"+2","+4","+1500","4","30%");taco_tmp=taco-2;bonus=+4;}
                      else if (caract[POURCENTAGE]<100)
                               {force_xml(ooo,"+2","+5","+2000","4","35%");taco_tmp=taco-2;bonus=+5;}
                      else
                               {force_xml(ooo,"+3","+6","+3000","5","40%");taco_tmp=taco-3;bonus=+6;}
                      break;
            case 19 : force_xml(ooo,"+3","+7","4500","7","50%");taco_tmp=taco-3;bonus=+7;break;
            case 20 : force_xml(ooo,"+3","+8","5000","7","60%");taco_tmp=taco-3;bonus=+8;break;
            case 21 : force_xml(ooo,"+4","+9","6000","9","70%");taco_tmp=taco-4;bonus=+9;break;
            case 22 : force_xml(ooo,"+4","+10","7500","11","80%");taco_tmp=taco-4;bonus=+10;break;
            case 23 : force_xml(ooo,"+5","+11","9000","11","90%");taco_tmp=taco-5;bonus=+11;break;
            case 24 : force_xml(ooo,"+6","+12","12000","19","100%");taco_tmp=taco-6;bonus=+12;break;
            case 25 : force_xml(ooo,"+7","+14","15000","19","100%");taco_tmp=taco-7;bonus=+14;break;
            default : break;
        }
    }
    else
    {
        switch(caract[FORCE])
        {
            case 1  : force_xml(ooo,"-5","-4","1/3","1","0%");taco_tmp=taco+5;bonus=-4;break;
            case 2  : force_xml(ooo,"-3","-2","1/5","1","0%");taco_tmp=taco+4;bonus=-2;break;
            case 3  : force_xml(ooo,"-3","-1","5/10","2","0%");taco_tmp=taco+3;bonus=-1;break;
            case 4  :
            case 5  : force_xml(ooo,"-2","-1","10/25","3","0%");taco_tmp=taco+2;bonus=-1;break;
            case 6  :
            case 7  : force_xml(ooo,"-1","","20/55","4","0%");taco_tmp=taco+1;break;
            case 8  :
            case 9  : force_xml(ooo,"","","35/90","5","1%");break;
            case 10 :
            case 11 : force_xml(ooo,"","","40/115","6","2%");break;
            case 12 :
            case 13 : force_xml(ooo,"","","45/140","7","4%");break;
            case 14 :
            case 15 : force_xml(ooo,"","","55/170","8","7%");break;
            case 16 : force_xml(ooo,"","+1","70/195","9","10%");bonus=+1;break;
            case 17 : force_xml(ooo,"+1","+1","85/220","10","13%");taco_tmp=taco-1;bonus=+1;break;
            case 18 : if (caract[POURCENTAGE]==0)
                               {force_xml(ooo,"+1","+2","110/235","11","16%");taco_tmp=taco-1;bonus=+2;}
                      else if (caract[POURCENTAGE]<51)
                               {force_xml(ooo,"+1","+3","135/280","12","20%");taco_tmp=taco-1;bonus=+3;}
                      else if (caract[POURCENTAGE]<76)
                               {force_xml(ooo,"+2","+3","160/305","13","25%");taco_tmp=taco-2;bonus=+3;}
                      else if (caract[POURCENTAGE]<91)
                               {force_xml(ooo,"+2","+4","185/330","14","30%");taco_tmp=taco-2;bonus=+4;}
                      else if (caract[POURCENTAGE]<100)
                               {force_xml(ooo,"+2","+5","235/380","15(3)","35%");taco_tmp=taco-2;bonus=+5;}
                      else
                               {force_xml(ooo,"+3","+6","335/340","16(6)","40%");taco_tmp=taco-3;bonus=+6;}
                      break;
            case 19 : force_xml(ooo,"+3","+7","485/640","16(8)","50%");taco_tmp=taco-3;bonus=+7;break;
            case 20 : force_xml(ooo,"+3","+8","535/700","17(10)","60%");taco_tmp=taco-3;bonus=+8;break;
            case 21 : force_xml(ooo,"+4","+9","635/810","17(12)","70%");taco_tmp=taco-4;bonus=+9;break;
            case 22 : force_xml(ooo,"+4","+10","785/970","18(14)","80%");taco_tmp=taco-4;bonus=+10;break;
            case 23 : force_xml(ooo,"+5","+11","935/1130","18(16)","90%");taco_tmp=taco-5;bonus=+11;break;
            case 24 : force_xml(ooo,"+6","+12","1235/1440","19(17)","95%");taco_tmp=taco-6;bonus=+12;break;
            case 25 : force_xml(ooo,"+7","+14","1535/1750","19(18)","99%");taco_tmp=taco-7;bonus=+14;break;
            default : break;
        }
    }
    modif_xml(g_markup_dom_nom (ooo,"intelligence1","name"),nb_texte(ch,caract[INTELLIGENCE]));
    intelligence_xml(ooo,caract[INTELLIGENCE],version_t);
    modif_xml(g_markup_dom_nom (ooo,"sagesse1","name"),nb_texte(ch,caract[SAGESSE]));
    sagesse_xml(ooo,caract[SAGESSE]);
    modif_xml(g_markup_dom_nom (ooo,"dexterite1","name"),nb_texte(ch,caract[DEXTERITE]));
    taco_lan=taco;
    switch(caract[DEXTERITE])
    {
        case 1  : dexterite_xml(ooo,"-6","-6","+5");taco_lan=taco+6;ca1=5;break;
        case 2  : dexterite_xml(ooo,"-4","-4","+5");taco_lan=taco+4;ca1=5;break;
        case 3  : dexterite_xml(ooo,"-3","-3","+4");taco_lan=taco+3;ca1=4;break;
        case 4  : dexterite_xml(ooo,"-2","-2","+3");taco_lan=taco+2;ca1=3;break;
        case 5  : dexterite_xml(ooo,"-1","-1","+2");taco_lan=taco+1;ca1=2;break;
        case 6  : dexterite_xml(ooo,"","","+1");ca1=1;break;
        case 7  :
        case 8  :
        case 9  :
        case 10 :
        case 11 :
        case 12 :
        case 13 :
        case 14 : dexterite_xml(ooo,"","","");break;
        case 15 : dexterite_xml(ooo,"","","-1");ca1=-1;break;
        case 16 : dexterite_xml(ooo,"+1","+1","-2");taco_lan=taco-1;ca1=-2;break;
        case 17 : dexterite_xml(ooo,"+2","+2","-3");taco_lan=taco-2;ca1=-3;break;
        case 18 : dexterite_xml(ooo,"+3","+3","-4");taco_lan=taco-3;ca1=-4;break;
        case 19 :
        case 20 : dexterite_xml(ooo,"+3","+3","-4");taco_lan=taco-3;ca1=-4;break;
        case 21 :
        case 22 :
        case 23 : dexterite_xml(ooo,"+4","+4","-5");taco_lan=taco-4;ca1=-5;break;
        case 24 :
        case 25 : dexterite_xml(ooo,"+5","+5","-6");taco_lan=taco-5;ca1=-6;break;
        default : break;
    }
    modif_xml(g_markup_dom_nom (ooo,"constitution1","name"),nb_texte(ch,caract[CONSTITUTION]));
    constitution_xml(ooo,caract[CONSTITUTION]);
    modif_xml(g_markup_dom_nom (ooo,"charisme1","name"),nb_texte(ch,caract[CHARISME]));
    if (version_t==ADD1)
    {
        switch(caract[CHARISME])
        {
            case 1  : charisme_xml(ooo,"0","-40%","-35%");break;
            case 2  : charisme_xml(ooo,"1","-35%","-30%");break;
            case 3  : charisme_xml(ooo,"1","-30%","-25%");break;
            case 4  : charisme_xml(ooo,"1","-25%","-20%");break;
            case 5  : charisme_xml(ooo,"2","-20%","-15%");break;
            case 6  : charisme_xml(ooo,"2","-15%","-10%");break;
            case 7  : charisme_xml(ooo,"3","-10%","-5%");break;
            case 8  : charisme_xml(ooo,"3","-5%","");break;
            case 9  :
            case 10 :
            case 11 : charisme_xml(ooo,"4","","");break;
            case 12 : charisme_xml(ooo,"5","","");break;
            case 13 : charisme_xml(ooo,"5","","+5%");break;
            case 14 : charisme_xml(ooo,"6","+5%","+10%");break;
            case 15 : charisme_xml(ooo,"7","+15%","+15%");break;
            case 16 : charisme_xml(ooo,"8","+20%","+25%");break;
            case 17 : charisme_xml(ooo,"10","+30%","+30%");break;
            case 18 : charisme_xml(ooo,"15","+40%","+35%");break;
            case 19 : charisme_xml(ooo,"20","+50%","+40%");break;
            case 20 : charisme_xml(ooo,"25","+60%","+45%");break;
            case 21 : charisme_xml(ooo,"30","+70%","+50%");break;
            case 22 : charisme_xml(ooo,"35","+80%","+55%");break;
            case 23 : charisme_xml(ooo,"40","+90%","+60%");break;
            case 24 : charisme_xml(ooo,"45","+100%","+70%");break;
            case 25 : charisme_xml(ooo,"50","+100%","+75%");break;;
            default : break;
        }
    }
    else
    {
        switch(caract[CHARISME])
        {
            case 1  : charisme_xml(ooo,"0","-8","-7");break;
            case 2  : charisme_xml(ooo,"1","-7","-6");break;
            case 3  : charisme_xml(ooo,"1","-6","-5");break;
            case 4  : charisme_xml(ooo,"1","-5","-4");break;
            case 5  : charisme_xml(ooo,"2","-4","-3");break;
            case 6  : charisme_xml(ooo,"2","-3","-2");break;
            case 7  : charisme_xml(ooo,"3","-2","-1");break;
            case 8  : charisme_xml(ooo,"3","-1","");break;
            case 9  :
            case 10 :
            case 11 : charisme_xml(ooo,"4","","");break;
            case 12 : charisme_xml(ooo,"5","","");break;
            case 13 : charisme_xml(ooo,"5","","+1");break;
            case 14 : charisme_xml(ooo,"6","+1","+2");break;
            case 15 : charisme_xml(ooo,"7","+3","+3");break;
            case 16 : charisme_xml(ooo,"8","+4","+5");break;
            case 17 : charisme_xml(ooo,"10","+6","+6");break;
            case 18 : charisme_xml(ooo,"15","+8","+7");break;
            case 19 : charisme_xml(ooo,"20","+10","+8");break;
            case 20 : charisme_xml(ooo,"25","+12","+9");break;
            case 21 : charisme_xml(ooo,"30","+14","+10");break;
            case 22 : charisme_xml(ooo,"35","+16","+11");break;
            case 23 : charisme_xml(ooo,"40","+18","+12");break;
            case 24 : charisme_xml(ooo,"45","+20","+13");break;
            case 25 : charisme_xml(ooo,"50","+20","+14");break;
            default : break;
        }
    }
    modif_xml(g_markup_dom_nom (ooo,"humour1","name"),nb_texte(ch,caract[HUMOUR]));
    modif_xml(g_markup_dom_nom (ooo,"beaute1","name"),nb_texte(ch,caract[BEAUTE]));

    fprintf(fichier,"<armure>\n");
    if (((signed short **)param)[BOUCLIER][0]!=0)
    {
        fprintf(fichier," <bouclier mag='%hd' />\n",((signed short **)param)[MAG_BOUCLIER][0]);
        if (((signed short **)param)[MAG_BOUCLIER][0]!=0)
        {
            ca1-=(1+((signed short **)param)[MAG_BOUCLIER][0]);
            sprintf(ch,"Bouclier %+hd",((signed short **)param)[MAG_BOUCLIER][0]);
            modif_xml(g_markup_dom_nom (ooo,"bouclier","name"),ch);
            sprintf(aff,"%+hd",-1-((signed short **)param)[MAG_BOUCLIER][0]);
        }
        else
        {
            modif_xml(g_markup_dom_nom (ooo,"bouclier","name"),"Bouclier normal");
            sprintf(aff,"%+hd",-1-((signed short **)param)[MAG_BOUCLIER][0]);
            ca1--;
        }
        modif_xml(g_markup_dom_nom (ooo,"bouclier1","name"),aff);
        modif_xml(g_markup_dom_nom (ooo,"bouclier2","name"),aff);
    }
    fprintf(fichier," <bague mag='%hd' />\n",((signed short **)param)[BONUS_CA][0]);
    if (((signed short **)param)[BONUS_CA][0]!=0)
    {
        //taco-=((signed short **)param)[BONUS_CA][0];
        spmp-=((signed short **)param)[BONUS_CA][0];/* bonus bague sur save */
        sbb-=((signed short **)param)[BONUS_CA][0];
        ssou-=((signed short **)param)[BONUS_CA][0];
        ssor-=((signed short **)param)[BONUS_CA][0];
        spp-=((signed short **)param)[BONUS_CA][0];
        sprintf(ch,"bague %+hd",((signed short **)param)[BONUS_CA][0]);
        modif_xml(g_markup_dom_nom (ooo,"bague_CA","name"),ch);
    }
    ca2=ca1;
    ch[0]=0;
    if (!str_isspace (((char **)param)[ARMURE1]))
    {
        strcat(ch,((char **)param)[ARMURE1]);
        for (i=0;i<MAX_ARMURE;i++)
        {
            if (strcmp(armures[i].nom,((char **)param)[ARMURE1])==0)
            {
                ca1+=armures[i].add2;
                sprintf(aff,"%+hd",-((signed short **)param)[BONUS_CA][0]);
                if (strncmp(armures[i].nom,"Bracelet",8)==0)
                {
                    sprintf(affichage,"%+hd",armures[i].add2);
                    ca1-=((signed short **)param)[BONUS_CA][0]; /* bague bonus CA + save */
                    ((signed short **)param)[MAG_ARMURE1][0]=0;
                }
                else
                {
                    if (((signed short **)param)[MAG_ARMURE1][0]!=0)
                    {
                        ca1-=((signed short **)param)[MAG_ARMURE1][0];
                        sprintf(aff,"--");
                    }
                    else
                        ca1-=((signed short **)param)[BONUS_CA][0]; /* bague bonus CA + save */
                    sprintf(ch,"%s %+hd",ch,((signed short **)param)[MAG_ARMURE1][0]);
                    sprintf(affichage,"%+hd",armures[i].add2-((signed short **)param)[MAG_ARMURE1][0]);
                }
                modif_xml(g_markup_dom_nom (ooo,"autre_CA1","name"),aff);
            }
        }
        modif_xml(g_markup_dom_nom (ooo,"armure1","name"),affichage);
        fprintf(fichier," <armure1 mag='%+hd' ac='%+hd'>%s</armure1>\n",((signed short **)param)[MAG_ARMURE1][0],ca1,((char **)param)[ARMURE1]);
        sprintf(aff,"%+hd",ca1);
        modif_xml(g_markup_dom_nom (ooo,"ca1","name"),aff);
    }
    if (!str_isspace (((char **)param)[ARMURE2]))
    {
        if (ch[0]!=0) strcat(ch," / ");
        strcat(ch,((char **)param)[ARMURE2]);
        for (i=0;i<MAX_ARMURE;i++)
        {
            if (strcmp(armures[i].nom,((char **)param)[ARMURE2])==0)
            {
                ca2+=armures[i].add2;
                sprintf(aff,"%+hd",-((signed short **)param)[BONUS_CA][0]);
                if (strncmp(armures[i].nom,"Bracelet",8)==0)
                {
                    sprintf(affichage,"%+hd",armures[i].add2);
                    ca2-=((signed short **)param)[BONUS_CA][0]; /* bague bonus CA + save */
                    ((signed short **)param)[MAG_ARMURE2][0]=0;
                }
                else
                {
                    if (((signed short **)param)[MAG_ARMURE2][0]!=0)
                    {
                        ca2-=((signed short **)param)[MAG_ARMURE2][0];
                        sprintf(aff,"--");
                    }
                    else
                        ca2-=((signed short **)param)[BONUS_CA][0]; /* bague bonus CA + save */
                    sprintf(ch,"%s %+hd",ch,((signed short **)param)[MAG_ARMURE2][0]);
                    sprintf(affichage,"%+hd",armures[i].add2-((signed short **)param)[MAG_ARMURE2][0]);
                }
                modif_xml(g_markup_dom_nom (ooo,"autre_CA2","name"),aff);
            }
        }
        modif_xml(g_markup_dom_nom (ooo,"armure2","name"),affichage);
        fprintf(fichier," <armure2 mag='%+hd' ac='%+hd'>%s</armure2>\n",((signed short **)param)[MAG_ARMURE2][0],ca2,((char **)param)[ARMURE2]);
        sprintf(aff,"%+hd",ca2);
        modif_xml(g_markup_dom_nom (ooo,"ca2","name"),aff);
    }
    modif_xml(g_markup_dom_nom (ooo,"armure","name"),ch); /* les deux armures */
    fprintf(fichier,"</armure>\n");

    if (version_t==ADD1 || ((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add2.nom==NULL)
        save_race=((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add1.save;
    else
        save_race=((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add2.save;

// ordre feuille  : pmp	pp	bbm	sou	sort
// spmp=20 spp=20 sbb=20 ssou=20 ssor=20
    if (save_race[0]!=0)
    {
        trouve_modif(save_race[0],&car,&coef);
        spmp-=caract[car]/coef;
    }
    if (save_race[1]!=0)
    {
        trouve_modif(save_race[1],&car,&coef);
        spp-=caract[car]/coef;
    }
    if (save_race[2]!=0)
    {
        trouve_modif(save_race[2],&car,&coef);
        sbb-=caract[car]/coef;
    }
    if (save_race[3]!=0)
    {
        trouve_modif(save_race[3],&car,&coef);
        ssou-=caract[car]/coef;
    }
    if (save_race[4]!=0)
    {
        trouve_modif(save_race[4],&car,&coef);
        ssor-=caract[car]/coef;
    }

    fprintf(fichier,"<armes>\n");
    if (((unsigned short **)param)[NB_ARMES][0]>2)
    {
        node=g_markup_dom_nom (ooo,"sous_tableau_arme","name");
        j=7; /* avant dernière ligne du tableau */

        for(i=j+1;(signed short)i<(((unsigned short **)param)[NB_ARMES][0]+6);i++)
        {                                                   /* ajout d'une ligne dans le tableau d'armes    */
            xml_ajoute_fin(node,"table:table-row");         /* ajout d'une node table:table-row à la fin    */
            copie_node((node->child)+node->fils-1,(node->child)+node->fils-2);    /* remet à la fin la dernière node              */
            copie_node((node->child)+node->fils-2,(node->child)+j);    /* met la node modèle à l'avant dernière place  */
//g_markup_dom_free(ooo);
            for(k=0;k<node->child[i].fils;k++)
                for(l=0;l<node->child[i].child[k].child[0].nb_att;l++)
                {
                    if (strcmp("nom_arme2",node->child[i].child[k].child[0].attributs[l].value)==0)
                    {
                        free(node->child[i].child[k].child[0].attributs[l].value);
                        sprintf(aff,"nom_arme%hu",i-j+2);
                        node->child[i].child[k].child[0].attributs[l].value=g_strdup(aff);
                    }
                    else if (strcmp("bt_f_a2",node->child[i].child[k].child[0].attributs[l].value)==0)
                    {
                        free(node->child[i].child[k].child[0].attributs[l].value);
                        sprintf(aff,"bt_f_a%hu",i-j+2);
                        node->child[i].child[k].child[0].attributs[l].value=g_strdup(aff);
                    }
                    else if (strcmp("bt_m_a2",node->child[i].child[k].child[0].attributs[l].value)==0)
                    {
                        free(node->child[i].child[k].child[0].attributs[l].value);
                        sprintf(aff,"bt_m_a%hu",i-j+2);
                        node->child[i].child[k].child[0].attributs[l].value=g_strdup(aff);
                    }
                    else if (strcmp("bd_f_a2",node->child[i].child[k].child[0].attributs[l].value)==0)
                    {
                        free(node->child[i].child[k].child[0].attributs[l].value);
                        sprintf(aff,"bd_f_a%hu",i-j+2);
                        node->child[i].child[k].child[0].attributs[l].value=g_strdup(aff);
                    }
                    else if (strcmp("bd_m_a2",node->child[i].child[k].child[0].attributs[l].value)==0)
                    {
                        free(node->child[i].child[k].child[0].attributs[l].value);
                        sprintf(aff,"bd_m_a%hu",i-j+2);
                        node->child[i].child[k].child[0].attributs[l].value=g_strdup(aff);
                    }
                    else if (strcmp("d_p/m_a2",node->child[i].child[k].child[0].attributs[l].value)==0)
                    {
                        free(node->child[i].child[k].child[0].attributs[l].value);
                        sprintf(aff,"d_p/m_a%hu",i-j+2);
                        node->child[i].child[k].child[0].attributs[l].value=g_strdup(aff);
                    }
                    else if (strcmp("d_g_a2",node->child[i].child[k].child[0].attributs[l].value)==0)
                    {
                        free(node->child[i].child[k].child[0].attributs[l].value);
                        sprintf(aff,"d_g_a%hu",i-j+2);
                        node->child[i].child[k].child[0].attributs[l].value=g_strdup(aff);
                    }
                    else if (strcmp("bd_t_a2",node->child[i].child[k].child[0].attributs[l].value)==0)
                    {
                        free(node->child[i].child[k].child[0].attributs[l].value);
                        sprintf(aff,"bd_t_a%hu",i-j+2);
                        node->child[i].child[k].child[0].attributs[l].value=g_strdup(aff);
                    }
                    else if (strcmp("taco_a2",node->child[i].child[k].child[0].attributs[l].value)==0)
                    {
                        free(node->child[i].child[k].child[0].attributs[l].value);
                        sprintf(aff,"taco_a%hu",i-j+2);
                        node->child[i].child[k].child[0].attributs[l].value=g_strdup(aff);
                    }
                    else if (strcmp("cap_a2",node->child[i].child[k].child[0].attributs[l].value)==0)
                    {
                        free(node->child[i].child[k].child[0].attributs[l].value);
                        sprintf(aff,"cap_a%hu",i-j+2);
                        node->child[i].child[k].child[0].attributs[l].value=g_strdup(aff);
                    }
                    else if (strcmp("cr_a2",node->child[i].child[k].child[0].attributs[l].value)==0)
                    {
                        free(node->child[i].child[k].child[0].attributs[l].value);
                        sprintf(aff,"cr_a%hu",i-j+2);
                        node->child[i].child[k].child[0].attributs[l].value=g_strdup(aff);
                    }
                }
        }
    }


    for(i=0;i<((unsigned short **)param)[NB_ARMES][0];i++)
    {
        j=(armes[((unsigned short **)param)[ARMES][i]].vitesse==0?taco_lan:taco_tmp)-taco;
        sprintf(aff,"nom_arme%hu",i+1);
        switch (((unsigned short **)param)[NV_ARMES][i])
        {
            case 0 : sprintf(affichage,"%+hd%+hd",-j,nm);j-=nm;
                     sprintf(ch,"%s n-m",armes[((unsigned short **)param)[ARMES][i]].nom);
                     break;
            case 2 : sprintf(affichage,"%+hd+1",-j);j-=1;
                     sprintf(ch,"%s (SP)",armes[((unsigned short **)param)[ARMES][i]].nom);
                     break;
            case 3 : sprintf(affichage,"%+hd+3",-j);j-=3;
                     sprintf(ch,"%s (2SP)",armes[((unsigned short **)param)[ARMES][i]].nom);
                     break;
            default: sprintf(affichage,"%+hd",-j);
                     sprintf(ch,"%s",armes[((unsigned short **)param)[ARMES][i]].nom);
                     break;
        }
        modif_xml(g_markup_dom_nom (ooo,aff,"name"),ch);

        sprintf(aff,"bt_f_a%hu",i+1);
        modif_xml(g_markup_dom_nom (ooo,aff,"name"),affichage);
        j+=(taco-((signed short **)param)[MAG_ARMES][i]);

        sprintf(affichage,"%+hd",((signed short **)param)[MAG_ARMES][i]);
        sprintf(aff,"bt_m_a%hu",i+1);
        modif_xml(g_markup_dom_nom (ooo,aff,"name"),affichage);
        sprintf(aff,"bd_m_a%hu",i+1);
        modif_xml(g_markup_dom_nom (ooo,aff,"name"),affichage);

        if (version_t==ADD1 || ((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add2.nom==NULL)
        {
            for (l=0;((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add1.bonus_arme[l].arme!=NULL;l++)
                if( compare_sans_casse(armes[((unsigned short **)param)[ARMES][i]].nom,((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add1.bonus_arme[l].arme)==0)
                 j-=((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add1.bonus_arme[l].bonus;
        }
        else
            for (l=0;((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add2.bonus_arme[l].arme!=NULL;l++)
                if( compare_sans_casse(armes[((unsigned short **)param)[ARMES][i]].nom,((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add2.bonus_arme[l].arme)==0)
                 j-=((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add2.bonus_arme[l].bonus;
        sprintf(affichage,"%hd",j);
        sprintf(aff,"taco_a%hu",i+1);
        modif_xml(g_markup_dom_nom (ooo,aff,"name"),affichage);

        sprintf(aff,"bd_f_a%hu",i+1);
        k=armes[((unsigned short **)param)[ARMES][i]].vitesse==0?0:bonus;
        switch (((unsigned short **)param)[NV_ARMES][i])
        {
            case 2 : sprintf(affichage,"%+hd+2",k);k+=2;break;
            case 3 : sprintf(affichage,"%+hd+3",k);k+=3;break;
            default: sprintf(affichage,"%+hd",k);break;
        }
        modif_xml(g_markup_dom_nom (ooo,aff,"name"),affichage);

        fprintf(fichier," <arme niv='%hu' num='%hu' taco='%hd' degat='%hd' mag='%hu'>%s</arme>\n"
                                   ,((unsigned short **)param)[NV_ARMES][i],((unsigned short **)param)[ARMES][i],j,k+((signed short **)param)[MAG_ARMES][i],((signed short **)param)[MAG_ARMES][i],armes[((unsigned short **)param)[ARMES][i]].nom);

        sprintf(aff,"bd_t_a%hu",i+1);
        sprintf(affichage,"%+hd",k+((signed short **)param)[MAG_ARMES][i]);
        modif_xml(g_markup_dom_nom (ooo,aff,"name"),affichage);

        if (armes[((unsigned short **)param)[ARMES][i]].vitesse!=0)
        {
            j=armes[((unsigned short **)param)[ARMES][i]].vitesse;
            if (caract[FORCE]<=5)
             j*=1.2;
            else if  (caract[FORCE]<=8)
             j*=1.1;
            else if  (caract[FORCE]==25)
             j*=.2;
            else if  (caract[FORCE]==24)
             j*=.3;
            else if  (caract[FORCE]==23)
             j*=.4;
            else if  (caract[FORCE]>=21)
             j*=.5;
            else if  (caract[FORCE]>=19)
             j*=.6;
            else if  (caract[FORCE]==18)
            {
             if (caract[POURCENTAGE]>=76)
              j*=.7;
             else
              j*=.8;
            }
            else if  (caract[FORCE]==17)
             j*=.8;
            else if  (caract[FORCE]>=14)
             j*=.9;
            if (j<2) j--;
            else     j++;
            j=3-j/2;
            if (caract[DEXTERITE]>=24)
             j+=3;
            else if (caract[DEXTERITE]>=21)
             j+=2;
            else if (caract[DEXTERITE]>=18)
             j++;
            else if (caract[DEXTERITE]<=4)
             j-=2;
            else if (caract[DEXTERITE]<=14)
             j--;
            switch (((unsigned short **)param)[NV_ARMES][i])
            {
                case 2 : j+=2;break;
                case 3 : j+=3;break;
                default: break;
            }

            sprintf(affichage,"%+hd",j+initiative);
            sprintf(aff,"cap_a%hu",i+1);
            modif_xml(g_markup_dom_nom (ooo,aff,"name"),affichage);

            j=(armes[((unsigned short **)param)[ARMES][i]].longueur-1)/30-3;
            if (j>0) j--;
            j=min_(j,3);
            j=max(j,-3);
            if (caract[DEXTERITE]>=18)
             j+=2;
            else if (caract[DEXTERITE]>=15)
             j++;
            else if (caract[DEXTERITE]<=4)
             j-=2;
            else if (caract[DEXTERITE]<=7)
             j--;
            switch (((unsigned short **)param)[NV_ARMES][i])
            {
                case 2 : j+=2;break;
                case 3 : j+=3;break;
                default: break;
            }

            sprintf(affichage,"%+hd",j+initiative);
            sprintf(aff,"cr_a%hu",i+1);
            modif_xml(g_markup_dom_nom (ooo,aff,"name"),affichage);
        }
        else
        {
            if (sscanf(g_markup_dom_nom (ooo,"dexterite2","name")->content->texte,"%d",&j)!=1) j=0;
            sprintf(affichage,"%+hd",initiative+j);
            sprintf(aff,"cr_a%hu",i+1);
            modif_xml(g_markup_dom_nom (ooo,aff,"name"),affichage);
        }

        sprintf(aff,"d_p/m_a%hu",i+1);
        modif_xml(g_markup_dom_nom (ooo,aff,"name"),armes[((unsigned short **)param)[ARMES][i]].PM);

        sprintf(aff,"d_g_a%hu",i+1);
            modif_xml(g_markup_dom_nom (ooo,aff,"name"),armes[((unsigned short **)param)[ARMES][i]].G);
    }
    fprintf(fichier,"</armes>\n");

    if (bt!=0)
    {
        sprintf(affichage,"+4 , x%hd",bt);
        modif_xml(g_markup_dom_nom (ooo,"backstab","name"),affichage);
    }
    sprintf(affichage,"n.m : %hd",nm);
    modif_xml(g_markup_dom_nom (ooo,"nonmaitrise","name"),affichage);

    /* save */
    sprintf(affichage,"%hd",spmp);
    modif_xml(g_markup_dom_nom (ooo,"spmp","name"),affichage);
    fprintf(fichier,"<save spmp='%s'",affichage);
    sprintf(affichage,"%hd",sbb);
    modif_xml(g_markup_dom_nom (ooo,"sbb","name"),affichage);
    fprintf(fichier," sbb='%s'",affichage);
    sprintf(affichage,"%hd",spp);
    modif_xml(g_markup_dom_nom (ooo,"spp","name"),affichage);
    fprintf(fichier," spp='%s'",affichage);
    sprintf(affichage,"%hd",ssor);
    modif_xml(g_markup_dom_nom (ooo,"ssor","name"),affichage);
    fprintf(fichier," ssor='%s'",affichage);
    sprintf(affichage,"%hd",ssou);
    modif_xml(g_markup_dom_nom (ooo,"ssou","name"),affichage);
    fprintf(fichier," ssoo='%s' />",affichage);

    sprintf(affichage,"%hd",taco);
    modif_xml(g_markup_dom_nom (ooo,"taco","name"),affichage);

    sprintf(affichage,"Sexe : %s",sexe);
    modif_xml(g_markup_dom_nom (ooo,"sexe","name"),affichage);
    if (version_t==ADD1 || ((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add2.nom==NULL)
    {
        sprintf(affichage,"Race : %s",((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add1.nom);
        modif_xml(g_markup_dom_nom (ooo,"race","name"),affichage);
        if (((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add1.resistance!=NULL)
            modif_xml(g_markup_dom_nom (ooo,"resistance","name"),((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add1.resistance);
        if (((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add1.vision!=NULL)
            modif_xml(g_markup_dom_nom (ooo,"vision","name"),((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add1.vision);
        aff[0]=0;
        for(i=0;((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add1.detection[i]!=NULL;i++)
        {
            if (i!=0) strcpy(aff,((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add1.detection[0]);
            else      strcat(aff,((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add1.detection[i]);
        }
        modif_xml(g_markup_dom_nom (ooo,"detection","name"),aff);
        if (((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add1.ecoute!=NULL)
            modif_xml(g_markup_dom_nom (ooo,"ecoute","name"),((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add1.ecoute);
    }
    else
    {
        sprintf(affichage,"Race : %s",((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add2.nom);
        modif_xml(g_markup_dom_nom (ooo,"race","name"),affichage);
        if (((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add2.resistance!=NULL)
            modif_xml(g_markup_dom_nom (ooo,"resistance","name"),((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add2.resistance);
        if (((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add2.vision!=NULL)
            modif_xml(g_markup_dom_nom (ooo,"vision","name"),((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add2.vision);
        aff[0]=0;
        for(i=0;((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add2.detection[i]!=NULL;i++)
        {
            if (i!=0) strcpy(aff,((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add2.detection[0]);
            else      strcat(aff,((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add2.detection[i]);
        }
        modif_xml(g_markup_dom_nom (ooo,"detection","name"),aff);
        if (((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add2.ecoute!=NULL)
            modif_xml(g_markup_dom_nom (ooo,"ecoute","name"),((struct_race ***)param)[MENU][MAIN_RACE][((unsigned short **)param)[RACE][0]].add2.ecoute);
    }


    fprintf(fichier,"<pdv nb_niv='%hu'>\n",((unsigned short **)param)[NB_PDV][0]);
    sprintf(affichage,"Points de vie : ");
    j=0;
    for(i=0;i<((unsigned short **)param)[NB_PDV][0];i++)
    {
        fprintf(fichier," <pdv_n niv='%hu'>%hu</pdv_n>\n",i+1,((unsigned short **)param)[PDV][i]);
        j+=((unsigned short **)param)[PDV][i];
        if (i!=0) strcat(affichage,"+");
        sprintf(ch,"%hd",((unsigned short **)param)[PDV][i]);
        strcat(affichage,ch);
    }
    sprintf(ch,"=%hd",j);
    strcat(affichage,ch);
    fprintf(fichier,"</pdv>\n");
    modif_xml(g_markup_dom_nom (ooo,"pdv","name"),affichage);

    fprintf(fichier,"<competence>\n");
    *affichage=0;
    tmp_node=g_markup_dom_nom (ooo,"connaissance0","name");
    for(i=0;i<((unsigned short **)param)[NB_COMP][0];i++)
    {
        fprintf(fichier," <comp niv='%hu'>%s</comp>\n",((unsigned short **)param)[NV_COMP][i],competences[((unsigned short **)param)[COMP][i]].nom);
        if (i!=0)
        {
            xml_ajoute_fin(tmp_node,"text:line-break");
        }
        xml_ajoute_fin_texte(tmp_node);
        xml_ecrit_dernier_texte(tmp_node,competences[((unsigned short **)param)[COMP][i]].nom);
        xml_ajoute_fin(tmp_node,"text:tab");
        xml_ajoute_fin_texte(tmp_node);
        if (competences[((unsigned short **)param)[COMP][i]].caract!=POURCENTAGE)
        {
            /*if (ranger!=0 && ((unsigned short **)param)[COMP][i]==52)
            {
                sprintf(ch,"%hd",caract[competences[((unsigned short **)param)[COMP][i]].caract]+competences[((unsigned short **)param)[COMP][i]].modif+((unsigned short **)param)[NV_COMP][i]-1+ranger);
                ranger=0;
            }
            else*/
                sprintf(ch,"%hd",caract[competences[((unsigned short **)param)[COMP][i]].caract]+competences[((unsigned short **)param)[COMP][i]].modif+((unsigned short **)param)[NV_COMP][i]-1);
            xml_ecrit_dernier_texte(tmp_node,ch);
        }
        else
            xml_ecrit_dernier_texte(tmp_node,"NA");
    }
    /*if (ranger!=0)
    {
        if (i!=0)
        {
            xml_ajoute_fin(tmp_node,"text:line-break");
        }
        xml_ajoute_fin_texte(tmp_node);
        xml_ecrit_dernier_texte(tmp_node,competences[52].nom);
        xml_ajoute_fin(tmp_node,"text:tab");
        xml_ajoute_fin_texte(tmp_node);
        sprintf(ch,"%hd",caract[competences[52].caract]+competences[52].modif+ranger-1);
        xml_ecrit_dernier_texte(tmp_node,ch);
    }*/
    fprintf(fichier,"</competence>\n<voleur>\n");
     for (j=0;j<8;j++)
     {
         sprintf(ch,"%hu",((unsigned short **)param)[C_VOLEUR][j]);
         modif_xml(g_markup_dom_nom (ooo,nom_fac_vol[j],"name"),ch);
         fprintf(fichier," <vol name=\"%s\">%hd</vol>\n",nom_fac_vol[j],((unsigned short **)param)[C_VOLEUR][j]);
     }
    fprintf(fichier,"</voleur>\n");


    if (((char ***)param)[PANTHEON][0])
    {
        fprintf(fichier,"<pantheon>\n %s\n",((char ***)param)[PANTHEON][0]);
        sprintf(ch,"Panthéon : %s",((char ***)param)[PANTHEON][0]);
        modif_xml(g_markup_dom_nom (ooo,"pantheon","name"),ch);
        if (((char ***)param)[DIEU][0])
        {
            fprintf(fichier," <dieu>\n  %s\n",((char ***)param)[DIEU][0]);
            fprintf(fichier," </dieu>\n");
            sprintf(ch,"Dieu : %s",((char ***)param)[DIEU][0]);
            modif_xml(g_markup_dom_nom (ooo,"dieu","name"),ch);

            node=noded;
            node=node->child;
            for(i=0;i<node->fils;i++)
            {
                if (node->child[i].texte>0)
                if (compare(node->child[i].content[0].texte,((char ***)param)[PANTHEON][0]))
                {
                    node=node->child+i;
                    i=node->fils;
                }
            }
            if (node->texte>0 && compare(node->content[0].texte,((char ***)param)[PANTHEON][0]))
            {
                for(i=0;i<node->fils;i++)
                {
                    if (node->child[i].texte>0)
                    if (compare(node->child[i].content[0].texte,((char ***)param)[DIEU][0]))
                    {
                        tmp_node=node->child+i;
                        i=node->fils;
                    }
                }
                if (tmp_node->texte>0 && compare(tmp_node->content[0].texte,((char ***)param)[DIEU][0]))
                {
                    node=g_markup_dom_node(tmp_node,"symbole");
                    if (node!=NULL && node->texte>0)
                    {
                        sprintf(ch,"Symbole de %s : %s",((char ***)param)[DIEU][0],node->content[0].texte);
                        modif_xml(g_markup_dom_nom (ooo,"symbole_dieu","name"),ch);
                    }
                    node=g_markup_dom_node(tmp_node,"commentaire");
                    if (node!=NULL && node->texte>0)
                    {
                        modif_xml(g_markup_dom_nom (ooo,"commentaire_dieu","name"),node->content[0].texte);
                    }
                }
            }


        }
        fprintf(fichier,"</pantheon>\n");
    }

    if (((char **)param)[TEXTE_COM])
    {
        fprintf(fichier,"<com>\n%s\n</com>\n",((char **)param)[TEXTE_COM]);
        tmp_node=g_markup_dom_nom (ooo,"dern_sect","name");
        xml_ecrit_dernier_texte_f(g_markup_dom_nom (ooo,"commentaires","name"),((char **)param)[TEXTE_COM]);
    }
    l=0;
    for (i=0;i<9;i++)
    {
        if (((unsigned short **)param)[NB_SORT_MAG_NIV][i]!=0)
        {
                affiche_sort_mag(i,param,ooo);

                node=g_markup_dom_node(ooo,"office:text");
                if (l==0)
                {
                    fprintf(fichier,"<mag>\n");
                    l=1;
                }
                fprintf(fichier," <niv niv=\"%hu\">\n",i+1);
                for(j=0;j<((unsigned short **)param)[NB_SORT_MAG_NIV][i];j++)
                    fprintf(fichier,"  <sort niv=\"%hu\">%s</sort>\n",((char ***)param)[SORT_MAG_MAIT][i][j],((char ****)param)[SORT_MAG][i][j]);
                fprintf(fichier," </niv>\n");

                /* affichage des codes : sorts compris, non compris, dans le livre */
                xml_ajoute_fin(node,"text:p");
                xml_ajoute_fin(node,"table:table");
                node=node->child+node->fils-1; /* on arrive sur la dernière node */
                for (j=0;j<6;j++) xml_ajoute_fin(node,"table:table-column");
                for (j=0;j<6;j++)
                {
                    xml_ajoute_fin_attribut(node->child+j); /* rajouter un élément attribut */
                    xml_ecrit_dernier_attribut(node->child+j,"table:style-name","Tableau1.VDA"); /* remplace le dernier attribut */
                }
                xml_ajoute_fin(node,"table:table-row"); /* node pointera sur le tableau du niveau */
                tmp_node=node->child+node->fils-1; /* on arrive sur la dernière node */
                xml_ajoute_fin(tmp_node,"table:table-cell"); /* création de la case */
                xml_ajoute_fin_attribut(tmp_node->child); /* rajouter un élément attribut */
                xml_ecrit_dernier_attribut(tmp_node->child,"table:style-name","Tableau1.VD1"); /* remplace le dernier attribut */
                xml_ajoute_fin_attribut(tmp_node->child); /* rajouter un élément attribut */
                xml_ecrit_dernier_attribut(tmp_node->child,"office:value-type","string"); /* remplace le dernier attribut */
                xml_ajoute_fin(tmp_node->child,"text:p");
                xml_ajoute_fin_texte(tmp_node->child->child);
                xml_ecrit_dernier_texte(tmp_node->child->child,"Légende : couleur des sorts");
                /* compris */
                xml_ajoute_fin(tmp_node,"table:table-cell"); /* création de la case */
                xml_ajoute_fin(tmp_node->child+1,"text:p");
                xml_ajoute_fin_texte(tmp_node->child[1].child);
                xml_ecrit_dernier_texte(tmp_node->child[1].child,"Compris");
                xml_ajoute_fin_attribut(tmp_node->child+1); /* rajouter un élément attribut */
                xml_ecrit_dernier_attribut(tmp_node->child+1,"table:style-name","Tableau1.VD2"); /* remplace le dernier attribut */
                xml_ajoute_fin_attribut(tmp_node->child+1); /* rajouter un élément attribut */
                xml_ecrit_dernier_attribut(tmp_node->child+1,"office:value-type","string"); /* remplace le dernier attribut */
                xml_ajoute_fin_attribut(tmp_node->child[1].child); /* rajouter un élément attribut */
                xml_ecrit_dernier_attribut(tmp_node->child[1].child,"text:style-name","sort"); /* remplace le dernier attribut */
                /* pas_compris */
                xml_ajoute_fin(tmp_node,"table:table-cell"); /* création de la case */
                xml_ajoute_fin(tmp_node->child+2,"text:p");
                xml_ajoute_fin_texte(tmp_node->child[2].child);
                xml_ecrit_dernier_texte(tmp_node->child[2].child,"Pas compris");
                xml_ajoute_fin_attribut(tmp_node->child+2); /* rajouter un élément attribut */
                xml_ecrit_dernier_attribut(tmp_node->child+2,"table:style-name","Tableau1.VD2"); /* remplace le dernier attribut */
                xml_ajoute_fin_attribut(tmp_node->child+2); /* rajouter un élément attribut */
                xml_ecrit_dernier_attribut(tmp_node->child+2,"office:value-type","string"); /* remplace le dernier attribut */
                xml_ajoute_fin_attribut(tmp_node->child[2].child); /* rajouter un élément attribut */
                xml_ecrit_dernier_attribut(tmp_node->child[2].child,"text:style-name","pas_compris"); /* remplace le dernier attribut */
                /* pas_lu */
                xml_ajoute_fin(tmp_node,"table:table-cell"); /* création de la case */
                xml_ajoute_fin(tmp_node->child+3,"text:p");
                xml_ajoute_fin_texte(tmp_node->child[3].child);
                xml_ecrit_dernier_texte(tmp_node->child[3].child,"Pas regardé");
                xml_ajoute_fin_attribut(tmp_node->child+3); /* rajouter un élément attribut */
                xml_ecrit_dernier_attribut(tmp_node->child+3,"table:style-name","Tableau1.VD2"); /* remplace le dernier attribut */
                xml_ajoute_fin_attribut(tmp_node->child+3); /* rajouter un élément attribut */
                xml_ecrit_dernier_attribut(tmp_node->child+3,"office:value-type","string"); /* remplace le dernier attribut */
                xml_ajoute_fin_attribut(tmp_node->child[3].child); /* rajouter un élément attribut */
                xml_ecrit_dernier_attribut(tmp_node->child[3].child,"text:style-name","pas_lu"); /* remplace le dernier attribut */

                xml_ajoute_fin(tmp_node,"table:table-cell"); /* création de la case */
                xml_ajoute_fin(tmp_node->child+4,"text:p");
                xml_ajoute_fin_texte(tmp_node->child[4].child);
                xml_ecrit_dernier_texte(tmp_node->child[4].child,"Mauvaise École");
                xml_ajoute_fin_attribut(tmp_node->child+4); /* rajouter un élément attribut */
                xml_ecrit_dernier_attribut(tmp_node->child+4,"table:style-name","Tableau1.VD2"); /* remplace le dernier attribut */
                xml_ajoute_fin_attribut(tmp_node->child+4); /* rajouter un élément attribut */
                xml_ecrit_dernier_attribut(tmp_node->child+4,"office:value-type","string"); /* remplace le dernier attribut */
                xml_ajoute_fin_attribut(tmp_node->child[4].child); /* rajouter un élément attribut */
                xml_ecrit_dernier_attribut(tmp_node->child[4].child,"text:style-name","pas_ecole"); /* remplace le dernier attribut */

                xml_ajoute_fin(tmp_node,"table:table-cell"); /* création de la case */
                xml_ajoute_fin(tmp_node->child+5,"text:p");
                xml_ajoute_fin_texte(tmp_node->child[5].child);
                xml_ecrit_dernier_texte(tmp_node->child[5].child,"École Spécialiste");
                xml_ajoute_fin_attribut(tmp_node->child+5); /* rajouter un élément attribut */
                xml_ecrit_dernier_attribut(tmp_node->child+5,"table:style-name","Tableau1.VD3"); /* remplace le dernier attribut */
                xml_ajoute_fin_attribut(tmp_node->child+5); /* rajouter un élément attribut */
                xml_ecrit_dernier_attribut(tmp_node->child+5,"office:value-type","string"); /* remplace le dernier attribut */
                xml_ajoute_fin_attribut(tmp_node->child[5].child); /* rajouter un élément attribut */
                xml_ecrit_dernier_attribut(tmp_node->child[5].child,"text:style-name","ecole_OK"); /* remplace le dernier attribut */
        }
    }
    if (l!=0)
    {
        fprintf(fichier,"</mag>\n");
    }
    fprintf(fichier,"<taille>%hu</taille>\n<poids>%hu</poids>\n",((unsigned short **)param)[TAILLE][0],((unsigned short **)param)[POIDS][0]);
    sprintf(ch,"%hu cm",((unsigned short **)param)[TAILLE][0]);
    modif_xml(g_markup_dom_nom (ooo,"taille","name"),ch);
    sprintf(ch,"%hu kg",((unsigned short **)param)[POIDS][0]);
    modif_xml(g_markup_dom_nom (ooo,"poids","name"),ch);
    /* affichage des xp dans la feuille de personnage */
     modif_xml(g_markup_dom_nom (ooo,"actu_xp","name"),actu_xp);
     modif_xml(g_markup_dom_nom (ooo,"but_xp","name"),but_xp);
     /* enregistrement des points divers */
    fprintf(fichier,"<nom>\n");
     if (!str_isspace (((char **)param)[PERSO]))
     {
        modif_xml(g_markup_dom_nom (ooo,"nom","name"),((char **)param)[PERSO]);
        fprintf(fichier," <perso>%s</perso>\n",((char **)param)[PERSO]);
     }
     else
        modif_xml(g_markup_dom_nom (ooo,"nom","name"),((char **)param)[NOM]);
     if (!str_isspace (((char **)param)[JOUEUR]))
     {
        modif_xml(g_markup_dom_nom (ooo,"joueur","name"),((char **)param)[JOUEUR]);
        fprintf(fichier," <joueur>%s</joueur>\n",((char **)param)[JOUEUR]);
     }
     fprintf(fichier,"</nom>\n");
     fprintf(fichier,"<couleur>\n");
     if (!str_isspace (((char **)param)[COULEUR_CHEVEUX]))
     {
        modif_xml(g_markup_dom_nom (ooo,"cheveux","name"),((char **)param)[COULEUR_CHEVEUX]);
        fprintf(fichier," <cheveux>%s</cheveux>\n",((char **)param)[COULEUR_CHEVEUX]);
     }
     if (!str_isspace (((char **)param)[COULEUR_PEAU]))
     {
        modif_xml(g_markup_dom_nom (ooo,"peau","name"),((char **)param)[COULEUR_PEAU]);
        fprintf(fichier," <peau>%s</peau>\n",((char **)param)[COULEUR_PEAU]);
     }
     if (!str_isspace (((char **)param)[COULEUR_YEUX]))
     {
        modif_xml(g_markup_dom_nom (ooo,"yeux","name"),((char **)param)[COULEUR_YEUX]);
        fprintf(fichier," <yeux>%s</yeux>\n",((char **)param)[COULEUR_YEUX]);
     }
    fprintf(fichier,"</couleur>\n");
    if (!str_isspace (((char **)param)[CLASSE_SOCIALE]))
    {
        modif_xml(g_markup_dom_nom (ooo,"classe sociale","name"),((char **)param)[CLASSE_SOCIALE]);
        fprintf(fichier,"<classoc>%s</classoc>\n",((char **)param)[CLASSE_SOCIALE]);
    }
    if (!str_isspace (((char **)param)[AGE]))
    {
        modif_xml(g_markup_dom_nom (ooo,"age","name"),((char **)param)[AGE]);
        fprintf(fichier,"<age>%s</age>\n",((char **)param)[AGE]);
    }
    modif_xml(g_markup_dom_nom (ooo,"alignement","name"),algnm[((unsigned short **)param)[ALIGNEMENT][0]]);
    fprintf(fichier,"<alignement>%s</alignement>\n",algnm[((unsigned short **)param)[ALIGNEMENT][0]]);


    /* fermeture du fichier xml */
    fprintf(fichier,"</document>");
    fclose (fichier);
    /* traitement du fichier xml et génération du fichier odt */

    tmp=rep_tmp();
    sprintf(ch,"%s%ccontent.xml",tmp,SEPARATEUR);
    enregistre_xml(ch,ooo);
    tmp1=chemin_exe();
    sprintf(affichage,"%s%cLibO%cfeuille.zip",tmp1,SEPARATEUR,SEPARATEUR);
    sprintf(aff,"%s%cfeuille.zip",tmp,SEPARATEUR);
    copie_fichier(aff,affichage);
    chdir(tmp);
    free(tmp);
#ifdef __linux__
    f_zip=zip_open("feuille.zip",ZIP_CREATE,NULL);
    n_zip=zip_source_file(f_zip,"content.xml",0,0);
    zip_replace(f_zip,zip_name_locate(f_zip,"content.xml",ZIP_FL_NOCASE) ,n_zip);
    zip_close(f_zip);
#else
    sprintf(affichage,"\"%s%cLibO%czip.exe\"  feuille.zip content.xml",tmp1,SEPARATEUR,SEPARATEUR);
    system(affichage); /* http://www.developpez.net/forums/d1009879/general-developpement/programmation-linux/gtk/portage-sous-windows/#post5652109 */
#endif
    sprintf(affichage,"%s%c%s.odt",((char **)param)[CHEMIN],SEPARATEUR,((char **)param)[NOM]);
    copie_fichier(affichage,aff);
    remove(aff); /* enlever les deux fichiers temporaires */
    remove(ch);
    chdir(tmp1);
    free(tmp1);
    g_markup_dom_free(ooo);
    g_markup_dom_free(noded);

  free(nom_de_fichier);
}

int ouvrir_fichier (GtkWidget *wid, gpointer param)
{
  GtkWidget *p_dialog = NULL, * win;
  char * nom_de_fichier,*tmp,*tmp1=NULL,ch[LONG];
  GMarkupDomNode *node=NULL;
  FILE * fp;

  ((unsigned short **)param)[MODIF][0]=0;

  p_dialog = gtk_file_chooser_dialog_new ("Ouvrir un personnage", NULL,
                                          GTK_FILE_CHOOSER_ACTION_OPEN,
                                          GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
                                          GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT,
                                          NULL);

  if (((char **)param)[NOM]!=NULL && ((char **)param)[NOM][0]!=0)
  {
       sprintf(ch,"%s.pers",((char **)param)[NOM]);
       gtk_file_chooser_set_filename (GTK_FILE_CHOOSER(p_dialog),ch);
       gtk_file_chooser_set_current_folder (GTK_FILE_CHOOSER(p_dialog),((char **)param)[CHEMIN]);
  }
  else
  {
     tmp=envp_donne_home();
     gtk_file_chooser_set_current_folder (GTK_FILE_CHOOSER(p_dialog),tmp);
     free(tmp);
  }

 if (gtk_dialog_run (GTK_DIALOG (p_dialog)) == GTK_RESPONSE_ACCEPT)
 {
    nom_de_fichier = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (p_dialog));
    gtk_widget_destroy (p_dialog);

    for(tmp=nom_de_fichier;*tmp;tmp++);
    for(;*tmp!=SEPARATEUR && tmp!=nom_de_fichier;tmp--)
     if (*tmp=='.')
      tmp1=tmp;
    if (tmp && tmp!=nom_de_fichier) *tmp=0;
    ((char **)param)[CHEMIN]=g_strdup(nom_de_fichier);
    if (tmp1)
    {
        *tmp1=0;
        ((char **)param)[NOM]=g_strdup(tmp+1);
        *tmp1='.';
    }
    else
        ((char **)param)[NOM]=g_strdup(tmp+1);
    if (tmp && tmp!=nom_de_fichier) *tmp=SEPARATEUR;
    if ((win=deja_edite(nom_de_fichier))!=NULL)
    {
        ((GtkWindow **)param)[FENETRE]=GTK_WINDOW(win);
        free(nom_de_fichier);
        return 4;
    }
    if ((node = g_markup_dom_new (nom_de_fichier, NULL)))
    {
        if (g_markup_dom_node (node,"pantheon")==NULL)
        {
             sprintf(ch,"le fichier\n%s\n ne correspond pas à un fichier pers de personnage",nom_de_fichier);
             p_dialog = gtk_message_dialog_new (GTK_WINDOW(((GtkWindow **)param)[FENETRE] ),GTK_DIALOG_MODAL,GTK_MESSAGE_INFO,GTK_BUTTONS_CLOSE,ch);
             gtk_dialog_run(GTK_DIALOG(p_dialog));
             gtk_widget_destroy(p_dialog);
             free(nom_de_fichier);
             free(((char **)param)[NOM]);
             ((char **)param)[NOM]=NULL;
             free(((char **)param)[CHEMIN]);
             ((char **)param)[CHEMIN]=NULL;
             return 1;
        }  /* nom vraimant particulier => trouver une erreur dans le fichier pers */
    }
    else
    {
         sprintf(ch,"le fichier\n%s\n ne correspond pas à un fichier de personnage\nSVP : me dire comment vous avez fait pour afficher ce message !",nom_de_fichier);
         p_dialog = gtk_message_dialog_new (GTK_WINDOW(((GtkWindow **)param)[FENETRE] ),GTK_DIALOG_MODAL,GTK_MESSAGE_INFO,GTK_BUTTONS_CLOSE,ch);
         gtk_dialog_run(GTK_DIALOG(p_dialog));
         gtk_widget_destroy(p_dialog);
         free(nom_de_fichier);
         return 2;
    }
    free(nom_de_fichier);
    if (((GtkWidget **)param)[FENETRE]!=NULL)
         affiche_caract(node,param); /* pour le cas où on ouvre un fichier au départ => toujours maintenant il me semble ! */
 }
 else
  gtk_widget_destroy (p_dialog);

 if (node==NULL) return 3;
 if (((GtkWidget**)param)[FILS]!=NULL)
    gtk_widget_destroy(((GtkWidget **)param)[FILS]);
    //g_signal_emit_by_name(((GtkWidget **)param)[FILS],"destroy",NULL);

 g_markup_dom_free(node);

 sprintf(ch,"%s%c%s.pers",((char **)param)[CHEMIN],SEPARATEUR,((char **)param)[NOM]);
 envp_mem_hist(ch);
 envp_init(((gpointer **)param)[MENU]);
 envp_mem_home(((char **)param)[CHEMIN]);
 sprintf(ch,"%s%c%s.pers.lock",((char **)param)[CHEMIN],SEPARATEUR,((char **)param)[NOM]);
 fp = fopen(ch, "w");
 fprintf(fp,"%ld %p",(signed long)getpid(),((GtkWindow **)param)[FENETRE]);
 fclose(fp);

 (void)wid;

 return 0;
}
