/*
    Génération de feuille de personnage complète AD&D 1 et 2
    Génération aléatoire de personnage

    Copyright (C) 2011 Bernard SIAUD

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#ifdef __linux__
#include <zip.h>
#endif
#include "include.h"

void svg_gr             (gpointer param);
void feuille_groupe     (gpointer param);
void sauve_groupe       (GtkWidget *wid, gpointer param);
void sauve_groupe_as    (GtkWidget *wid, gpointer param);
void nv_pers_groupe     (GtkWidget *wid, gpointer param);
void sup_pers_groupe    (GtkWidget *wid, gpointer param);
void pers_groupe_destroy(GtkWidget *wid, gpointer param);
void pers_groupe_aff    (GtkWidget *wid, gpointer param);
void active_fin_groupe  (GtkWidget *wid, gpointer param);
struct_groupe * ouvrir_perso_groupe(struct_groupe * debut,gpointer param_t);


//void ouvrir_groupe (GtkWidget *wid, gpointer param)
void ouvrir_groupe (GtkWidget *wid, gpointer param)
{
  GtkWidget *button = NULL;
  GtkWidget *win = NULL;
  GtkWidget *vbox = NULL;
  GtkWidget *vbox1 = NULL;
  GError * error;
  gpointer * param_t=(gpointer *)malloc(10*sizeof(gpointer)); /* la case 9 est pour les chemins */
  guint rep=0;
  GMarkupDomNode * node=NULL,* node1=NULL;
  GtkFileFilter * filtre= gtk_file_filter_new();
  char * nom_de_fichier=NULL,* tmp, * tmp1;
  struct_groupe * debut=NULL, * gr_tmp=NULL;
  char ch[LONG],aff[LONG];
  gint x=30,y=30,l,h;
  FILE * fp;

  param_t[1]=NULL;
  param_t[2]=NULL;
  param_t[8]=param; /* menu */
  ((unsigned short **)param_t)[5]=(unsigned short *)malloc(sizeof(unsigned short)); /* modif ou non */


  if (((gpointer *)param)[4]==NULL)
  {
    win = gtk_file_chooser_dialog_new ("Ouvrir un groupe de personnages", NULL,
                                          GTK_FILE_CHOOSER_ACTION_OPEN,
                                          GTK_STOCK_NEW, GTK_RESPONSE_CANCEL,
                                          GTK_STOCK_OPEN, GTK_RESPONSE_YES,
                                          NULL);

     gtk_file_filter_add_pattern (filtre,"*.grp");
     gtk_file_chooser_set_filter(GTK_FILE_CHOOSER(win),filtre);
     tmp=envp_donne_home();
     gtk_file_chooser_set_current_folder (GTK_FILE_CHOOSER(win),tmp);
     free(tmp);
     rep=gtk_dialog_run (GTK_DIALOG (win));

  }
 if ( (gint)rep == GTK_RESPONSE_YES || ((gpointer *)param)[4]!=NULL)
 {
     if (((gpointer *)param)[4]==NULL)
     {
#ifdef __linux__
        nom_de_fichier = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (win));
#else
        nom_de_fichier=windows_home(gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (win)));
#endif
        gtk_widget_destroy (win);
     }
     else
     {
         nom_de_fichier=g_strdup(((char **)param)[4]);
         //free(((char **)param)[4]);
         ((gpointer *)param)[4]=NULL;
     }
     if (deja_edite(nom_de_fichier))
        return;

    node = g_markup_dom_new (nom_de_fichier, NULL);
    if (node!=NULL) node1=g_markup_dom_node (node,"document");
    if (node1==NULL || node1->nb_att==0 || strcmp(node1->attributs->value,"groupe")!=0)
    {
         sprintf(ch,"le fichier\n%s\n ne correspond pas à un fichier grp de groupe",nom_de_fichier);
         win = gtk_message_dialog_new (GTK_WINDOW(((GtkWidget **)param)[0]),GTK_DIALOG_MODAL,GTK_MESSAGE_INFO,GTK_BUTTONS_CLOSE,ch);
         gtk_dialog_run(GTK_DIALOG(win));
         gtk_widget_destroy(win);
         free(nom_de_fichier);
         free(param_t);
         return;
    }  /* nom vraimant particulier => trouver une erreur dans le fichier pers */

    envp_mem_hist(nom_de_fichier);
    envp_init(param);

    tmp1=NULL;
    for(tmp=nom_de_fichier;*tmp;tmp++) if (*tmp==SEPARATEUR) tmp1=tmp;
    if (tmp1!=NULL)
    {
        *tmp1=0;
        envp_mem_home(nom_de_fichier);
        *tmp1=SEPARATEUR;
    }
    else
        envp_mem_home("");
    tmp1=NULL;
    for(;*tmp!=SEPARATEUR && tmp!=nom_de_fichier;tmp--) if (*tmp=='.') tmp1=tmp;
    if (tmp!=nom_de_fichier)
    {
      *tmp=0;
      ((char **)param_t)[1]=g_strdup(nom_de_fichier);
      tmp++;
    }
    else
    {
        ((char **)param_t)[1]=g_strdup(".");
    }
    if (tmp1!=NULL)
    {
        *tmp1=0;
    }
    ((char **)param_t)[2]=g_strdup(tmp);
    gr_tmp=NULL;
    //chdir(((char **)param_t)[1]);
    for (rep=0;rep<node1->fils;rep++)
    {
        /* mise bout à bout des chemins du fichier groupe et du perso */
        tmp=node1->child[rep].content->texte;
        if (*tmp!=SEPARATEUR)
        {
            strcpy(aff,((char **)param_t)[1]);
            for(tmp1=aff;*tmp1!=0;tmp1++);
            if (*tmp=='.' &&  *(tmp+1)==SEPARATEUR)
            { /* repérer ./ en début */
                tmp+=2;
            }
            while (*tmp=='.' &&  *(tmp+1)=='.' &&  *(tmp+2)==SEPARATEUR) /* repérer ../ en début */
            { /* descendre d'un niveau dans le chemin pour chaque ../ repéré */
                while  (tmp1>((char **)param_t)[1] && (*tmp1==SEPARATEUR || *tmp1==0) )
                    tmp1--; /* les / de la fin du dernier chemin */
                while (tmp1>((char **)param_t)[1] && *tmp1!=SEPARATEUR)
                    tmp1--;
                tmp+=3;
            }
            *tmp1=0;
            sprintf(ch,"%s%c%s.pers",aff,SEPARATEUR,tmp);
        }
        else
            sprintf(ch,"%s.pers",tmp);
        param_t[9]=(gpointer *)ch;
        //gr_tmp=ouvrir_perso_groupe(debut,GTK_WINDOW(win),param_t);
        gr_tmp=ouvrir_perso_groupe(debut,param_t);
        if (gr_tmp!=NULL)
        {
            debut=gr_tmp;
            param_t[4]=(gpointer)debut;
        }
    }
    g_markup_dom_free(node);

    free(nom_de_fichier);
 }
 else
 {
    gtk_widget_destroy (win);
    param_t[4]=(gpointer)debut;
 }

  win = gtk_window_new (GTK_WINDOW_TOPLEVEL); /* déclaration d'une fenêtre complète */
  gtk_container_set_border_width (GTK_CONTAINER (win), 8);
  gtk_window_set_title (GTK_WINDOW (win), "Groupes de personnages");
  //gtk_window_set_position (GTK_WINDOW (win), GTK_WIN_POS_CENTER);
  gtk_widget_realize (win);
  /* icone */
  tmp=chemin_exe();
  sprintf(ch,"%s%cgroupe_ico.png",tmp,SEPARATEUR);
  free(tmp);
  if (!gtk_window_set_icon_from_file(GTK_WINDOW (win),ch,&error))
  {                                                                  /* met une icone à la fenêtre                                   */
   traite_erreur(error);
   g_error_free(error);
  }

  /* Create a vertical box with buttons */
  vbox = gtk_vbox_new (FALSE, 6);
  gtk_container_add (GTK_CONTAINER (win), vbox);


  button = gtk_button_new_from_stock (GTK_STOCK_ADD); /*GTK_STOCK_DIALOG_INFO);*/
  g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (nv_pers_groupe), (gpointer) param_t);
  gtk_box_pack_start (GTK_BOX (vbox), button, TRUE, TRUE, 0);

  vbox1 = gtk_vbox_new (TRUE, 6);
  gtk_box_pack_start (GTK_BOX (vbox), vbox1, TRUE, TRUE, 0);

  gr_tmp=debut;
  while (gr_tmp)
  {
    gtk_box_pack_start (GTK_BOX (vbox1), gr_tmp->wid, TRUE, TRUE, 0);
    gr_tmp=gr_tmp->suiv;
  }

  button = gtk_button_new_from_stock (GTK_STOCK_SAVE);
  g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (sauve_groupe), (gpointer) param_t);
  gtk_box_pack_start (GTK_BOX (vbox), button, TRUE, TRUE, 0);

  button = gtk_button_new_from_stock (GTK_STOCK_SAVE_AS);
  g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (sauve_groupe_as), (gpointer) param_t);
  gtk_box_pack_start (GTK_BOX (vbox), button, TRUE, TRUE, 0);

  button = gtk_button_new_from_stock (GTK_STOCK_CLOSE);
  g_signal_connect (button, "clicked", G_CALLBACK (active_fin_groupe), (gpointer) param_t);
  gtk_box_pack_start (GTK_BOX (vbox), button, TRUE, TRUE, 0);

  g_signal_connect (win, "destroy", G_CALLBACK (fin_groupe), (gpointer) param_t);
  gtk_widget_show_all (win);

  param_t[0]=(gpointer)win;
  param_t[6]=(gpointer)vbox1;
  //param_t[7]=(gpointer)((void **)param)[4];

  gr_tmp=debut;
  while (gr_tmp)
  {
        gtk_window_move(GTK_WINDOW(gr_tmp->fils),x,y);
        //do
        {
            gtk_window_get_size(GTK_WINDOW(gr_tmp->fils),&l,&h);
        }
        //while (l==16 && h==16);
        if (l==16 && h==16) {l=500;h=500;}
        x+=(3*l)/5;y+=(5*h)/7;
        if ((x+l/2)>gdk_screen_width())  x-=(gdk_screen_width() -30);
        if ((y+h/2)>gdk_screen_height()) y-=(gdk_screen_height()-30);
    gr_tmp=gr_tmp->suiv;
  }
  if (nom_de_fichier!=NULL)
  {
      sprintf(ch,"%s%c%s.grp.lock",((char **)param_t)[1],SEPARATEUR,((char **)param_t)[2]);
      fp = fopen(ch, "w");
      fprintf(fp,"%ld %p",(signed long)getpid(),win);
      fclose(fp);
  }

  (void)wid;
}

void sauve_groupe   (GtkWidget *wid, gpointer param)
{
    ((unsigned short **)param)[5][0]=0;
    if (((char **)param)[1]!=NULL && ((char **)param)[2]!=NULL)
        svg_gr(param);
    else
        sauve_groupe_as(wid,param);
}

void sauve_groupe_as(GtkWidget *wid, gpointer param)
{
  GtkWidget * win;
  GtkFileFilter * filtre= gtk_file_filter_new();
  char * nom_de_fichier,* tmp, * tmp1;

  gint rep;

  ((unsigned short **)param)[5][0]=0;

  win = gtk_file_chooser_dialog_new ("Sauver un groupe de personnages", NULL,
                                          GTK_FILE_CHOOSER_ACTION_SAVE,
                                          GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
                                          GTK_STOCK_SAVE_AS, GTK_RESPONSE_ACCEPT,
                                          NULL);
/*                                          GTK_FILE_CHOOSER_ACTION_OPEN,
                                          GTK_STOCK_NEW, GTK_RESPONSE_CANCEL,
                                          GTK_STOCK_OPEN, GTK_RESPONSE_YES,
                                          NULL);*/

 tmp=envp_donne_home();
 gtk_file_chooser_set_current_folder (GTK_FILE_CHOOSER(win),tmp);
 free(tmp);
 gtk_file_filter_add_pattern (filtre,"*.grp");
 gtk_file_chooser_set_filter(GTK_FILE_CHOOSER(win),filtre);
 rep=gtk_dialog_run (GTK_DIALOG (win));

 if ( rep == GTK_RESPONSE_ACCEPT)
 {
    /* prendre en compte le cas windows :( quelle merde cet OS ! */
#ifdef __linux__
    nom_de_fichier = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (win));
#else
    nom_de_fichier=windows_home(gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (win)));
#endif
    gtk_widget_destroy (win);

    for(tmp=nom_de_fichier;*tmp;tmp++);
    tmp1=NULL;
    for(;*tmp!=SEPARATEUR && tmp!=nom_de_fichier;tmp--) if (*tmp=='.') tmp1=tmp;
    if (tmp!=nom_de_fichier)
    {
      *tmp=0;
      ((char **)param)[1]=g_strdup(nom_de_fichier);
      tmp++;
    }
    else
    {
        ((char **)param)[1]=g_strdup(".");
    }
    envp_mem_home(((char **)param)[1]);
    if (tmp1!=NULL)
    {
        *tmp1=0;
    }
    ((char **)param)[2]=g_strdup(tmp);
    free(nom_de_fichier);
    svg_gr(param);
 }
 else
     gtk_widget_destroy (win);

 (void)wid;
}

void svg_gr                         (gpointer param)
{
    FILE * fichier;
    struct_groupe * pt;
    char ch[LONG],aff[LONG],chaine[LONG],*tmp,*tmp1,*tmp2;
    GtkWidget *p_dialog = NULL;

    sprintf(aff,"%s%c%s_grp.odt",((char **)param)[1],SEPARATEUR,((char **)param)[2]);
    fichier = fopen(aff, "rb");
    if (fichier!=NULL) /* Le fichier existe déjà */
    {
        fclose(fichier);
        sprintf(chaine,"%s~",aff);
        copie_fichier(chaine,aff);
    }

    sprintf(ch,"%s%c%s.grp",((char **)param)[1],SEPARATEUR,((char **)param)[2]);
    envp_mem_hist(ch);
    envp_init(((gpointer *)param)[8]);
    fichier = fopen(ch, "rb");
    if (fichier!=NULL) /* Le fichier existe déjà */
    {
        fclose(fichier);
        sprintf(chaine,"%s~",ch);
        copie_fichier(chaine,ch);
    }

    sprintf(chaine,"Fichiers de sauvegarde\n\nSaugarde pour nouveau travail\n%s\n\nRésumé du groupe\n%s\nAttention, les personnages doivent être enrigistrés",ch,aff);
    p_dialog = gtk_message_dialog_new (NULL,GTK_DIALOG_MODAL,GTK_MESSAGE_OTHER,GTK_BUTTONS_OK,chaine);
    gtk_dialog_run(GTK_DIALOG(p_dialog));
    gtk_widget_destroy(p_dialog);


    feuille_groupe(param);
    fichier = fopen(ch, "w");
    fprintf(fichier,"<document type=\"groupe\">\n");
    tmp2=NULL;
    for(pt=((struct_groupe **)param)[4];pt!=NULL;pt=pt->suiv)
    {
        for (tmp=pt->fichier[0],tmp1=((char **)param)[1];*tmp!=0 && *tmp1!=0 && *tmp1==*tmp;tmp++,tmp1++)
            if (*tmp==SEPARATEUR)
                tmp2=tmp;
        if (*tmp1==0 && *tmp==0)
        { /* même répertoire */
            fprintf(fichier," <perso>.%c%s</perso>\n",SEPARATEUR,pt->fichier[1]);
        }
        else if (tmp2!=NULL)
        {
            if (*tmp==SEPARATEUR && *tmp1==0)
            {
                fprintf(fichier," <perso>%s%c%s</perso>\n",tmp+1,SEPARATEUR,pt->fichier[1]);
            }
            else
            {
                if (*tmp==0 && *tmp1==SEPARATEUR)
                {
                    ch[0]=0;
                }
                else
                    sprintf(ch,"..%c%s",SEPARATEUR,tmp2+1);
                while(*tmp1!=0)
                { /* répertoire différent, mais pas dans l'arborescence de  ((char **)param)[1] */
                    if (*tmp1==SEPARATEUR)
                    {
                        if (*ch==0)
                            sprintf(aff,"..%s",ch);
                        else
                            sprintf(aff,"..%c%s",SEPARATEUR,ch);
                        strcpy(ch,aff);
                    }

                    tmp1++;
                }
                fprintf(fichier," <perso>%s%c%s</perso>\n",ch,SEPARATEUR,pt->fichier[1]);
            }
        }
        else /* reprendre à la racine, rien en commun */
            fprintf(fichier," <perso>%s%c%s</perso>\n",pt->fichier[0],SEPARATEUR,pt->fichier[1]);
    }
    fprintf(fichier,"</document>\n");

    fclose(fichier);

    (void)param;
}

void nv_pers_groupe (GtkWidget *wid, gpointer param)
{
  GtkWidget * win;
  GtkFileFilter * filtre= gtk_file_filter_new();
  char * nom_de_fichier;
  struct_groupe * gr_tmp;

  win = gtk_file_chooser_dialog_new ("Ouvrir un groupe de personnages", NULL,
                                          GTK_FILE_CHOOSER_ACTION_OPEN,
                                          GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
                                          GTK_STOCK_OPEN, GTK_RESPONSE_YES,
                                          NULL);

 gtk_file_filter_add_pattern (filtre,"*.pers");
 gtk_file_chooser_set_filter(GTK_FILE_CHOOSER(win),filtre);
 if (gtk_dialog_run (GTK_DIALOG (win))==GTK_RESPONSE_CANCEL)
 {
    gtk_widget_destroy (win);
    return;
 }
  /* prendre en compte le cas windows :( quelle merde cet OS ! */
#ifdef __linux__
  nom_de_fichier = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (win));
#else
  nom_de_fichier=windows_home(gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (win)));
#endif
 gtk_widget_destroy (win);
//g_debug (G_STRLOC);
 ((gpointer *)param)[9]=(gpointer *)nom_de_fichier;
 gr_tmp=ouvrir_perso_groupe(((struct_groupe **)param)[4],param);
 if (gr_tmp!=NULL)
 {
   ((unsigned short **)param)[5][0]=1;
   ((struct_groupe **)param)[4]=gr_tmp;
   while(gr_tmp->suiv!=NULL) gr_tmp=gr_tmp->suiv;
   gtk_box_pack_start (GTK_BOX (((GtkWidget **)param)[6]), gr_tmp->wid, TRUE, TRUE, 0);
   gtk_widget_show_all( gr_tmp->wid);
 }
 free(nom_de_fichier);


 (void)wid;
 (void)param;
}

void sup_pers_groupe(GtkWidget *wid, gpointer param)
{
    if (((struct_groupe *)param)->ouvert==1)
        gtk_widget_destroy (((struct_groupe *)param)->fils);
    gtk_widget_destroy (((struct_groupe *)param)->wid);

    if (((struct_groupe *)param)->suiv!=NULL)
    {
        ((struct_groupe *)param)->suiv->prec=((struct_groupe *)param)->prec;
    }
    if (((struct_groupe *)param)->prec==NULL) /* début */
    {
       ((struct_groupe **)(((struct_groupe *)param)->pt))[4]=((struct_groupe *)param)->suiv;
    }
    else
    {
        ((struct_groupe *)param)->prec->suiv=((struct_groupe *)param)->suiv;
    }

    free (((struct_groupe *)param)->fichier[0]);
    free (((struct_groupe *)param)->fichier[1]);
    free(((struct_groupe *)param));

    (void)wid;
}

struct_groupe * ouvrir_perso_groupe(struct_groupe * debut,gpointer param_t)
{
    GtkWidget * win, * button;
    char ch[LONG];
    struct_groupe * gr_tmp, * gr_tmp1;
    GMarkupDomNode * node2=NULL,* node3;
    GtkWidget * widg = NULL;
    char * tmp, * tmp1=NULL;

        if ((node2 = g_markup_dom_new (((char **)param_t)[9], NULL)))
        {
            if (g_markup_dom_node (node2,"pantheon")==NULL)
            {
                 sprintf(ch,"le fichier %s\n ne correspond pas à un fichier pers de personnage",((char **)param_t)[9]);
                 win = gtk_message_dialog_new (NULL,GTK_DIALOG_MODAL,GTK_MESSAGE_INFO,GTK_BUTTONS_CLOSE,ch);
                 gtk_dialog_run(GTK_DIALOG(win));
                 gtk_widget_destroy(win);
                 g_markup_dom_free(node2);
                 return NULL;
            }  /* nom vraimant particulier => trouver une erreur dans le fichier pers */
            else
            {
                gr_tmp1=(struct_groupe *)malloc(sizeof(struct_groupe));
                if (debut!=NULL)
                {
                    for(gr_tmp=debut;gr_tmp->suiv!=NULL;gr_tmp=gr_tmp->suiv);
                    gr_tmp->suiv=gr_tmp1;
                }
                else
                {
                    gr_tmp=NULL;
                    debut=gr_tmp1;
                }
                gr_tmp1->suiv=NULL;
                gr_tmp1->prec=gr_tmp;
                gr_tmp1->pt=param_t;
                for(tmp=((char **)param_t)[9];*tmp;tmp++);
                for(;(*tmp!=SEPARATEUR && *tmp!='/') && tmp!=((char **)param_t)[9];tmp--)
                 if (*tmp=='.')
                  tmp1=tmp;
                if (tmp!=((char **)param_t)[9])
                {
                  *tmp=0;
                  gr_tmp1->fichier[0]=g_strdup(((char **)param_t)[9]);
                  *tmp=SEPARATEUR;
                  tmp++;
                }
                else
                  gr_tmp1->fichier[0]=g_strdup(".");
                if (tmp1)
                {
                    *tmp1=0;
                    gr_tmp1->fichier[1]=g_strdup(tmp);
                    *tmp1='.';
                }
                else
                    gr_tmp1->fichier[1]=g_strdup(tmp);
                //if (tmp && tmp!=((char **)param_t)[9]) *tmp=SEPARATEUR;
                gr_tmp1->fils=nouv_ouv(NULL,param_t,GROUPE);
                gr_tmp1->ouvert=1;
                g_signal_connect (G_OBJECT (gr_tmp1->fils), "destroy", G_CALLBACK (pers_groupe_destroy), (gpointer) gr_tmp1);

                gr_tmp1->wid=gtk_hbox_new (TRUE, 6);
                node3=g_markup_dom_node(node2,"perso");
                if (node3!=NULL && node3->texte>0)
                    widg=gtk_label_new (node3->content->texte);
                else
                    widg=gtk_label_new (((char **)param_t)[9]);
                gtk_box_pack_start (GTK_BOX (gr_tmp1->wid), widg, TRUE, TRUE, 0);

                button = gtk_button_new_from_stock (GTK_STOCK_DELETE);
                g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (sup_pers_groupe), (gpointer) gr_tmp1);
                gtk_box_pack_start (GTK_BOX (gr_tmp1->wid), button, TRUE, TRUE, 0);

                button = gtk_button_new_from_stock (GTK_STOCK_EDIT);
                g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (pers_groupe_aff), (gpointer) gr_tmp1);
                gtk_box_pack_start (GTK_BOX (gr_tmp1->wid), button, TRUE, TRUE, 0);
            }

            g_markup_dom_free(node2);
        }

        return debut;
}

void pers_groupe_destroy(GtkWidget *wid, gpointer param)
{
    ((struct_groupe *)param)->ouvert=0;

    (void)wid;
}

void pers_groupe_aff(GtkWidget *wid, gpointer param)
{
    char ch[LONG];
    gpointer * mem=((gpointer *)((struct_groupe *)param)->pt)[4];

    if (((struct_groupe *)param)->ouvert==0)
    {
        sprintf(ch,"%s%c%s.pers",((struct_groupe *)param)->fichier[0],SEPARATEUR,((struct_groupe *)param)->fichier[1]);
        //((gpointer *)param)[9]=(gpointer)ch;
        ((gpointer *)(((struct_groupe *)param)->pt))[9]=(gpointer)ch;
        //((struct_groupe *)param)->fils=nouv_ouv(((GtkWidget **)(((struct_groupe *)param)->pt))[0],((struct_groupe *)param)->pt,GROUPE);
        ((struct_groupe *)param)->fils=nouv_ouv(NULL,((struct_groupe *)param)->pt,GROUPE);
        g_signal_connect (G_OBJECT (((struct_groupe *)param)->fils), "destroy", G_CALLBACK (pers_groupe_destroy),param);
        ((struct_groupe *)param)->ouvert=1;
    }
    else
    {
        gtk_window_present (GTK_WINDOW(((struct_groupe *)param)->fils));
    }

    ((gpointer *)((struct_groupe *)param)->pt)[4]=mem;
    (void)wid;
}

void active_fin_groupe(GtkWidget *wid, gpointer param)
{
    gtk_widget_destroy(((GtkWidget**)param)[0]);

    (void)wid;
}

void feuille_groupe(gpointer param)
{
    struct_classe * s_c;
#ifdef __linux__
    struct zip * f_zip=NULL;
    struct zip_source * n_zip=NULL;
#endif
    struct_groupe * pt;
    char * chemin, ch[LONG],affichage[LONG], aff[LONG],*tmp,*tmp1;
    chemin=chemin_exe();
    sprintf(ch,"%s%cLibO%cgroupe.xml",chemin,SEPARATEUR,SEPARATEUR);
    free(chemin);
    GMarkupDomNode * ooo=g_markup_dom_new(ch,NULL),* tmp_node,* tmp1_node,* tmp2_node ,* node, *pers;
    unsigned short i,k;
    signed short vol,j,vd=-1,version_=ADD2,mag=0,clerc=0,sage,inte;

    modif_xml(g_markup_dom_nom (ooo,"nom","name"),((char **)param)[2]);
    node=g_markup_dom_node (ooo,"office:text");

    for(pt=((struct_groupe **)param)[4];pt!=NULL;pt=pt->suiv)
    {
        vol=0;
        vd=-1;
        clerc=0;
        mag=0;
        xml_ajoute_fin(node,"text:section");
        copie_node(node->child+node->fils-1,node->child+node->fils-2);
        copie_node(node->child+node->fils-2,node->child+node->fils-3);
        sprintf (ch,"%s%c%s.pers",pt->fichier[0],SEPARATEUR,pt->fichier[1]);
        pers=g_markup_dom_new(ch,NULL);
        tmp_node=g_markup_dom_node(pers,"version");
        for (i=0;i<3;i++)
            if (strcmp(tmp_node->content->texte,vers[i])==0)
                version_=i;

        for (i=0;i<8;i++)
        {
            tmp_node=g_markup_dom_nom(pers,nom_min[i],"name");
            modif_xml(g_markup_dom_nom(node->child+node->fils-3,nom_min[i],"name"),tmp_node->content->texte);
            if (i==0 && strcmp(tmp_node->content->texte,"18")==0)
            {
                tmp_node=g_markup_dom_nom(pers,"pourcentage","name");
                modif_xml(g_markup_dom_nom(node->child+node->fils-3,"pourcentage","name"),tmp_node->content->texte);
            }
            tmp_node=g_markup_dom_nom(pers,nom_fac_vol[i],"name");
            modif_xml(g_markup_dom_nom(node->child+node->fils-3,nom_fac_vol[i],"name"),tmp_node->content->texte);
            j=0;sscanf(tmp_node->content->texte,"%hd",&j);vol+=j;
        }

        if (vol==0) xml_sup_node(g_markup_dom_nom(node->child+node->fils-3,"voleur","name"));
        sscanf(g_markup_dom_nom(node->child+node->fils-3,"sagesse","name")->content->texte,"%hd",&sage);
        sscanf(g_markup_dom_nom(node->child+node->fils-3,"intelligence","name")->content->texte,"%hd",&inte);

        tmp_node=g_markup_dom_node(pers,"perso");
        if (tmp_node!=NULL)
        {
            ch[0]=0;
            if (tmp_node->content->texte!=0) strcpy(ch,tmp_node->content->texte);
            j=0;
            while(ch[j]!=0) j++;
            ch[j]=' ';
            j++;
            ch[j]=':';
            j++;
            ch[j]=' ';
            j++;
            ch[j]=0;
        }
        tmp_node=g_markup_dom_node(pers,"profession");
        if (tmp_node!=NULL)
        for (i=0;i<tmp_node->fils;i++)
            if (strcmp("p",tmp_node->child[i].name)==0)
            {
                s_c=trouve_classe(tmp_node->child[i].content->texte,((struct_classe***)param)[8][MAIN_CLASSE]);
                while(ch[j]!=0) j++;
                ch[j]=' ';
                j++;
                ch[j]=0;
                strcpy(ch+j,tmp_node->child[i].content->texte);
                while(ch[j]!=0) j++;
                ch[j]=':';
                j++;
                ch[j]=0;
                for(k=0;k<tmp_node->child[i].nb_att;k++)
                    if (strcmp(tmp_node->child[i].attributs[k].name,"niv")==0)
                    {
                        strcpy(ch+j,tmp_node->child[i].attributs[k].value);
                        k=0;
                        sscanf(tmp_node->child[i].attributs[k].value,"%hd",&k);
                        if (((s_c->add2.nom==NULL || version_==ADD1) && s_c->add1.vade_retro!=NON) || ((s_c->add1.nom==NULL || version_==ADD2) && s_c->add2.vade_retro!=NON))
                        {
                            if (s_c->add2.nom==NULL || version_==ADD1)
                                vd=max(vd,k+s_c->add1.vade_retro);
                            else
                                vd=max(vd,k+s_c->add2.vade_retro);
                        }
                        /*void aff_nb_sort(GMarkupDomNode * node,liste_classe * l_c,struct_classe * s_c,signed short * clerc,signed short * mag,signed short sage,signed short inte,signed short version_);*/
                        aff_nb_sort(node->child+node->fils-3,s_c,&clerc,&mag,sage,inte,k,version_);
                        k=tmp_node->child[i].nb_att; /* sortie de la boucle : on a trouvé le niveau */
                    }
            }
        if (mag==0 && clerc==0)
            xml_sup_node(g_markup_dom_nom(node->child+node->fils-3,"section_sorts","name"));
        else if (mag==0)
        {
            xml_sup_node(g_markup_dom_nom(node->child+node->fils-3,"suppr_mag0","name"));
            xml_sup_node(g_markup_dom_nom(node->child+node->fils-3,"suppr_mag1","name"));
        }
        else if (clerc==0)
        {
            xml_sup_node(g_markup_dom_nom(node->child+node->fils-3,"suppr_clerc0","name"));
            xml_sup_node(g_markup_dom_nom(node->child+node->fils-3,"suppr_clerc1","name"));
        }
        while(ch[j]!=0) j++;
        ch[j]=' ';
        j++;
        ch[j]='-';
        j++;
        ch[j]=' ';
        j++;
        ch[j]=0;
        tmp_node=g_markup_dom_node(pers,"race");
        strcpy(ch+j,tmp_node->content[0].texte);
        while(ch[j]!=0) j++;
        ch[j]=' ';
        j++;
        ch[j]='-';
        j++;
        ch[j]=' ';
        j++;
        ch[j]=0;
        tmp_node=g_markup_dom_node(pers,"sexe");
        strcpy(ch+j,tmp_node->content[0].texte);
        while(ch[j]!=0) j++;
        ch[j]=' ';
        j++;
        ch[j]='-';
        j++;
        ch[j]=' ';
        j++;
        ch[j]=0;
        tmp_node=g_markup_dom_node(pers,"poids");
        strcpy(ch+j,tmp_node->content[0].texte);
        while(ch[j]!=0) j++;
        ch[j]='k';
        j++;
        ch[j]='g';
        j++;
        ch[j]=' ';
        j++;
        ch[j]='-';
        j++;
        ch[j]=' ';
        j++;
        ch[j]=0;
        tmp_node=g_markup_dom_node(pers,"taille");
        strcpy(ch+j,tmp_node->content[0].texte);
        while(ch[j]!=0) j++;
        ch[j]='c';
        j++;
        ch[j]='m';
        j++;
        ch[j]=' ';
        j++;
        ch[j]='-';
        j++;
        ch[j]=' ';
        j++;
        ch[j]=0;
        tmp_node=g_markup_dom_node(pers,"alignement");
        strcpy(ch+j,tmp_node->content[0].texte);

        modif_xml(g_markup_dom_nom(node->child+node->fils-3,"nom","name"),ch);

        tmp_node=g_markup_dom_node(pers,"pdv");
        ch[0]=0;
        j=0;
        vol=0;
        for (i=0;i<tmp_node->fils;i++)
        {
            if (i!=0)
            {
                ch[j]='+';
                j++;
                ch[j]=0;
            }
            strcpy(ch+j,tmp_node->child[i].content->texte);
            k=0;sscanf(tmp_node->child[i].content->texte,"%hd",&k);
            vol+=k;
            while(ch[j]!=0) j++;
        }
        ch[j]='=';
        j++;
        sprintf(ch+j,"%hd",vol);
        tmp_node=g_markup_dom_nom(node->child+node->fils-3,"pdv","name");
        modif_xml(tmp_node,ch);

        tmp_node=g_markup_dom_node(pers,"armes");
        tmp1_node=g_markup_dom_nom(node->child+node->fils-3,"armes","name");
        if (tmp_node->fils>0)
        {
            tmp2_node=tmp1_node->child+3;
            xml_ecrit_dernier_texte(tmp2_node->child[0].child,tmp_node->child[0].content->texte);
            xml_ecrit_dernier_texte(tmp2_node->child[1].child,tmp_node->child[0].attributs[3].value);
            xml_ecrit_dernier_texte(tmp2_node->child[2].child,tmp_node->child[0].attributs[2].value);
            if (tmp_node->fils>1)
            {
                tmp2_node=tmp1_node->child+4;
                xml_ecrit_dernier_texte(tmp2_node->child[0].child,tmp_node->child[1].content->texte);
                xml_ecrit_dernier_texte(tmp2_node->child[1].child,tmp_node->child[1].attributs[3].value);
                xml_ecrit_dernier_texte(tmp2_node->child[2].child,tmp_node->child[1].attributs[2].value);
                if (tmp_node->fils>2)
                {
                    for(i=2;i<tmp_node->fils;i++)
                    {
                        xml_ajoute_fin(tmp1_node,"node");
                        tmp2_node=tmp1_node->child+tmp1_node->fils-2;
                        copie_node(tmp1_node->child+tmp1_node->fils-1,tmp2_node);
                        copie_node(tmp2_node,tmp1_node->child+tmp1_node->fils-3);
                        xml_ecrit_dernier_texte(tmp2_node->child[0].child,tmp_node->child[i].content->texte);
                        xml_ecrit_dernier_texte(tmp2_node->child[1].child,tmp_node->child[i].attributs[3].value);
                        xml_ecrit_dernier_texte(tmp2_node->child[2].child,tmp_node->child[i].attributs[2].value);
                    }
                }
            }
            else if (tmp_node->fils==1)
                supprime_node(tmp1_node,tmp1_node->fils-2);
        }
        else if (tmp_node->fils==1)
            supprime_node(tmp1_node,tmp1_node->fils-2);

        tmp_node=g_markup_dom_node(pers,"armure1");
        if (tmp_node->nb_att==2)
        {
            sprintf(ch,"%s%s : %s",tmp_node->content->texte,tmp_node->attributs->value,tmp_node->attributs[1].value);
        }
        else
        { /* pas encore l'AC */
            sprintf(ch,"%s %s",tmp_node->content->texte,tmp_node->attributs->value);
        }
        xml_ecrit_dernier_texte(g_markup_dom_nom(node->child+node->fils-3,"armure1","name"),ch);

        tmp_node=g_markup_dom_node(pers,"armure2");
        if (tmp_node->nb_att==2)
        {
            sprintf(ch,"%s%s : %s",tmp_node->content->texte,tmp_node->attributs->value,tmp_node->attributs[1].value);
        }
        else
        { /* pas encore l'AC */
            sprintf(ch,"%s %s",tmp_node->content->texte,tmp_node->attributs->value);
        }
        xml_ecrit_dernier_texte(g_markup_dom_nom(node->child+node->fils-3,"armure2","name"),ch);

        tmp_node=g_markup_dom_node(pers,"save");
        if (tmp_node!=NULL)
        {   /* cases non remplies pour les premiers persos sauvés */
            xml_ecrit_dernier_texte(g_markup_dom_nom(node->child+node->fils-3,"spmp","name"),tmp_node->attributs[0].value);
            xml_ecrit_dernier_texte(g_markup_dom_nom(node->child+node->fils-3,"spp","name"),tmp_node->attributs[1].value);
            xml_ecrit_dernier_texte(g_markup_dom_nom(node->child+node->fils-3,"sbb","name"),tmp_node->attributs[2].value);
            xml_ecrit_dernier_texte(g_markup_dom_nom(node->child+node->fils-3,"ssou","name"),tmp_node->attributs[3].value);
            xml_ecrit_dernier_texte(g_markup_dom_nom(node->child+node->fils-3,"ssor","name"),tmp_node->attributs[4].value);
        }
        if (vd>0)
        {
            vd=min_(vd,13);
            if (version_==ADD1)
            {
                tmp_node=g_markup_dom_nom(node->child+node->fils-3,"liste_vd","name");
                for(i=0;i<13;i++)
                    xml_ecrit_dernier_texte(tmp_node->child[i].child,vd_add1[i][vd-1]);
            }
            else if (version_==ADD2)
            {
                tmp_node=g_markup_dom_nom(node->child+node->fils-3,"liste_vd","name");
                for(i=0;i<13;i++)
                    xml_ecrit_dernier_texte(tmp_node->child[i].child,vd_add2[i][vd-1]);
            }
            else vd=0;
        }
        if (vd<=0)
        {
            xml_sup_node(g_markup_dom_nom(node->child+node->fils-3,"vd0","name"));
            xml_sup_node(g_markup_dom_nom(node->child+node->fils-3,"vd1","name"));
            xml_sup_node(g_markup_dom_nom(node->child+node->fils-3,"VD","name"));
        }
        g_markup_dom_free(pers);
    }
    xml_sup_node(node->child+node->fils-2); /* suppression de la node modèle */

    tmp=rep_tmp();
    sprintf(ch,"%s%ccontent.xml",tmp,SEPARATEUR);
    enregistre_xml(ch,ooo);
    tmp1=chemin_exe();
    sprintf(affichage,"%s%cLibO%cgroupe.zip",tmp1,SEPARATEUR,SEPARATEUR);
    sprintf(aff,"%s%cgroupe.zip",tmp,SEPARATEUR);
    copie_fichier(aff,affichage);
    chdir(tmp);
    free(tmp);
#ifdef __linux__
    f_zip=zip_open("groupe.zip",ZIP_CREATE,NULL);
    n_zip=zip_source_file(f_zip,"content.xml",0,0);
    zip_replace(f_zip,zip_name_locate(f_zip,"content.xml",ZIP_FL_NOCASE) ,n_zip);
    zip_close(f_zip);
#else
    sprintf(affichage,"\"%s%cLibO%czip.exe\"  groupe.zip content.xml",tmp1,SEPARATEUR,SEPARATEUR);
    system(affichage); /* http://www.developpez.net/forums/d1009879/general-developpement/programmation-linux/gtk/portage-sous-windows/#post5652109 */
#endif
    sprintf(affichage,"%s%c%s_grp.odt",((char **)param)[1],SEPARATEUR,((char **)param)[2]);
    chdir(tmp1);
    copie_fichier(affichage,aff);
    remove(aff); /* enlever les deux fichiers temporaires */
    remove(ch);
    free(tmp1);
    g_markup_dom_free(ooo);
}

void aff_nb_sort(GMarkupDomNode * node,struct_classe * s_c,signed short * clerc,signed short * mag,signed short sage,signed short inte,unsigned short niv,signed short version_)
{
    GMarkupDomNode * tmp1_node;
    gint tmp_sort;
    signed short i,j,l;
    char aff[LONG];
    char * metier;
    unsigned char add_;
    so_add * nb_sorts;
    if ((version_ ==ADD1 && s_c->add1.nom!=NULL) || s_c->add2.nom==NULL)
    {
        add_=ADD1;
        metier=s_c->add1.nom;
    }
    else if (((version_ ==ADD2 && s_c->add2.nom!=NULL) || s_c->add1.nom==NULL))
    {
        add_=ADD2;
        metier=s_c->add2.nom;
    }
    else
    {
        add_=0;
        nb_sorts=NULL;
        metier=NULL;
    }

    if ((add_==ADD1 && (s_c->add1.sort_clerc!=NULL || s_c->add1.sort_druide!=NULL))
     || (add_==ADD2 &&  s_c->add2.sort_clerc!=NULL))
    {
        if (*clerc>0)
        {
            xml_ajoute_fin(g_markup_dom_nom(node,"section_sorts","name"),"section");
            xml_ajoute_fin(g_markup_dom_nom(node,"section_sorts","name"),"section");
            decale_node(g_markup_dom_nom(node,"section_sorts","name"),1);
            decale_node(g_markup_dom_nom(node,"section_sorts","name"),1);
            copie_node(g_markup_dom_nom(node,"section_sorts","name")->child+1,g_markup_dom_nom(node,"suppr_clerc0","name"));
            copie_node(g_markup_dom_nom(node,"section_sorts","name")->child+2,g_markup_dom_nom(node,"suppr_clerc1","name"));
        }
        if (add_==ADD1)
        {
            if (s_c->add1.sort_clerc!=NULL)
                nb_sorts=s_c->add1.sort_clerc;
            else
                nb_sorts=s_c->add1.sort_druide;
        }
        else
        {
            nb_sorts=s_c->add2.sort_clerc;
        }
        tmp1_node=g_markup_dom_nom(node,"clerc","name");
        xml_ecrit_dernier_texte(tmp1_node->child[0].child,metier);
        clerc[0]++;
        tmp1_node=g_markup_dom_nom(node,"clerc","name");
        xml_ecrit_dernier_texte(tmp1_node->child[0].child,metier);
        for (i=0;i<niv && nb_sorts->nb[i]!=NULL;i++); /* i : recherche du niveau maximum de compétance de la classe */
        if (i>0)
        {
            i--;
            for (j=0;j<niv && nb_sorts->nb[i][j]!=-1;j++); /* i : recherche du nombre max de niveau de sort de la classe */
            if (nb_sorts->nb[i][j]==-1) j--;
            for (l=1;l<=j && nb_sorts->nb[i][l]!=-1;l++)
            {
                if ((l<5 || sage>17 || (sage==17 && l==5)) && ((add_==ADD1 && (s_c->add1.bonus_clerc=='b' || s_c->add1.bonus_druide=='b') )|| (add_==ADD2 && s_c->add2.bonus_clerc=='b')))
                {

                    tmp_sort=nb_sorts->nb[i][l];
                    if (tmp_sort==0)  {aff[0]='0';aff[1]=0;}
                    else if (tabl_sagesse[sage-1][l+1][0]==0)  sprintf(aff,"%d",tmp_sort);
                    else                                       sprintf(aff,"%d",tmp_sort+tabl_sagesse[sage-1][l+1][0]-'0');
                    xml_ecrit_dernier_texte(tmp1_node->child[l].child,aff);
                }
                else
                {
                    sprintf(aff,"%d",nb_sorts->nb[i][l]);
                    xml_ecrit_dernier_texte(tmp1_node->child[l].child,aff);
                }
            }
            for(;l<8;l++)
                    xml_ecrit_dernier_texte(tmp1_node->child[l].child,"-");
            if (j<7) /* pas uns classe pure de lanceur de sorts */
            {
                xml_ecrit_dernier_texte(tmp1_node->child[7].child,metier);
                    aff[0]=0;
                    sprintf(aff,"c : %hu",nb_sorts->nb[i][0]); /* le niveau de maîtrise */
                    xml_ecrit_dernier_texte(tmp1_node->child[7].child,aff);
            }
        }
    }
    if ((add_==ADD1 && (s_c->add1.sort_mago!=NULL || s_c->add1.sort_illus!=NULL))
           || (add_==ADD2 &&  s_c->add2.sort_mago!=NULL))
    {
        if (*mag>0)
        {
            xml_ajoute_fin(g_markup_dom_nom(node,"section_sorts","name"),"section");
            xml_ajoute_fin(g_markup_dom_nom(node,"section_sorts","name"),"section");
            decale_node(g_markup_dom_nom(node,"section_sorts","name"),1);
            decale_node(g_markup_dom_nom(node,"section_sorts","name"),1);
            copie_node(g_markup_dom_nom(node,"section_sorts","name")->child+1,g_markup_dom_nom(node,"suppr_mag0","name"));
            copie_node(g_markup_dom_nom(node,"section_sorts","name")->child+2,g_markup_dom_nom(node,"suppr_mag1","name"));
        }
        if (add_==ADD1 && (s_c->add1.sort_mago!=NULL || s_c->add1.sort_illus!=NULL))
        {
            if (s_c->add1.sort_mago!=NULL)
                nb_sorts=s_c->add1.sort_mago;
            else
                nb_sorts=s_c->add1.sort_illus;
            if (tabl_inte1[inte-1][1][0]!=0)
                sscanf(tabl_inte1[inte-1][1],"%hd",&j); /* limite du niveau de sort */
            else j=0;
        }
        else
        { /* j : limitation par l'intelligence du nombre de niveaux compréhensibles */
            nb_sorts=s_c->add2.sort_mago;
            if (tabl_inte2[inte-1][1][0]!=0)
                sscanf(tabl_inte2[inte-1][1],"%hd",&j); /* limite du niveau de sort */
            else j=0;
        }
        for (i=1;i<niv && nb_sorts->nb[i]!=NULL;i++);
        if (nb_sorts->nb[i]==NULL) i--; /* i : recherche du niveau maximum de compétance de la classe */

        tmp1_node=g_markup_dom_nom(node,"magicien","name");
        xml_ecrit_dernier_texte(tmp1_node->child[0].child,metier);
        for (l=1;l<=j && nb_sorts->nb[i-1][l]!=-1;l++)
        {
            sprintf(aff,"%d",nb_sorts->nb[niv-1][l]);
            xml_ecrit_dernier_texte(tmp1_node->child[l].child,aff);
        }
        for(;l<9;l++)
                xml_ecrit_dernier_texte(tmp1_node->child[l].child,"-");
        for (j=0;j<niv && nb_sorts->nb[i][j]!=-1;j++); /* i : recherche du nombre max de niveau de sort de la classe */
        if (nb_sorts->nb[i][j]==-1) j--;
        if (j<9) /* pas uns classe pure de lanceur de sorts */
        {
                aff[0]=0;
                sprintf(aff,"m : %hu",nb_sorts->nb[i-1][0]); /* le niveau de maîtrise */
                xml_ecrit_dernier_texte(tmp1_node->child[9].child,aff);
        }
        (*mag)++;
        if ( s_c->add2.nom!=NULL && compare_sans_casse("entropiste",s_c->add2.nom)==0)
        {
            xml_ajoute_fin(g_markup_dom_nom(node,"section_sorts","name"),"section");
            //xml_ajoute_fin(g_markup_dom_nom(node,"section_sorts","name"),"section");
            decale_node(g_markup_dom_nom(node,"section_sorts","name"),1);
            //decale_node(g_markup_dom_nom(node,"section_sorts","name"),1);
            copie_node(g_markup_dom_nom(node,"section_sorts","name")->child+1,g_markup_dom_nom(node,"suppr_mag0","name"));
            copie_node(g_markup_dom_nom(node,"section_sorts","name")->child+2,g_markup_dom_nom(node,"suppr_mag1","name"));
            niv=min_(niv,9);
            niv--;
            for(l=0;l<10;l++)
            {
                sprintf(aff,"%d:%d; %d:%d",2*l+1,hiatus[niv][2*l],2*l+2,hiatus[niv][2*l+1]);
                xml_ecrit_dernier_texte(tmp1_node->child[l].child,aff);
            }

            (*mag)++;
        }

    }

    (void)version_;
}
