/* Licence GPL               */
/* version 0.0.1 le 10/10/10 */
/* Par Bernard SIAUD         */
/* MERCI À Seldnor de http://dnd.ezael.net pour les caractéristiques de AD&D1 */



#ifndef INCLUDE_H_INCLUDED
#define INCLUDE_H_INCLUDED

#include <stdlib.h>
#include <gtk/gtk.h>

/* les define pour les méthodes */
#define _3D6    0
#define _4D6    1
#define _3D6x6  2
#define _5D6    3
#define _4D5p3  4
/* le sexe */
#define HOMME 0
#define FEMME 1
/* Les versions de dongeon et dragon */
#define DD       0
#define ADD1     1
#define ADD2     2
#define NOUVEAU  20
#define OUVRIR   21
#define GROUPE   22
#define OUV_HIST 23

#define TROP        99

/* "Force","Sagesse","Intelligence","Dextérité","Constitution","Charisme","Humour","Beauté" */
#define FORCE            0
#define INTELLIGENCE     1
#define SAGESSE          2
#define DEXTERITE        3
#define CONSTITUTION     4
#define CHARISME         5
#define BEAUTE           6
#define HUMOUR           7
#define POURCENTAGE      8
/* méthode de tirage des pdv */
#define PDV_1D           0
#define PDV_2D           1
#define PDV_MAX          2

/* ordre des param de main.c */
#define MAX_MAIN        20
#define MAIN_WIN        0
#define MAIN_VAL        1
#define MAIN_MENU_MAN   2
#define MAIN_GR_ACTION  3
#define MAIN_AFF_GR     4
#define MAIN_CLASSE     5
// 6 : vbox1
#define MAIN_SAVE       7
#define MAIN_GTK_ACT_GR 8
#define MAIN_AFF_PANT   9
#define MAIN_NB_CLASSE  10
#define MAIN_NB_RACE    11
//12 ?
#define MAIN_NB_SAVE    13
#define MAIN_NB_SORT    14
#define MAIN_SORT       15
#define MAIN_PARAM_CLAS 16
#define MAIN_PARAM_RACE 17
#define MAIN_PARAM_HIST 18
#define MAIN_RACE       19


/* l'ordre du tableau de mémorisation des caractéristique */
#define TEXTE            0
#define CARACT           1
#define VERSION          2
#define FILS             3
#define FENETRE          4
#define RACE             5
#define SEXE             6
//#define NB_METIER        7
//#define NV_METIER        8
#define METIER           9
#define XP_METIER       21
#define NB_ARMES        10
#define NV_ARMES        11
#define ARMES           12
#define NB_PDV          13
#define PDV             14
#define NB_COMP         15
#define NV_COMP         16
#define COMP            17
#define NOM             18
#define CHEMIN          19
#define C_VOLEUR        20
#define PANTHEON        22
#define DIEU            23
#define TEXTE_COM       24
#define SORT_MAG        25
#define NB_SORT_MAG_NIV 26
#define SORT_MAG_MAIT   27
#define TAILLE          28
#define POIDS           29
#define MAG_ARMES       30
#define JOUEUR          31
#define PERSO           32
#define CLASSE_SOCIALE  33
#define COULEUR_CHEVEUX 34
#define COULEUR_PEAU    35
#define COULEUR_YEUX    36
#define AGE             37
#define ARMURE1         38
#define MAG_ARMURE1     39
#define ARMURE2         40
#define MAG_ARMURE2     41
#define BOUCLIER        42
#define MAG_BOUCLIER    43
#define BONUS_CA        44
#define MODIF           45
#define MENU            46
#define ALIGNEMENT      47

#define MAX_TIRAGE      48

/* Sphère de prêtre */
#define P_GENERALE      1
#define P_ANIMALE       2
#define P_ASTRALE       4
#define P_CHAOS         8
#define P_CHARME        16
#define P_CLIMAT        32
#define P_COMBAT        64
#define P_CONJURATION   128
#define P_CREATION      256
#define P_DIVINATION    512
#define P_ELEMENTAIRE   1024
#define P_ELEMENTAIRE_A 2048
#define P_ELEMENTAIRE_E 4096
#define P_ELEMENTAIRE_F 8192
#define P_ELEMENTAIRE_T 16384
#define P_GARDE         32768
#define P_GUERRE        65536
#define P_LOI           131072
#define P_NECROMANTIQUE 262144
#define P_NOMBRE        524288
#define P_PENSEE        1048576
#define P_PROTECTION    2097152
#define P_SOINS         4194304
#define P_SOLEIL        8388608
#define P_TEMPS         16777216
#define P_VEGETALE      33554432
#define P_VIGILENCE     67108864
#define P_VOYAGEUR      134217728

/* l'ordre du tableau de modification des caractéristiques */
#define M_MEMO          0
#define M_CARACT        1
#define M_ENTREE        2
#define M_FENETRE       3
#define M_PERE          4
#define M_VERSION       5
#define M_RACE          6
#define M_SEXE          7

#define M_NV_CLASSE     8
#define M_NB_CLASSE     9
#define M_HB_CLASSE    10
#define M_VB_CLASSE    11
#define M_PM_CLASSE    12
#define M_PC_CLASSE    13
#define M_EB_CLASSE    34
#define M_XP_CLASSE    35

#define M_NV_ARMES     14
#define M_NB_ARMES     15
#define M_HB_ARMES     16
#define M_VB_ARMES     17
#define M_PM_ARMES     18
#define M_PC_ARMES     19
#define M_LA_ARMES     32
#define M_CE_ARMES     33
#define M_MAG_ARMES    41

#define M_NV_COMP      20
#define M_NB_COMP      21
#define M_HB_COMP      22
#define M_VB_COMP      23
#define M_PM_COMP      24
#define M_PC_COMP      25
#define M_LA_COMP      31

#define M_NV_PDV       26
#define M_NB_PDV       27
#define M_VB_PDV       28
#define M_CA_VOL       29
#define M_LA_VOL       30

#define M_PANTHEON     36
#define M_DIEU         37
#define M_MOD_DIEU     38

#define M_TEXTE        39
#define M_NB_SORT_MAG  40
#define M_SORT_MAG     56
#define M_D_TAILLE     42
#define M_D_POIDS      43
#define M_DV_TAILLE    44
#define M_DV_POIDS     45
#define M_C_TAILLE     46
#define M_C_POIDS      47
#define M_TAILLE_RACE  48
#define M_LABEL_TAILLE 49

#define M_NOM_PERSO    50
#define M_NOM_JOUEUR   51
#define M_CLASS_SOCIAL 52
#define M_COUL_PEAU    53
#define M_COUL_CHEVEUX 54
#define M_COUL_YEUX    55
#define M_AGE          57
#define M_ARMURE1      58
#define M_MAG_ARMURE1  59
#define M_ARMURE2      60
#define M_MAG_ARMURE2  61
#define M_BOUCLIER     62
#define M_MAG_BOUCLIER 63
#define M_BONUS_CA     64
#define M_MODIF        65
#define M_ALIGNEMENT   66


/* l'ordre les métiers */
#define BARDE         5
#define PRETRE        7
#define DRUIDE        8
#define MAGICIEN      9
#define ILLUSIONNISTE 10

#define MAX_ARMES       55
#define MAX_COMPETENCE  80
#define MAX_ARMURE      29

/* gestion des compétences */
#define COMPT_TOUS    1
#define COMPT_COMB    2
#define COMPT_LARRON  4
#define COMPT_MAGO    8
#define COMPT_CLERC   16

#define NA            9

/* alignement */
#define BL 1
#define BN 2
#define BC 4
#define NL 8
#define NN 16
#define NC 32
#define ML 64
#define MN 128
#define MC 256

#define NB_SORT_MAG     331

#ifdef __linux__
#define SEPARATEUR    '/'
#else
#define SEPARATEUR    '\\'

/* compatibilité de fonctions */
#define getpid _getpid
#define getcwd _getcwd
#define chdir _chdir

#endif

/* mémorisation du nombre maximum de fichier mémoriser */
#define MEM_FICH_MAX   8

/* pour parer le problème de windows.h */
#ifndef LONG
#define LONG 1024
#endif
#ifndef max
#define max(i,j) (i>j?i:j)
#endif

#define nom_sexe(i) i==0?"Masculin":"Féminin"
#define maitrise_arme(i) i==0?"Non maitrisée":(i==1?"Maitrisée":(i==2?"Spécialisation":"Double spécialisation"))
#define min_(i,j) (i>j?j:i)

/* stockage des informations sur une classe */

typedef struct
{
    char * nom;
    signed short ** nb;
} so_add;

typedef struct
{
    char * type;
    so_add add1;
    so_add add2;

} struct_sort;

struct sv_add
{
    char * nom;
    unsigned short ** save;
};

typedef struct
{
  struct sv_add add1;
  struct sv_add add2;
} struct_save;

struct bonus_armes
{
    char * arme;
    signed short bonus;
};

struct cl_add1
{
    char * nom;
    unsigned char min_f;
    unsigned char min_i;
    unsigned char min_s;
    unsigned char min_d;
    unsigned char min_co;
    unsigned char min_ch;
    unsigned char max_f;
    unsigned char max_i;
    unsigned char max_s;
    unsigned char max_d;
    unsigned char max_co;
    unsigned char max_ch;
    signed char dix_f;
    signed char dix_i;
    signed char dix_s;
    signed char dix_d;
    signed char dix_co;
    signed char dix_ch;
    signed short * ac;
    signed short * backstab;
    signed char vade_retro;
    char * pdv[20];
    char ** armes;
    signed char nb_arme[4];
    char ** armures;
    char ** bouclier;
    char ** special;
    char * voleur;
    signed short ** tab_voleur;
    unsigned short alignement;
    signed long * XP;
    struct sv_add * save;
    signed short * tacO[2];
    so_add * sort_mago;
    so_add * sort_illus;
    so_add * sort_clerc;
    char bonus_clerc;
    so_add * sort_druide;
    char bonus_druide;
};
struct cl_add2
{
    char * nom;
    unsigned char min_f;
    unsigned char min_i;
    unsigned char min_s;
    unsigned char min_d;
    unsigned char min_co;
    unsigned char min_ch;
    unsigned char max_f;
    unsigned char max_i;
    unsigned char max_s;
    unsigned char max_d;
    unsigned char max_co;
    unsigned char max_ch;
    signed char dix_f;
    signed char dix_i;
    signed char dix_s;
    signed char dix_d;
    signed char dix_co;
    signed char dix_ch;
    signed char vade_retro;
    signed short * ac;
    signed short * backstab;
    char * pdv[20];
    char ** armes;
    signed char nb_arme[3];
    char ** armures;
    char ** bouclier;
    char ** special;
    char * voleur;
    signed short ** tab_voleur;
    unsigned short alignement;
    signed long * XP;
    struct sv_add * save;
    signed short tacO[3];
    so_add * sort_mago;
    char ** sort_mago_ecole;
    so_add * sort_clerc;
    char bonus_clerc;
    char ** sort_clerc_sphere;
    char ** liste_competances;
    unsigned short progression_competances[2];
};

typedef struct
{
  struct cl_add1 add1;
  struct cl_add2 add2;
  GtkWidget * menu;
} struct_classe;

typedef struct str_l_cl
{
    char * nom;
    struct str_l_cl * suiv;
    unsigned short niveau;
    unsigned long xp;
} liste_classe;

typedef struct str_l_cl_r
{
    liste_classe * classe;
    char * age;
    struct str_l_cl_r * suiv;
} liste_classe_race;

struct ra_add1
{
    char * nom;
    unsigned char min_f;
    unsigned char min_i;
    unsigned char min_s;
    unsigned char min_d;
    unsigned char min_co;
    unsigned char min_ch;
    unsigned char max_f;
    unsigned char max_i;
    unsigned char max_s;
    unsigned char max_d;
    unsigned char max_co;
    unsigned char max_ch;
    unsigned char min_f_f;
    unsigned char min_i_f;
    unsigned char min_s_f;
    unsigned char min_d_f;
    unsigned char min_co_f;
    unsigned char min_ch_f;
    unsigned char max_f_f;
    unsigned char max_i_f;
    unsigned char max_s_f;
    unsigned char max_d_f;
    unsigned char max_co_f;
    unsigned char max_ch_f;
    signed char modif_f;
    signed char modif_i;
    signed char modif_s;
    signed char modif_d;
    signed char modif_co;
    signed char modif_ch;
    liste_classe_race * liste_classe;
    unsigned char * limite;
    signed short * tranche_age;
    char * vision;
    char* ecoute;
    char * resistance;
    struct bonus_armes * bonus_arme;
    char * save[5];
    char ** langue;
    char ** detection;
    char * surprendre;
    char * sefairesurprendre;
    signed short ** tab_voleur;
};

struct ra_add2
{
    char * nom;
    unsigned char min_f;
    unsigned char min_i;
    unsigned char min_s;
    unsigned char min_d;
    unsigned char min_co;
    unsigned char min_ch;
    unsigned char max_f;
    unsigned char max_i;
    unsigned char max_s;
    unsigned char max_d;
    unsigned char max_co;
    unsigned char max_ch;
    unsigned char min_f_f;
    unsigned char min_i_f;
    unsigned char min_s_f;
    unsigned char min_d_f;
    unsigned char min_co_f;
    unsigned char min_ch_f;
    unsigned char max_f_f;
    unsigned char max_i_f;
    unsigned char max_s_f;
    unsigned char max_d_f;
    unsigned char max_co_f;
    unsigned char max_ch_f;
    signed char modif_f;
    signed char modif_i;
    signed char modif_s;
    signed char modif_d;
    signed char modif_co;
    signed char modif_ch;
    liste_classe_race * liste_classe;
    unsigned char * limite;
    signed short * tranche_age;
    char * vision;
    char * ecoute;
    char * resistance;
    struct bonus_armes * bonus_arme;
    char * save[5];
    char ** langue;
    char ** detection;
    char * surprendre;
    char * sefairesurprendre;
    char ** competence;
    signed short ** tab_voleur;
};

typedef struct
{
    struct ra_add1 add1;
    struct ra_add2 add2;
    GtkWidget * menu;

} struct_race;

typedef struct
{
    unsigned short nb;
    gpointer param;
} struct_param_nb;

#define FIN -999
#define NON -99

/* race et classe */
#define FEUILLE_NOM         "A1"

#define FEUILLE_MIN_F_H     "C3"
#define FEUILLE_MIN_I_H     "C4"
#define FEUILLE_MIN_S_H     "C5"
#define FEUILLE_MIN_D_H     "C6"
#define FEUILLE_MIN_Co_H    "C7"
#define FEUILLE_MIN_Ch_H    "C8"
#define FEUILLE_MIN_F_F     "D3"
#define FEUILLE_MIN_I_F     "D4"
#define FEUILLE_MIN_S_F     "D5"
#define FEUILLE_MIN_D_F     "D6"
#define FEUILLE_MIN_Co_F    "D7"
#define FEUILLE_MIN_Ch_F    "D8"
#define FEUILLE_MAX_F_H     "F3"
#define FEUILLE_MAX_I_H     "F4"
#define FEUILLE_MAX_S_H     "F5"
#define FEUILLE_MAX_D_H     "F6"
#define FEUILLE_MAX_Co_H    "F7"
#define FEUILLE_MAX_Ch_H    "F8"
#define FEUILLE_MAX_F_F     "G3"
#define FEUILLE_MAX_I_F     "G4"
#define FEUILLE_MAX_S_F     "G5"
#define FEUILLE_MAX_D_F     "G6"
#define FEUILLE_MAX_Co_F    "G7"
#define FEUILLE_MAX_Ch_F    "G8"
#define FEUILLE_MOD_F       "I3"
#define FEUILLE_MOD_I       "I4"
#define FEUILLE_MOD_S       "I5"
#define FEUILLE_MOD_D       "I6"
#define FEUILLE_MOD_Co      "I7"
#define FEUILLE_MOD_Ch      "I8"
#define FEUILLE_VOL_TABLE   "D43"

/* race */
#define FEUILLE_CLASSE      "B11"
#define FEUILLE_AGE         "B12"
#define FEUILLE_TRANCH_AGE1 "B14"
#define FEUILLE_TRANCH_AGE2 "D14"
#define FEUILLE_VISION      "B17"
#define FEUILLE_ECOUTE      "B18"
#define FEUILLE_RESISTANCE  "B19"
#define FEUILLE_BONUS_ARME  "B21"
#define FEUILLE_SAVE_RACE   "B25"

#define FEUILLE_LANGUE      "B27"
#define FEUILLE_DETECTION   "B29"
#define FEUILLE_SURPRENDRE  "B31"
#define FEUILLE_SE_FAIRE_SU "B33"
#define FEUILLE_RACE_COMP   "B35"

/* classe */
#define FEUILLE_PDV         "B11"
#define FEUILLE_ARME        "B13"
#define FEUILLE_MAIT_ARME_D "B15"
#define FEUILLE_MAIT_ARM_PE "C15"
#define FEUILLE_MAIT_ARM_PR "D15"
#define FEUILLE_AC          "B16"
#define FEUILLE_ARMURES     "B17"
#define FEUILLE_BOUCLIER    "B18"
#define FEUILLE_SPECIAL     "B20"
#define FEUILLE_VOLEUR      "B22"
#define FEUILLE_BACK_STAB   "B23"
#define FEUILLE_COMP_C      "B24"
#define FEUILLE_ALIGNEMENT  "B27"
#define FEUILLE_XP          "B29"
#define FEUILLE_SAVE        "E29"
#define FEUILLE_TACO_D      "E31"
#define FEUILLE_TACO_A      "F31"
#define FEUILLE_TACO        "E32"
#define FEUILLE_SORT_M      "E33"
#define FEUILLE_SORT_M_S    "E34"
#define FEUILLE_SORT_C      "E35"
#define FEUILLE_SORT_C_B    "F35"
#define FEUILLE_SORT_C_S    "E36"
#define FEUILLE_SORT_D_B    "F36"
#define FEUILLE_COMP_C1     "E37"
#define FEUILLE_COMP_I      "E38"
#define FEUILLE_COMP_N      "G38"
#define FEUILLE_VADE_RETRO  "N2"
#define FEUILLE_MAX_B_CONST "N7"

#define FEUILLE_LAR_VOL     17

/* save */
#define FEUILLE_DEPART_SAVE "A2"

/* lecture des fichiers xml */
typedef struct _xml_attr xml_attr;
typedef struct _GMarkupDomNode GMarkupDomNode;
typedef struct _GMarkupDomContext GMarkupDomContext;


struct str_gr
{
    char * fichier[2];
    GtkWidget * wid;
    GtkWidget * fils;
    gpointer pt;
    struct str_gr * suiv;
    struct str_gr * prec;
    unsigned short ouvert;
}; /* pour la feuille de gestion des groupes */
typedef struct str_gr struct_groupe;

typedef struct
{
    gchar * nom;
    unsigned short longueur;
    unsigned short vitesse;
    gchar PM[8];
    gchar G[8];
    unsigned short race ; /* bonus éventuel en fonction de la race */
} struct_armes;

typedef struct
{
    gchar * nom;
    signed short add1;
    signed short add2;
} struct_armure;


typedef struct
{
    gchar * nom;
    unsigned short unite;
    unsigned short caract;
    unsigned short modif;
    unsigned short classe;
} struct_competences;

struct _GMarkupDomContext
{
  guint level;
  guint item;
  GMarkupDomNode *root;
  GMarkupDomNode *current;
};

struct _xml_attr
{
  gchar *name;
  gchar *value;
};

typedef struct {
           gchar * texte;
           guint    item;
         } contenu;

struct _GMarkupDomNode
{
  gchar *name;
  guint item; /* numéro de l'item dans la liste des items du père */
  guint level;
  contenu * content;
  guint texte; /* nombre d'entrées texte */
  xml_attr *attributs;
  guint nb_att;
  contenu * com;
  guint nb_com;
  struct _GMarkupDomNode *parent;
  struct _GMarkupDomNode *child;
  guint fils; /* nombre de nodes fille */
};

typedef struct
{
    char * nom;
    unsigned short niveau;
    char * portee;
    char * vsm;
    char * duree;
    char * lance;
    char * effet;
    char * save;
    char * composant;
    unsigned long sphere;
} struct_sortileges;


/* définition dans le fichier tableaux.c */
extern gchar * vers[];
extern gchar * init[];
extern gchar * nom[];
extern gchar * nom_min[];
//extern gchar * nom_race[];
//extern gchar * nom_classe[];
extern gchar algnm[9][3];
extern struct_armes armes[MAX_ARMES];
extern struct_competences competences[MAX_COMPETENCE];
extern gchar * nom_fac_vol[];
extern gchar * nom_fac_voleur[];
extern signed short fac_vol_caract[11][8];
extern gchar vd_add1[13][14][4];
extern gchar vd_add2[13][14][4];
extern gchar tabl_constit[25][5][8];
extern gchar tabl_inte1[25][5][8];
extern gchar tabl_inte2[25][5][8];
extern gchar tabl_sagesse[25][10][16];
/* pour les xp des niveaux */

extern struct_sortileges sortileges_mag[];
extern char * ecole_mag[];
extern unsigned short c_poids_taille[80][2];
extern unsigned short taille_race[7][4];
extern float poids_race[7];
extern unsigned short v_poids_taille[9];
extern float force_taille[16];
extern float force_poids[16];
struct_armure armures[MAX_ARMURE];
extern gint hiatus[9][20];

/* main.c */
void ouvre_nouveau_fichier(GtkWidget *wid, gpointer param);

/* fichier.c */
int copie_fichier(char const *path_dest, char const *path_src);
void sauvegarde_perso (GtkWidget *wid, gpointer param);
void sauvegarde_perso_sous (GtkWidget *wid, gpointer param);
int ouvrir_fichier (GtkWidget *wid, gpointer param);

/* tirage.c */
signed short tirage_age(liste_classe_race * l_c_r,liste_classe * l_c,unsigned short version);
GtkWidget * nouv_ouv(GtkWidget *wid, gpointer param,unsigned char quoi);
void caract_voleur(gpointer param);
GtkWidget * affichage_perso(unsigned short race,unsigned char sexe,unsigned char version_dd,unsigned short * caract,liste_classe * metier,unsigned short * nb_armes,unsigned short * nv_armes,unsigned short * num_armes,signed short * mag_armes,unsigned short * nb_pdv,unsigned short * num_pdv,unsigned short * nb_comp,unsigned short * nv_comp,unsigned short * num_comp,char * age,gpointer param);
unsigned char trouve_sexe(GList * k);
unsigned char trouve_version(GList * k);
void tirage (GtkWidget *wid, gpointer param);
int tirage_perso(char methode, unsigned char race,liste_classe * metier,unsigned char version, unsigned short * caract, unsigned short * caract_min, unsigned short * caract_max, unsigned short * caract_pref,gpointer param);
/* caract_min : caractéristiques minimales souhaitées (pour une classe par exemple                                               */
/* caract_pref : ordre de préférence personnel des caractéristiques, 8 pour les deux dernières et dire qu'elles sont inamovibles */

/* messages.c */
void explication (GtkWidget *wid, gpointer param);
void menu_aide(GtkWidget *,gpointer);
void menu_a_propos(GtkWidget *,gpointer);
void menu_licence(GtkWidget *,gpointer);
void traite_erreur(GError *);

/* call_back_menu.c */
void version(GtkRadioAction *action, GtkRadioAction *current, gpointer param);
//void print_race(GtkRadioAction *action, GtkRadioAction *current, gpointer param);
void print_race(GtkRadioAction *action, gpointer param);
void print_force(GtkRadioAction *action, GtkRadioAction *current, gpointer param);
void print_intelligence(GtkRadioAction *action, GtkRadioAction *current, gpointer param);
void print_sagesse(GtkRadioAction *action, GtkRadioAction *current, gpointer param);
void print_dexterite(GtkRadioAction *action, GtkRadioAction *current, gpointer param);
void print_constitution(GtkRadioAction *action, GtkRadioAction *current, gpointer param);
void print_charisme(GtkRadioAction *action, GtkRadioAction *current, gpointer param);
void print_beaute(GtkRadioAction *action, GtkRadioAction *current, gpointer param);
void print_humour(GtkRadioAction *action, GtkRadioAction *current, gpointer param);


/* menu.c */
liste_classe * trouve_liste_classe_menu( gpointer param);
int change_entree_menu(GList * p_action,char * nom,char * titre); /* renvoie 0 si l'entrée existe, 1 sinon */
unsigned short donne_race(struct_race * race,unsigned short nb);
GtkWidget * cree_entree_menu(char * nom_,char * titre,GtkUIManager *  pere,unsigned short i,char * chemin,struct_param_nb * param_nb,void (*fonction)());
GtkWidget * cree_entree_menu_check(char * nom_,char * titre,GtkUIManager *  pere,unsigned short i,char * chemin,struct_param_nb * param_nb,void (*fonction)());
GtkWidget * cree_entree_menu_radio(char * nom_,char * titre,GtkUIManager *  pere,unsigned short i,char * chemin,gpointer param_nb,GtkWidget * groupe,void (*fonction)());
void race_classe(unsigned short race,unsigned short version, gpointer param);
GtkAction * trouve_action(gchar * ch,GList * gl);
void inverse(unsigned short caract,unsigned short t,gpointer param);
void non_humour_beaute(GtkActionGroup *p_actionGroup);
void humour_beaute(GtkActionGroup *p_actionGroup);
void supprime(char * ch,gpointer param);
void valide(char * ch,gpointer param);
void inactive(gchar *,GtkActionGroup *);
void active(gchar *,GtkActionGroup *);
void Tearoff_on(GtkUIManager * menu_Manager,char * chemin);
void race_init  (GtkUIManager * menu,gpointer param);
void classe_init(GtkUIManager * menu,gpointer param);



/* fin.c */
void cb_fin(GtkWidget *p_widget, gpointer param);
void fin_feuille(GtkWidget *p_widget, gpointer param);
void fin_perso(GtkWidget *p_widget, gpointer param);
void fin_modif_caract(GtkWidget *p_widget, gpointer param);
void fin_modif_sphere(GtkWidget *p_widget, gpointer param);
void fin_groupe(GtkWidget *p_widget, gpointer param);


/* xml.c */
gchar * mintexte(gchar *);
void g_markup_dom_free (GMarkupDomNode *);
GMarkupDomNode *g_markup_dom_new (const gchar *filename, GError **error);
void dom_print (GMarkupDomNode *root,FILE * sortie,gint pos);
void enregistre_xml(char * nom, GMarkupDomNode * ooo); /* génère le fichier xml */
GMarkupDomNode * g_markup_dom_nom (GMarkupDomNode *node,gchar * nom,gchar * attr); /* trouve une node en fonction d'une valeur particulière d'un attribut particulier */
GMarkupDomNode * g_markup_dom_node (GMarkupDomNode *node,gchar * nom_val); /* trouve une node à partir du nom de la balise */
void copie_node(GMarkupDomNode * arrive,GMarkupDomNode * modele); /* copie une node modèle sur une autre node */
void xml_ajoute_fin(GMarkupDomNode * node,gchar * texte); /* mettre une node fille en fin d'une node, le node de la node étant indiqué par le texte */
void xml_ajoute_fin_texte(GMarkupDomNode * node); /* rajouter un élément texte en fin d'une node */
void xml_ecrit_dernier_texte(GMarkupDomNode * node,gchar * ch); /* remplace le dernier texte d'une node */
void xml_ajoute_fin_attribut(GMarkupDomNode * node); /* rajouter un élément attribut */
void xml_ecrit_dernier_attribut(GMarkupDomNode * node,char * nom, char * val); /* remplace le dernier attribut */
void decale_node(GMarkupDomNode *node,unsigned short i); /* decale les node pour mettre la dernière node à la place i */
void supprime_node(GMarkupDomNode *node,guint place); /* supprime la node */
void xml_sup_node(GMarkupDomNode *node); /* supprime la node passée en paramètre */
int str_isspace (const gchar *s);
void modif_xml(GMarkupDomNode *item,gchar * ch);


/* caract.c */
liste_classe * donne_choix_classe(gpointer param);
void valide_c(GtkWidget *wid, gpointer param);
void initialise_c(GtkWidget *wid, gpointer param);
void annule_c(GtkWidget *wid, gpointer param);
void moins(unsigned short offset,gpointer param);
void plus(unsigned short offset, gpointer param);
void moins_c(GtkWidget *wid, gpointer param);
void plus_c(GtkWidget *wid, gpointer param);
void moins_c_a(GtkWidget *wid, gpointer param);
void plus_c_a(GtkWidget *wid, gpointer param);
void moins_c_c(GtkWidget *wid, gpointer param);
void plus_c_c(GtkWidget *wid, gpointer param);
void moins_c_pdv(GtkWidget *wid, gpointer param);
void plus_c_pdv(GtkWidget *wid, gpointer param);
void initialise_classes(gpointer param);
void initialise_armes(gpointer param);
void initialise_comp(gpointer param);
void initialise_pdv(gpointer param);
void initialise_vol(GtkWidget *wid, gpointer param);
void initialise_mag(gpointer param);
void init_taille(gpointer param);
void compt_vol2(GtkWidget *wid, gpointer param);
void verif_pdv(GtkWidget *wid, gpointer param);
void verif_compt(GtkWidget *wid, gpointer param);
void verif_armes(GtkWidget *wid, gpointer param);
void verif_classe(GtkWidget *wid, gpointer param);
void verif_pan(GtkWidget *wid, gpointer param);
void verif_dieu(GtkWidget *wid, gpointer param);
void verif_aligt(GtkWidget *wid,gpointer param);
void modif_classe(GtkWidget *wid, gpointer param);
void modif_race(GtkWidget *wid, gpointer param);
void modif_xp(GtkWidget *wid, gpointer param);
void modif_taille(GtkWidget *wid, gpointer param);
unsigned short niveau_(unsigned long xp,unsigned long * tab_xp,unsigned short maxi);
unsigned short niveau_max(unsigned long xp,unsigned long * tab_xp,unsigned short maxi);
void cal_caract_voleur(signed short * comp,unsigned short dext,struct_classe * classe, unsigned short niveau,struct_race * race,unsigned short vers_);
gchar * nb_texte(gchar * ch,unsigned short nb);
void affiche_caract(GMarkupDomNode *node,gpointer param);
void caract_label(gpointer param);
void tire_taille_poids(GtkWidget *wid, gpointer param);
void calc_taille_poids(GtkWidget *wid, gpointer param);
void adapte_taille(GtkWidget *wid, gpointer param);
void adapte_poids(GtkWidget *wid, gpointer param);
void modif_c(GtkWidget *wid, gpointer param);
void modif_force(GtkWidget *wid, gpointer param);
void modif_intelligence(GtkWidget *wid, gpointer param);
void modif_sagesse(GtkWidget *wid, gpointer param);
void modif_constitution(GtkWidget *wid, gpointer param);
void modif_dexterite(GtkWidget *wid, gpointer param);
void modif_charisme(GtkWidget *wid, gpointer param);
liste_classe * trouve_liste_classe( gpointer param);

/* modif_caract.c */
gpointer modifier_caract(GtkWidget *wid, gpointer param);

/* pretre.c */
char * tabl_algt_s(char * liste);
GMarkupDomNode * nv_tableau_sort(GMarkupDomNode * ooo,unsigned short niveau,char * metier);
void insere_ligne_pretre(GMarkupDomNode * node,struct_sortileges * sort,unsigned short info);
void affiche_sort_pretre(char * pantheon,char * dieu,GMarkupDomNode * ooo);
unsigned short compare(char *,char*);
void nouveau_dieux (GtkWidget *wid, gpointer param);
void aff_pan(GtkListStore * list_dieu,GtkWidget * wid_dieu,unsigned short pan);
void sphere_nouv(GtkWidget *wid, gpointer param);

/* magicien.c */
void affiche_sort_mag(unsigned short niveau,gpointer param,GMarkupDomNode * ooo);
void init_mag(GtkWidget *wid, gpointer param);

/* groupe.c */
void ouvrir_groupe  (GtkWidget *wid, gpointer param);
void aff_nb_sort(GMarkupDomNode * node,struct_classe * s_c,signed short * clerc,signed short * mag,signed short sage,signed short inte,unsigned short niveau,signed short version_); /* afficher les sorts : dévéloppée pour groupe, mais utile pour fichier */


/* envp.c */
char * chemin_dieux_libre(char * chemin);
char * chemin_dieux(char * chemin);
char * chemin_exe();
char * envp_init(gpointer param);
char * envp_donne_home();
void envp_mem_home(char * chemin);
void envp_mem_hist(char * chemin);
char * rep_tmp();
char * windows_home(char * chemin);
void ouvre_fichier(GtkWidget *wid, gpointer * param,char * aff,char eff);
void  menu_va_hist(GtkWidget *wid, gpointer * param);
GtkWidget * deja_edite(char * nom_de_fichier);

/* feuille .c */
unsigned short trouve_niveau_xp(struct_classe * classe,signed long pt_xp,unsigned short version);
char * pdv_classe(struct_classe * classe,unsigned short niv,unsigned short versi);
void free_metier(liste_classe * l_c);
unsigned short trouve_num_metier(char * nom,gpointer param);
struct_classe * trouve_classe(char * nom,struct_classe * l_c);
signed char compare_sans_casse(char * s1,char * s2);
signed char compare_liste_classe(liste_classe * depart, liste_classe * nv);
liste_classe * range_l_cl(liste_classe * depart, liste_classe * nv);
void retourne_classe(struct_classe * classe, char * fichier, gpointer param);
void  aff_classe(GtkWidget *wid, gpointer * param);
void retourne_race(struct_race * race, char * fichier);
void  aff_race(GtkWidget *wid, gpointer * param);
void retourne_save(struct_save * save, char * fichier);
void  affiche_save(GtkWidget *wid, gpointer * param);
void retourne_sort(struct_sort * sort, char * fichier);
void  affiche_sort(GtkWidget *wid, gpointer * param);

/* zip.c */
char * content_libo(char * fichierZIP,size_t * longueur);


#endif /* INCLUDE_H_INCLUDED */
