/*
    Génération de feuille de personnage complète AD&D 1 et 2
    Génération aléatoire de personnage

    Copyright (C) 2011 Bernard SIAUD

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <string.h>
#include "include.h"


gboolean drap_inverse=0;

liste_classe * trouve_liste_classe_menu(gpointer param)
{
    liste_classe * sortie=NULL, * tmp;
    unsigned short i;

    for (i=0;i<((unsigned short **)param)[MAIN_NB_CLASSE][0];i++)
    {
        if (gtk_check_menu_item_get_active(GTK_CHECK_MENU_ITEM(((struct_classe **)param)[MAIN_CLASSE][i].menu)))
        {
            tmp=(liste_classe *)malloc(sizeof(liste_classe));
            tmp->suiv=NULL;
            tmp->xp=0;
            tmp->niveau=1;
            if (((struct_classe **)param)[MAIN_CLASSE][i].add1.nom!=NULL)
                tmp->nom=g_strdup(((struct_classe **)param)[MAIN_CLASSE][i].add1.nom);
            else
                tmp->nom=g_strdup(((struct_classe **)param)[MAIN_CLASSE][i].add2.nom);
            sortie=range_l_cl(sortie,tmp);
        }
    }
    return sortie;
}


unsigned short donne_race(struct_race * race,unsigned short nb)
{
    unsigned short i;

    for (i=0;i<nb;i++)
        if (gtk_check_menu_item_get_active(GTK_CHECK_MENU_ITEM(race[i].menu)))
            return i;

    gtk_check_menu_item_set_active(GTK_CHECK_MENU_ITEM(race[0].menu),1);
    return 0;
}


int change_entree_menu(GList * p_action,char * nom_,char * titre)
{
  GtkAction *action;

  action=trouve_action(nom_,p_action) ;
  if (action!=NULL)
  {
        g_object_set(action,"label",titre,NULL);
        return 0;
  }
  else
    return 1;
}



GtkWidget * cree_entree_menu(char * nom_,char * titre,GtkUIManager *  menu_Manager,unsigned short i,char * chemin,struct_param_nb * param_nb,void (*fonction)())
{
 //if (strncmp(nom_,"vide",4)==0) return;

 GtkWidget * pere ;
 GtkWidget *pMenu ;
 GtkWidget * nv_entree;
 unsigned short j;
 GList * gl;
 GList * k;
 int id_;

 pere = gtk_ui_manager_get_widget(menu_Manager,chemin);          /* on trouve l'item pere du sous-menu                 */
 pMenu=gtk_menu_item_get_submenu(GTK_MENU_ITEM(pere));                                      /* on trouve le sous-menu                             */
 gl=gtk_container_get_children(GTK_CONTAINER(pMenu));                                       /* on récupère la GList des entrées du sous-menus     */

 i++;
 for (k = gl,j=0; k != NULL; k = g_list_next(k),j++)                                        /* on cherche l'entree i                              */
 {
  if (j==i)                                                                                 /* elle existe déjà                                   */
  {
   nv_entree=k->data;                                                                       /* on modifie son etat                                */
   gtk_menu_item_set_label(GTK_MENU_ITEM(nv_entree),titre);                                 /*                        - l'affichage               */
   g_object_set(nv_entree,"sensitive",1,NULL);
   if (i==1)
   {
    id_=g_signal_handler_is_connected(nv_entree,((gulong **)(param_nb->param))[12][0]);
    if (!id_)
        ((gulong **)(param_nb->param))[12][0]=g_signal_connect(G_OBJECT(nv_entree), "activate", G_CALLBACK(*fonction), param_nb);
   }                                              /*                        - l'activation              */
  }
                                                                                            /* affection d'une fonction callback                  */

 }
 if (i>=j)                                                                                  /* si elle n'existe pas                               */
 {
    nv_entree = gtk_menu_item_new_with_mnemonic (nom_);                                     /*  creation de l'entrée                              */
    gtk_menu_item_set_label(GTK_MENU_ITEM(nv_entree),titre);                                /*  affectation la chaine à afficher pour le menu     */

    gtk_menu_shell_insert(GTK_MENU_SHELL(pMenu), nv_entree,i);                              /* insertion de l'entrée dans le menu à la place i+1  */
    //gtk_menu_shell_append(GTK_MENU_SHELL(pMenu), nv_entree);
    if (fonction!=NULL) g_signal_connect(G_OBJECT(nv_entree), "activate", G_CALLBACK(*fonction), param_nb);
 }
 return nv_entree;
}

GtkWidget *  cree_entree_menu_check(char * nom_,char * titre,GtkUIManager *  menu_Manager,unsigned short i,char * chemin,struct_param_nb * param_nb,void (*fonction)())
{
 //if (strncmp(nom_,"vide",4)==0) return;

 GtkWidget * pere ;
 GtkWidget *pMenu ;
 GtkWidget * nv_entree;
 unsigned short j;
 GList * gl;
 GList * k;
 //int id_;

 pere = gtk_ui_manager_get_widget(menu_Manager,chemin);                                     /* on trouve l'item pere du sous-menu                 */
 pMenu=gtk_menu_item_get_submenu(GTK_MENU_ITEM(pere));                                      /* on trouve le sous-menu                             */
 gl=gtk_container_get_children(GTK_CONTAINER(pMenu));                                       /* on récupère la GList des entrées du sous-menus     */

 i++;
 for (k = gl,j=0; k != NULL; k = g_list_next(k),j++)                                        /* on cherche l'entree i                              */
 {
  if (j==i)                                                                                 /* elle existe déjà                                   */
  {
   if (i==1)
   {
    gtk_widget_destroy(GTK_WIDGET(k->data));
    nv_entree = gtk_check_menu_item_new_with_mnemonic (nom_);                                     /*  creation de l'entrée                              */
    if (fonction!=NULL) g_signal_connect(G_OBJECT(nv_entree), "activate", G_CALLBACK(*fonction), param_nb->param);
   }                                              /*                        - l'activation              */
   else
    nv_entree=k->data;                                                                       /* on modifie son etat                                */
   gtk_menu_item_set_label(GTK_MENU_ITEM(nv_entree),titre);                                 /*                        - l'affichage               */
  }
                                                                                            /* affection d'une fonction callback                  */

 }
 if (i>=j)                                                                                  /* si elle n'existe pas                               */
 {
    nv_entree = gtk_check_menu_item_new_with_mnemonic (nom_);                                     /*  creation de l'entrée                              */
    gtk_menu_item_set_label(GTK_MENU_ITEM(nv_entree),titre);                                /*  affectation la chaine à afficher pour le menu     */
    if (fonction!=NULL) g_signal_connect(G_OBJECT(nv_entree), "activate", G_CALLBACK(*fonction), param_nb->param);
 }
 gtk_menu_shell_insert(GTK_MENU_SHELL(pMenu), nv_entree,i);                              /* insertion de l'entrée dans le menu à la place i+1  */
 return nv_entree;
}

GtkWidget * cree_entree_menu_radio(char * nom_,char * titre,GtkUIManager *  menu_Manager,unsigned short i,char * chemin,gpointer param,GtkWidget* groupe,void (*fonction)())
{
 //if (strncmp(nom_,"vide",4)==0) return;

 GtkWidget * pere ;
 GtkWidget *pMenu ;
 GtkWidget * nv_entree;
 unsigned short j;
 GList * gl;
 GList * k;
 //int id_;

 pere = gtk_ui_manager_get_widget(menu_Manager,chemin);                                     /* on trouve l'item pere du sous-menu                 */
 pMenu=gtk_menu_item_get_submenu(GTK_MENU_ITEM(pere));                                      /* on trouve le sous-menu                             */
 gl=gtk_container_get_children(GTK_CONTAINER(pMenu));                                       /* on récupère la GList des entrées du sous-menus     */

 i++;
 for (k = gl,j=0; k != NULL; k = g_list_next(k),j++)                                        /* on cherche l'entree i                              */
 { /* j= tearoff */
  if (j==i)                                                                                 /* elle existe déjà                                   */
  {
   if (i==1)
   {
    gtk_widget_destroy(GTK_WIDGET(k->data));
    if (groupe==NULL)
        nv_entree = gtk_radio_menu_item_new_with_mnemonic (NULL,nom_);                                     /*  creation de l'entrée                              */
    else
        nv_entree = gtk_radio_menu_item_new_with_mnemonic_from_widget (GTK_RADIO_MENU_ITEM(groupe),nom_);                                     /*  creation de l'entrée                              */
    if (fonction!=NULL) g_signal_connect(G_OBJECT(nv_entree), "activate", G_CALLBACK(*fonction), param);
   }                                              /*                        - l'activation              */
   else
    nv_entree=k->data;                                                                       /* on modifie son etat                                */
   gtk_menu_item_set_label(GTK_MENU_ITEM(nv_entree),titre);                                 /*                        - l'affichage               */
  }
                                                                                            /* affection d'une fonction callback                  */

 }
 if (i>=j)                                                                                  /* si elle n'existe pas                               */
 {
    if (groupe==NULL)
        nv_entree = gtk_radio_menu_item_new_with_mnemonic (NULL,nom_);                                     /*  creation de l'entrée                              */
    else
        nv_entree = gtk_radio_menu_item_new_with_mnemonic_from_widget(GTK_RADIO_MENU_ITEM(groupe),nom_);                                     /*  creation de l'entrée                              */
    gtk_menu_item_set_label(GTK_MENU_ITEM(nv_entree),titre);                                /*  affectation la chaine à afficher pour le menu     */

     if (fonction!=NULL) g_signal_connect(G_OBJECT(nv_entree), "activate", G_CALLBACK(*fonction), param);
 }
 gtk_menu_shell_insert(GTK_MENU_SHELL(pMenu), nv_entree,i);                              /* insertion de l'entrée dans le menu à la place i+1  */

 return nv_entree;
}


void race_classe(unsigned short race,unsigned short version_dd, gpointer param)
{
    liste_classe *liste=trouve_liste_classe_menu(param);
    liste_classe_race * liste_cr , * tmp_l;
    unsigned short i=0;
    /* pour la recherche de la liste la plus semblable
    liste_classe * tmp_c1, * tmp_c2;
    liste_classe_race *tmp_lmax;
    unsigned short max=0
    signed char j;*/


    if (drap_inverse!=0 || liste==NULL) return;
    drap_inverse=1;
    if (version_dd==ADD1)
        liste_cr=((struct_race **)param)[MAIN_RACE][race].add1.liste_classe;
    else if (version_dd==ADD2)
        liste_cr=((struct_race **)param)[MAIN_RACE][race].add2.liste_classe;
    else
    {
        drap_inverse=0;
        return;
    }

    for(tmp_l=liste_cr;tmp_l!=NULL;tmp_l=tmp_l->suiv)
        if (compare_liste_classe(liste,tmp_l->classe)==0)
        {
            drap_inverse=0;
            return;
        }



    for (i=0;i<((unsigned short **)param)[MAIN_NB_CLASSE][0];i++)
        gtk_check_menu_item_set_active(GTK_CHECK_MENU_ITEM(((struct_classe **)param)[MAIN_CLASSE][i].menu),0);


    /* recherche de la liste la plus emblable => le problème, c'est que ça "immobilise" le choix */
    /*for(tmp_l=liste_cr;tmp_l!=NULL;tmp_l=tmp_l->suiv)
    {
        i=0;
        tmp_c1=liste;
        tmp_c2=tmp_l->classe;

        while (tmp_c2!=NULL && tmp_c1!=NULL)
        {
            j=compare_sans_casse(tmp_c1->nom,tmp_c2->nom);
            if (j==0)
            {
                i++;
                tmp_c1=tmp_c1->suiv;
                tmp_c2=tmp_c2->suiv;
            }
            else if (j<0)
                tmp_c1=tmp_c1->suiv;
            else
                tmp_c2=tmp_c2->suiv;
        }
        if (i>max)
        {
             tmp_lmax=tmp_l;
             max=i;
        }
    }
    if (max!=0)
        tmp_c2=tmp_lmax->classe;
    else
       tmp_c2= liste_cr->classe;
    for (i=0;i<((unsigned short **)param)[MAIN_NB_CLASSE][0] && tmp_c2!=NULL;i++)
    {
        if (version_dd==ADD1)
        {
            if (compare_sans_casse(tmp_c2->nom,((struct_classe **)param)[MAIN_CLASSE][i].add1.nom)==0)
            {
                gtk_check_menu_item_set_active(GTK_CHECK_MENU_ITEM(((struct_classe **)param)[MAIN_CLASSE][i].menu),1);
                tmp_c2=tmp_c2->suiv;
            }

        }
        else
        {
            if (compare_sans_casse(tmp_c2->nom,((struct_classe **)param)[MAIN_CLASSE][i].add2.nom)==0)
            {
                gtk_check_menu_item_set_active(GTK_CHECK_MENU_ITEM(((struct_classe **)param)[MAIN_CLASSE][i].menu),1);
                tmp_c2=tmp_c2->suiv;
            }

        }

    }*/
    drap_inverse=0;
}

GtkAction * trouve_action(gchar * ch,GList * gl)
{
   GList * k;
   GtkAction * action;
   gchar *action_name;

   if (strncmp(ch,"vide",4)==0) return NULL;

    for (k = gl; k != NULL; k = g_list_next(k))
    {




        action = GTK_ACTION(k->data);
        g_object_get(action,
                     "name",     &action_name,
                     NULL);
        if (strcmp(action_name,ch)==0)
        {
            g_free(action_name);
            return action;
        }
        g_free(action_name);
    }

    return NULL;
}



void inverse(unsigned short caract,unsigned short t,gpointer param)
{
   unsigned short i;
   GtkActionGroup *act_gr = *((GtkActionGroup **)param+3);
   GList * gl=gtk_action_group_list_actions (act_gr),*k;
   gchar *action_name;
   /*gchar action_active;*/
   char ch[8],ligne[32];
   GtkAction *action;
   unsigned short * val =*((unsigned short **)param+1);

   if (drap_inverse) return ;

   drap_inverse=1; /* drapeau pour ne pas repasser ici qu'on n'en soit sorti ! */
   for(i=0;i<8 && val[i]!=t;i++);
   if (i>7) printf("Erreur !");
   else
   {
       sprintf(ch,"%s%d",init[i],val[caract]);
        for (k = gl; k != NULL; k = g_list_next(k))
        {
            action = GTK_ACTION(k->data);
            g_object_get(action,
                         "name",     &action_name,
                         NULL);
            if (strcmp(action_name,ch)==0)
            {
                val[i]=val[caract];
                g_object_set(action,"active",1,NULL);
            }
            if (strcmp(action_name,nom_min[caract])==0)
            {
                sprintf(ligne,"%s : %d",nom_min[caract],t);
                g_object_set(action,"label",ligne,NULL);
            }
            if (strcmp(action_name,nom_min[i])==0)
            {
                sprintf(ligne,"%s : %d",nom_min[i],val[caract]);
                g_object_set(action,"label",ligne,NULL);
            }
            g_free(action_name);
        }
       val[caract]=t;
   }
   drap_inverse=0;
}


void non_humour_beaute(GtkActionGroup *p_actionGroup)
{
        inactive("f7",p_actionGroup);
        inactive("f8",p_actionGroup);
        inactive("s7",p_actionGroup);
        inactive("s8",p_actionGroup);
        inactive("i7",p_actionGroup);
        inactive("i8",p_actionGroup);
        inactive("d7",p_actionGroup);
        inactive("d8",p_actionGroup);
        inactive("co7",p_actionGroup);
        inactive("co8",p_actionGroup);
        inactive("ch7",p_actionGroup);
        inactive("ch8",p_actionGroup);
}

void humour_beaute(GtkActionGroup *p_actionGroup)
{
        active("f7",p_actionGroup);
        active("f8",p_actionGroup);
        active("s7",p_actionGroup);
        active("s8",p_actionGroup);
        active("i7",p_actionGroup);
        active("i8",p_actionGroup);
        active("d7",p_actionGroup);
        active("d8",p_actionGroup);
        active("co7",p_actionGroup);
        active("co8",p_actionGroup);
        active("ch7",p_actionGroup);
        active("ch8",p_actionGroup);
}


void supprime(char * ch,gpointer param)
{
    GtkAction *action=trouve_action(ch,gtk_action_group_list_actions (*((GtkActionGroup **)param+3)));

    if (action!=NULL)
     g_object_set(action,"active",0,NULL);
}

void valide(char * ch,gpointer param)
{
    GtkAction *action=trouve_action(ch,gtk_action_group_list_actions (*((GtkActionGroup **)param+3)));

    if (action!=NULL)
     g_object_set(action,"active",1,NULL);
}


void inactive(gchar * ch,GtkActionGroup * p_actionGroup)
{
    GtkAction *action=trouve_action(ch,gtk_action_group_list_actions (p_actionGroup));

    if (action!=NULL)
        g_object_set(action,"sensitive",0,NULL);
    /*{
        gboolean drap;
        g_object_get(action,"visible",&drap,NULL);
        printf ("%s visible avant : %d, ",ch,drap);
        g_object_set(action,"visible",0,NULL);
        g_object_get(action,"visible",&drap,NULL);
        printf ("après : %d\n",drap);
    }*/
}

void active(gchar * ch,GtkActionGroup * p_actionGroup)
{
    GtkAction *action=trouve_action(ch,gtk_action_group_list_actions (p_actionGroup));

    if (action!=NULL)
        g_object_set(action,"sensitive",1,NULL);
}

void Tearoff_on(GtkUIManager * menu_Manager,char * chemin)
{
    GtkWidget * pere = gtk_ui_manager_get_widget(menu_Manager,chemin); /* identification du sous-menu           */
    GtkWidget * pMenu=gtk_menu_item_get_submenu(GTK_MENU_ITEM(pere));  /* en deux étapes                        */

    GtkWidget * nv_entree = gtk_tearoff_menu_item_new();               /* création du TeaOff                    */
    gtk_menu_shell_prepend(GTK_MENU_SHELL(pMenu), nv_entree);          /* insertion du Teaoff dans le sous-menu */
}

void race_init  (GtkUIManager * menu,gpointer param)
{
    unsigned short i,nb=((unsigned short **)param)[MAIN_NB_RACE][0];
    char aff[LONG];
    struct_race * race=((struct_race**)param)[MAIN_RACE];

    for(i=0;i<nb;i++)
    {
        if (race[i].add1.nom)
            sprintf(aff,"aff_%s",race[i].add1.nom);
        else
            sprintf(aff,"aff_%s",race[i].add2.nom);
        //if (change_entree_menu(NULL,aff,aff+4))
        {
            cree_entree_menu(aff,aff+4,menu,i,"/menubar/Vue/Race",((struct_param_nb **)param)[MAIN_PARAM_RACE]+i,aff_race);
            race[i].menu=cree_entree_menu_radio(aff,aff+4,menu,i,"/menubar/Tirage/race",param,((struct_race **)param)[MAIN_RACE][0].menu,(GCallback)print_race); //(GCallback)print_race, (gpointer) param)

        }
    }
}

void classe_init(GtkUIManager * menu,gpointer param)
{
    unsigned short i,nb=((unsigned short **)param)[MAIN_NB_CLASSE][0];
    char aff[LONG];
    struct_classe * classe=((struct_classe**)param)[MAIN_CLASSE];

    for(i=0;i<nb;i++)
    {
        if (classe[i].add1.nom)
            sprintf(aff,"aff_%s",classe[i].add1.nom);
        else
            sprintf(aff,"aff_%s",classe[i].add2.nom);
        //if (change_entree_menu(NULL,aff,aff+4))
        {
            cree_entree_menu(aff,aff+4,menu,i,"/menubar/Vue/Classe",((struct_param_nb **)param)[MAIN_PARAM_CLAS]+i,aff_classe);
            ((struct_classe **)param)[MAIN_CLASSE][i].menu=cree_entree_menu_check(aff,aff+4,menu,i,"/menubar/Tirage/Classes",((struct_param_nb **)param)[MAIN_PARAM_CLAS]+i,(GCallback)print_race);
        }
    }
}

