/*
    Génération de feuille de personnage complète AD&D 1 et 2
    Génération aléatoire de personnage

    Copyright (C) 2011 Bernard SIAUD

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#if defined(__FreeBSD__)
#include <stdlib.h>
#else
#include <malloc.h>
#endif
#include "include.h"



void explication (GtkWidget *wid, gpointer param)
{
  GtkWidget *dialog = NULL;

  dialog = gtk_message_dialog_new (GTK_WINDOW ((GtkWidget*)((void **)param)[0]), GTK_DIALOG_MODAL, GTK_MESSAGE_INFO, GTK_BUTTONS_CLOSE, "tirage de personnages AD&D");
  gtk_window_set_position (GTK_WINDOW (dialog), GTK_WIN_POS_CENTER);
  gtk_dialog_run (GTK_DIALOG (dialog));
  gtk_widget_destroy (dialog);

  (void)wid;
}


void menu_aide(GtkWidget *p_widget, gpointer param)
{
 GtkWidget *dialogue = NULL;
 GtkWidget *d_label1 = NULL;
 char * chemin, ch[LONG];
 GError * error;

  /*gchar * ch;
  FILE * fichier;

  ficher=*/



 dialogue=gtk_dialog_new();
 chemin=chemin_exe();
 sprintf(ch,"%s%cadd.png",chemin,SEPARATEUR);
 free(chemin);
 if (!gtk_window_set_icon_from_file(GTK_WINDOW (dialogue),ch,&error))
 {                                                                  /* met une icone à la fenêtre                                   */
  traite_erreur(error);
  g_error_free(error);
 }
 gtk_window_set_title(GTK_WINDOW(dialogue),"Aide");
 gtk_window_set_default_size(GTK_WINDOW(dialogue),300,-1);
 /* création d'un label (espace de texte) avec un texte simple, sans formatage */
 d_label1=gtk_label_new("Tirage aléatoire de personnages\n Choisisser votre ordre de préférance des caractéristiques\nChoisissez les classes et la feuille sera remplie");
 gtk_label_set_line_wrap(GTK_LABEL(d_label1),FALSE);/* insertion du label dans le conteneur principal */
 gtk_box_pack_start (GTK_BOX (GTK_DIALOG(dialogue)), d_label1, TRUE, TRUE, 0);
 gtk_label_set_justify(GTK_LABEL(d_label1),GTK_JUSTIFY_CENTER);

 d_label1=gtk_label_new("\nVous pouvez ensuite tout modifier à partir du bouton modifier pour faire la feuille du personnage de votre choix\n(caractérisques, classes, niveaux, armes)");
 gtk_label_set_line_wrap(GTK_LABEL(d_label1),FALSE);/* insertion du label dans le conteneur principal */
 gtk_box_pack_start (GTK_BOX (GTK_DIALOG(dialogue)), d_label1, TRUE, TRUE, 0);
 gtk_label_set_justify(GTK_LABEL(d_label1),GTK_JUSTIFY_CENTER);

 gtk_widget_show_all(GTK_WIDGET(dialogue));
 /* On lance la boite de dialogue */
 gtk_dialog_run(GTK_DIALOG(dialogue));

 (void)p_widget;
 (void)param;
}

void menu_a_propos(GtkWidget *p_widget, gpointer param)
{
 GtkWidget *dialogue = NULL;
 GtkWidget *d_label = NULL;
 GError * error;
 char * chemin,ch[LONG];

 dialogue=gtk_dialog_new();
 chemin=chemin_exe();
 sprintf(ch,"%s%cadd.png",chemin,SEPARATEUR);
 free(chemin);
 if (!gtk_window_set_icon_from_file(GTK_WINDOW (dialogue),ch,&error))
 {                                                                  /* met une icone à la fenêtre                                   */
  traite_erreur(error);
  g_error_free(error);
 }
 gtk_window_set_title(GTK_WINDOW(dialogue),"A Propos");
 gtk_window_set_default_size(GTK_WINDOW(dialogue),300,-1);
 /* création d'un label (espace de texte) avec un texte simple, sans formatage */
 d_label=gtk_label_new("Génération de personnages AD&D\npar\nTroumad Alias Bernard SIAUD\nhttp://troumad.org\n\nRemerciements à\nhttp://gtk.developpez.com\nhttp://dnd.ezael.net/viewforum.php");

 gtk_label_set_line_wrap(GTK_LABEL(d_label),FALSE);
 /* insertion du label dans le conteneur principal */
 gtk_box_pack_start (GTK_BOX (GTK_DIALOG(dialogue)), d_label, TRUE,TRUE, 0);
 gtk_label_set_justify(GTK_LABEL(d_label),GTK_JUSTIFY_CENTER);
 gtk_widget_show_all(GTK_WIDGET(dialogue));
 /* On lance la boite de dialogue */
 gtk_dialog_run(GTK_DIALOG(dialogue));

 (void)p_widget;
 (void)param;
}


void menu_licence(GtkWidget *p_widget, gpointer param)
{
 GtkWidget *dialogue = NULL;
 GtkWidget *d_label = NULL;
 GtkWidget *d_label1 = NULL;
 GError * error;
 char * chemin,ch[LONG];

 dialogue=gtk_dialog_new();
 chemin=chemin_exe();
 sprintf(ch,"%s%cgnu_ico.png",chemin,SEPARATEUR);
 free(chemin);
 if (!gtk_window_set_icon_from_file(GTK_WINDOW (dialogue),ch,&error))
 {                                                                  /* met une icone à la fenêtre                                   */
  traite_erreur(error);
  free(error);
 }
 gtk_window_set_title(GTK_WINDOW(dialogue),"Licence GPL");
 gtk_window_set_default_size(GTK_WINDOW(dialogue),300,-1);
 /* création d'un label (espace de texte) avec un texte simple, sans formatage */
 d_label=gtk_label_new("Génération de feuille de personnage complète AD&D 1 et 2\nGénération aléatoire de personnage\n\nCopyright (C) 2011 Bernard SIAUD\n\nThis program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.\n\nThis program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.\n\nYou should have received a copy of the GNU General Public License along with this program.  If not, see <http://www.gnu.org/licenses/>");
 d_label1=gtk_label_new("\n\nVersion française non officielle : http://fsffrance.org/gpl/gpl.fr.html");
 /* label avec saut de ligne */
 gtk_label_set_line_wrap(GTK_LABEL(d_label),TRUE);
 gtk_label_set_line_wrap(GTK_LABEL(d_label1),TRUE);
 /* insertion du label dans le conteneur principal */
 gtk_box_pack_start (GTK_BOX (GTK_DIALOG(dialogue)), d_label, TRUE, TRUE, 0);
 gtk_label_set_justify(GTK_LABEL(d_label),GTK_JUSTIFY_CENTER);
 gtk_box_pack_start (GTK_BOX (GTK_DIALOG(dialogue)), d_label1, TRUE, TRUE, 0);
 gtk_label_set_justify(GTK_LABEL(d_label1),GTK_JUSTIFY_CENTER);
 gtk_widget_show_all(GTK_WIDGET(dialogue));
 /* On lance la boite de dialogue */
 gtk_dialog_run(GTK_DIALOG(dialogue));

 (void)p_widget;
 (void)param;
}

void traite_erreur(GError *error)
{
 printf("%s\n",error->message);                                      /* affichage de l'erreur                                       */
}
