/*
    Génération de feuille de personnage complète AD&D 1 et 2
    Génération aléatoire de personnage

    Copyright (C) 2011 Bernard SIAUD

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <string.h>
#include "include.h"

void aff_liste_pan(GtkListStore * list_pan,GtkWidget * wid_pan,GtkWidget * wid_dieu,char * s_pan,char * s_dieu,GMarkupDomNode * node);
unsigned long * tabl_sphere(char * liste);
unsigned short * tabl_sphere_s(char * liste);
void modif_pan(GtkWidget *wid, gpointer param);
void modif_dieu(GtkWidget *wid, gpointer param);
void sphere_0(GtkWidget *wid, gpointer param);
void sphere_MAJ(GtkWidget *wid, gpointer param);
void sphere_min(GtkWidget *wid, gpointer param);
void ferme_sphere(GtkWidget *wid, gpointer param);
void sphere_supp(GtkWidget *wid, gpointer param);
void modif_p(GtkWidget *wid, gpointer param);

char * nom_sphere[]={
  "Générale", /* 0 */
  "Animale",
  "Astrale",
  "Chaos",
  "Charme",
  "Climat", /* 5 */
  "Combat", /* 6 */
  "Conjuration", /* 7 */
  "Création",  /* 8 */
  "Divination", /* 9 */
  "Élémentaire", /* 10 */
  "Air élémentaire",
  "Eau élémentaire",
  "Feu élémentaire",
  "Terre élémentaire",
  "Garde", /* 15 */
  "Guerre", /* 16 */
  "Loi",
  "Nécromantique",
  "Nombres",
  "Pensée", /* 20 */
  "Protection", /* 21 */
  "Soins", /* 22 */
  "Soleil",
  "Temps",
  "Végétale", /* 25 */
  "Vigilance",
  "Voyageurs"
 };

struct_sortileges sortileges[]={
    {"À demain",6,"0","V S","instantanée","1 round","r=3m","annule","Aucun",16777216},
    {"Abaissement des eaux / Elévation des eaux",4,"120 pas","V S M","1 tour/niveau","1 tour","Spéciale","Aucun","Symbole religieux + 1 pincée de poussière",5120},
    {"Abjuration",4,"10 pas","V S M","Spéciale","1 round","1 créature","Spécial","Symbole religieux + petite quantité d'un matériau honni par la créature",128},
    {"Action libre",4,"Toucher","V S M","1 tour/niveau","7","Créature touchée","Aucun","1 lanière de cuir ou objet similaire",16},
    {"Action répétée",5,"30 mètres","V S","spéciale","5","une créature","annule","Aucun",16777216},
    {"Adaptation",3,"spéciale","V S M","spéciale","spéciale","une unité de 200 individus maximum","Aucun","symbole sacré du prêtre",65536},
    {"Addition",4,"30 mètres","V S M","spéciale","1 round","spéciale","Aucun","une table de formules numérologiques inscrites sur une tablette d'invoire",524544},
    {"Age de dragon",7,"30 mètres","V S M","1 round/niveau","1 round","un dragon","annule","une poignée de sable ramassée dans l'empeinte d'un dragon",16777216},
    {"Age végétal",4,"30 mètres","V S M","spéciale","permanente","une balance; une graine ou un arbre/niveau","Aucun","le symbole sacré du prêtre et une fleure de pommier",16777216},
    {"Aide",2,"Toucher","V S M","1 round + 1 round/niveau","5","Créature touchée","Aucun","Petite bande d'étoffe blanche enduite de substance collante + symbole religieux",262144},
    {"Allégement",2,"30 mètres","V S M","1 heure/niveau","2","cube c=3mètres","Aucun","une plume et un morceau de papier humidifié par une bulle de savon",134217728},
    {"Amitié avec les animaux",1,"10 pas","V S M","Permanente","1 heure","1 animal","Annule","Symbole religieux + Nourriture",2},
    {"Analyse d'équilibre",1,"80 mètres","V S M","(5 +1/niveau)round","1 round","une créature; un objet ou un carré c=3 mètres","Aucun","4 pièces en fer",524800},
    {"Animation d'un objet",6,"30 pas","V S","1 round/niveau","9","1 pied cubique/niveau","Aucun","Aucun",384},
    {"Animation de la pierre",7,"40 pas","V S M","1 round/niveau","1 round","2 pieds cubiques/niveau","Aucun","1 pierre + 1 goutte de sang du prêtre",17408},
    {"Animation des morts",3,"10 pas","V S M","Permanente","1 round","Spéciale","Aucun","1 goutte de sang + 1 morceau de chair de la créature + poudre ou éclat d'os",262144},
    {"Animaux",6,"30 pas","V S","2 rounds/niveau","9","Spéciale","Aucun","Aucun",128},
    {"Anti-dragon",6,"10 mètre/niveau","V S M","(1D4 + 1/2niv) round","1 round","cube c=1;5m","annule","symbole sacré du prêtre et une écaille de dragon",67108864},
    {"Apaisement / Effroi",1,"10 pas","V S","Spéciale","1","1 créature/4 niveaux","Spécial","Aucun",16},
    {"Appel de créatures sylvestres",4,"100 pas/niveau","V S M","Spéciale","Spécial","Spéciale","Annule","1 pomme de pin + 8 boules de houx",130},
    {"Appel de la foudre",3,"0","V S","1 tour/niveau","1 tour","Rayon de 360 pieds","36192","Aucun",32},
    {"Arbre",3,"0","V S M","6 tours + 1 tour/niveau","6","Le lanceur","Aucun","Symbole religieux + 1 brindille d'arbre",33554432},
    {"Arc-en-ciel",5,"120 pas","V S M","1 round/niveau","7","Spéciale","Aucun","Symbole religieux + eau bénite + 1 arc-en-ciel (voir Manuel des joueurs)",8388640},
    {"Artillerie illusoire",5,"300 mètres","V S M","instantanée","1 tour","carré c=30m","Aucun","un petit cylindre vide en laiton",65536},
    {"Asile / Appel",7,"Toucher","V S M","Spéciale","1 jour","Spéciale","Aucun","Objet spécialement préparé (coût 2000 PO - 5000 PO)",128},
    {"Augure",2,"0","V S M","Spéciale","2 rounds","Spéciale","Aucun","Petites baguettes; os de dragons; valant au moins 1000 PO",512},
    {"Aura de bien-être",2,"toucher","V S","1 heure/niveau","2","créature touchée","Aucun","Aucun",134217728},
    {"Autorisation préalable",5,"150 mètres","V S","1 tour/niveau","3","une créature","Annule","Aucun",131072},
    {"Baie magique / Baie vénéneuse",2,"Toucher","V S M","1 jour + 1 jour/niveau","1 round","2d4 baies fraîches","Aucun","Symbole religieux",33554432},
    {"Barrière antivermine",1,"30 mètres","V S M","(5 + 1/niveau)rounds","1 round","une créaure; un objet ou un côté c=3m","Aucun","4 pièces en fer",67108864},
    {"Barrière de lames",6,"30 pas","V S","3 rounds/niveau","9","Spéciale","Spécial","Aucun",33024},
    {"Barrière de rétention",5,"spéciale","V S M","1 tour/niveau","1 tour","cube; c=(3m/niv)","annule","une petite cage en fils d'argent",67108864},
    {"Bassin réfléchissant",4,"10 pas","V S M","1 round/niveau","2 heures","Spéciale","Aucun","Huile extraite de graines",512},
    {"Bassin temporel",5,"toucher","V S M","1 round/niveau","1 round","spéciale","Aucun","une surface réfléchissante appropriée et une pincée de quartz pulvérisé",16777216},
    {"Bâton sylvanien",7,"Toucher","V S M","Spéciale","4","Le bâton du lanceur","Aucun","Symbole religieux ou feuilles du même type d'arbre que le bâton",3354688},
    {"Bâtons en serpents / Serpents en bâtons",4,"30 pas","V S M","2 rounds/niveau","7","1d4 bâtons + 1 bâton/niveau dans un cube de 10 pieds d'arête","Aucun","1 petit morceau d'écorce + plusieurs écailles de serpent",33554432},
    {"Bénédiction / Malédiction",1,"60 pas","V S M","6 rounds","1 round","Cube de 50 pieds d'arête","Aucun","Eau bénite",1},
    {"Bénédiction d'abondance",5,"toucher","V S M","permanente","1 round","l'équivalent de 27l/niveau","Aucun","le symbole sacré du prêtre",256},
    {"Bénitier magique",5,"Toucher","V S M","Spéciale","1 heure","Spéciale","Aucun","Symbole religieux + 1 bénitier",512},
    {"Calmer les esprits",2,"20 mètres","V S","Spéciale","1","1D6 créatures/niveau","Spécial","Aucun",131072},
    {"Cantique",2,"0","V S","Durée du cantique","2 rounds","Rayon de 30 pieds","Aucun","Aucun",64},
    {"Capture de pensée",1,"0","V S","instantanée","3","10 mètres","Aucun","Aucun",1048576},
    {"Causalité aléatoire",3,"10 mètres","V S M","spéciale","3 round + 1/niveau","une arme","annule","un dès de bronze",8},
    {"Cercle d'intimité",4,"spéciale","V S M","1 heure/niv","4","cercle D=15m","Aucun","un poil de putois; une moustache de sourie et assez de sel pour faire le cercle",134217728},
    {"Cercle d'union / Cercle d'infortunes",1,"0","V S","2D10 rounds","5","spéciale","Aucun","Aucun",2097152},
    {"Chaleur bénite",4,"toucher","V S","1 round/niveau","4","Spéciale","Aucun","Aucun",8388608},
    {"Changement de plan",5,"Toucher","V S M","Permanente","8","Créature touchée (spécial)","Annule","Petit bâtonnet métallique fourchu",4},
    {"Char de Sustarre",7,"10 pas","V S M","12 heures","1 tour","Spéciale","Aucun","1 petit morceau de bois + 2 boules de houx + source de feu",9472},
    {"Charme personnes ou mammifères",2,"80 pas","V S","Spéciale","5","1 personne ou 1 mammifère","Annule","Aucun",2},
    {"Charme-serpents",2,"30 pas","V S","Spéciale","5","Cube de 30 pieds d'arête","Aucun","Aucun",2},
    {"Chausse-trappe",3,"20 mètres/niveau","V S M","1 tour/niveau","1 tour","spéciale","Aucun","un chausse trappe en or",65536},
    {"Chemin dégagé / Chemin encombré",5,"0","V S M","1 heure/niv","5","spéciale","Aucun","une lame de couteau et une branche de genêt / une poignée de petits cailloux et une poignée d'herbes",134217728},
    {"Chêne animé",6,"Toucher","V S M","1 jour/niveau","1 tour","1 chêne","Aucun","Symbole religieux",33554432},
    {"Cheval de bois",4,"10 mètres","V S M","1 heure/niv","4","une buche ou une plante","Aucun","une buche ou une plante de la taille appropriée et un fer à cheval",134217728},
    {"Chœur céleste*",3,"0","V","Instantanée","5","Spéciale","1/2","Aucun",64},
    {"Choix du futur",3,"toucher","V S M","1 round","3","une créature","Aucun","deux grains de sable et une pétale de rose",16777216},
    {"Clair d'étoiles",3,"10 pas/niveau","V S M","1 tour/niveau","6","Carré de 10 pieds de côté/niveau","Aucun","Plusieurs tiges d'Amaryllis (notamment Hypoxis) + boules de houx",8388608},
    {"Climat incontrôlé",7,"0","V S","1 tour/niveau","1 tour","10D4 km²","Aucun","Aucun",8},
    {"Coffre pondéreux",1,"toucher","V S M","1 jour/niveau","1","cube c=1;5mètre","Aucun","une boule de plomb",67108864},
    {"Coffre véloce",2,"toucher","V S M","permanent","2","cube c=3mètres","Aucun","une jambe de grenouille séchée; une plume et une écaille de poisson",67108864},
    {"Collet",3,"Toucher","V S M","Permanente jusqu'à déclenchement","3 rounds","Cercle de 2' de diamètre + 1/6' par niveau","Aucun","Symbole religieux + peau de serpent + fibre musculaire d'un animal puissant",33554432},
    {"Colonne de feu",5,"60 pas","V S M","Instantanée","8","Colonne de 5 pieds de rayon et 30 pieds de haut","Spécial","1 pincée de souffre",64},
    {"Combat chaotique",4,"30 mètres","V S","1 round/niveau","3","une créature","Aucun","Aucun",8},
    {"Combinaison",1,"Toucher","V S","Spéciale","1 round","Le cercle de prêtres","Aucun","Aucun",1},
    {"Combustion prolongée",1,"Toucher","V S","1 heure/niveau","1","Spéciale","Aucun","Aucun",33563648},
    {"Commandement / Doute",4,"spéciale","V S M","spéciale","spéciale","une créature","Aucun","une pincée de limaille / le symbole sacré du prêtre",65536},
    {"Communication avec les morts",3,"1","V S M","Spéciale","1 tour","1 créature","Spécial","Symbole religieux + encens",512},
    {"Communion",5,"0","V S M","Spéciale","1 tour","Spéciale","Aucun","Symbole religieux + eau bénite + encens",512},
    {"Communion avec la nature",5,"0","V S","Spéciale","1 tour","Spéciale","Aucun","Aucun",512},
    {"Confusion",7,"80 pas","V S M","1 round/niveau","1 round","1d4 créatures dans un carré de 40'x40'","Spécial","3 coquilles de noix",16},
    {"Conjuration d'animaux 1",4,"Rayon de 1;5 km","V S","Spéciale","7","Spéciale","Aucun","Aucun",130},
    {"Conjuration d'animaux 2",5,"60 pas/niveau","V S","Spéciale","8","Spéciale","Aucun","Aucun",130},
    {"Conjuration d'animaux 3",6,"100 pas/niveau","V S","Spéciale","9","Spéciale","Aucun","Aucun",130},
    {"Conjuration d'insectes",3,"30 pas","V S M","1 round/niveau","1 round","1 créature","Aucun","Symbole religieux + 1 pétale de fleur + boue ou argile humide",2},
    {"Conjuration d'un élémental de feu / Renvoi d'un élémental de feu",6,"80 pas","V S","1 tour/niveau","6 rounds","Spéciale","Aucun","Aucun",9216},
    {"Conjuration d'un élémental de terre / Renvoi d'un élémental de terre",7,"40 pas","V S","1 tour/niveau","1 tour","Spéciale","Aucun","Aucun",17536},
    {"Conjuration du climat",6,"0","V S","Spéciale","1 tour","Spéciale","Aucun","Aucun",160},
    {"Connaissance de l'âge",1,"0","V S M","instantanée","1","un objet ou une créature","Aucun","une page de calendrier",16777216},
    {"Connaissance de la direction",1,"0","V S M","instantanée","1","spéciale","Aucun","un morceau de parchemin de carte vieux de au moins 100 ans",134217728},
    {"Connaissance des alignements / Alignement indétectable",2,"10 pas","V S","1 tour","1 round","1 créature ou 1 objet","Annule","Aucun",512},
    {"Connaissance des coutumes",3,"spéciale","V S","spéciale","3","le prêtre","annule","Aucun",134217728},
    {"Connaissance du temps",1,"0","V S","instantanée","1","le prêtre","Aucun","Aucun",16777216},
    {"Conséquence",5,"0","V S M","instantanée","1 round","Spéciale","Aucun","3 pièces ou dès spéciaux en platine (+ 1000 po)",524800},
    {"Contrôle climatique",7,"0","V S M","4d12 heures","1 tour","9d4 km carrés","Aucun","Symbole religieux; encens; chapelet ou objet similaire",131104},
    {"Contrôle de la température sur 10'",4,"0","V S M","4 tours + 1 tour/niveau","7","Rayon de 10'","Aucun","1 bande d'écorce de saule (our augmenter la température) ou des feuilles de framboisier (pour la diminuer)",32},
    {"Contrôle des émotions",3,"10 mètres","V S M","1 roud/niv","5","une créature/5 niveau du prêtre dans un cube c=6m","spécial","un morceau de laine brute ou non cardé",1048592},
    {"Contrôle des probabilités",4,"30 mètres","V S M","spéciale","4","une créature","annule","cube d'un mélange de sucre et de lait et un dès cubique d'une taille équivalente",524288},
    {"Contrôle des vents",5,"0","V S","1 tour/niveau","8","Rayon de 40 pieds/niveau","Aucun","Aucun",32},
    {"Coquille anti-animaux",6,"0","V S M","1 tour/niveau","1 round","Hémisphère de 20' de diamètre","Aucun","Symbole religieux + 1 poignée de poivre",2097154},
    {"Coquille anti-plantes",5,"0","V S","1 tour/niveau","8","Hémisphre de 15' de diamètre","Aucun","Aucun",35651584},
    {"Courage",1,"240 mètres","V S M","spéciale","1 tour","une unité de 200 individus maximum","Aucun","un cube de fonte",65536},
    {"Courroux spirituel*",6,"300 mètres","V S","intantanée","1 tour","Spéciale","1/2","Aucun",64},
    {"Création d'eau / Destruction d'eau",1,"30 pas","V S M","Permanente","1 round","16 litres/niveau","Aucun","1 goutte d'eau",1024},
    {"Création d'un campement / Lever le camp",3,"0","V S M","spéciale","3","r=15m","Aucun","un morceau de corde; un bout de bois et une goutte d'eau",134217728},
    {"Création de nourriture et d'eau",3,"10 pas","V S","Spéciale","1 tour","1 pied cubique/niveau","Aucun","Aucun",256},
    {"Création de symbole sacré",2,"0","V","permanente","2","le prêtre"," ","Aucun",256},
    {"Croc-en-jambe",2,"Toucher","V S","1 tour/niveau","5","1 objet long de plus de 10 pieds","Annule","Aucun",33554432},
    {"Croisade",5,"60 pas","V S M","Jusqu'à accomplissement","8","1 créature","Annule","Symbole religieux",16},
    {"Croissance animale / Réduction animale",5,"80 pas","V S M","2 rounds/niveau","8","Maximum de 8 animaux dans une zone de 20 pieds de côté","Aucun","Symbole religieux + un peu de nourriture",2},
    {"Croissance d'épines",3,"60 pas","V S M","3d4 tours + 1 tour/niveau","6","Cube de 10 pieds de côté/niveau","Aucun","Symbole religieux + 7 épines acérées ou 7 brindilles taillées en pointe",33554432},
    {"Croissance végétale",3,"160 pas","V S M","Permanente","1 round","Spéciale","Spécial","Symbole religieux",33554432},
    {"Déformation de l'espace",7,"50 mètres","V S M","1 round/niveau","7","sphère D=15 m","Aucun","un aimant et une sphère d'obsidienne",524288},
    {"Déguisement",5,"200 mètres","V S M","1tour/3niveaux","2 tours","une unité de 300 individus au max;","Aucun","un voile de soie et une longueue de résille de platine",65536},
    {"Délabrement de la mémoire",5,"10 mètres","V S M","2 rounds/niveau","1 round","une créature","annule","rubis (+200 po)",1048576},
    {"Délivrance de la malédiction / Malédiction",3,"Toucher","V S","Permanente","6","Spéciale","Spécial","Aucun",2097152},
    {"Détection de la magie",1,"30 pas","V S M","1 tour","1 round","Passage de 10 pieds de large","Aucun","Symbole religieux",512},
    {"Détection des charmes / Charme indétectable",2,"30 pas","V S","1 tour","1 round","1 créature/round","Aucun","Aucun",512},
    {"Détection des collets et des fosses",1,"0","V S M","4 rounds/niveau","4","Passage de 10 pieds de large; 40 pieds de long","Aucun","Symbole religieux",512},
    {"Détection des mensonges / Mensonge indétectable",4,"30 pas","V S M","1 round/niveau","7","1 créature","Annule","Poudre d'or (1 PO)",512},
    {"Détection des pièges",2,"30 pas","V S","3 tours","5","Chemin de 10 pas","Aucun","Aucun",512},
    {"Détection du mal",1,"120 pas","V S M","1 tour + 5 rounds/niveau","1 round","Passage de 10 pieds de large","Aucun","Symbole religieux",1},
    {"Détection du poison",1,"0","V S M","1 tour + 1 round/niveau","4","Spéciale","Aucun","Bande de velin bénite",512},
    {"Détection extradimensionnelle",3,"0","V S","1 round/niveau","3","un chemin 3x18m","Aucun","Aucun",524800},
    {"Diable de poussière",2,"30 pas","V S","2 rounds/niveau","2 rounds","Spécial","Aucun","Aucun",3072},
    {"Discours captivant",2,"0","V S","Spéciale","1 round","Rayon de 90 pieds","Annule","Aucun",131088},
    {"Dissipation de la magie",3,"60 pas","V S","Spéciale","6","Cube de 30 pieds d'arête ou 1 objet","Aucun","Aucun",2097152},
    {"Dissipation du mal / Dissipation du bien",5,"Toucher","V S M","1 round/niveau","8","Créature touchée","Annule","Symbole religieux + eau bénite",2097280},
    {"Distorsion du bois / Redressement du bois",2,"10 pas/niveau","V S","Permanente","5","Spéciale","Spécial","Aucun",33554432},
    {"Divination",4,"0","V S M","Spéciale","1 tour","Spéciale","Aucun","Symbole religieux + 1 offrande sacrificielle",512},
    {"Doléance du voleur",3,"10 mètre/niveau","V S M","1 tour/niveau","1 tour","cube c=(1;5m/niv)","annule","symbole sacré du prêtre et une clef en argent",67108864},
    {"Domination mentale",4,"50 mètres","V S M","3rounds/niveau","4","une créature","annule","fils fins",1048576},
    {"Élévation*",4,"0","V M","1 tour","12 heures","un prêtre","Aucun","symbole sacré + offrande de 500 po ou +",1},
    {"Élimination des Invisibilités",3,"30 mètres","V S M","1 round/niveau","1 tour","cube; c=(3m/prêtre)","Aucun","symbole sacré et un miroir en argent d<7;5 cm",67108864},
    {"Émission de pensées",4,"30 mètres","V S M","1 tour + 3round/niv","5","une créature","annule","petit ballon",1048576},
    {"Enchevêtrement",1,"80 pas","V S M","1 tour","4","Cube de 40 pieds d'arête","36192","Symbole religieux",33554432},
    {"Endurance du froid/de la chaleur",1,"Toucher","V S","1 heure 1/2 par niveau","1 round","Créature touchée","Aucun","Aucun",2097152},
    {"Engins d'ombre",7,"240 m","V S M","8 tours","3 tours","carré c=180m","Aucun","un modèle miniature d'un engin de siège",65536},
    {"Esprit de puissance*",7,"0","V S M","1 heure","3 tours","les prêtres","Aucun","une offrande appropriée à la divinité",128},
    {"Esprits groupes",6,"0","V S","(1 +1/niv) tours","1 round","cercle D=9m","Aucun","Aucun",1048576},
    {"Étiques Inversées",4,"120 mètres","V S M","1 tour","1","spéciale","annule","une balance miniature en or",8},
    {"Extorsion",7,"10 pas","V S M","Spéciale","1 round","1 créature","Aucun","Symbole religieux + matière venant du plan de la créature",144},
    {"Façonnage de la pierre",3,"Toucher","V S M","Permanente","1 round","Cube de 3' d'arête + cube de 1' d'arête/niveau","Aucun","Argile douce",17408},
    {"Fatalité rampante",7,"0","V S","4 rounds/niveau","1 round","Spéciale","Aucun","Aucun",130},
    {"Fenêtre astrale",3,"5 mètres","V S","2 rounds/niveau","3","3x3m","Aucun","Aucun",4},
    {"Festin de zizanie",2,"toucher","V S","5 tours + 2/niveau","2 tours","spéciale","annule","Aucun",8},
    {"Festin des héros",6,"10 pas","V S M","1 heure","1 tour","1 individu/niveau","Aucun","Symbole religieux + gelée royale",256},
    {"Feu féérique",1,"80 pas","V M","4 rounds/niveau","4","10 pieds carrés/niveau dans un rayon de 40 pieds","Aucun","Petit morceau de phosphorescence",32},
    {"Fléau d'insectes",5,"120 pas","V S M","2 rounds/niveau","1 tour","Nuage de 180' de diamètre et 60' de haut","Aucun","Morceaux de sucre + grains de céréales + graisse",64},
    {"Force d'un seul",3,"10 mètres","V S","2D6 rounds","3","(1 +1/2niveau)créatures","Aucun","Aucun",131072},
    {"Force du champion",5,"0","V S M","spéciale","2","spéciale","Aucun","une chaine de 5 fils d'or (+ de 1000 po)",131072},
    {"Forêt hallucinatoire / Forêt révélée",4,"80 pas","V S","Permanente","7","Carré de 40 pieds de côté/niveau","Aucun","Aucun",33554432},
    {"Fortifiant*",4,"0","V S M","spéciale","6","Créature touchée","Aucun","Symbole sacré du prêtre",4194304},
    {"Fortification illusoire",7,"240 m","V S M","spéciale","10 tours","spéciale","Aucun","symbole sacré du prêtre; du mortier pulvérisé et une gemme de 3000 po au -",65536},
    {"Foudroiement magique",3,"(40 +10/niveau)mètres","V S","spéciale","2","une créature","annule","Aucun",8},
    {"Fusion dans la pierre",3,"0","V S","8 rounds + 1d8 rounds","6","Le lanceur","Aucun","Aucun",17408},
    {"Gardien sacré",1,"Toucher","V S M","1 jour/niveau","1","créature touchée","Aucun","une pétale de rose qui a été embrassé par le bénéficiaire du sort",32768},
    {"Génie",4,"0","V S M","instantanée","5","le prêtre","Aucun","gemme de 500po ou +",1048576},
    {"Glyphe de garde",3,"Toucher","V S M","Permanente jusqu'à décharge","Spécial","Spéciale","Spécial","Encens + poudre de diamant (2000 PO) si la zone dépasse 50 pieds carrés",32768},
    {"Gourdin magique",1,"Toucher","V S M","4 rounds + 1 round/niveau","2","1 gourdin en chêne normal","Aucun","Symbole religieux + 1 feuille de trèfle",33554496},
    {"Guérison / Mise à mal",6,"Toucher","V S","Permanente","1 round","Créature touchée","Aucun","Aucun",4194304},
    {"Guérison accélérée",3,"toucher","V S","1-4 jours","1 tour","une créature","Aucun","Aucun",16777216},
    {"Guérison de la cécité ou de la surdité / Cécité ou Surdité",3,"Toucher","V S","Permanente","1 round","Créature touchée","Spécial","Aucun",262144},
    {"Guérison de la paralysie",3,"10 pas/niveau","V S","Permanente","6","1d4 créatures dans un cube de 20' d'arête","Aucun","Aucun",2097152},
    {"Guérison des maladies / Contamination",3,"Toucher","V S","Permanente","1 round","Créature touchée","Aucun","Aucun",262144},
    {"Harmonie défensive",4,"5 mètres","V S","(1 +2D4)round","1","une créature/deux niveau","Aucun","Aucun",131072},
    {"Hésitation",2,"30 mètres","V S M","1 round/niveau","2","un cercle r=6m","annule","un fragment de carapace de tortue",16777216},
    {"Horloge corporelle",4,"toucher","V S M","1 heure/niveau","4","une créature","Aucun","un grain de maïs; une goutte d'eau et une bouteille de verre bouchée",16777216},
    {"Hôte*",5,"10 mètres","V S M","12 heures","1 tour","un prêtre","Spécial","calice de + de 1000 po;",16},
    {"Idée",2,"0","V S M","instantanée","4","le prêtre","Aucun","une pièce en or",1048576},
    {"Immobilisation des animaux",3,"80 pas","V S","2 rounds/niveau","6","1-4 animaux dans un cube de 40 pieds d'arête","Annule","Aucun",2},
    {"Immobilisation des personnes",2,"120 pas","V S M","2 rounds/niveau","5","1d4 personnes dans un cube de 20 pieds","Annule","Petite pièce de fer rigide",131088},
    {"Immobilisation des plantes",4,"80 pas","V S","1 round/niveau","7","Spéciale","Annule","Aucun",33554432},
    {"Immunité contre les sorts",4,"Toucher","V S M","1 tour/niveau","1 round","Créature touchée","Aucun","Les mêmes que pour le sort considéré",2097152},
    {"Incrédulité",6,"0","V S","1 roud/niv","5","spéciale","spécial","Aucun",1048576},
    {"Injonction",1,"30 pas","V","1 round","1","1 créature","Spécial","Aucun",131088},
    {"Insectes géants / Insectes rapetissés",4,"20 pas","V S M","Spéciale","7","1 à 6 insectes","Aucun","Symbole religieux",2},
    {"Inspiration divine",7,"0","V S M","instantanée","5","Le prêtre","Aucun","une gemme de 500 po ou +",1049088},
    {"Intemporalité",7,"toucher","V S M","1 jour/niveau","7","une créature","annule","Aucun",524288},
    {"Interdiction",6,"30 pas","V S M","Permanente","6 rounds","Cube de 60 pieds d'arête/niveau","Spécial","Symbole religieux + eau bénite + encens (1000 PO par cube de 60 pieds) (voir Manuel des joueurs)",2097152},
    {"Interdiction des élémentaux",5,"spéciale","V S M","1 tour/niveau","1 tour","cube c=(1;5m/niv)","Aucun","symbole sacré et 4 perles en verre (verte; bleue; rouge et jaune)",67109888},
    {"Intrus paranogéne",7,"spéciale","V S M","Spéciale","1 tour","une créature","Spécial","une bouffée d'atmosphère du plan éthéré et le cerveau d'un lézard",512},
    {"Invisibilité aux animaux",1,"Toucher","S M","1 tour + 1 round/niveau","4","1 créature touchée/niveau","Aucun","Houx",2},
    {"Invisibilité aux morts-vivants",1,"Toucher","V S M","6 rounds","4","Créature touchée","Spécial","Symbole religieux",262144},
    {"Invoquer la foi",1,"0","V S M","1 round","1","le prêtre","Aucun","symbole sacré du prêtre",128},
    {"Jonction avec un voyageur astral",4,"0","V S","Permanente","1 tour","le prêtre","Aucun","Aucun",4},
    {"Lame enflammée",2,"0","V S M","4 rounds + 1 round/2 niveaux","4","lame d'épée de 3' de long","Aucun","1 feuille de sumac",9216},
    {"Langage des animaux",2,"0","V S","2 rounds/niveau","5","1 animal dans un rayon de 30 pieds","Aucun","Aucun",514},
    {"Langage des monstres",6,"30 pas","V S","2 rounds/niveau","9","Le lanceur","Aucun","Aucun",512},
    {"Langage des plantes",4,"0","V S M","1 round/niveau","1 tour","Rayon de 30 pieds","Aucun","1 goutte d'eau + 1 pincée de fiente séchée + 1 flamme",33554432},
    {"Langues / Baragouin",4,"0","V S","1 tour","7","Le lanceur","Aucun","Aucun",512},
    {"Le grand cercle / Le cercle noir*",6,"0","V S","1 round","6 tours","Spéciale","Spécial","Aucun",8388608},
    {"Lecture de l'esprit",2,"5 mètres/niveau","V S","1 roud/niv","2","spéciale","Aucun","Aucun",1048576},
    {"Lecture de l'instant",3,"0","V S M","instantanée","1 round","spéciale","Aucun","36 petits disques en os poli gravés représentants les nombres",524288},
    {"Lecture de personnalité",1,"0","V S M","spéciale","2 tours","une créature","Aucun","un livre de formles et notes numériques différent de celui de téléthaumaturgie",524288},
    {"Lecture des émotions",1,"5 mètres/niveau","V S M","instantanée","3","une créature","annule","un carré de cire blanche non maquée",1048576},
    {"Lecture des souvenirs",3,"5 mètres","V S M","1 roud/niv","1 round","une créature","annule","un morceau de tissu en lin avec des filaments en or entrelacés dans sa trame",1048576},
    {"Ligne de protection / ligne de destruction*",3,"0","V S M","1 round/niveau","1 round","ligne de 30m","Annule","objets religieux des prêtres",2097152},
    {"Localisation d'animaux ou de plantes",1,"100 pas + 20 pas/niveau","V S M","1 round/niveau","1 round","Passage de 20 pieds de large et long de 20 pas/niveau","Aucun","Symbole religieux",33554946},
    {"Localisation d'un objet / Dissimulation d'un objet",3,"60 pas + 10 pas/niveau","V S M","8 heures","1 tour","1 objet","Aucun","1 morceau de magnétite",512},
    {"Lumière / Ténèbres",1,"120 pas","V S","1 heure + 1 tour/niveau","4","Globe de 20 pieds de rayon","Spécial","Aucun",8388608},
    {"Lumière continuelle / Ténèbres continuelles",3,"120 pas","V S","Permanente","6","Globe de 60 pieds de rayon","Spécial","Aucun",8388608},
    {"Main secourable",3,"spéciale","V S M","1 heure/niv","1 round","spéciale","Aucun","un gant de soie noire",134217728},
    {"Manie de l'ordre",4,"10 mètres","V S M","permanente","5","une créature","Annule","un cube parfais en métal",131072},
    {"Manipulation extradimensionnelle",5,"10 mètres","V S M","(2D12 +4/niveau) round","5","espace extradimensionnel de 6x6m max","spécial","bande de tissu doré de 5 po ou +",524288},
    {"Manteau de bravoure / Manteau de Terreur",4,"Toucher","V S M","Spéciale","6","Créature touchée","Annule","1 plume d'aigle ou de faucon",16},
    {"Marche aérienne",5,"Toucher","V S M","1 heure + 1 tour/niveau","8","Créature touchée","Aucun","Symbole religieux + duvet de chardon",3072},
    {"Marche aisée",5,"15 mètres","V S M","1 jour/niveau","1 tour","une créature/niveau","Aucun","un morceau de cuir à chaussure",134217728},
    {"Marche sur le vent",7,"Toucher","V S M","1 heure/niveau","1 round","Spéciale","Aucun","Feu + eau bénite",1024},
    {"Marche sur les eaux",3,"Toucher","V S M","1 tour + 1 tour/niveau","6","Spéciale","Aucun","Symbole religieux + 1 morceau de liège",5120},
    {"Marteau spirituel",2,"10 pas/niveau","V S M","3 rounds + 1 round/niveau","5","Spéciale","Aucun","1 marteau de guerre normal",64},
    {"Messager",2,"20 pas/niveau","V S","1 jour/niveau","1 round","1 créature","Annule","Aucun",2},
    {"Métal brûlant / Métal gelé",2,"40 pas","V S","7 rounds","5","Spéciale","Spéciale","Aucun",9216},
    {"Meurtre de l'esprit",7," "," "," "," "," "," ","Aucun",1311232},
    {"Miroir physique",6,"30 mètres","V S M","1d4 + 8 round","6","spéciale","Aucun","miroir de platine poli (+ 500po)",524288},
    {"Mise à la terre",5,"30 mètres","V S M","1 tour/niveau","1 tour","carré c=10m/prêtres","Aucun","symbole sacré du prêtre et une pelote de fil d'argent",67108864},
    {"Missive erronée",1,"toucher","V S M","permanente","1","une page/niveau","Aucun","trois gouttes d'encre",8},
    {"Modification de mémoire",4,"9 mètres","V S","permanente","spéciale","une créature","annule","Aucun",16777216},
    {"Moment propice",2,"0","V S M","1 round/niveau","1 round","r=15 mètre","Aucun","3 dès en argent",524288},
    {"Monture monstrueuse",6,"30 mètres","V S","1 heure/niv","6","cercle r=6m","annule","Aucun",134217728},
    {"Moral",1,"spéciale","V S M","spéciale","spéciale","une unité de 200 individus maximum","Aucun","une gemme de 100 po au moins",65536},
    {"Mort simulée",3,"Toucher","V","1 tour + 1 round/niveau","36192","Personne touchée","Aucun","Aucun",262144},
    {"Mot de rappel",6,"0","V","Spéciale","1","Spéciale","Aucun","Aucun",128},
    {"Mur d'épines",6,"80 pas","V S","1 tour/niveau","9","Cube de 10 pieds d'arête/niveau","Aucun","Aucun",33554688},
    {"Mur de feu",5,"80 pas","V S M","Spéciale","8","Spéciale","Aucun","Phosphore",9216},
    {"Murs écrasants",6,"toucher","V S M","permanent jusqu'à activation","1 tour","spéciale","Aucun","un cube en fer (c=2;5 cm) et une coquille de noix",67108864},
    {"Murs hurlants",5,"toucher","V S M","1 jour/niveau","1 tour","cube c=6m","Aucun","une petite cloche en or et une aile d'abeille",67108864},
    {"Murs tentaculaires",7,"toucher","V S M","spéciale","1 round","cube de 15m d'arète","Aucun","une tentacule désséchée de pieuvre",67108864},
    {"Musique des sphères",2,"50 mètres","V S M","1 tour + 1 round/niveau","4","cercle D=6mètres","Annule","3 trois petits arc en argent fin (3x100 po mim)",524304},
    {"Neutralisation du poison / Poison",4,"Toucher","V S","Permanente","7","Créature touchée ou 1 pied cubique de substance/2 niveaux","Aucun","Aucun",4194304},
    {"Nuage de purification",5,"30 mètres","V S","1 round/niveau","5","cube c=6mètres","Aucun","Aucun",7168},
    {"Obscurcissement",2,"0","V S","4 rounds/niveau","5","Spéciale","Aucun","Aucun",32},
    {"Obstination bornée",3,"60 mètres","V S","1 round/niveau","1 tour","une créature","Annule","Aucun",131072},
    {"Obstination légale",6,"10 mètres","V S","permanente","1 tour","une créature","Annule","Aucun",131072},
    {"Octroi de sorts",4,"Toucher","V S M","Spéciale","1 tour","Personne touchée","Aucun","Symbole religieux + 1 objet mineur appartenant au bénéficiaire; symbolique de sa profession",16},
    {"Onde mentale*",5,"0","V S","instantanée","1","Spéciale","Spécial","Aucun",512},
    {"Orbe desséchante de Sol",6,"30 mètres","V S M","instantanée","6","une gemme","Spécial","une topaze (+500 po)",8388608},
    {"Ordres chaotiques",5,"toucher","V S M","1 tour/niveau","3","une créature","spéciale","un morceau de peau d'anguille;",8},
    {"Orientation",6,"Toucher","V S M","1 tour/niveau","3 rounds","Créature touchée","Aucun","Ustensiles de divination",512},
    {"Parler avec un voyageur astral",1,"Toucher","V S","1 round/niveau","1 round","une créature","Aucun","Aucun",4},
    {"Parole divine / Parole infernale",7,"0","V","Spéciale","1","Rayon de 30 pieds","Aucun","Aucun",64},
    {"Passage sans trace",1,"Toucher","V S M","1 tour/niveau","1 round","Créature touchée","Aucun","Brindille de pin ou de magnolia",33554432},
    {"Passe-plantes",5,"Toucher","V S","Spéciale","8","Spéciale","Aucun","Aucun",33554432},
    {"Peau d'écorce",2,"Toucher","V S M","4 rounds + 1 round/niveau","5","Créature touchée","Aucun","Symbole religieux + 1 poignée d'écorce de chêne",35651584},
    {"Pénitence",5,"Toucher","V S M","Permanente","1 tour","1 personne","Aucun","Symbole religieux; chapelet ou livre de prières + encens",1},
    {"Perception des Émotions",2,"300 mètres","V S M","instantanée","1 tour","une unité/5 niveau","Aucun","symbole sacré du prêtre",65536},
    {"Pieds emmêlés / Passage sélectif",4,"240 mètres","V S M","2 tours/niveau","2 tours","100m²/niveau","Aucun","une goutte de mélasse / une pincée de poussière de graphite",65536},
    {"Piège de feu",2,"Toucher","V S M","Permanente jusqu'à décharge","1 tour","Objet touché","36192","Boules de houx",9216},
    {"Pierre magique",1,"0","V S M","Spéciale","4","Spéciale","Aucun","Symbole religieux + 3 petits galets",64},
    {"Pierres acérées",5,"30 pas","V S M","3d4 tours + 1 tour/niveau","6","Carré de 10 pieds de côté/niveau; 1 épine par pied de côté","Aucun","4 petites stalactites",17408},
    {"Pierres commères",6,"Toucher","V S M","1 tour","1 tour","1 pied cubique de pierre","Aucun","1 goutte de mercure + argile",17920},
    {"Pliure dimensionnelle",4,"1;5 mètre","V S M","1 round","1 round","cercle de 3m","Aucun","feuille souple de platine de 15 po ou +",524288},
    {"Poche extradimensionnelle",5,"toucher","V S M","(1D12 +2/niveau) round","1 round","spéciale","Aucun","récipient; 200po de poudre de diamant; une feuille de platine de 500 po",524288},
    {"Point focal*",4,"3 mètres","V S M","spéciale","1 jour","spéciale","Aucun","vêtements spéciaux; encens; huiles;;; (coût +1000 po)",1},
    {"Porte végétale",4,"Toucher","V S M","Spéciale","7","Spéciale","Aucun","Symbole religieux + 1 morceau de charbon de bois",33554432},
    {"Pourriture lente",3,"toucher","V S M","1 semaine/niveau","1 round","Spéciale","Aucun","une pincée de sucre",33554432},
    {"Prière",3,"0","V S M","1 round/niveau","6","Rayon de 60 pieds","Aucun","Symbole religieux + chapelet ou objet similaire",64},
    {"Production de feu / Extinction de feu",4,"40 pas","V S M","1 round","7","Carré de 12 pieds de côté","Aucun","Pâte de souffre et de cire",9216},
    {"Production de flammes",2,"0","V S","1 round/niveau","5","Spéciale","Aucun","Aucun",9216},
    {"Projection astrale",7," "," "," "," "," "," ","Aucun",4},
    {"Protection contre la foudre",4,"Toucher","V S M","Spéciale","7","Créature touchée","Aucun","Symbole religieux",2097184},
    {"Protection contre le feu",3,"Toucher","V S M","Spéciale","6","Créature touchée","Aucun","Symbole religieux",2106368},
    {"Protection contre le mal / Protection contre le bien",1,"Toucher","V S M","3 rounds/niveau","4","Créature touchée","Aucun","Eau bénite ou encens brûlant",2097152},
    {"Protection contre le mal sur un rayon de 10'",4,"Toucher","V S M","1 tour/niveau","7","Sphère de 10 pieds de rayon","Aucun","Eau bénite + encens",2097152},
    {"Protection contre le plan négatif",3,"Toucher","V S","Spéciale","1 round","1 créature","Aucun","Aucun",2359296},
    {"Puiser dans la puissance divine",2,"0","V S M","1 round/niveau","2","le prêtre","Aucun","Le symbole sacré du prêtre et une fiole d'eau bénite sanctifiés par un haut prêtre de la même foi que le personnage",128},
    {"Purification / Putréfaction de la nourriture et des boissons",1,"30 pas","V S","Permanente","1 round","1 pied cubique/niveau; zone de 10 pieds de côté","Aucun","Aucun",1},
    {"Pyrotechnie",3,"160 pas","V S M","Spéciale","6","10 ou 100 fois une unique source de feu","Spécial","1 source de feu",9216},
    {"Ralentissement du poison",2,"Toucher","V S M","1 heure/niveau","1","Créature touchée","Aucun","Symbole religieux + 1 gousse d'ail",4194304},
    {"Ralliement",2,"240 mètres","V S M","instantanée","1 tour","une unité de 300 individus au max;","Aucun","miniature de la banière ou étendard de la cause",65536},
    {"Rappel à la vie / Mort",5,"30 pas","V S","Permanente","1 round","1 personne","Spécial","Aucun",262144},
    {"Rapport",4,"10 mètres/niveau","V S","(1 +1/nieau)round","1 round","une créature","Aucun","Aucun",1048576},
    {"Rayon de lune",5,"60 pas + 10 pas/niveau","V S M","1 round/niveau","7","Sphère de 5 pieds de rayon (+ spécial)","Aucun","Graines de plante (&quotsemence de lune&quot) + feldspath",8388608},
    {"Rayon de soleil",7,"10 pas/niveau","V S M","1 round + 1d4 rounds","4","Sphère de 5 pieds de rayon (+ spécial)","Spécial","Semence d'aster + morceau de feldspath aventurin",8388608},
    {"Réclusion",6,"toucher","V S M","(3D12 +4/niv) round","6","une créature","annule","une jolie boite en cristal (+1500po); une gemme (+250po)",524288},
    {"Régénération / Flétrissure",7,"Toucher","V S M","Permanente","3 rounds","Créature touchée","Aucun","Objet de prière + eau bénite",262144},
    {"Réincarnation",7,"Toucher","V S","Permanente","1 tour","Personne touchée","Aucun","Aucun",262144},
    {"Répulsion des insectes",4,"0","V S M","1 tour/niveau","1 round","Rayon de 10 pieds","Aucun","Fleurs de souci broyées ou 1 poireau écrasé ou feuilles d'orties ou résine de camphrier",209154},
    {"Répulsion du bois",6,"0","V S","1 round/niveau","9","Chemin de 120 pieds de large; 20 pieds de long/niveau","Aucun","Aucun",33554432},
    {"Résistance au feu/au froid",2,"Toucher","V S M","1 round/niveau","5","Créature touchée","Aucun","1 goutte de mercure",2097152},
    {"Respiration aquatique / Respiration aérienne",3,"Toucher","V S","1 heure/niveau","6","Créature touchée","Aucun","Aucun",7168},
    {"Restitution / Perte d'énergie",7,"Toucher","V S","Permanente","3 rounds","Créature touchée","Aucun","Aucun",262144},
    {"Résurrection",7,"Toucher","V S M","Permanente","1 tour","Créature touchée","Aucun","Symbole religieux + eau bénite",262144},
    {"Retirement",2,"0","V S","Spéciale","5","Le lanceur","Aucun","Aucun",2097152},
    {"Route flottante",7,"0","V S M","1 tour/niv","1 round","spéciale","Aucun","un gros morceau de marbre noir et une boucle de fil d'or",134217728},
    {"Rupture mentale",5,"3 mètres/niveau","V S M","spéciale","1 round","une créature","annule","une statuette d'une tête humaine 8 cm en porcelaine fine et délicate",1048576},
    {"Sanctification / Profanation*",2,"10 mètres","V S M","Spéciale","1 tour","carré de 10mètres de côté/prêtre","Aucun","le symbole sacré et une poignée de terre venant du temple de même foi / le symbole sacré et poignée de terre venant d'une tombe",1},
    {"Sanctuaire",1,"Toucher","V S M","2 rounds + 1 round/niveau","4","Créature touchée","Aucun","Symbole religieux + petit miroir d'argent",2097152},
    {"Semences de feu",6,"Toucher","V S M","Spéciale","1 round/semence","Spéciale","36192","Glands ou boules de houx",9216},
    {"Séparation des eaux",6,"20 pas/niveau","V S M","1 tour/niveau","1 tour","Spéciale","Aucun","Symbole religieux",21504},
    {"Serviteur aérien",6,"10 pas","V S","1 jour/niveau","9","Spéciale","Aucun","Aucun",128},
    {"Seuil",7,"30 pas","V S","Spéciale","5","Spéciale","Aucun","Aucun",128},
    {"Sieste",2,"toucher","V S M","spéciale","2","une créature/niveau","Aucun","un morceau de taie d'oreiller; une plume et un caillou",16777216},
    {"Silence dans un rayon de 15'",2,"120 pas","V S","2 rounds/niveau","5","Sphère de 15 pieds de rayon","Aucun","Aucun",32768},
    {"Soins des blessures critiques / Blessures critiques",5,"Toucher","V S","Permanente","8","Créature touchée","Aucun","Aucun",4194304},
    {"Soins des blessures graves / Blessures graves",4,"Toucher","V S","Permanente","7","Créature touchée","Aucun","Aucun",4194304},
    {"Soins des blessures légères / Blessures légères",1,"Toucher","V S","Permanente","5","Créature touchée","Aucun","Aucun",4194304},
    {"Solipsisme",4,"10 mètres/niveau","V S M","spéciale","1 round","(10 +10/niveau)m²","spécial","une fleur de lotus et un morceau de laine",1048576},
    {"Sols grinçants",3,"30 mètres","V S M","1 heure/niveau","3","cube; c=(3m/niv)","Aucun","un gond de fer rouillé qui grince",67108864},
    {"Sommeil chaotique",4,"toucher","V S M","permanente","1 tour","une créature","annule","une pincée de sable et trois grains de café",8},
    {"Sort astral",7,"Toucher","V S","Spéciale","1/2 heure","Spéciale","Aucun","Aucun",4},
    {"Souffle de vie / souffle de mort",7,"0","V S M","1 heure/niveau","1 tour","R=50m/heure","Aucun","Symbole sacré du prêtre + poussière ramassée sur une momie",262144},
    {"Stase climatique",4,"30 mètres","V S M","1 heure/niveau","1 tour","cube; c=(3m/niv)","Aucun","symbole sacré du prêtre et une goutte de pluie",67108896},
    {"Symbole",7,"Toucher","V S M","1 tour/niveau","3","Spéciale","Spécial","Mercure + phosphore",32768},
    {"Télépathie",3,"30 mètres","V S","1 tour +2rounds/niveau","5","une créature","annule","Aucun",1048576},
    {"Téléthaumaturgie",3,"0","V S M","spéciale","2 round","une créature","Aucun","un petit livre de formule et note numérologique spécial",524288},
    {"Tempête de feu / Étouffement de feu",7,"160 pas","V S","1 round","1 round","2 cubes de 10 pieds d'arête/niveau; minimum 16 cubes de 10 pieds de côté","36192","Aucun",9216},
    {"Temps inversé",6,"30 mètres","V S M","1-4 round","6","une créature","annule","une flèche aiguisée en argent (l<7;5cm) de  +500po",16777216},
    {"Terre de stabilité",6,"10 mètre/niveau","V S M","1 jour/niveau","6","cube; c=(3m/niv)","Aucun","symbole sacré du prêtre et une pincée de cendre volcanique",67108864},
    {"Transfert mystique*",2,"0","V S","9 rounds","1 round","le prêtre","Aucun","Aucun",16},
    {"Transmutation de l'eau en poussière / Création d'eau améliorée",6,"60 pas","V S M","Permanente","8","1 pas cubique/niveau","Spécial","Symbole religieux + poussière de diamant (500 PO) + éclat de coquillage marin",21504},
    {"Transmutation de la pierre en boue / Transmutation de la boue en pierre",5,"160 pas","V S M","Spéciale","8","Cube de 20 pieds d'arête/niveau","Aucun","Argile + eau",21504},
    {"Transmutation du métal en bois",7,"80 pas","V S","Permanente","1 round","1 objet métallique","Spécial","Aucun",17408},
    {"Transport par les plantes",6,"Toucher","V S","Spéciale","4","Spéciale","Aucun","Aucun",33554432},
    {"Traversée des flammes",3,"Toucher","V S M","1 round + 1 round/niveau","5","Créature(s) touchée(s)","Aucun","Symbole religieux + 500 PO de poudre de rubis/créature affectée",9216},
    {"Tremblement de terre",7,"120 pas","V S M","1 round","1 tour","Diamètre de 5 pieds/niveau","Aucun","1 pincée de poussière + 1 morceau de pierre + argile",17408},
    {"Union*",1,"30 mètres","V S M","Spéciale","1 round","spéciale","Aucun","une petite table de formules numérologiques inscrites sur une plaquette en ivoire et une longueur de corde",1},
    {"Variation de la gravité",6,"10m/niv","V S M","1tour/3niveaux","2 tours","carré c=120m","Aucun","un fil à plomb donc le fil est en platine et le plomb une gemme de 1000 po ou +;",65536},
    {"Vent divin",7," "," "," "," "," "," ","Aucun",3072},
    {"Vêtement magique",3,"Toucher","V S M","5 rounds/niveau","1 round","Le lanceur","Aucun","Symbole religieux + 1 vêtement",2097152},
    {"Vieillissement d'objet / Rajeunissement d'objet",5,"10 mètres","V S M","permanente","1 round","volume c=(30 cm/niv)","Aucun","flasque d'eau de mer et morceau de charbon / coquille d'uf et cheuveux de la tête d'un enfant",16777216},
    {"Vieillissement d'une créature / Redonner la jeunesse",6,"toucher","V S M","permanente","1 round","une créature","annule","une pincée de rubis pulvérisé",16777216},
    {"Vigilance contre les mort-vivants",5,"spéciale","V S M","1 tour/niveau","2 tours","cube c=(1;5m/niv)","Aucun","symbole sacré du prêtre",67108864},
    {"Vigilance efficace contre les monstres",3,"30 mètres","V S M","1 round/niveau","3","cube; c=(3m/niv)","annule","symbole sacré du prêtre et une pincée de sel",67108864},
    {"Vigilance indéfectible de la sentinelle sacrée",5,"0","V S M","1heure/niveau","1 tour","sphère r=1;5m","Aucun","encre avec la poudre d'un saphir écrasé (+ 1000po)",32768},
    {"Vision véritable",5,"Toucher","V S M","1 round/niveau","8","Créature touchée","Aucun","Onguent spécial (300 PO minimum)",512},
    {"Vouivre de garde",2,"30 pas","V S M","8 heures ou jusqu'à déclenchement","5","Sphère de 10 pieds de rayon","Annule","Symbole religieux",32768},
    {"Zone d'air pur",3,"10 mètre/niveau","V S M","1 tour/niveau","3","cube; c=(3m/niv)","Aucun","symbole sacré du prêtre; un mouchoir en soie et un bout de toile d'araignée",67108864},
    {"Zone de vérité",2,"30 mètres","V S M","1 round/niveau","2","carré c=1;5m/niveau","annule","le symbole sacré et une émeraude; un rubis ou un diamant faux;",67108864}
};


void modif_p(GtkWidget *wid, gpointer param)
{
   ((unsigned short **)param)[6][0]=1;

   (void)wid;
}


unsigned short compare(char * s,char* r)
{

    while(*s==' ' || *s=='\n')
    {
        s++;
    }
    while(*r==' ' || *r=='\n')
    {
        r++;
    }


    while(*s==*r && *s!=0 && *s!='\n' && *r!=0 && *r!='\n')
    {
        s++;
        r++;
    }

    return ( (*s==0 || *s=='\n') && (*r==0 || *r=='\n') );
}
unsigned long * tabl_sphere(char * liste)
{
    unsigned long * retour=NULL;
    unsigned long un=1;
    unsigned short i=0,j=0,nombre=0;

    /* compter le nombre de sphere dans la liste */
    for(i=0;liste[i]!=0;i++)
    {
        if (nombre==0 && liste[i]>='0' && liste[i]<='9')
        {
            j++;
            nombre=1;
        }
        else if (liste[i]<'0' || liste[i]>'9')
            nombre=0;
    }
    retour=(unsigned long *)malloc((j+1)*sizeof(unsigned long));
    retour[0]=j;
    nombre=0;
    if (j>0)
    {
        for (i=1;i<+j;i++) retour[i]=0;
        j=1;
        for(i=0;liste[i]!=0;i++)
        {
            if (nombre==0 && liste[i]>='0' && liste[i]<='9')
            {
                j++;
                nombre=1;
                retour[j-1]=liste[i]-'0';
            }
            else if (liste[i]<'0' || liste[i]>'9')
                nombre=0;
            else
                retour[j-1]=liste[i]-'0'+retour[j-1]*10;
        }
        for (i=1;i<j;i++) retour[i]=un<<retour[i];
    }

    return retour; /* Le premier élément du tableau est le nombre de sphères du tableau */
}

unsigned short * tabl_sphere_s(char * liste)
{
    unsigned short * retour=NULL;
    unsigned short i=0,j=0,nombre=0;

    /* compter le nombre de sphere dans la liste */
    for(i=0;liste[i]!=0;i++)
    {
        if (nombre==0 && liste[i]>='0' && liste[i]<='9')
        {
            j++;
            nombre=1;
        }
        else if (liste[i]<'0' || liste[i]>'9')
            nombre=0;
    }
    nombre=0;
    retour=(unsigned short *)malloc((j+1)*sizeof(unsigned short));
    retour[0]=j;
    if (j>0)
    {
        for (i=1;i<+j;i++) retour[i]=0;
        j=1;
        for(i=0;liste[i]!=0;i++)
        {
            if (nombre==0 && liste[i]>='0' && liste[i]<='9')
            {
                j++;
                nombre=1;
                retour[j-1]=liste[i]-'0';
            }
            else if (liste[i]<'0' || liste[i]>'9')
                nombre=0;
            else
                retour[j-1]=liste[i]-'0'+retour[j-1]*10;
        }
    }

    return retour; /* Le premier élément du tableau est le nombre de sphères du tableau */
}

char * tabl_algt_s(char * liste)
{
    char * retour=NULL;
    unsigned short i,j=0,k,l;

    retour=(char *)malloc(9*sizeof(char));
    for(k=0;k<9;k++)
     retour[k]=0;
    for(i=0;liste[i]!=0;i++)
     if (liste[i]==' ')
        j=i;
    while (j>0)
    {
        l=1;
        if (liste [i]==0)
        {
            for(k=0;k<9;k++)
                if (compare_sans_casse(algnm[k],liste+j+1)==0)
                {
                    l=0;
                    retour[k]=1;
                }

        }
        else
        {
            liste[i]=0;
            for(k=0;k<9;k++)
                if (compare_sans_casse(algnm[k],liste+j+1)==0)
                {
                    l=0;
                    retour[k]=1;
                }
            liste[i]=' ';
        }
        if (l==1)
        {
            i--;
            liste[i]=' ';
            if (i==j)
                l=0;
        }
        if (l==0)
        {
            i=j;
            do
            {
                j--;
            }
            while (j>0 && liste[j]!=' ');
        }
    }
    if (i>0)
    {
        liste[i]=0;
        for(k=0;k<9;k++)
            if (compare_sans_casse(algnm[k],liste)==0)
                retour[k]=1;
        liste[i]=' ';
    }

    return retour; /* Le premier élément du tableau est le nombre de sphères du tableau */
}

void insere_ligne_pretre(GMarkupDomNode * node,struct_sortileges * sort,unsigned short info)
{
    GMarkupDomNode * tmp_node;
    char ch[LONG];
    unsigned short j;


    xml_ajoute_fin(node,"table:table-row"); /* node pointera sur le tableau du niveau */
    tmp_node=node->child+node->fils-1; /* on arrive sur la dernière node */
    /* première case : le nom du sort */
    xml_ajoute_fin(tmp_node,"table:table-cell"); /* création de la case */
    xml_ajoute_fin(tmp_node->child,"text:p");
    xml_ajoute_fin_texte(tmp_node->child->child);
    xml_ecrit_dernier_texte(tmp_node->child->child,sort->nom);
    xml_ajoute_fin_attribut(tmp_node->child); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child,"table:style-name","Tableau1.VD11"); /* remplace le dernier attribut */
    xml_ajoute_fin_attribut(tmp_node->child); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child,"office:value-type","string"); /* remplace le dernier attribut */
    if (info==2)
    {
        xml_ajoute_fin_attribut(tmp_node->child->child); /* rajouter un élément attribut */
        xml_ecrit_dernier_attribut(tmp_node->child->child,"text:style-name","pas_compris"); /* remplace le dernier attribut */
    }
    else if (info==3)
    {
        xml_ajoute_fin_attribut(tmp_node->child->child); /* rajouter un élément attribut */
        xml_ecrit_dernier_attribut(tmp_node->child->child,"text:style-name","pas_lu"); /* remplace le dernier attribut */
    }
    else if (info==4)
    {
        xml_ajoute_fin_attribut(tmp_node->child->child); /* rajouter un élément attribut */
        xml_ecrit_dernier_attribut(tmp_node->child->child,"text:style-name","pas_ecole"); /* remplace le dernier attribut */
    }
    else if (info==5)
    {
        xml_ajoute_fin_attribut(tmp_node->child->child); /* rajouter un élément attribut */
        xml_ecrit_dernier_attribut(tmp_node->child->child,"text:style-name","ecole_OK"); /* remplace le dernier attribut */
    }
    else
    {
        xml_ajoute_fin_attribut(tmp_node->child->child); /* rajouter un élément attribut */
        xml_ecrit_dernier_attribut(tmp_node->child->child,"text:style-name","sort"); /* remplace le dernier attribut */
    }



    /* deuxième case : portee */
    xml_ajoute_fin(tmp_node,"table:table-cell"); /* création de la case */
    xml_ajoute_fin(tmp_node->child+1,"text:p");
    xml_ajoute_fin_texte(tmp_node->child[1].child);
    xml_ecrit_dernier_texte(tmp_node->child[1].child,sort->portee);
    xml_ajoute_fin_attribut(tmp_node->child+1); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child+1,"table:style-name","Tableau1.VD21"); /* remplace le dernier attribut */
    xml_ajoute_fin_attribut(tmp_node->child+1); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child+1,"office:value-type","string"); /* remplace le dernier attribut */
    /* vsm */
    xml_ajoute_fin(tmp_node,"table:table-cell"); /* création de la case */
    xml_ajoute_fin(tmp_node->child+2,"text:p");
    xml_ajoute_fin(tmp_node->child[2].child,"text:span");
    xml_ajoute_fin_texte(tmp_node->child[2].child->child);
    xml_ecrit_dernier_texte(tmp_node->child[2].child->child,sort->vsm);
    xml_ajoute_fin_attribut(tmp_node->child+2); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child+2,"table:style-name","Tableau1.VD21"); /* remplace le dernier attribut */
    xml_ajoute_fin_attribut(tmp_node->child+2); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child+2,"office:value-type","string"); /* remplace le dernier attribut */
    xml_ajoute_fin_attribut(tmp_node->child[2].child->child); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child[2].child->child,"text:style-name","T6b"); /* remplace le dernier attribut */
    xml_ajoute_fin_attribut(tmp_node->child[2].child); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child[2].child,"text:style-name","PVD"); /* remplace le dernier attribut */
    /* duree */
    xml_ajoute_fin(tmp_node,"table:table-cell"); /* création de la case */
    xml_ajoute_fin(tmp_node->child+3,"text:p");
    xml_ajoute_fin_texte(tmp_node->child[3].child);
    xml_ecrit_dernier_texte(tmp_node->child[3].child,sort->duree);
    xml_ajoute_fin_attribut(tmp_node->child+3); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child+3,"table:style-name","Tableau1.VD21"); /* remplace le dernier attribut */
    xml_ajoute_fin_attribut(tmp_node->child+3); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child+3,"office:value-type","string"); /* remplace le dernier attribut */
    /* lance */
    xml_ajoute_fin(tmp_node,"table:table-cell"); /* création de la case */
    xml_ajoute_fin(tmp_node->child+4,"text:p");
    xml_ajoute_fin_texte(tmp_node->child[4].child);
    xml_ecrit_dernier_texte(tmp_node->child[4].child,sort->lance);
    xml_ajoute_fin_attribut(tmp_node->child+4); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child+4,"table:style-name","Tableau1.VD21"); /* remplace le dernier attribut */
    xml_ajoute_fin_attribut(tmp_node->child+4); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child+4,"office:value-type","string"); /* remplace le dernier attribut */
    xml_ajoute_fin_attribut(tmp_node->child[4].child); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child[4].child,"text:style-name","PVD"); /* remplace le dernier attribut */
    /* effet */
    xml_ajoute_fin(tmp_node,"table:table-cell"); /* création de la case */
    xml_ajoute_fin(tmp_node->child+5,"text:p");
    xml_ajoute_fin(tmp_node->child[5].child,"text:span");
    xml_ajoute_fin_texte(tmp_node->child[5].child->child);
    xml_ecrit_dernier_texte(tmp_node->child[5].child->child,sort->effet);
    xml_ajoute_fin_attribut(tmp_node->child+5); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child+5,"table:style-name","Tableau1.VD21"); /* remplace le dernier attribut */
    xml_ajoute_fin_attribut(tmp_node->child+5); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child+5,"office:value-type","string"); /* remplace le dernier attribut */
    xml_ajoute_fin_attribut(tmp_node->child[5].child->child); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child[5].child->child,"text:style-name","T6"); /* remplace le dernier attribut */
    /* save */
    xml_ajoute_fin(tmp_node,"table:table-cell"); /* création de la case */
    xml_ajoute_fin(tmp_node->child+6,"text:p");
    xml_ajoute_fin_texte(tmp_node->child[6].child);
    xml_ecrit_dernier_texte(tmp_node->child[6].child,sort->save);
    xml_ajoute_fin_attribut(tmp_node->child+6); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child+6,"table:style-name","Tableau1.VD21"); /* remplace le dernier attribut */
    xml_ajoute_fin_attribut(tmp_node->child+6); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child+6,"office:value-type","string"); /* remplace le dernier attribut */
    /* composant */
    xml_ajoute_fin(tmp_node,"table:table-cell"); /* création de la case */
    xml_ajoute_fin(tmp_node->child+7,"text:p");
    xml_ajoute_fin(tmp_node->child[7].child,"text:span");
    xml_ajoute_fin_texte(tmp_node->child[7].child->child);
    xml_ecrit_dernier_texte(tmp_node->child[7].child->child,sort->composant);
    xml_ajoute_fin_attribut(tmp_node->child+7); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child+7,"table:style-name","Tableau1.VD21"); /* remplace le dernier attribut */
    xml_ajoute_fin_attribut(tmp_node->child+7); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child+7,"office:value-type","string"); /* remplace le dernier attribut */
    xml_ajoute_fin_attribut(tmp_node->child[7].child->child); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child[7].child->child,"text:style-name","T6b"); /* remplace le dernier attribut */
    /* sphère */
    xml_ajoute_fin(tmp_node,"table:table-cell"); /* création de la case */
    xml_ajoute_fin(tmp_node->child+8,"text:p");
    ch[0]=0;
    if (info==0)
    {
        for(j=0;j<G_N_ELEMENTS(nom_sphere);j++)
            if (sort->sphere&(1<<j))
            {
                if (ch[0]!=0)
                    sprintf(ch,"%s %s",ch,nom_sphere[j]);
                else
                    sprintf(ch,"%s",nom_sphere[j]);
            }
    }
    else
    {
        for(j=0;j<12;j++)
            if (sort->sphere&(1<<j))
            {
                if (ch[0]!=0)
                    sprintf(ch,"%s %s",ch,ecole_mag[j]);
                else
                    sprintf(ch,"%s",ecole_mag[j]);
            }
    }
    xml_ajoute_fin(tmp_node->child[8].child,"text:span");
    xml_ajoute_fin_texte(tmp_node->child[8].child->child);
    xml_ecrit_dernier_texte(tmp_node->child[8].child->child,ch);
    xml_ajoute_fin_attribut(tmp_node->child+8); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child+8,"table:style-name","Tableau1.VD31"); /* remplace le dernier attribut */
    xml_ajoute_fin_attribut(tmp_node->child+8); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child+8,"office:value-type","string"); /* remplace le dernier attribut */
    xml_ajoute_fin_attribut(tmp_node->child[8].child->child); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child[8].child->child,"text:style-name","T6b"); /* remplace le dernier attribut */
    xml_ajoute_fin_attribut(tmp_node->child[8].child); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child[8].child,"text:style-name","PVD"); /* remplace le dernier attribut */
}

GMarkupDomNode * nv_tableau_sort(GMarkupDomNode * ooo,unsigned short niveau,char * metier)
{
    GMarkupDomNode * tmp_node, * node;
    char ch[LONG];
    unsigned short i;

    /* rajouter un tableau à la fin */
    node=g_markup_dom_node(ooo,"office:text");
    xml_ajoute_fin(node,"text:p");
    xml_ajoute_fin_attribut(node->child+node->fils-1); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(node->child+node->fils-1,"text:style-name","SautePage"); /* remplace le dernier attribut */
    xml_ajoute_fin(node,"table:table");
    node=node->child+node->fils-1; /* on arrive sur la dernière node */
    for (i=0;i<9;i++) xml_ajoute_fin(node,"table:table-column");
    for (i=0;i<9;i++)
    {
        xml_ajoute_fin_attribut(node->child+i); /* rajouter un élément attribut */
        xml_ecrit_dernier_attribut(node->child+i,"table:style-name","Tableau1.VDA"); /* remplace le dernier attribut */
    }
    xml_ecrit_dernier_attribut(node->child,"table:style-name","Tableau1.VDL"); /* remplace le dernier attribut */
    xml_ecrit_dernier_attribut(node->child+2,"table:style-name","Tableau1.VDAE"); /* remplace le dernier attribut */
    xml_ecrit_dernier_attribut(node->child+4,"table:style-name","Tableau1.C"); /* remplace le dernier attribut */
    xml_ecrit_dernier_attribut(node->child+8,"table:style-name","Tableau1.VDB"); /* remplace le dernier attribut */
    xml_ajoute_fin(node,"table:table-row"); /* node poinetra sur le tableau du niveau */
    tmp_node=node->child+node->fils-1; /* on arrive sur la dernière node */
    /* rajouter la ligne de titre */
    /* première case : le nom du sort */
    xml_ajoute_fin(tmp_node,"table:table-cell"); /* création de la case */
    sprintf(ch,"Sorts %s niveau %hu",metier,niveau);
    xml_ajoute_fin_attribut(tmp_node->child); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child,"table:style-name","Tableau1.VD1"); /* remplace le dernier attribut */
    xml_ajoute_fin_attribut(tmp_node->child); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child,"office:value-type","string"); /* remplace le dernier attribut */
    xml_ajoute_fin(tmp_node->child,"text:p");
    xml_ajoute_fin_texte(tmp_node->child->child);
    xml_ecrit_dernier_texte(tmp_node->child->child,ch);
    /* deuxième case : portee */
    xml_ajoute_fin(tmp_node,"table:table-cell"); /* création de la case */
    xml_ajoute_fin(tmp_node->child+1,"text:p");
    xml_ajoute_fin_texte(tmp_node->child[1].child);
    xml_ecrit_dernier_texte(tmp_node->child[1].child,"Portée");
    xml_ajoute_fin_attribut(tmp_node->child+1); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child+1,"table:style-name","Tableau1.VD2"); /* remplace le dernier attribut */
    xml_ajoute_fin_attribut(tmp_node->child+1); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child+1,"office:value-type","string"); /* remplace le dernier attribut */
    /* vsm */
    xml_ajoute_fin(tmp_node,"table:table-cell"); /* création de la case */


    xml_ajoute_fin(tmp_node->child+2,"text:p");
    xml_ajoute_fin_texte(tmp_node->child[2].child);
    xml_ecrit_dernier_texte(tmp_node->child[2].child,"vsm");
    xml_ajoute_fin_attribut(tmp_node->child+2); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child+2,"table:style-name","Tableau1.VD2"); /* remplace le dernier attribut */
    xml_ajoute_fin_attribut(tmp_node->child+2); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child+2,"office:value-type","string"); /* remplace le dernier attribut */
    /* duree */
    xml_ajoute_fin(tmp_node,"table:table-cell"); /* création de la case */
    xml_ajoute_fin(tmp_node->child+3,"text:p");
    xml_ajoute_fin_texte(tmp_node->child[3].child);
    xml_ecrit_dernier_texte(tmp_node->child[3].child,"Durée");
    xml_ajoute_fin_attribut(tmp_node->child+3); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child+3,"table:style-name","Tableau1.VD2"); /* remplace le dernier attribut */
    xml_ajoute_fin_attribut(tmp_node->child+3); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child+3,"office:value-type","string"); /* remplace le dernier attribut */
    /* lance */
    xml_ajoute_fin(tmp_node,"table:table-cell"); /* création de la case */
    xml_ajoute_fin(tmp_node->child+4,"text:p");
    xml_ajoute_fin_texte(tmp_node->child[4].child);
    xml_ecrit_dernier_texte(tmp_node->child[4].child,"T lancé");
    xml_ajoute_fin_attribut(tmp_node->child+4); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child+4,"table:style-name","Tableau1.VD2"); /* remplace le dernier attribut */
    xml_ajoute_fin_attribut(tmp_node->child+4); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child+4,"office:value-type","string"); /* remplace le dernier attribut */
    /* effet */
    xml_ajoute_fin(tmp_node,"table:table-cell"); /* création de la case */
    xml_ajoute_fin(tmp_node->child+5,"text:p");
    xml_ajoute_fin_texte(tmp_node->child[5].child);
    xml_ecrit_dernier_texte(tmp_node->child[5].child,"Z effet");
    xml_ajoute_fin_attribut(tmp_node->child+5); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child+5,"table:style-name","Tableau1.VD2"); /* remplace le dernier attribut */
    xml_ajoute_fin_attribut(tmp_node->child+5); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child+5,"office:value-type","string"); /* remplace le dernier attribut */
    /* save */
    xml_ajoute_fin(tmp_node,"table:table-cell"); /* création de la case */
    xml_ajoute_fin(tmp_node->child+6,"text:p");
    xml_ajoute_fin_texte(tmp_node->child[6].child);
    xml_ecrit_dernier_texte(tmp_node->child[6].child,"Save");
    xml_ajoute_fin_attribut(tmp_node->child+6); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child+6,"table:style-name","Tableau1.VD2"); /* remplace le dernier attribut */
    xml_ajoute_fin_attribut(tmp_node->child+6); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child+6,"office:value-type","string"); /* remplace le dernier attribut */
    /* composant */
    xml_ajoute_fin(tmp_node,"table:table-cell"); /* création de la case */
    xml_ajoute_fin(tmp_node->child+7,"text:p");
    xml_ajoute_fin_texte(tmp_node->child[7].child);
    xml_ecrit_dernier_texte(tmp_node->child[7].child,"Composant");
    xml_ajoute_fin_attribut(tmp_node->child+7); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child+7,"table:style-name","Tableau1.VD2"); /* remplace le dernier attribut */
    xml_ajoute_fin_attribut(tmp_node->child+7); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child+7,"office:value-type","string"); /* remplace le dernier attribut */
    /* sphère */
    xml_ajoute_fin(tmp_node,"table:table-cell"); /* création de la case */
    xml_ajoute_fin(tmp_node->child+8,"text:p");
    xml_ajoute_fin_texte(tmp_node->child[8].child);
    if (strcmp(metier,"mago")==0)
        xml_ecrit_dernier_texte(tmp_node->child[8].child,"École");
    else
        xml_ecrit_dernier_texte(tmp_node->child[8].child,"Sphère");
    xml_ajoute_fin_attribut(tmp_node->child+8); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child+8,"table:style-name","Tableau1.VD3"); /* remplace le dernier attribut */
    xml_ajoute_fin_attribut(tmp_node->child+8); /* rajouter un élément attribut */
    xml_ecrit_dernier_attribut(tmp_node->child+8,"office:value-type","string"); /* remplace le dernier attribut */

    return node;
}


void affiche_sort_pretre(char * pantheon,char * dieu,GMarkupDomNode * ooo)
{ /* couple panthéon/dieu si deux dieux même nom dans deux panthéons différents */
    char ch[LONG];

    GMarkupDomNode * noded=g_markup_dom_new(chemin_dieux(ch),NULL), * tmp_node=NULL,*node=NULL;
    unsigned long * mineure=NULL, *majeure=NULL;
    unsigned short niveau,sort,i,sort_ok;

    node=noded;
    if (pantheon==NULL || dieu==NULL ) return;
    node=node->child;
    for(i=0;i<node->fils;i++)
    {
        if (node->child[i].texte>0)
        if (compare(node->child[i].content[0].texte,pantheon))
        {
            node=node->child+i;
            i=node->fils;
        }
    }
    if (node->texte>0 && compare(node->content[0].texte,pantheon))
    {
        for(i=0;i<node->fils;i++)
        {
            if (node->child[i].texte>0)
            if (compare(node->child[i].content[0].texte,dieu))
            {
                tmp_node=node->child+i;
                i=node->fils;
            }
        }
        if (tmp_node->texte>0 && compare(tmp_node->content[0].texte,dieu))
        {
            node=g_markup_dom_node(tmp_node,"min");
            if (node->texte>0)
             mineure=tabl_sphere(node->content[0].texte);
            else
            {
                mineure=(unsigned long *)malloc(sizeof(unsigned long));
                *mineure=0;
            }
            node=g_markup_dom_node(tmp_node,"maj");
            if (node->texte>0)
             majeure=tabl_sphere(node->content[0].texte);
            else
            {
                majeure=(unsigned long *)malloc(sizeof(unsigned long));
                *majeure=0;
            }

            for (niveau=1;niveau<=3;niveau++)
            {
                node=nv_tableau_sort(ooo,niveau,"Prêtre");

                /* trouver les sorts de ce niveau */
                for(sort=0;sort<G_N_ELEMENTS(sortileges);sort++)
                {
                    if (sortileges[sort].niveau==niveau)
                    {
                        sort_ok=0;
                        for (i=1;i<=mineure[0];i++)
                            if (sortileges[sort].sphere&mineure[i])
                                sort_ok=1;
                        for (i=1;i<=majeure[0];i++)
                            if (sortileges[sort].sphere&majeure[i])
                                sort_ok=1;
                        if (sort_ok==1)
                            insere_ligne_pretre(node,sortileges+sort,0);
                    }
                }
            }
            if (majeure[0]>0) for (niveau=4;niveau<=7;niveau++)
            {
                node=nv_tableau_sort(ooo,niveau,"prêtre");

                for(sort=0;sort<G_N_ELEMENTS(sortileges);sort++)
                {
                    sort_ok=0;
                    if (sortileges[sort].niveau==niveau)
                        for (i=1;i<=majeure[0];i++)
                            if (sortileges[sort].sphere&majeure[i])
                                sort_ok=1;
                    if (sort_ok==1)
                        insere_ligne_pretre(node,sortileges+sort,0);
                }
            }
        }
    }

    if (majeure!=NULL) free(majeure);
    if (mineure!=NULL) free(mineure);
    g_markup_dom_free(noded);
}


void aff_pan(GtkListStore * list_dieu,GtkWidget * wid_dieu,unsigned short pan)
{
    unsigned short i;
    char ch[LONG];

    GMarkupDomNode * node1=g_markup_dom_new(chemin_dieux(ch),NULL),* node=g_markup_dom_node(node1,"document");
    GtkTreeIter iter;

     gtk_list_store_clear (list_dieu);
     gtk_list_store_append (list_dieu, & iter);
     gtk_list_store_set (list_dieu, & iter,0,"Aucun",-1);
     if (pan>0)
     {
         for(i=0;i<node->child[pan].fils;i++)
         {
          gtk_list_store_append (list_dieu, & iter);
          gtk_list_store_set (list_dieu, & iter,0, node->child[pan].child[i].content->texte,-1);
         }
         gtk_combo_box_set_active (GTK_COMBO_BOX (wid_dieu),0);

     }
     else
        gtk_combo_box_set_active (GTK_COMBO_BOX (wid_dieu),0);
     g_markup_dom_free(node1);
}


void aff_liste_pan(GtkListStore * list_pan,GtkWidget * wid_pan,GtkWidget * wid_dieu,char * s_pan,char * s_dieu,GMarkupDomNode * node)
{
    unsigned short i,l;
    signed short j=-1;
    GtkTreeIter iter;

     gtk_list_store_clear (list_pan);
     gtk_list_store_append (list_pan, & iter);
     gtk_list_store_set (list_pan, & iter,0,"aucun",-1);
     for(i=1;i<node->fils;i++)
     {
      gtk_list_store_append (list_pan, & iter);
      gtk_list_store_set (list_pan, & iter,0, node->child[i].content->texte,-1);
      if (compare_sans_casse(s_pan,node->child[i].content->texte)==0)
      {
        for(j=0;(unsigned short)j<node->child[i].fils;j++)
            if (compare_sans_casse(s_dieu,node->child[i].child[j].content->texte)==0)
            { /* imposer le dieu qu ivient d'être rentré */
                l=j;
                j=node->child[i].fils; /* forcer la sortie de la boucle */
            }
            j=i; /* retenir l'entrée du panthéon */
      }
     }
     if (j!=-1)
     /*for (i=1;i<node->fils && strcmp(node->child[i].content->texte,s_pan)!=0;i++);
     if (i<node->fils)*/
          gtk_combo_box_set_active (GTK_COMBO_BOX (wid_pan),j);
     else
          gtk_combo_box_set_active (GTK_COMBO_BOX (wid_pan),1);
     gtk_combo_box_set_active (GTK_COMBO_BOX (wid_dieu),l+1);
    //g_markup_dom_free(node);
}



void modif_pan(GtkWidget *wid, gpointer param)
{
  unsigned short pan=gtk_combo_box_get_active(GTK_COMBO_BOX(((GtkWidget **)param)[0]));

  if ((signed short)pan==-1) pan=0;
  aff_pan(((GtkListStore **)param)[2],(((GtkWidget **)param)[1]),pan);
  ((unsigned short **)param)[6][0]=0;

  (void)wid;
}


void sphere_0(GtkWidget *wid, gpointer param)
{
 unsigned short i;

 for(i=0;i<G_N_ELEMENTS (nom_sphere);i++)
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(((GtkWidget ****)param)[3][i][0]),1);

 (void)wid;
}

void sphere_MAJ(GtkWidget *wid, gpointer param)
{
 unsigned short i;

 for(i=0;i<G_N_ELEMENTS (nom_sphere);i++)
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(((GtkWidget ****)param)[3][i][1]),1);

 (void)wid;
}

void sphere_min(GtkWidget *wid, gpointer param)
{
 unsigned short i;

 for(i=0;i<G_N_ELEMENTS (nom_sphere);i++)
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(((GtkWidget ****)param)[3][i][2]),1);

 (void)wid;
}



void modif_dieu(GtkWidget *wid, gpointer param)
{
  unsigned short pan =gtk_combo_box_get_active(GTK_COMBO_BOX(((GtkWidget **)param)[0]));
  unsigned short dieu=gtk_combo_box_get_active(GTK_COMBO_BOX(((GtkWidget **)param)[1]));
  unsigned short * majeure=NULL, *mineure=NULL;
  unsigned short i;
  char * ali;

  if ((signed short)pan ==-1) return; /* je supprimme les entrées      */
  if ((signed short)dieu==-1 || dieu==0) return; /* qui ne sont pas dans dieu.add */

  GMarkupDomNode * noded=((GMarkupDomNode **)param)[7],*tmp_node,*node;
  node=noded;
  tmp_node=g_markup_dom_node(node,"document")->child[pan].child+dieu-1;

    node=g_markup_dom_node(tmp_node,"min");
    if (node->texte>0)
     mineure=tabl_sphere_s(node->content[0].texte);
    else
    {
        mineure=(unsigned short *)malloc(sizeof(unsigned short));
        *mineure=0;
    }
    node=g_markup_dom_node(tmp_node,"maj");
    if (node->texte>0)
     majeure=tabl_sphere_s(node->content[0].texte);
    else
    {
        majeure=(unsigned short *)malloc(sizeof(unsigned short));
        *majeure=0;
    }

 for(i=1;i<=mineure[0];i++)
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(((GtkWidget ****)param)[3][mineure[i]][2]),1);
 for(i=1;i<=majeure[0];i++)
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(((GtkWidget ****)param)[3][majeure[i]][1]),1);

 if (majeure!=NULL) free(majeure);
 if (mineure!=NULL) free(mineure);

 node=g_markup_dom_node(tmp_node,"alignement");
 if (node->texte>0)
 {
    ali=tabl_algt_s(node->content[0].texte);
    for (i=0;i<9;i++)
        if (ali[i]!=0)
            gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(((GtkWidget ***)param)[10][i]),1);
        else
            gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(((GtkWidget ***)param)[10][i]),0);
    free(ali);
 }

 node=g_markup_dom_node(tmp_node,"symbole");
 if (node->texte>0)
    gtk_entry_set_text(GTK_ENTRY(((GtkWidget **)param)[8]),node->content[0].texte);
 node=g_markup_dom_node(tmp_node,"commentaire");
 if (node->texte>0)
    gtk_entry_set_text(GTK_ENTRY(((GtkWidget **)param)[9]),node->content[0].texte);

 node=g_markup_dom_node(tmp_node,"vd");
 if (node->texte>0)
 {
     if (compare_sans_casse(node->content[0].texte,"repousse")==0)
        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(((GtkWidget ***)param)[11][0]),1);
     else if (compare_sans_casse(node->content[0].texte,"attire")==0)
        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(((GtkWidget ***)param)[11][2]),1);
     else
        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(((GtkWidget ***)param)[11][1]),1);
 }
 else
        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(((GtkWidget ***)param)[11][1]),1);

 ((unsigned short **)param)[6][0]=0;
 (void)wid;
}

void sphere_nouv(GtkWidget *wid, gpointer param)
{
  unsigned short pan =gtk_combo_box_get_active(GTK_COMBO_BOX(((GtkWidget **)param)[0]));
  unsigned short dieu=gtk_combo_box_get_active(GTK_COMBO_BOX(((GtkWidget **)param)[1]));
  char * s_pan =gtk_combo_box_get_active_text (GTK_COMBO_BOX(((GtkWidget **)param)[0]));
  char * s_dieu=gtk_combo_box_get_active_text (GTK_COMBO_BOX(((GtkWidget **)param)[1]));
  char majeure[LONG]={0};
  char mineure[LONG]={0};
  char ch[LONG]={0};
  guint i;
  GMarkupDomNode * node1=((GMarkupDomNode **)param)[7],*node=g_markup_dom_node (node1,"document"),*pt_node;
  GtkWidget *p_dialog = NULL;

  if (dieu==0 || pan==0) return; /* Pas de dieu ou de panthéon ! */
  if ((signed short)pan ==-1)
  { /* nouvelle sphère */ /* sphère ou panthéon ? */
    for(i=1;i<node->fils && strcmp(node->child[i].content->texte,s_pan)<0;i++);
    xml_ajoute_fin(node,"pan");
    if (i+1<node->fils)
        decale_node(node,i);
    xml_ajoute_fin_texte(node->child+i); /* rajouter un élément texte en fin d'une node */
    xml_ecrit_dernier_texte(node->child+i,s_pan); /* remplace le dernier texte d'une node */
    xml_ajoute_fin(node->child+i,"die");
    xml_ajoute_fin_texte(node->child[i].child);
    xml_ecrit_dernier_texte(node->child[i].child,s_dieu);
    node=node->child[i].child;
  }
  else if ((signed short)dieu==-1)
  { /* nouveau dieu d'une sphère existante */
    node=node->child+pan;
    for(i=1;i<node->fils && strcmp(node->child[i].content->texte,s_dieu)<0;i++);
    xml_ajoute_fin(node,"die");
    if (i+1<node->fils)
        decale_node(node,i);
    xml_ajoute_fin_texte(node->child+i); /* rajouter un élément texte en fin d'une node */
    xml_ecrit_dernier_texte(node->child+i,s_dieu); /* remplace le dernier texte d'une node */
    node=node->child+i;
  }
  else
  { /* modification d'un dieu existant */
    node=node->child[pan].child+dieu-1;
    pt_node=g_markup_dom_node(node,"val");
    if (pt_node && pt_node->texte!=0 && strcmp(pt_node->content->texte,"1")==0)
    {
        sprintf(ch,"Le dieu %s du panthéon %s est protégé.\nVersion de test.",s_dieu,s_pan);
        p_dialog = gtk_message_dialog_new (NULL,GTK_DIALOG_MODAL,GTK_MESSAGE_ERROR,GTK_BUTTONS_CANCEL,ch);
        gtk_dialog_run (GTK_DIALOG (p_dialog));
        gtk_widget_destroy(p_dialog);
        //return;
    }
    sprintf(ch,"Êtes-vous certains de vouloir Réinitialiser le dieu %s du panthéon %s",s_dieu,s_pan);
    p_dialog = gtk_message_dialog_new (NULL,GTK_DIALOG_MODAL,GTK_MESSAGE_QUESTION,GTK_BUTTONS_YES_NO,ch);
    switch(gtk_dialog_run(GTK_DIALOG(p_dialog)))
    {
        case GTK_RESPONSE_NO:
            gtk_widget_destroy(p_dialog);
            return ;
        default :
            gtk_widget_destroy(p_dialog);
            break;
    }
  }

 for(i=0;i<G_N_ELEMENTS (nom_sphere);i++)
 {
   if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(((GtkWidget ****)param)[3][i][1])))
   {
       sprintf(ch,"%hu ",i);
       strcat(majeure,ch);
   }
   else if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(((GtkWidget ****)param)[3][i][2])))
   {
       sprintf(ch,"%hu ",i);
       strcat(mineure,ch);
   }
 }

 if ((signed short)pan ==-1 || (signed short)dieu==-1)
 {
     xml_ajoute_fin(node,"maj");
     xml_ajoute_fin_texte(node->child); /* rajouter un élément texte en fin d'une node */
     xml_ajoute_fin(node,"min");
     xml_ajoute_fin_texte(node->child+1); /* rajouter un élément texte en fin d'une node */
     xml_ajoute_fin(node,"symbole");
     xml_ajoute_fin_texte(node->child+2); /* rajouter un élément texte en fin d'une node */
     xml_ajoute_fin(node,"commentaire");
     xml_ajoute_fin_texte(node->child+3); /* rajouter un élément texte en fin d'une node */
     xml_ajoute_fin(node,"vd");
     xml_ajoute_fin_texte(node->child+4); /* rajouter un élément texte en fin d'une node */
     xml_ajoute_fin(node,"alignement");
     xml_ajoute_fin_texte(node->child+5); /* rajouter un élément texte en fin d'une node */
 }
 else
 {
     pt_node=g_markup_dom_node(node,"maj");
     if (pt_node->texte==0) xml_ajoute_fin_texte(pt_node);
     pt_node=g_markup_dom_node(node,"min");
     if (pt_node->texte==0) xml_ajoute_fin_texte(pt_node);
 }
 xml_ecrit_dernier_texte(g_markup_dom_node(node,"maj"),majeure); /* remplace le dernier texte d'une node */
 xml_ecrit_dernier_texte(g_markup_dom_node(node,"min"),mineure); /* remplace le dernier texte d'une node */
 xml_ecrit_dernier_texte(g_markup_dom_node(node,"symbole"),(char *)gtk_entry_get_text (((GtkEntry **)param)[8])); /* remplace le dernier texte d'une node */
 xml_ecrit_dernier_texte(g_markup_dom_node(node,"commentaire"),(char *)gtk_entry_get_text (((GtkEntry **)param)[9])); /* remplace le dernier texte d'une node */

 if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(((GtkWidget ***)param)[11][0])))
 {
    xml_ecrit_dernier_texte(g_markup_dom_node(node,"vd"),"repousse"); /* remplace le dernier texte d'une node */
 }
 else if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(((GtkWidget ***)param)[11][2])))
 {
    xml_ecrit_dernier_texte(g_markup_dom_node(node,"vd"),"attire"); /* remplace le dernier texte d'une node */
 }
 else
 {
    xml_ecrit_dernier_texte(g_markup_dom_node(node,"vd"),"neutre"); /* remplace le dernier texte d'une node */
 }

 *ch=0;
 for (i=0;i<9;i++)
 {
    if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(((GtkWidget ***)param)[10][i])))
    {
        if (*ch!=0)
            strcat(ch," ");
        strcat(ch,algnm[i]);
printf("%s => ",ch);
    }
 }
printf("%s pour %s\n",ch,s_dieu);
 xml_ecrit_dernier_texte(g_markup_dom_node(node,"alignement"),ch);

 enregistre_xml(chemin_dieux_libre(ch),node1);
 aff_liste_pan(((GtkListStore **)param)[5],((GtkWidget **)param)[0],((GtkWidget **)param)[1],s_pan,s_dieu,g_markup_dom_node(node1,"document"));

 ((unsigned short **)param)[6][0]=0;


 (void)wid;
}

void sphere_supp(GtkWidget *wid, gpointer param)
{
  char ch[LONG];

  unsigned short pan =gtk_combo_box_get_active(GTK_COMBO_BOX(((GtkWidget **)param)[0]));
  unsigned short dieu=gtk_combo_box_get_active(GTK_COMBO_BOX(((GtkWidget **)param)[1]));
  char *s_pan=gtk_combo_box_get_active_text (GTK_COMBO_BOX(((GtkWidget **)param)[0]));
  char *s_dieu=gtk_combo_box_get_active_text (GTK_COMBO_BOX(((GtkWidget **)param)[1]));
  /*s=gtk_combo_box_text_get_active_text (GTK_COMBO_BOX_TEXT(((GtkWidget **)param)[0]));
  s_pan =g_strdup(s);
  s=gtk_combo_box_text_get_active_text (GTK_COMBO_BOX_TEXT(((GtkWidget **)param)[1]));
  s_dieu=g_strdup(s);*/

  GMarkupDomNode * node1=g_markup_dom_new(chemin_dieux(ch),NULL);
  GMarkupDomNode * node=g_markup_dom_node(node1,"document"),* pt_node;
  GtkWidget *p_dialog = NULL;

  if (dieu==0 || pan==0|| (signed short)pan ==-1|| (signed short)dieu==-1)
  { /* nouveau dieu d'une sphère existante */
        p_dialog = gtk_message_dialog_new (NULL,GTK_DIALOG_MODAL,GTK_MESSAGE_ERROR,GTK_BUTTONS_CANCEL,"Rien à enlever !");
        gtk_dialog_run (GTK_DIALOG (p_dialog));
        gtk_widget_destroy(p_dialog);
        /*free(s_pan);
        free(s_dieu);*/
        return;
  }
  else
  { /* modification d'un dieu existant */
    node=node->child+pan;
    pt_node=g_markup_dom_node(node->child+dieu-1,"val");
    if (pt_node && pt_node->texte!=0 && strcmp(pt_node->content->texte,"1")==0)
    {
        sprintf(ch,"Le dieu %s du panthéon %s est protégé",s_dieu,s_pan);
        p_dialog = gtk_message_dialog_new (NULL,GTK_DIALOG_MODAL,GTK_MESSAGE_ERROR,GTK_BUTTONS_CANCEL,ch);
        gtk_dialog_run (GTK_DIALOG (p_dialog));
        gtk_widget_destroy(p_dialog);
        /*free(s_pan);
        free(s_dieu);*/
        return;
    }
    sprintf(ch,"Êtes-vous certains de vouloir supprimer le dieu %s du panthéon %s",s_dieu,s_pan);
    p_dialog = gtk_message_dialog_new (NULL,GTK_DIALOG_MODAL,GTK_MESSAGE_QUESTION,GTK_BUTTONS_YES_NO,ch);
    switch(gtk_dialog_run(GTK_DIALOG(p_dialog)))
    {
        case GTK_RESPONSE_NO:
            gtk_widget_destroy(p_dialog);
            /*free(s_pan);
            free(s_dieu);*/
            return ;
        default :
            gtk_widget_destroy(p_dialog);
            break;
    }
  }

  ((unsigned short **)param)[6][0]=0; /* on supprime le dieu, donc les modifs qui ont été faites avec */
  supprime_node(node,dieu-1);
  if (node->fils==0)
  { /* supprimer le pantheon */
    sprintf(ch,"Voulez-vous supprimer aussi le panthéon %s que vous venez de vider ?",s_pan);
    p_dialog = gtk_message_dialog_new (NULL,GTK_DIALOG_MODAL,GTK_MESSAGE_QUESTION,GTK_BUTTONS_YES_NO,ch);
    switch(gtk_dialog_run(GTK_DIALOG(p_dialog)))
    {
        case GTK_RESPONSE_NO:
            gtk_widget_destroy(p_dialog);
            break; ;
        default :
            gtk_widget_destroy(p_dialog);
            //supprime_node(g_markup_dom_node(node1,"document"),pan);
            supprime_node(node,pan);
            break;
    }

  }

  enregistre_xml(chemin_dieux(ch),node1);
  aff_liste_pan(((GtkListStore **)param)[5],((GtkWidget **)param)[0],((GtkWidget **)param)[1],s_pan,s_dieu,g_markup_dom_node(node1,"document"));
  free(s_pan);
  free(s_dieu);

  (void)wid;
}


void ferme_sphere(GtkWidget *wid, gpointer param)
{
  gtk_widget_destroy(((GtkWidget **)param)[4]);
  g_markup_dom_free(((GMarkupDomNode **)param)[7]);

  (void)wid;
}


void nouveau_dieux (GtkWidget *wid, gpointer param)
{
    char * chemin,ch[LONG];

    GMarkupDomNode * node1=g_markup_dom_new(chemin_dieux(ch),NULL),* node;
    GtkWidget * pWindow,* table_d, * label, *** radio;
    if (node1==NULL || (node=g_markup_dom_node (node1,"document"))==NULL || g_markup_dom_node (node,"pan")==NULL)
    {
             pWindow = gtk_message_dialog_new (GTK_WINDOW(param),GTK_DIALOG_MODAL,GTK_MESSAGE_INFO,GTK_BUTTONS_CLOSE,"le fichier dieux.add\n ne correspond pas à un fichier xml de dieux");
             gtk_dialog_run(GTK_DIALOG(pWindow));
             gtk_widget_destroy(pWindow);
             return;
    }
    unsigned short i,j;
    static gint nb_spheres = G_N_ELEMENTS (nom_sphere);
    GtkListStore * p_model_pan = gtk_list_store_new (1, G_TYPE_STRING);
    GtkListStore * p_model_dieu = gtk_list_store_new (1, G_TYPE_STRING);
    //GtkWidget * p_combo_pantheon= gtk_combo_box_text_new ();
    GtkWidget * p_combo_pantheon=gtk_combo_box_entry_new_with_model(GTK_TREE_MODEL(p_model_pan),0);
    //GtkWidget * p_combo_dieu= gtk_combo_box_text_new ();
    GtkWidget * p_combo_dieu    =gtk_combo_box_entry_new_with_model(GTK_TREE_MODEL (p_model_dieu),0);
    GtkTreeIter  iter;
    GtkWidget *button = NULL, *Box_, * event_,* commentaire, * symbole;
    gpointer *  tparam;
    unsigned short * p_modif=(unsigned short *)malloc(sizeof(unsigned short));
    tparam=(gpointer *)malloc(12*sizeof(void *));
    *p_modif=0;
    GtkCellRenderer * p_cell = NULL,* p_cell_dieu = NULL;
    GdkColor color;
    GtkWidget ** alignement, * table, **vd;

    GError * error;

    //gtk_combo_box_set_model(GTK_COMBO_BOX(p_combo_pantheon),GTK_TREE_MODEL(p_model_pan));
    //gtk_combo_box_set_model(GTK_COMBO_BOX(p_combo_dieu),GTK_TREE_MODEL (p_model_dieu));


    pWindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    gtk_window_set_title(GTK_WINDOW(pWindow), "Panthéons et Dieux");
    g_signal_connect(G_OBJECT(pWindow), "destroy", G_CALLBACK(fin_modif_sphere), tparam);
    chemin=chemin_exe();
    sprintf(ch,"%s%cdieux_ico.png",chemin,SEPARATEUR);
    free(chemin);
    if (!gtk_window_set_icon_from_file(GTK_WINDOW (pWindow),ch,&error))
    {                                                                  /* met une icone à la fenêtre                                   */
        traite_erreur(error);
        g_error_free(error);
    }
    table_d=gtk_table_new(11+nb_spheres/2,16,TRUE);
    gtk_container_add(GTK_CONTAINER(pWindow), table_d);


         label=gtk_label_new ("Panthéon");
         gtk_label_set_justify(GTK_LABEL(label),GTK_JUSTIFY_CENTER); /* centrer la ligne */
         gtk_table_attach(GTK_TABLE(table_d), label,
            0,8,0,1,
            GTK_EXPAND , GTK_EXPAND,
            0, 0);
         p_cell = gtk_cell_renderer_text_new ();
         gtk_cell_layout_pack_start (GTK_CELL_LAYOUT (p_combo_pantheon), p_cell, FALSE);
         gtk_cell_layout_set_attributes (GTK_CELL_LAYOUT (p_combo_pantheon),p_cell, "text", 0,NULL);
         gtk_list_store_append (p_model_pan, & iter);
         gtk_list_store_set (p_model_pan, & iter,0,"Aucun",-1);
         for(i=1;i<node->fils;i++)
         {
          gtk_list_store_append (p_model_pan, & iter);
          gtk_list_store_set (p_model_pan, & iter,0, node->child[i].content->texte,-1);
         }
         gtk_table_attach(GTK_TABLE(table_d), p_combo_pantheon,
            0,8,1,2,
            GTK_EXPAND , GTK_EXPAND,
            0, 0);
         gtk_combo_box_set_active (GTK_COMBO_BOX (p_combo_pantheon),0);
         g_signal_connect (G_OBJECT (p_combo_pantheon), "changed", G_CALLBACK (modif_pan), (gpointer) tparam);

         label=gtk_label_new ("Dieu");
         gtk_label_set_justify(GTK_LABEL(label),GTK_JUSTIFY_CENTER); /* centrer la ligne */
         gtk_table_attach(GTK_TABLE(table_d), label,
            8,16,0,1,
            GTK_EXPAND , GTK_EXPAND,
            0, 0);
         p_cell_dieu = gtk_cell_renderer_text_new ();
         gtk_cell_layout_pack_start (GTK_CELL_LAYOUT (p_combo_dieu), p_cell_dieu, FALSE);
         gtk_cell_layout_set_attributes (GTK_CELL_LAYOUT (p_combo_dieu),p_cell_dieu, "text", 0,NULL);
         gtk_list_store_append (p_model_dieu, & iter);
         gtk_list_store_set (p_model_dieu, & iter,0,"Aucun",-1);
         gtk_combo_box_set_active (GTK_COMBO_BOX (p_combo_dieu),0);
         gtk_table_attach(GTK_TABLE(table_d), p_combo_dieu,
            8,16,1,2,
            GTK_EXPAND , GTK_EXPAND,
            0, 0);
         g_signal_connect (G_OBJECT (p_combo_dieu), "changed", G_CALLBACK (modif_dieu), (gpointer) tparam);



    radio=(GtkWidget ***)malloc(nb_spheres*sizeof(GtkWidget **));
    label=gtk_label_new(NULL);
    gtk_label_set_markup (GTK_LABEL(label),"<span size=\"7500\">Non</span>");
    gtk_label_set_justify(GTK_LABEL(label),GTK_JUSTIFY_CENTER);
      gtk_table_attach(GTK_TABLE(table_d), label,
            5,6,2,3,
            GTK_EXPAND , GTK_EXPAND,
            0, 0);
    label=gtk_label_new(NULL);
    gtk_label_set_markup (GTK_LABEL(label),"<span size=\"7500\">Non</span>");
    gtk_label_set_justify(GTK_LABEL(label),GTK_JUSTIFY_CENTER);
      gtk_table_attach(GTK_TABLE(table_d), label,
            13,14,2,3,
            GTK_EXPAND , GTK_EXPAND,
            0, 0);
    label=gtk_label_new(NULL);
    gtk_label_set_markup (GTK_LABEL(label),"<span size=\"7500\">MAJ</span>");
    gtk_label_set_justify(GTK_LABEL(label),GTK_JUSTIFY_CENTER);
      gtk_table_attach(GTK_TABLE(table_d), label,
            6,7,2,3,
            GTK_EXPAND , GTK_EXPAND,
            0, 0);
    label=gtk_label_new(NULL);
    gtk_label_set_markup (GTK_LABEL(label),"<span size=\"7500\">MAJ</span>");
    gtk_label_set_justify(GTK_LABEL(label),GTK_JUSTIFY_CENTER);
      gtk_table_attach(GTK_TABLE(table_d), label,
            14,15,2,3,
            GTK_EXPAND , GTK_EXPAND,
            0, 0);
    label=gtk_label_new(NULL);
    gtk_label_set_markup (GTK_LABEL(label),"<span size=\"7500\">min</span>");
    gtk_label_set_justify(GTK_LABEL(label),GTK_JUSTIFY_CENTER);
      gtk_table_attach(GTK_TABLE(table_d), label,
            7,8,2,3,
            GTK_EXPAND , GTK_EXPAND,
            0, 0);
    label=gtk_label_new(NULL);
    gtk_label_set_markup (GTK_LABEL(label),"<span size=\"7500\">min</span>");
    gtk_label_set_justify(GTK_LABEL(label),GTK_JUSTIFY_CENTER);
      gtk_table_attach(GTK_TABLE(table_d), label,
            15,16,2,3,
            GTK_EXPAND , GTK_EXPAND,
            0, 0);
    for(i=0;i<nb_spheres;i++)
    {
        radio[i]=(GtkWidget **)malloc(3*sizeof(GtkWidget *));
        label=gtk_label_new(NULL);
        sprintf(ch,"<span size=\"10500\">%s</span>",nom_sphere[i]);
        gtk_label_set_markup (GTK_LABEL(label),ch);
        gtk_label_set_justify(GTK_LABEL(label),GTK_JUSTIFY_CENTER);
          gtk_table_attach(GTK_TABLE(table_d), label,
                (i%2)*8, (i%2)*8+5,i/2+3,i/2+4,
                GTK_EXPAND , GTK_EXPAND,
                0, 0);
        for(j=0;j<3;j++)
        {
            if (j==0) radio[i][0] = gtk_radio_button_new(NULL);
            else radio[i][j] = gtk_radio_button_new_from_widget(GTK_RADIO_BUTTON(radio[i][0]));
            gtk_table_attach(GTK_TABLE(table_d), radio[i][j],
                (i%2)*8+5+j, (i%2)*8+6+j,i/2+3,i/2+4,
                GTK_EXPAND , GTK_EXPAND,
                0, 0);
            g_signal_connect (G_OBJECT (radio[i][j]), "clicked", G_CALLBACK (modif_p), (gpointer) tparam);
        }
    }

   Box_= gtk_frame_new("Symbole sacré");
   event_= gtk_event_box_new();
   color.pixel = 32;
   color.red = 60000;
   color.green = 55000;
   color.blue = 40000;
   gtk_widget_modify_bg (event_, GTK_STATE_NORMAL, &color);
   gtk_container_add (GTK_CONTAINER (event_), Box_);
   symbole=gtk_entry_new();
   gtk_container_add (GTK_CONTAINER (Box_), symbole);
        gtk_table_attach(GTK_TABLE(table_d), event_,
            0, 8,3+nb_spheres/2,5+nb_spheres/2,
            GTK_EXPAND , GTK_EXPAND,
            0, 0);
     g_signal_connect (G_OBJECT (symbole), "changed", G_CALLBACK (modif_p), (gpointer) tparam);

   Box_= gtk_frame_new("Commentaire");
   event_= gtk_event_box_new();
   color.pixel = 32;
   color.red = 40000;
   color.green = 55000;
   color.blue = 60000;
   gtk_widget_modify_bg (event_, GTK_STATE_NORMAL, &color);
   gtk_container_add (GTK_CONTAINER (event_), Box_);
   commentaire=gtk_entry_new();
   gtk_container_add (GTK_CONTAINER (Box_), commentaire);
        gtk_table_attach(GTK_TABLE(table_d), event_,
            0, 8,5+nb_spheres/2,7+nb_spheres/2,
            GTK_EXPAND , GTK_EXPAND,
            0, 0);
     g_signal_connect (G_OBJECT (commentaire), "changed", G_CALLBACK (modif_p), (gpointer) tparam);

       Box_ = gtk_frame_new("Alignement");
       event_= gtk_event_box_new();
       color.pixel = 32;
       color.red = 55000;
       color.green = 35000;
       color.blue = 5000;
       gtk_widget_modify_bg (event_, GTK_STATE_NORMAL, &color);
       gtk_container_add (GTK_CONTAINER (event_), Box_);

       table=gtk_table_new(4,4,TRUE);
       gtk_container_add(GTK_CONTAINER(Box_) , table);
        label=gtk_label_new(NULL);
        gtk_label_set_markup (GTK_LABEL(label),"L");
        gtk_table_attach(GTK_TABLE(table), label,
            1,2,0,1,
            GTK_FILL , GTK_FILL,
            0, 0);
        label=gtk_label_new(NULL);
        gtk_label_set_markup (GTK_LABEL(label),"N");
        gtk_table_attach(GTK_TABLE(table), label,
            2,3,0,1,
            GTK_FILL , GTK_FILL,
            0, 0);
        label=gtk_label_new(NULL);
        gtk_label_set_markup (GTK_LABEL(label),"C");
        gtk_table_attach(GTK_TABLE(table), label,
            3,4,0,1,
            GTK_FILL , GTK_FILL,
            0, 0);
        label=gtk_label_new(NULL);
        gtk_label_set_markup (GTK_LABEL(label),"B");
        gtk_table_attach(GTK_TABLE(table), label,
            0,1,1,2,
            GTK_FILL , GTK_FILL,
            0, 0);
        label=gtk_label_new(NULL);
        gtk_label_set_markup (GTK_LABEL(label),"N");
        gtk_table_attach(GTK_TABLE(table), label,
            0,1,2,3,
            GTK_FILL , GTK_FILL,
            0, 0);
        label=gtk_label_new(NULL);
        gtk_label_set_markup (GTK_LABEL(label),"M");
        gtk_table_attach(GTK_TABLE(table), label,
            0,1,3,4,
            GTK_FILL , GTK_FILL,
            0, 0);
       alignement=(GtkWidget ** )malloc(9*sizeof(GtkWidget *));
       for(i=0;i<9;i++)
       {
            alignement[i] = gtk_check_button_new();
            gtk_table_attach(GTK_TABLE(table), alignement[i],
                1+i%3,2+i%3,1+i/3,2+i/3,
                GTK_FILL , GTK_FILL,
                0, 0);

            g_signal_connect (G_OBJECT (alignement[i]), "clicked", G_CALLBACK (modif_p), (gpointer) tparam);
       }
        gtk_table_attach(GTK_TABLE(table_d), event_,
            8, 11,3+nb_spheres/2,7+nb_spheres/2,
            GTK_EXPAND , GTK_EXPAND,
            0, 0);

       Box_ = gtk_frame_new("Alignement");
       event_= gtk_event_box_new();
       color.pixel = 32;
       color.red = 35000;
       color.green = 55000;
       color.blue = 5000;
       gtk_widget_modify_bg (event_, GTK_STATE_NORMAL, &color);
       gtk_container_add (GTK_CONTAINER (event_), Box_);
       table=gtk_vbox_new(FALSE, 6);
       gtk_container_add(GTK_CONTAINER(Box_) , table);

       vd=(GtkWidget ** )malloc(3*sizeof(GtkWidget *));
       vd[0] = gtk_radio_button_new_with_label(NULL,"repousse");
       gtk_box_pack_start (GTK_BOX(table) , vd[0],FALSE,TRUE,1);
       g_signal_connect (G_OBJECT (vd[0]), "clicked", G_CALLBACK (modif_p), (gpointer) tparam);
       vd[1] = gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(vd[0]),"neutre");
       gtk_box_pack_start (GTK_BOX(table) , vd[1],FALSE,TRUE,1);
       g_signal_connect (G_OBJECT (vd[1]), "clicked", G_CALLBACK (modif_p), (gpointer) tparam);
       vd[2] = gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(vd[0]),"attire");
       gtk_box_pack_start (GTK_BOX(table) , vd[2],FALSE,TRUE,1);
       g_signal_connect (G_OBJECT (vd[2]), "clicked", G_CALLBACK (modif_p), (gpointer) tparam);

        gtk_table_attach(GTK_TABLE(table_d), event_,
            11, 16,3+nb_spheres/2,7+nb_spheres/2,
            GTK_EXPAND , GTK_EXPAND,
            0, 0);

  button = gtk_button_new_with_label ("Aucune");
  chemin=chemin_exe();
  sprintf(ch,"%s%cdieux_non.png",chemin,SEPARATEUR);
  free(chemin);
  gtk_button_set_image(GTK_BUTTON(button),gtk_image_new_from_file("ch"));
  g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (sphere_0), (gpointer) tparam);
            gtk_table_attach(GTK_TABLE(table_d),button,
                0, 4,7+nb_spheres/2,9+nb_spheres/2,
                GTK_EXPAND , GTK_EXPAND,
                0, 0);
  button = gtk_button_new_with_label ("MAJEURE");
  chemin=chemin_exe();
  sprintf(ch,"%s%cdieux.png",chemin,SEPARATEUR);
  free(chemin);
  gtk_button_set_image(GTK_BUTTON(button),gtk_image_new_from_file(ch));
  g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (sphere_MAJ), (gpointer) tparam);
            gtk_table_attach(GTK_TABLE(table_d), button,
                6, 10,7+nb_spheres/2,9+nb_spheres/2,
                GTK_EXPAND , GTK_EXPAND,
                0, 0);
  button = gtk_button_new_with_label ("mineure");
  chemin=chemin_exe();
  sprintf(ch,"%s%cdieux_min.png",chemin,SEPARATEUR);
  free(chemin);
  gtk_button_set_image(GTK_BUTTON(button),gtk_image_new_from_file(ch));
  g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (sphere_min), (gpointer) tparam);
            gtk_table_attach(GTK_TABLE(table_d), button,
                12, 16,7+nb_spheres/2,9+nb_spheres/2,
                GTK_EXPAND , GTK_EXPAND,
                0, 0);

  button = gtk_button_new_from_stock (GTK_STOCK_APPLY); /*GTK_STOCK_DIALOG_INFO);*/
  g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (sphere_nouv), (gpointer) tparam);
            gtk_table_attach(GTK_TABLE(table_d), button,
                0, 4,9+nb_spheres/2,11+nb_spheres/2,
                GTK_EXPAND , GTK_EXPAND,
                0, 0);
  button = gtk_button_new_from_stock (GTK_STOCK_CANCEL); /*GTK_STOCK_DIALOG_INFO);*/
  g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (modif_dieu), (gpointer) tparam);
            gtk_table_attach(GTK_TABLE(table_d), button,
                4, 8,9+nb_spheres/2,11+nb_spheres/2,
                GTK_EXPAND , GTK_EXPAND,
                0, 0);
  button = gtk_button_new_from_stock (GTK_STOCK_DELETE); /*GTK_STOCK_DIALOG_INFO);*/
  g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (sphere_supp), (gpointer) tparam);
            gtk_table_attach(GTK_TABLE(table_d), button,
                8, 12,9+nb_spheres/2,11+nb_spheres/2,
                GTK_EXPAND , GTK_EXPAND,
                0, 0);
  button = gtk_button_new_from_stock (GTK_STOCK_CLOSE); /*GTK_STOCK_DIALOG_INFO);*/
  g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (ferme_sphere),(gpointer) tparam);
            gtk_table_attach(GTK_TABLE(table_d), button,
                12, 16,9+nb_spheres/2,11+nb_spheres/2,
                GTK_EXPAND , GTK_EXPAND,
                0, 0);

  tparam[ 0]=(gpointer)p_combo_pantheon;
  tparam[ 1]=(gpointer)p_combo_dieu;
  tparam[ 2]=(gpointer)p_model_dieu;
  tparam[ 3]=(gpointer)radio;
  tparam[ 4]=(gpointer)pWindow;
  tparam[ 5]=(gpointer)p_model_pan;
  tparam[ 6]=(gpointer)p_modif;
  tparam[ 7]=(gpointer)node1;
  tparam[ 8]=(gpointer)symbole;
  tparam[ 9]=(gpointer)commentaire;
  tparam[10]=(gpointer)alignement;
  tparam[11]=(gpointer)vd;

  gtk_widget_show_all (pWindow);

  (void)wid;
  (void)param;
}
