/*
    Génération de feuille de personnage complète AD&D 1 et 2
    Génération aléatoire de personnage

    Copyright (C) 2011 Bernard SIAUD

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Un grand merci à Denis Léger pour sa liste de sort de magicien que j'ai
    récupéré pour compléter la mienne.
*/

#include "include.h"

gchar * vers[]={"DD","ADD","ADD2","?"};
gchar * init[]={"f","i","s","d","co","ch","b","h"};
gchar * nom[]={"Force","Intelligence","Sagesse","Dextérité","Constitution","Charisme","Beauté","Humour"};
gchar * nom_min[]={"force","intelligence","sagesse","dexterite","constitution","charisme","beaute","humour","pourcentage"};
//gchar * nom_race[]={"Humain","Elfe","Demi Elfe","Nain","Gnome","Hobbit","Demi Orc","autre"};
//gchar * nom_classe[]={"Guerrier","Paladin","Ranger","Voleur","Assassin","Barde","Clerc","Prêtre","Druide","Magicien","Illusionniste","Abjurateur","Conjurateur","Devin","Enchanteur","Invocateur","Nécromencien","Transmutateur","Entropiste","Moine","Autre"};
gchar algnm[9][3]={"BL","BN","BC","NL","N","NC","ML","MN","MC"};


gchar vd_add1[13][14][4]= /* vade retro */
{
    {"10","7","4","T","T","D","D","D*","D*","D*","D*","D*","D*","D*"},
    {"13","10","7","T","T","D","D","D","D*","D*","D*","D*","D*","D*"},
    {"16","13","10","4","T","T","D","D","D","D","D","D","D","D*"},
    {"19","16","13","7","4","T","T","D","D","D","D","D","D","D*"},
    {"20","19","16","10","7","4","T","T","D","D","D","D","D","D"},
    {"-","20","19","13","10","7","4","T","T","T","T","T","T","D"},
    {"-","-","20","16","13","10","7","4","T","T","T","T","T","D"},
    {"-","-","-","20","16","13","10","7","4","4","4","4","4","T"},
    {"-","-","-","-","20","16","13","10","7","7","7","7","7","T"},
    {"-","-","-","-","-","20","16","13","10","10","10","10","10","4"},
    {"-","-","-","-","-","-","20","16","13","13","13","13","13","7"},
    {"-","-","-","-","-","-","-","19","16","16","16","16","16","10"},
    {"-","-","-","-","-","-","-","20","19","19","19","19","19","13"}
};

gchar vd_add2[13][14][4]= /* vade retro */
{
    {"10","7","4","R","R","D","D","D*","D*","D*","D*","D*","D*","D*"},
    {"13","10","7","4","R","R","D","D","D*","D*","D*","D*","D*","D*"},
    {"16","13","10","7","4","R","R","D","D","D*","D*","D*","D*","D*"},
    {"19","16","13","10","7","4","R","R","D","D","D","D*","D*","D*"},
    {"20","19","16","13","10","7","4","R","R","D","R","D","D","D*"},
    {"-","20","19","16","13","10","7","4","R","R","R","D","D","D*"},
    {"-","-","20","19","16","13","10","7","4","R","R","R","R","D"},
    {"-","-","-","20","19","16","13","10","7","4","4","R","R","R"},
    {"-","-","-","-","20","19","16","13","10","7","7","4","4","R"},
    {"-","-","-","-","-","20","19","16","13","10","10","7","7","4"},
    {"-","-","-","-","-","-","20","19","16","13","13","10","10","7"},
    {"-","-","-","-","-","-","-","20","19","16","16","13","13","10"},
    {"-","-","-","-","-","-","-","-","20","19","19","16","16","13"}
};


struct_competences competences[MAX_COMPETENCE] =
{
    {"Acrobatie",1,DEXTERITE,0,4}, /* 0 */
    {"Agriculture",1,INTELLIGENCE,0,1},
    {"Allumage de feu",1,SAGESSE,-1,1},
    {"Armurerie",2,INTELLIGENCE,-2,2},
    {"Astrologie",2,INTELLIGENCE,0,24},
    {"Brassage",1,INTELLIGENCE,0,1},
    {"Chant",1,CHARISME,0,1},
    {"Charpenterie",1,FORCE,0,1},
    {"Chasse",1,SAGESSE,-1,2},
    {"Combat Aveugle",2,POURCENTAGE,POURCENTAGE,6},
    {"Conduite de Chars",1,DEXTERITE,2,2}, /* 10 */
    {"Connaissance des animaux",1,INTELLIGENCE,0,2},
    {"Connaissance des Sorts",1,INTELLIGENCE,-2,24},
    {"Contrefaçon",1,DEXTERITE,-1,4},
    {"Cordonnerie",1,DEXTERITE,0,1},
    {"Course",1,CONSTITUTION,-6,2},
    {"Couture/Confection",1,DEXTERITE,-1,1},
    {"Cuisine",1,INTELLIGENCE,0,1},
    {"Danse",1,DEXTERITE,0,1},
    {"Déguisement",1,CHARISME,-1,4},
    {"Don Artistique",1,SAGESSE,0,1},/* 20 */
    {"Dressage d'animaux",1,SAGESSE,-1,1},
    {"Endurance",6,CONSTITUTION,0,2},
    {"Équitation à Terre",1,SAGESSE,3,1},
    {"« Équitation » en Vol",2,SAGESSE,-2,1},
    {"Estimation",1,INTELLIGENCE,0,4},
    {"Étiquette",1,CHARISME,0,1},
    {"Fabrication d'Arcs et de Flèches",1,DEXTERITE,-1,2},
    {"Forge",1,FORCE,0,1},
    {"Forge d'Armes",3,INTELLIGENCE,-3,2},
    {"Funambulisme",1,DEXTERITE,0,4}, /* 30 */
    {"Génie",2,INTELLIGENCE,-3,24},
    {"Héraldique",1,INTELLIGENCE,0,1},
    {"Herboristerie",2,INTELLIGENCE,-2,24},
    {"Histoire Ancienne",1,INTELLIGENCE,-1,28},
    {"Histoire Locale",1,CHARISME,0,20},
    {"Instrument de Musique",1,DEXTERITE,-1,20},
    {"Jeu",1,CHARISME,0,6},
    {"Jonglerie",1,DEXTERITE,-1,4},
    {"Langues Anciennes",1,INTELLIGENCE,0,24},
    {"Langues Vivantes",1,INTELLIGENCE,0,1},/* 40 */
    {"Lecture sur les Lèvres",2,INTELLIGENCE,-2,4},
    {"Lecture/Écriture",1,INTELLIGENCE,1,24},
    {"Maçonnerie",1,FORCE,-2,1},
    {"Maîtrise des animaux",1,SAGESSE,-1,1},
    {"Manœuvres Navales",1,DEXTERITE,1,1},
    {"Maroquinerie",1,INTELLIGENCE,0,1},
    {"Mines",2,SAGESSE,-3,1},
    {"Nage",1,FORCE,0,1},
    {"Navigation",1,INTELLIGENCE,-2,26},
    {"Pêche",1,SAGESSE,-1,1},/* 50 */
    {"Perception du climat",1,SAGESSE,-1,1},
    {"Pistage",2,SAGESSE,0,2},
    {"Pose de Collets",1,DEXTERITE,-1,6},
    {"Poterie",1,DEXTERITE,-2,1},
    {"Religion",1,SAGESSE,0,24},
    {"Saut",1,FORCE,0,4},
    {"Sens de l'Orientation",1,SAGESSE,1,1},
    {"Soins",2,SAGESSE,-2,16},
    {"Survie",2,INTELLIGENCE,0,2},
    {"Taille des Gemmes",2,DEXTERITE,-2,12}, /* 60 */
    {"Tissage",1,INTELLIGENCE,-1,1},
    {"Utilisation des Cordes",1,DEXTERITE,0,1},
    {"Ventriloquie",1,INTELLIGENCE,-3,4},
    {"Vie en Montagne",1,POURCENTAGE,POURCENTAGE,2},
    {"Balisage",1,SAGESSE,0,2},
    {"Camouflage",1,SAGESSE,0,6},
    {"Canotage",1,SAGESSE,1,1},
    {"Cartographie",1,INTELLIGENCE,-2,1},
    {"Équitation marine",2,DEXTERITE,-2,1},
    {"Fabrication d'armes rudimentaires",1,SAGESSE,-3,2},
    {"Fauconnerie",1,SAGESSE,-1,1},
    {"Fureter",1,INTELLIGENCE,-2,6},
    {"Persuasion",1,CHARISME,0,1},
    {"Sens des distances",1,SAGESSE,0,1},
    {"Signaux",1,INTELLIGENCE,-2,1},
    {"Signes de Piste",1,INTELLIGENCE,-1,6},
    {"Soins Vétérinaires",1,SAGESSE,-3,16},
    {"Spéléologie",1,INTELLIGENCE,-2,2},
    {"Vigilance",1,SAGESSE,1,1}



};


struct_armes armes[MAX_ARMES]=
{
    {"Bardiche"                       , 150 , 9  ,"2-8","3-12",0}, /* 0*/
    {"Bâton 1,8m"                     , 180 , 4  ,"1-6","1-6",0},
    {"Bâton 2,4m"                     , 240 , 4  ,"1-6","1-6",0},
    {"Bâton d'escrime"                , 150 , 3  ,"1-6","1-3",0},
    {"Bec de corbin"                  , 180 , 2  ,"1-8","1-6",0},
    {"Canne d'escrime"                ,  90 , 2  ,"1-6","1-4",0},
    {"Carreau Léger"                  , 0   , 0  ,"1-4","1-4",0},
    {"Carreau lourd"                  , 0   , 0  ,"2-5","2-7",0},
    {"Chauve-Souris"                  , 240 , 8  ,"2-8","2-8",0},
    {"Cimeterre"                       ,  90 , 4  ,"1-8","1-8",0},
    {"Corsèque"                       , 245 , 8  ,"1-8","1-8",0}, /* 10 */
    {"Couteau de Brèche"              , 245 , 8  ,"2-7","2-12",0},
    {"Dague"                          ,  38 , 2  ,"1-4","1-3",0},
    {"Épée, bâtarde"                  , 135 , 6  ,"2-8","2-16",0},
    {"Épée, courte"                   ,  60 , 3  ,"1-6","1-8",1},
    {"Épée, large"                    , 105 , 5  ,"2-8","2-7",0},
    {"Épée, longue"                   , 105 , 5  ,"1-8","1-12",1},
    {"Épieu, cavalier"                ,  60 , 5  ,"2-5","1-4",0},
    {"Épieu, fantassin"               , 120 , 7  ,"2-7","2-8",0},
    {"Espadon, épée à deux mains"     , 180 , 10 ,"1.10","3-18",0},
    {"Étoile du matin"                , 120 , 7  ,"2-8","2-7",0}, /* 20 */
    {"Fauchard"                       , 245 , 8  ,"1-6","1-8",0},
    {"Fléau, cavalier"                ,  60 , 6  ,"2-5","2-5",0},
    {"Fléau, fantassin"               , 120 , 7  ,"2-7","2-8",0},
    {"Flèche / Arc"                   , 0   , 0  ,"1-6","1-6",1},
    {"Fléchette"                      , 0   , 0  ,"1-3","1-2",0},
    {"Fourche de guerre"              , 210 , 7  ,"1-8","2-8",0},
    {"Fourche Fauchard"               , 240 , 8  ,"1-8","1-10",0},
    {"Fronde, bille"                  , 0   , 0  ,"2-5","2-7",0},
    {"Fronde, pierre"                 , 0   , 0  ,"1-4","1-4",0},
    {"Fouet"                          , 240 , 5  ,"0-3","0-3",0}, /* 30 */
    {"Glève Guisarme"                 , 245 , 9  ,"2-8","2-12",0},
    {"Guisarme"                       , 180 , 8  ,"2-8","1-8",0},
    {"Guisarme Voulge"                , 210 , 10 ,"2-8","2-8",0},
    {"Hache d'armes"                  , 120 , 7  ,"1-8","1-8",0},
    {"Hachette ou de jet"             ,  45 , 4  ,"1-6","1-4",0},
    {"Hallebarde"                     , 150 , 9  ,"1-10","2-12",0},
    {"Javelot"                        , 0   , 0  ,"1-6","1-6",0},
    {"Lance, cheval léger"            , 300 , 7  ,"1-6","1-8",0},
    {"Lance, cheval lourd"            , 420 , 8  ,"3-9","3-18",0},
    {"Lance, cheval moyen"            , 360 , 6  ,"2-7","2-12",0}, /* 40 */
    {"Lance de fantassin 1m50"        , 150 , 6  ,"1-6","1-8",0},
    {"Lance de fantassin 3m90"        , 390 , 8  ,"1-6","1-8",0},
    {"Marteau de guerre"              ,  45 , 4  ,"2-5","1-4",0},
    {"Marteau de Lucerne"             , 150 , 9  ,"2-8","1-6",0},
    {"Masse d'armes, cavalier"        ,  45 , 6  ,"1-6","1-4",0},
    {"Masse d'armes, fantassin"       ,  75 , 7  ,"2-7","1-6",0},
    {"Massue"                         ,  90 , 4  ,"1-6","1-3",0},
    {"Pertuisane"                     , 210 , 9  ,"1-6","2-7",0},
    {"Pique"                          , 540 , 13 ,"1-6","1-12",0},
    {"Sarbacane"                      , 0   , 0  ,"0-1","0-1",0},/* 50 */
    {"Serpe Guisarme"                 , 245 , 10 ,"2-8","1-10",0},
    {"Trident 1m20"                   , 120 , 6  ,"2-7","3-12",0},
    {"Trident 2m45"                   , 245 , 8  ,"2-7","3-12",0}, /* 53 */
    {"Voulge"                         , 245 , 10 ,"2-8","2-8",0}   /* fin liste ADD1 : 52 +1 entrées */
};

struct_armure armures[MAX_ARMURE]=
{
    {"Armure complète",1,1},
    {"Armure de bataille",2,2},
    {"Armure de plates",3,3},
    {"Armure feuilleté",4,4},
    {"Harnois",4,4},
    {"Armure à bandes",4,4},
    {"Ar. plates bronze",4,4},
    {"Cotte de mailles",5,5},
    {"Brigantine",6,6},
    {"Cuirasse",6,6},
    {"Lorica",6,6},
    {"Armure d'écailles",6,6},
    {"Ar. de cuir cloutée",7,7},
    {"Armure annelée",7,7},
    {"Broigne",7,7},
    {"Armure de cuir",8,8},
    {"Hoqueton",8,8},
    {"Armure matelassée",8,8},
    {"Aucune",10,10},
    {"Bracelets CA 9",9,9},
    {"Bracelets CA 8",8,8},
    {"Bracelets CA 7",7,7},
    {"Bracelets CA 6",6,6},
    {"Bracelets CA 5",5,5},
    {"Bracelets CA 4",4,4},
    {"Bracelets CA 3",3,3},
    {"Bracelets CA 2",2,2},
    {"Bracelets CA 1",1,1},
    {"Bracelets CA 0",0,0}
};


signed short fac_vol_caract[11][8]={
                          {-15,-10,-10,-20,-10,  0,  0,  0},
                          {-10, -5,-10,-15, -5,  0,  0,  0},
                          { -5,  0, -5,-10,  0,  0,  0,  0},
                          {  0,  0,  0, -5,  0,  0,  0,  0},
                          {  0,  0,  0,  0,  0,  0,  0,  0},
                          {  0,  0,  0,  0,  0,  0,  0,  0},
                          {  0,  0,  0,  0,  0,  0,  0,  0},
                          {  0, +5,  0,  0,  0,  0,  0,  0},
                          { +5,+10,  0, +5, +5,  0,  0,  0},
                          {+10,+15, +5,+10,+10,  0,  0,  0},
                          {+15,+20,+10,+15,+15,  0,  0,  0}
                         };

gchar * nom_fac_vol[]={"pickpoket","crochetage","reperage","dpl_sil","dis_ombre","ecoute_porte","escalade","lecture"};
gchar * nom_fac_voleur[]={
    "Pickpocket",
    "Crochetage\ndes serrures",
    "Repérage\ndésamorçage pièges",
    "Déplacement\nsilencieux",
    "Dissimulation\ndans l'ombre",
    "Écoute\naux portes",
    "Escalade",
    "Lecture\ndes languages"};


gchar tabl_constit[25][5][8]=
{
        {"-3","25%","30%","-2",""},
        {"-2","30%","35%","-1",""},
        {"-2","35%","40%","",""},
        {"-1","40%","45%","",""},
        {"-1","45%","50%","",""},
        {"-1","50%","55%","",""},
        {"","55%","60%","",""},
        {"","60%","65%","",""},
        {"","65%","70%","",""},
        {"","70%","75%","",""},
        {"","75%","80%","",""},
        {"","80%","85%","",""},
        {"","85%","90%","",""},
        {"","88%","92%","",""},
        {"+1","90%","94%","",""},
        {"+2","95%","96%","",""},
        {"+2(+3)","97%","98%","",""},
        {"+2(+4)","99%","100%","",""},
        {"+2(+5)","99%","100%","+1",""},
        {"+2(+5)","99%","100%","+1","1/6T"},
        {"+2(+6)","99%","100%","+2","1/5T"},
        {"+2(+6)","99%","100%","+2","1/4T"},
        {"+2(+6)","99%","100%","+3","1/3T"},
        {"+2(+7)","99%","100%","+3","1/2T"},
        {"+2(+7)","100%","100%","+4","1/1T"}
};

gchar tabl_inte2[25][5][8]=
{

        {"0","","","",""}, /* 1*/
        {"1","","","",""},
        {"1","","","",""},
        {"1","","","",""},
        {"1","","","",""}, /* 5 */
        {"1","","","",""},
        {"1","","","",""},
        {"1","","","",""},
        {"2","4","35%","6",""},
        {"2","5","40%","7",""}, /* 10 */
        {"2","5","45%","7",""},
        {"3","6","50%","7",""},
        {"3","6","55%","9",""},
        {"4","7","60%","9",""},
        {"4","7","65%","11",""}, /* 15 */
        {"5","8","70%","11",""},
        {"6","8","75%","14",""},
        {"7","9","85%","18",""},
        {"8","9","95%","Tous","Illu 1"},
        {"9","9","96%","Tous","Illu 2"}, /* 20 */
        {"10","9","97%","Tous","Illu 3"},
        {"11","9","98%","Tous","Illu 4"},
        {"12","9","99%","Tous","Illu 5"},
        {"15","9","100%","Tous","Illu 6"},
        {"20","9","100%","Tous","Illu 7"} /* 25 */
};

gchar tabl_inte1[25][5][8]=
{

        {"0","","","",""}, /* 1*/
        {"0","","","",""},
        {"0","","","",""},
        {"0","","","",""},
        {"0","","","",""}, /* 5 */
        {"0","","","",""},
        {"0","","","",""},
        {"1","","","",""},
        {"1","4","35%","6","4"},
        {"2","5","45%","7","5"}, /* 10 */
        {"2","5","45%","7","5"},
        {"3","6","45%","7","5"},
        {"3","6","55%","9","6"},
        {"4","7","55%","9","6"},
        {"4","7","65%","11","7"}, /* 15 */
        {"5","8","65%","11","7"},
        {"6","8","75%","14","8"},
        {"7","9","85%","18","9"},
        {"8","9","95%","Tous","10"},
        {"9","9","95%","Tous","10"}, /* 20 */
        {"10","9","95%","Tous","10"},
        {"11","9","95%","Tous","10"},
        {"12","9","95%","Tous","10"},
        {"15","9","95%","Tous","10"},
        {"20","9","95%","Tous","10"} /* 25 */
};

gchar tabl_sagesse[25][10][16]=
{

        {"-6","","","","","","","","80%",""},
        {"-4","","","","","","","","60%",""},
        {"-3","","","","","","","","50%",""},
        {"-2","","","","","","","","45%",""},
        {"-1","","","","","","","","40%",""},
        {"-1","","","","","","","","35%",""},
        {"-1","","","","","","","","30%",""},
        {"0","","","","","","","","25%",""},
        {"0","0","0","0","0","0","0","0","20%",""},
        {"0","0","0","0","0","0","0","0","15%",""},
        {"0","0","0","0","0","0","0","0","10%",""},
        {"0","0","0","0","0","0","0","0","5%",""},
        {"0","1","0","0","0","0","0","0","0%",""},
        {"0","2","0","0","0","0","0","0","0%",""},
        {"+1","2","1","0","0","0","0","0","0%",""},
        {"+2","2","2","0","0","0","0","0","0%",""},
        {"+3","2","2","1","0","0","0","0","0%",""},
        {"+4","2","2","1","1","0","0","0","0%",""},
        {"+4","3","2","1","2","0","0","0","0%","1"},
        {"+4","3","3","1","3","0","0","0","0%","1+2"},
        {"+4","3","3","2","3","1","0","0","0%","1+2+3"},
        {"+4","3","3","2","4","2","0","0","0%","1+2+3+4"},
        {"+4","3","3","2","4","4","0","0","0%","1+2+3+4+5"},
        {"+4","3","3","2","4","4","2","0","0%","1+2+3+4+5+6"},
        {"+4","3","3","2","4","4","3","1","0%","1+2+3+4+5+6+7"}
};
char * ecole_mag[]={"Abjuration",
                    "Altération",
                    "Conjuration",
                    "Enchantement/charme",
                    "Divination majeure",
                    "Eau élémentaire",
                    "Feu élémentaire",
                    "Illusion",
                    "Invocation/évocation",
                    "Entropique",
                    "Terre élémentaire",
                    "Nécromancie"
                   };

struct_sortileges sortileges_mag[NB_SORT_MAG]={
    {"Agrandissement",1,"5 p/niv","V,S,M","5R/niv","1","1 créature","Annule","pincée de limaille de fer",2},
    {"Alarme",1,"10 m","V,S,M","4 heures + 1/2 heure/niveau","1 round","cube de 6 m d'arête maxi","Aucun","une petite clochette et un morceau de très beau fil d'argent",257},
    {"Altération des Feux Naturels",1,"5 p/niv","V,S","2R/niv","1","R=10P","Aucun","",66},
    {"Amis",1,"0","V,S,M","1 D4R+ 1 /n","1","R=60P","spécial","craie(ou farine), du noir de fumée(ou de la suie) et du vermillon",8},
    {"Approximation hasardeuse",1,"300 m","V","instantanée","2DI2 h","gr ou cl d'obj","aucun","",4624},
    {"Armure",1,"toucher","V,S,M","spéciale","1","1 créature","Aucun","morceau de cuir finement tanné béni par un prêtre",4},
    {"Aura magique de Nystul",1,"toucher","V,S,M","l jour/niv","1","spéciale","Spécial","petit carré de soie",128},
    {"Bouclier",1,"0","V,S","5R/niv","1","Spéciale","Aucun","",256},
    {"Changement d'apparence",1,"0","V,S","2D6R+2%","1","lanceur du sort","Aucun","",128},
    {"Charme personne",1,"120p","V,S","Spéciale","1","1 personne","Annule","",8},
    {"Chute de plume",1,"10 p/niv","V","1 R/niv","1","spéciale","Aucun","",2},
    {"Compréhension des Langages",1,"Toucher","V,S,M","5R/niv","IR","1 créat parl, obj écrit","Aucun","pincée de suie, quelques grains de sels",2},
    {"Démêlage",1,"10 m","V,S,M","1 round","3","cube 3m","spécial","une loupe de poche",4624},
    {"Détection de la Magie",1,"0","V,S","2RAùv","1","spéciale","Aucun","",16},
    {"Détection des morts-vivants",1,"0","V,S,M","3 tours","1 round","3 m x (18 m + 3 m/niveau)","Aucun","une motte de terre provenant d'une tombe",2064},
    {"Disque flottant de Tenser",1,"20p","V,S,M","3T+I/iv","1","spéciale","Aucun","une goutte de mercure",256},
    {"Effacement",1,"30P","V,S","permanent","1","1 scroll (ou 2 pages","Spécial","",2},
    {"Familier",1,"1/31ieu/niv","V,S,M","spéciale","2DI2 h","créat touchée","Spécial","herbe pour 1000po dans un feu",4},
    {"(Blocage de passage) Fermeture",1,"30p/niv","V","1 R/niv","1","2OP2/niv","Aucun","",2},
    {"Force fantasmagorique",1,"60p+10/dv","V,S,M","spéciale","1","40OPx+100àl","Spécial","un morceau de toison de mouton",128},
    {"Glisse",1,"10 m","V,S,M","3 rounds + 1 round/niveau","1 R","3 m x 3 m","Spécial","un morceau de saindoux ou de beurre",4},
    {"Hantise",1,"10 m","V,S","spéciale","1 R","1 créature","Annule","---",128},
    {"Hypnotisme",1,"5 m","V,S","spéciale","1 R","cube de 9 m d'arête","Annule","---",8},
    {"Identification",1,"0","V,S,M","1R/niv","Spécial","1obj/niv","Aucun","perle (100po) et une plume de hibou",16},
    {"Lecture de la Magie",1,"0","V,S,M","2R/niv","1","spéciale","Aucun","cristal pur ou prisme minéral",16},
    {"Lumière",1,"60p","V,M","1 T/niv","1","R=20P","Spécial","luciole ou morceau de mousse phosphorescente",2},
    {"Lumières Dansantes",1,"40p+ 1 0/niv","V,S,M","2R/niv","1","spéciale","Aucun","morceau de phosphore ou un ver luisant",2},
    {"Main Brûlante",1,"0","V,S,M","Instantanée","1","lanceur de sort","1/2","",2},
    {"Marque de Magicien (Signature Magique)",1,"toucher","V,S,M","permanente","1","IP2","Aucun","poudre de diamant (100 po) + pigment pour la couleur",2},
    {"Message",1,"0","V,S,M","5R/niv","1","spéciale","Aucun","morceau de cuivre fin",2},
    {"Mur de brouillard",1,"30 m","V,S,M","2d4 rounds + 1 round/niveau","1 R","Cube de 6 m d'arête + 3 m/niveau","Aucun","une poignée de pois cassés",256},
    {"Monture",1,"IOP","V,S,M","2H+ 1 /niv","IT","1 monture","Aucun","touffe de poils de l'animal conjuré",4},
    {"Orbe chromatique",1,"","V,S,M","","","","","",0},
    {"Patte d’araignée",1,"toucher","V,S,M","3R+I/niv","1","Créat touchée","Annule","une goutte de goudron et une araignée vivante",2},
    {"Poigne Électrique",1,"toucher","V,S","spéciale","1","(Créat touchée","Aucun","",2},
    {"Préservation",1,"Toucher","?","1 jour","1","1 créature ou 1 objet, maximum taille humaine","?","---",2},
    {"Protection contre le Mal",1,"toucher","V,S,M","2R/niv","1","Créat touchée","Aucun","poudre d'argent",1},
    {"Projectile Magique",1,"60p+10/niv","V,S","instantanée","1","1 créature/2niv","Aucun","",256},
    {"Rafistolage (Réparation)",1,"30p","V,S,M","permanente","1","1 objet","Aucun","petits aimants ou 2 copeaux métalliques",2},
    {"Réflexion du regard",1,"0","V,S","2R+ 1 /niv","1","spéciale","Aucun","",2},
    {"Rumeur Illusoire",1,"60p+ 1 0/niv","V,S,M","3R/niv","1","portée d'ouïe","Spécial","un brin de laine ou un morceau de cire",128},
    {"Rupture hasardeuse",1,"","V,S","","5R","","","",4864},
    {"Sarcasme (moquerie)",1,"60 m","V,S,M","1 round","1","Rayon de 9 m","Annule","une limace",8},
    {"Saut",1,"toucher","V,S,M","1D3+1 R/niv","1","Créat touchée","Aucun","patte arrière de sauterelle",2},
    {"Serviteur Invisible",1,"0","V,S,M","1 H+ 1 T/niv","1","R=30P","Aucun","un bout de ficelle ou un morceau de bois",4},
    {"Sommeil",1,"30 p","V,S,M","5R/niv","1","spéciale","Aucun","pincée de sable fin, des pétales de roses ou un grillon",8},
    {"Toucher glacial",1,"0","V,S","3 rounds + 1 round/niveau","1","le lanceur du sort","Annule","---",2048},
    {"Tour mineur",1,"10P","V,S","1 h/niv","1","spéciale","Aucun","",1535},
    {"Vaporisation Colorée",1,"0","V,S,M","instantanée","1","5'x2O'x2O'éventail","Spécial","3 poncées de poudre ou de sable coloré (rouge jaune et bleu)",2},
    {"Ventriloquie",1,"10 p/niv<90","V,M","4R+ 1 /niv","1","1 créat ou 1 objet","Spécial","un parchemin roulé en petit cône",128},
    {"Annulateur insensé de Yadouk",2,"toucher","V,S,M","1d6R+1R/niv","2","créature touchée","aucun","petite quantité de jaune d’œuf",4609},
    {"Apparence Altérée",2,"0","V,S","3D4R+2/niv","2","lanceur de sort","Aucun","",2},
    {"Bouche Magique",2,"10p","V,S,M","spéciale","2","1 obj","Aucun","alvéole de ruche",2},
    {"Bouclier du chaos",2,"0","V,S","1d10R+2R/niv","2","le lanceur","spécial","",513},
    {"Cécité",2,"30 m + 10 m/niveau","V","permanente","2","1 créature","Annule","---",128},
    {"Conjuration d'Essaim",2,"60p","V,S,M","spéciale","2","10P,","Annule","un carré de tissus rouge",4},
    {"Connaissance des alignements",2,"10 m","V,S","1 round/niveau","1 R","1 créature ou 1 objet/2 rounds","Annule","---",16},
    {"Corde Enchantée",2,"toucher","V,S,M","2T/niv","2","spéciale","Aucun","extrait de maïs en poudre et un morceau de parchemin roulé",2},
    {"Déblocage",2,"60p","v","spéciale","1","10 P,/niv","Spéciale","",2},
    {"Détecteur Funeste de Kalnégarek",2,"toucher","V,S,M","2R/niv","2","une créature","aucun","un petit prisme",4864},
    {"Détection de l'invisible",2,"10 p/niv","V,S,M","5 R/niv","2","10P de large","Aucun","une pincée de talc et de poudre d'argent",16},
    {"Détection du mal",2,"60 pas","V,S","5R/niv","2","Passage 10 pieds de large","Aucun","",16},
    {"Détection faussée",2,"30 m","V,S","8 heures","2","1 créature ou 1 objet","Annule","---",128},
    {"Écriture Oublieuse de Yaduck",2,"","","","","","","",0},
    {"E.S.P.",2,"5p/niv","V,S,M","1 R/niv","2","1 créature","Aucun","une pièce de cuivre",16},
    {"Flèche acide de Melf",2,"180 m","V,S,M","spéciale","2","1 cible","Spéciale","une fléchette, une feuille de rhubarbe en poudre et un estomac de vipère",4},
    {"Flou",2,"0","V,S,M","3R+/niv","2","lanceur de sort","Aucun","",128},
    {"Force",2,"toucher","V,S,M","1 H/niv","1T","Personne touchée","Aucun","une touffe de poil ou d'excrément d'un animal particulièrement fort ",2},
    {"Force Fantasmagorique Majeure",2,"60p+ 1 0/niv","V,S,M","spéciale","2","200P²+50/niv","Spécial","un morceau de toison de mouton",128},
    {"Fracassement",2,"30P+10/niv","V,S,M","instantanée","2","R=3P","Aucun","un éclat de mica",2},
    {"Image Miroir",2,"0","V,S","3 R/niv","2","R=6P","Aucun","",128},
    {"Invisibilité",2,"Toucher","V,S,M","spéciale","2","créature touchée","Aucun","un cil et un morceau de gomme arabique",128},
    {"Irrésistible Rire de Tasha",2,"60p","V,S,M","3 T+ 1 /niv","2","1 créat ou + 30P3","Annule","une petite plume et de minuscules tartes à la crème",8},
    {"Irritation",2,"10p/niv","V,S,M","spéciale","2","l à 4 créat R=15P","Annule","une feuille de sumac vénéneux ou de chêne",2},
    {"Lévitation",2,"20p/niv","V,S,M","1 T/niv","2","1 créat ou objet","Annule","petite boule de cuir ou un morceau de fils d'or",2},
    {"Lien",2,"30p","V,S,M","1 R/niv","2","spéciale","Aucun","",8},
    {"Localisation des Objets",2,"20p/niv","V,S,M","1 R/niv","2","spéciale","Annule","brindille fourchue",16},
    {"Lumière Éternelle",2,"60P","V, S","permanente","2","R=60P","Spécial","",2},
    {"Motif Hypnotique",2,"30P","V, S","spéciale","2","1  adversaire","Aucun","baton d'encens allumé ou batonnet de cristal rempli de matière phosphorescente",128},
    {"Nuage de Brouillard",2,"10P","V,S","4R+I/niv","2","spéciale","Aucun","",2},
    {"Nuage Puant",2,"30p","V,S,M","1 R/niv","2","20PI","Spécial","un œuf pourri",256},
    {"Or des Fous",2,"10p","V,S,M","1 H/niv","1R","10 pouce3/niv","Spécial","Spécial",130},
    {"Oubli",2,"30p","V,S","permanente","2","2OP3","Annule","",8},
    {"Peur",2,"30 m + 10 m/niveau","V,S,M","1d4 rounds + 1 round/niveau","2","rayon de 4,5 m","Spécial","un morceau d'os de squelette, zombie, goule, ghast ou momie",8},
    {"Piège de Léomund",2,"Toucher","V,S,M","permanente","2","30PI/niv","Aucun","morceau de pyrite de fer",128},
    {"Poches Profondes",2,"Toucher","V,S,M","12h+ 1 /niv","1T","1 vêtement","Aucun","une petite aiguille d'or et une bande belle étoffe",136},
    {"Poussière Scintillante",2,"10p/niv","V,S,M","1 D4R+ 1 /n","2","(.20 P)l","Spécial","un morceau de mica",4},
    {"Protection contre les tours mineurs",2,"toucher","V,S","5 heures + 1 heure/niveau","1 R","créature ou objet touché","Aucun","---",1},
    {"Pyrotechnie",2,"120p","V,S,M","spéciale","2","1 source de feu","Aucun","un feu",2},
    {"Rayon d'Affaiblissement",2,"10p+5/niv","V,S","1 R/niv","2","1 créature","Annule","",8},
    {"Sphère Enflammée",2,"10P","V,S,M","1 R/niv","2","R-3P","Annule","un peu de suif, de souffre et de limaille de fer",256},
    {"Surdité",2,"60 m","V,S,M","spéciale","2","1 créature","Annule","un peu de cire d'abeille",128},
    {"Ténèbres sur 5 mètres",2,"10p/niv","V,S,M","1 T+ 1 R/niv","2","R=ISP","Aucun","morceau fourrure de chauve souris et goutte de poix ou morceau de charbon",2},
    {"Toile d'Araignée",2,"5p/niv","V,S,M","2T/niv","2","spéciale","Annule 1/2","morceau de toile d'araignée",256},
    {"Vent de murmure",2,"1/31ieue/niv","V,S","spéciale","1","R=2P","Aucun","",130},
    {"Verrou magique (de Magicien)",2,"Toucher","V, S","permanent","2","30PI/niv","Aucun","",2},
    {"Analyse Fondamentale d'Alamir",3,"Toucher","V,S,M","spéciale","1R","un objet","spécial","baguette chêne centenaire",4112},
    {"Boule de Feu",3,"","V,S,M","instantanée","3","R=20P","½","une boule de guano de chauve souris",256},
    {"Cabane de Léomund",3,"0","V,S,M","4H+I/niv","3","R--15P","Aucun","une petite perle de cristal",2},
    {"Calligraphie Illusoire",3,"Toucher","V,S,M","1 jour/niv","spécial","créat","spécial","une encre à base de plomb (300po)",128},
    {"Clairvoyance",3,"spéciale","V,S,M","1 R/niv","3","spéciale","Aucun","une pincée de glande pinéale réduite en cendre",16},
    {"Clairaudiance",3,"spéciale","V,S,M","1 R/niv","3","spéciale","Aucun","une petite corne (100po)",16},
    {"Clignotement",3,"0","v","1 R/niv","1","lanceur","Aucun","",2},
    {"Conjuration Monstre 1",3,"302","v.S M","2R+ 1 /niv","3","spéciale","Aucun","petit sac+ petite chandelle",4},
    {"Dissipation de la magie",3,"120 m","V,S","instantanée","3","cube de 9 m d'arête","Aucun","---",1},
    {"Éclair",3,"40p+ 1 0/niv","V.S.M","Instantanée","3","spéciale","½","un morceau de fourrure + batonet ambre, cristal ou verre",256},
    {"Flèche de Feu",3,"30p+]O/niv","V,S,M","IR","3","spéciale","Aucun","Huile + morceau de silex",4},
    {"Flux de Feu",3,"30 m","V,S,M","1R/niv","3","une source de feu","aucun","un petit pinceau et un pot de poix",4610},
    {"Force Spectrale",3,"0","V,S","spéciale","3","(40p/niv)l","Spéciale","",128},
    {"Forme Ectoplasmique",3,"0","S'M","2R/niv","1","le lanceur","Aucun","un morceau de gaze et une volute de fumée",130},
    {"Hâte",3,"60p","V,S,M","3R+I/niv","3","1 créat/niv","Aucun","pelure de racine de réglisse",2},
    {"Immobilisation des morts-vivants",3,"18 m","V,S,M","1d4 rounds + 1 round/niveau","5","1d3 morts-vivants","Annule","une pincée de soufre et de l'ail réduit en poudre",2048},
    {"Immobilisation des personnes",3,"120p","V,S,M","2R/niv","3","1 à 4 pers","Annule","petit morceau de fer droit",8},
    {"lnfravision",3,"Toucher","V,S,M","2h+l/niv","IR","créat touchée","Aucun","une pincée de carotte séchée ou une agate",2},
    {"Invisibilité sur 3 mètres",3,"Toucher","V,S,M","spéciale","3","R=10P","Aucun","un cil et un morceau de gomme arabique",128},
    {"Langues",3,"0","V, M","1 R/niv","3","R=30P","Aucun","zigourat en argile",2},
    {"Langues des Fous",3,"toucher","V,S,M","1h/niv","1T","mage+1créat/niv","aucun","un petit sifflet en os",4610},
    {"Lenteur",3,"90p+ 10/niv","V,S,M","3 R+ 1 /niv","3","(40')', 1 créat/niv","Annule","une goutte de mélasse",2},
    {"Minuscule Météore de Melf",3,"70p+ 10/niv","V,S,M","spéciale","3","spéciale","Aucun","salpêtre et souffre",258},
    {"Monture Fantôme",3,"Toucher","V,S","1 H/niv","IT","spéciale","Aucun","",132},
    {"Mort Simulée",3,"Toucher","V,S","1 H+ 1 T/niv","1","créat touchée","Aucun","",2048},
    {"Mur de Vent",3,"","V,S,M","1 R/niv","3","(10'lx5'h)/niv","Spéciale","un petit ventail et une plume d'origine exotique",2},
    {"Non Détection",3,"Toucher","V,S,M","1 H+ 1 /niv","3","1 créat ou obj","Aucun","une pincée de poudre de diamant (300 po)",1},
    {"Objet",3,"Toucher","V,S","4h/niv","3","(2P)3 /niv","Spéciale","",2},
    {"Page secrète",3,"Toucher","V,S,M"," dissipation","IT","1 page 2P2","Aucun","écailles de hareng en poudre et de l'essence de feufollet ou de boggart",2},
    {"Protection contre le mal sur 3 m",3,"Toucher","V,S,M","2R/niv","3","R=10P","Aucun","poudre d'ag/limaille de fer",1},
    {"Protec. contre les projectiles normaux",3,"Toucher-","V,S,M","1 T/niv","3","créat touchée","Aucun","un morceau de carapace de tortue",1},
    {"Rafale de Vent",3,"0","V,S,M","Instantanée ","3","10pxl0P/niv","Aucun","une graine de légume",2},
    {"Réalité Alternative",3,"0","V,S,M","instantanée","3","créat touchée","aucun","un petit dé sans marquage",4610},
    {"Respiration Aquatique",3,"Toucher","V, S, M","ID4H+I/niv","3","créat touchée","Aucun","petit morceau de roseau ou bout de paille",2},
    {"Runes Explosives",3,"Toucher","V,S","spéciale","3","R=10P","Aucun","",2},
    {"Sceau du Serpent de Sépia",3,"5p","V,S,M","spéciale","3","1 sceau","Aucun","??",4},
    {"Suggestion",3,"30P","V, M","spéciale","1","1 créature","Annule","une langue de serpent et un peu de cire d'abeille ou huile douce,",8},
    {"Toucher Vampirique",3,"0","V,S","un toucher","3","le lanceur","Aucun","",2048},
    {"Tromperie (Alignement d'emprunt)",3,"0","V,S","1 tour/niveau","3","le lanceur du sort","","---",2},
    {"Vol",3,"toucher","V,S,M","1 D6T+ 1 /niv","3","1 créature","Aucun","une plume d'aile",2},
    {"Abri sûr de Léomund",4,"20p","V,S,M","ID4H+1+1/n","4T","30P3/niv","Aucun","un éclat de pierre carré, de la chaux écrasée, quelques grains de sable, de l'eau et du bois,",10},
    {"Affaiblissement (Énervation)",4,"10 m/niveau","V,S","1d4 heures + 1 heure/niveau","4","1 créature","Annule","---",2048},
    {"Arme enchantée",4,"toucher","V,S,M","5 R/niv","IT","Arme(s) touchée(s)","Aucun","chaux en poudre et carbone",8},
    {"(Tueur) Assassin Fantasmatique",4,"5p/niv","V,S","1 R/niv","4","1 créature","Spéciale","",128},
    {"Bouclier de Feu",4,"0","V,S,M","2R+ 1 /niv","4","lanceur","Aucun","un peu de phosphore/une luciole ou un ver luisant vivant ou la queue de 4 de ces animaux morts",258},
    {"Brouillard Dense",4,"30P","V,S","spéciale","4","20'x2O'x 10'/niv","Aucun","poudre de pois cassés + poudre sabot animal",2},
    {"Charme de Feu",4,"10P","V,S,M","2R/niv","4","feu : R=15P","Annule","un petit morceau de soie multicolore",8},
    {"Charme Monstre",4,"60p","V,S","spéciale","4","R 20P","Annule","",8},
    {"Confusion",4,"120p","V,S,M","2R+ 1 /niv","4","(60P)3","spéciale","3 coquilles de noix",8},
    {"Contagion",4,"30p","V,S","Permanent","4","1 créature","Annule","",2048},
    {"Création Mineure",4,"toucher","V,S,M","1 h/niv","IT","Spéciale","Aucun","un petit morceau ce l'objet à créer",128},
    {"Cri",4,"0","V, M","Instantanée","1","Cône l0Px30P","Spéciale","",0},
    {"Croissance Végétale",4,"10p/niv","V,S","Permanent","4","(10'/niv)'","Aucun","",2},
    {"Délivrance de la malédiction",4,"toucher","V,S","Permanent","4","spéciale","spéciale","",1},
    {"Détection de la scrutation",4,"0","V,S,M","1 d6T+ 1 /niv","3","R=120P","Spéciale","petit morceau de miroir et un petit cornet acoustique en laiton",16},
    {"Excavation",4,"30P","V,S,M","1 R/niv","4","(5'/niv)3","spéciale","une petite pelle et un seau miniature",256},
    {"Extension 1",4,"0","V","spéciale","2","spéciale","spéciale","",2},
    {"Globe Mineur d'invulnérabilité",4,"0","V,S,M","1 R/niv","4","(30P)3","spéciale","une perle de verre ou de cristal",1},
    {"Invisibilité Majeure (Renforcée)",4,"Toucher","V,S","4R+ 1 /niv","4","Créature touchée","Aucun","",128},
    {"Conjuration Monstre Il",4,"40p","V,S,M","3R+I/niv","4","spéciale","Aucun","un petit sac et une fine chandelle",4},
    {"Là/Pas Là",4,"30m","V,S,M","1-6T","1R","cube3m","aucun","un morceau de fourrure de cha dans une petite boite",4864},
    {"Maladresse",4,"10p/niv","V,S,M","1 R/niv","4","(30P)3","spéciale","lait caillé",8},
    {"Malchance",4,"10m","V,S,M","2d10R","4","une créature","annule","morceau de miroir brisé",768},
    {"Malédiction",4,"","","","","","","",0},
    {"(Auto)Métamorphose",4,"0","V","2T/niv","4","lanceur","Aucun","",2},
    {"Métamorphose d'autrui",4,"5 m/niveau","V,S,M","permanente","4","1 créature","Annule","un cocon de chenille",2},
    {"Miroir magique",4,"toucher","V,S,M","1 round/niveau","1 heure","spéciale","","Au",24},
    {"Monstre d'ombre",4,"30p","V,S","-1 R/niv","4","(20P)3","Spécial","",128},
    {"Motif Arc en Ciel",4,"10P","S,M","Spécial","4","(30P)3","Annule","prisme de cristal + un peu de phosphore",130},
    {"Moyen Mnémonique de Rary",4,"0","V,S,M","1 jour","IT","lanceur","Aucun","un bout de ficelle, une plaque d'ivoire (100po) et de l'encre formée d'une part de sécrétion de calamar géant et d'autre part soit de sang de dragon noir, soit de liquide digestif de limace géante,",2},
    {"Mur de Feu",4,"60p","V,S,M","spéciale","4","spéciale","Aucun","du phosphore",256},
    {"Mur de glace",4,"10 m/niveau","V,S,M","1 tour/niveau","4","spéciale","Aucun","un petit morceau de quartz ou de roche cristalline",256},
    {"Mur Illusoire",4,"30P","V,S","Permanent","4","l'x 10'x 10'","Aucun","poudre très rare (400po) + 4 jours de préparation",128},
    {"Œil de Magicien",4,"0","V,S,M","1 R/niv","IT","spéciale","Aucun","une touffe de fourrure de chauve souris",2},
    {"Peau de pierre",4,"Toucher","V,S,M","Spéciale","1","1 créature","Aucun","poudre de granit et de diamant",2},
    {"Piège de feu",4,"Toucher","V,S,M"," décharge","IT","objet touché","½","souffre ou salpètre",257},
    {"Porte Dimensionnelle",4,"0","v","Instantanée","1","lanceur","Aucun","",2},
    {"Renvoi de sorts mineur",4,"0","V,S,M","3R/niv","4","le mage","aucun","1 pa polie",1},
    {"Sphère résistante d'Otiluke",4,"20 m","V,S,M","1 round/niveau","4","30 cm de diamètre/niveau","","un morceau hémisphérique de diamant et un de gomme arabique",258},
    {"Tempête de Glace",4,"10p/niv","V,S,M","spéciale","4","spéciale","Aucun","une pincée de poussière et quelques gouttes d'eau",256},
    {"Terrain Hallucinatoire",4,"20p/niv","V,S,M","1 H/niv","IT","(30'/niv)l","Aucun","une pierre, une brindille et un morceau de plante verte",128},
    {"Terreur",4,"0","V,S,M","spéciale","4","cône","Annule","un cœur de poule ou une plume blanche",128},
    {"Transformation de Masse",4,"10p/niv","V,S,M","spéciale","4","(10P/niv)2","Aucun","poignée d'écorce du type d'arbre",2},
    {"Vacuité",4,"10p/niv","V,S,M","1 H/niv","4","R= 10P/niv","Aucun","un carreau de la plus fine des soies noires (100po)",130},
    {"Animation des Morts",5,"","V,S,M","permanent","5R","spéciale","Aucun","une goutte de sang et une pincée de poudre d'os ou un éclat d'os",2048},
    {"Bulle d'air",5,"0","V,S,M","IT/niv","5","R=I0P","Aucun","une poignée de sels alcalins ou bromés",2},
    {"Chaos",5,"5p/ni,","V,S,M","1 R/niv","5","(40P)'-","Spéciale","un petit disque de bronze et une petite baguette de fer",8},
    {"Coffre secret de Léomund",5,"spéciale","V,M,S","60 jours","1 T","1 coffre","Aucun","le coffre (5000po)",6},
    {"Cône de Froid",5,"0","V,S,M","instantané","5","spéciale","½","minuscule cône de cristal ou de verre",256},
    {"Conjuration d'un Élémentaire",5,"60p","V,S,M","spéciale","1 T","spéciale","Aucun","encens/eau et sable/soufre et phosphore/argile douce",4},
    {"Conjuration Monstre III",5,"50p","V,S,M","4R+ 1 /niv","5","spécial","Aucun","un petit sac et une fine chandelle",4},
    {"Conjuration d'un Monstre d'Ombre",5,"10p","V,S,M","1R+1/niv","5","(j op)3","Aucun","un morceau de quartz fumé",4},
    {"Congédiement (renvoi)",5,"10 m","?","permanente","1 round","1 créature","?","spécial",1},
    {"Contact autre Plan",5,"0","V","spéciale","1T","spéciale","aucun","",16},
    {"Création majeure",5,"10 m","V,S,M","spéciale","1 tour","spéciale","Aucun","un morceau de la matière à créer",128},
    {"Croissance Animale",5,"60p","V,S,M","1 R/niv","5","8 anim (20P)3","Aucun","une pincée de poudre d'os",2},
    {"Débilité mentale",5,"10p/niv","V,S,M","permanent","5","1 créature","Annule","une poignée d'argile, de cristal, de verre ou de sphère minérale",8},
    {"Discussion oiseuse de Léomund",5,"10 m","V","spéciale","5","1 créature ou plus, dans un rayon de 3 m","Spécial","---",264},
    {"Distorsion des Distances",5,"10p/niv","V,S,M","2T/niv","5","1/niv","Aucun","une boulette d'argile douce",2},
    {"Domination",5,"10p/niv","V,S","spéciale","5","1 personne","Annule","",8},
    {"Envoi",5,"spéciale","V,S,M","spéciale","1 tour","1 créature","Aucun","deux petits cylindres reliés par un court fil de cuivre",256},
    {"Évitement",5,"10p","V,S,M","+dissipation","5","(3P)3","Spéciale","une aiguille aimantée",3},
    {"Extension Il",5,"0","V","spécial","4","spéciale","Aucun","",2},
    {"Fabrication",5,"5p/niv","V,S,M","Permanent","spéciale","spéciale","Aucun","matériaux utiles",10},
    {"Façonnage de la Pierre",5,"Toucher","V,S,M","Permanent","1 R","(1P)3/niv","Aucun","un peu d'argile",2},
    {"Faux-semblant",5,"Rayon de 3 m","V,S","12 heures","5","1 personne/2 niveaux","Aucun","---",128},
    {"Forme Ondoyante",5,"40 m","S,M","1d10R","5","cube 3m/niveau","½","petite rame scultée décorée d'aigue-marine (500po)",4610},
    {"Illusion avancée",5,"60 m + 10 m/niveau","V,S,M","1 round/niveau","1 round","1 cube de 12 m d'arête + 1 cube/niveau de 3 m d'arête","Spécial","un peu de laine de mouton et quelques grains de sable",128},
    {"immobilité des monstres",5,"5p/niN","V,S,M","1 R/niv","5","1 à 4 créat","Annule","une barre ou bâtonnet métallique par monstre",8},
    {"Magie d'ombre",5,"50 m + 10 m/niveau","V,S","spéciale","5","spéciale","","---",128},
    {"Main d'interposition de Bigby",5,"10 m/niveau","V,S,M","1 round/niveau","5","spéciale","Aucun","un gant de matière souple",256},
    {"Molosse Fidèle de Mordenkainen",5,"10p","V,S,M","1 H+. 5/niv","5","spéciale","Aucun","un petit sifflet d'argent, un éclat d'os et un bout de fil",4},
    {"Monstres mi-ombre",5,"30 m","V,S","1 round/niveau","5","Cube de 6 m d'arête","Spécial","---",128},
    {"Mur de Fer",5,"5p/niv","V,S,M","Permanent","5","","Aucun","un petit morceau de plaque de fer",256},
    {"Mur de force",5,"30P","V,S,M","spécial","5","(10P)² /niv","Aucun","une pincée de poudre de diamant (5000 po)",256},
    {"Mur de Pierre",5,"5p/niv","V,S,M","permanent","5","spéciale","Aucun","un petit bloc de granit",256},
    {"Nuage Mortel",5,"10p","V,S","1 R/niv","5","40x20x20P","Aucun*","",256},
    {"Objet",5,"","","","","","","",0},
    {"Passe-Muraille",5,"30p","V,S,M","1 H+ 1 R/niv","5","spéciale","Aucun","une pincée de graine de sésame",2},
    {"Porte d'ombre",5,"10 m","S","1 round/niveau","2","spéciale","Aucun","---",128},
    {"Réceptacle magique",5,"10 m/niveau","V,S,M","spéciale","1 round","1 créature","Spécial","spécial",2048},
    {"Rêve",5,"toucher","V,S","spéciale","1 tour","1 créature","Aucun","---",384},
    {"Télékinésie",5,"10p/niv","V,S","spécial","5","spéciale","Annule","",2},
    {"Téléportation",5,"Toucher","V","instantané","2","spéciale","Aucun","",2},
    {"Transformation de la pierre",5,"Toucher","V,S,M","Permanent","IR","(1 P)I/niv","Aucun","",0},
    {"Transmutation de la Pierre en boue",5,"10p/niv","V,S,M","Spéciale","5","(20p)3 /niv-","Aucun","argile+eau/sable, citron doux et eau",2},
    {"Vision Fausse",5,"0","V,S,M","1 D4+ 1 R/niv","5","r=30P","Aucun","poudre émeraude (500po)",16},
    {"Vortex",5,"30m","V,S,M","1d4R+1R/niv","5R","cercle D=1,5m","1/2","banderole en soie",4864},
    {"Abaissement des eaux",6,"80pas","V,S,M","5R/niv","1T","10x10x2pniv","aucun","une petite fiole d'eau",2},
    {"Asservissement",6,"10 m","V,S,M","spéciale","1 tour","spéciale","Annule","spécial",4},
    {"Brume Mortelle (Brouillard de mort)",6,"30 pas","V,S,M","1d4R+1/niv","6","2 cubes 10p/niv","aucun","une pincée de poudre de pois cassés, de la poudre d'un sabot d'animal et un type d'acide puissant",258},
    {"Carcan (choc) Entropique",6,"30 m","V,S,M","2d4R","6","une créature","Annule","un petit tube de verre",4612},
    {"Chaîne d'Eclair",6,"40pas+5/niv","V,S,M","Instantanée","5","Spéciale","1/2","une touffe de fourrure, un morceau d'ambre et une épingle/niv",256},
    {"Conjuration d'animaux",6,"Spéciale","V,S","1 round/niveau","6","Rayon de 30 m","Aucun","---",4},
    {"Conjuration de monstres 4",6,"Spéciale","V,S,M","5 rounds + 1 round/niveau","6","Rayon de 60 m","Aucun","un petit sac et une fine chandelle",4},
    {"Connaissance des Légendes",6,"0","V,S,M","Spécial","Spécial","Spéciale","Aucun","encens, bande d'ivoire + un objet de valeur",16},
    {"Contingence",6,"0","V,S,M","1 jour/niveau","1 tour","le lanceur du sort","Aucun","spécial",256},
    {"Contrôle du Climat",6,"0","V,S,M","1T","4d6heures","9d4km","Aucun","encens, morceau de terre, de bois + eau",2},
    {"Coquille anti-magie",6,"0","V,S","1 tour/niveau","1","30 cm de diamètre/niveau","Aucun","---",1},
    {"Double illusoire",6,"10 m","S","1 round/niveau","1","spéciale","Aucun","---",128},
    {"Désintégration",6,"5pas/niv","V,S,M","Instantanée","6","Spéciale","Annule","un aimant naturel et une pincée de pousière",2},
    {"Élucubration de Mordenkainen",6,"0","V,S","Instantanée","1","le lanceur","Aucun","",2},
    {"Enchantement d'armure +2",6,"??","?","??","??","??","?","??",8},
    {"Enchantement d'un objet",6,"toucher","V,S,M","spéciale","spéciale","spéciale","Annule","spécial",264},
    {"Extension III",6,"0","V","Spécial","6","Spéciale","Aucun","",2},
    {"Garde et Défense",6,"0","V,S,M","1H/niv","3T","Spéciale","Aucun","encens, soufre, huile, une ficelle sang colosse des ombres et une petite baguette d'ag",266},
    {"Glissement de Terrain",6,"10p/niv","V,S,M","Permanent","Spécial","Spéciale","Aucun","argile, terre sable petit sac et lame de fer",2},
    {"Illusion permanente",6,"10 m/niveau","V,S,M","permanente","6","Cube de 6 m d'arête + 1 cube de 3 m d'arête/niveau","Spécial","une touffe de laine de mouton",128},
    {"Illusion programmée",6,"10 m/niveau","V,S,M","spéciale","6","Cube de 6 m d'arête + 1 cube de 3 m d'arête/niveau","Spécial","une touffe de laine de mouton",128},
    {"Magie de la demi-ombre",6,"60 m + 10 m/niveau","V,S","spéciale","6","spéciale","Spécial","---",128},
    {"Magie_ des Mirages",6,"10p/niv","V,S(,M)","Spécial","Spécial","cube 10p/niv","Aucun","",130},
    {"Main impérieuse de Bigby",6,"10 m/niveau","V,S,M","1 round/niveau","6","spéciale","Aucun","un gant",256},
    {"Mauvais oeil",6,"20 m","V,S","1 round/3 niveaux","6","1 créature","Spécial","---",136},
    {"Projection de l'image",6,"10p/niv","V,S,M","1R/niv","6","Spéciale","Aucun","poupée représentant le magicien",130},
    {"Rôdeur (chasseur) invisible",6,"10 m","V,S,M","spéciale","1 round","spéciale","Aucun","encens et un morceau de corne sculptée en croissant",4},
    {"Quête magique",6,"10 m","V","spéciale","4","1 créature","Aucun","---",8},
    {"Reflets",6,"30 m","V,S","1 round/niveau","6","Cube de 6 m d'arête","Spécial","---",128},
    {"Réincarnation",6,"toucher","V,S,M","permanente","1 tour","personne touchée","Aucun","un petit tambour et une goutte de sang",2048},
    {"Répulsion",6,"0","V,S,M","1 round/2 niveaux","6","Couloir de 3 m sur 3 m/niveau","Aucun","2 barres de fer magnétisées et 2 statuettes de chien (ébène et ivoire)",1},
    {"Sort de mort",6,"10 m/niveau","V,S,M","instantanée","6","1 cube/niveau de 10 m d'arête","Aucun","une perle noire écrasée (1000 po)",2048},
    {"Sphère glaciale d'Otiluke",6,"spéciale","V,S,M","spéciale","6","spéciale","Spécial","un diamant (1000 po)",258},
    {"Suggestion de masse",6,"30 m","V,M","4 tours + 4 tours/niveau","6","1 créature/niveau","Annule","langue de serpent, et un morceau d'alvéole de ruche ou une goutte d'huile",8},
    {"Séparation des eaux",6,"10 m/niveau","V,S,M","5 rounds/niveau","1 tour","6 m sur 90 cm/niveau sur 9 m/niveau","Aucun","deux petites plaques de cristal ou de verre",2},
    {"Transformation de Tenser",6,"0","V,S,M","1 round/niveau","6","le lanceur du sort","Aucun","une potion d'héroïsme ou de super-héroïsme",258},
    {"Transformation de la Pierre en Chair",6,"10p/niv","V,S,M","Permanent","6","1 créature","Spécial","pincée de terre, goutte de sans/citron doux, eau et terre",2},
    {"Transformation de l'Eau en Poussière",6,"60 pas","V,S,M","Permanent","5","cube 10p/niv","aucun (spécial)","poussière de diamant (500po)/+poussière normale",2},
    {"Transparence",6,"Toucher","V,S,M","1R/niv","1R","Spéciale","Aucun","un petit morceau de cristal ou de verre",2},
    {"Vision véritable",6,"toucher","V,S,M","1 round/niveau","1 round","Champ de vision, max 18 m","Aucun","onguent rare (300 po)",16},
    {"Voile",6,"10 m/niveau","V,S","1 tour/niveau","6","1 cube/niveau de 6 m d'arête","Aucun","---",128},
    {"Banissement",7,"20 m","V,S,M","instantanée","7","Rayon de 18 m","Spécial","spécial",1},
    {"Boule de feu à retardement",7,"100 m + 10 m/niveau","V,S,M","spéciale","7","Rayon de 6 m","1/2","guano de chauve-souris et soufre",256},
    {"Cage de force",7,"10 m/2 niveaux","V,S+spécial","6 tours + 1 tour/niveau","3–4 ","Cube de 6 m d'arête","Aucun","spécial",256},
    {"Charme-plantes",7,"30 m","V,S,M","permanente","1 tour","3 x 9 m","Annule","une pincée d'humus, une goutte d'eau et une tige ou une feuille",8},
    {"Conjuration instantanée de Drawmij",7,"infinie + spéciale","V,S,M","instantanée","1","1 petit objet","Aucun","une gemme (5000 po)",4},
    {"Contrôle des morts-vivants",7,"18 m","V,S,M","3d4 rounds + 1 round/niveau","1 round","1d6 morts-vivants","Spécial","un petit morceau d'os et un autre de viande crue",2048},
    {"Conjuration de monstres 5",7,"Spéciale","V,S,M","6 rounds + 1 round/niveau","6","Rayon de 21 m","Aucun","un petit sac et une fine chandelle",4},
    {"Evanouissement",7,"toucher","V","instantanée","2","1 objet","Aucun","---",2},
    {"Dissimulation",7,"toucher","V,S,M","1 semaine + 1 jour/niveau","7","1 cube/niveau de 60 cm d'arête","Spécial","un cil de basilic, de la gomme arabique et une goutte de chaux",129},
    {"Doigt de mort",7,"60 pas","V,S","Permanent","5","1 créature","Annule","",2048},
    {"Duo-dimension",7,"0","V,S,M","3 rounds + 1 round/niveau","7","le lanceur du sort","Aucun","effigie plate du magicien, en ivoire (500-1000 po) et un parchemin",2},
    {"Epée de Mordenkainen",7,"30 m","V,S,M","1 round/niveau","7","spéciale","Spécial","une épée miniature en platine (500 po)",256},
    {"Gravité inversée",7,"5 m/niveau","V,S,M","1 round/niveau","7","9 m x 9 m","Aucun","un morceau de magnétite et de la limaille de fer",2},
    {"Invisibilité de masse",7,"10 m/niveau","V,S,M","spéciale","7","60 x 60 m","Aucun","un cil et de la gomme arabique",128},
    {"Manoir magnifique de Mordenkainen",7,"10 m","V,S,M","1 heure/niveau","7","27 m2/niveau","Aucun","porte miniature taillée dans l'ivoire, marbre poli et cuillère en argent",6},
    {"Mot de pouvoir : \"Etourdissement\"",7,"5 m/niveau","V","spéciale","1","1 créature à moins de 90 pv","Aucun","---",4},
    {"Parcours de l'ombre",7,"toucher","V,S","6 tours/niveau","1","spéciale","Aucun","---",128},
    {"Poigne de fer de Bigby",7,"10 m/niveau","V,S,M","1 round/niveau","7","spéciale","Aucun","un gant",256},
    {"Porte de phase",7,"toucher","V","1 utilisation/2 niveaux","7","spéciale","Aucun","---",2},
    {"Renvoi des sorts",7,"0","V,S,M","3 rounds/niveau maximum","7","le lanceur du sort","Aucun","un petit miroir d'argent",1},
    {"Simulacre",7,"toucher","V,S,M","permanente","spéciale","1 créature","Aucun","spécial",128},
    {"Souhait mineur",7,"spéciale","V","spéciale","spéciale","spéciale","Spécial","spécial",260},
    {"Statue",7,"toucher","V,S,M","1 heure/niveau","7","créature touchée","Spécial","citron, sable, goutte d'eau et petite barre de fer",2},
    {"Téléportation sans erreur",7,"toucher","V","instantanée","1","spéciale","Spécial","---",2},
    {"Vaporisation prismatique",7,"0","V,S","instantanée","7","Pulvérisation de 21 m x 4,5 m","Spécial","---",4},
    {"Vision",7,"0","V,S,M","spéciale","7","le lanceur du sort","Aucun","spécial",16},
    {"Antipathie/Sympathie",8,"30 m","V,S,M","2 heures/niveau","1 heure","spéciale","Spécial","spécial",8},
    {"Charme de masse",8,"5 m/niveau","V","spéciale","8","spéciale","Annule","---",8},
    {"Clone",8,"toucher","V,S,M","permanente","1 tour","spéciale","Aucun","chair de la personne à reproduire",2048},
    {"Conjuration de monstres 6",8,"Spéciale","V,S,M","7 rounds + 1 round/niveau","8","Rayon de 80 m","Aucun","un petit sac et une fine chandelle",4},
    {"Danse irrésistible d'Otto",8,"toucher","V","1d4 rounds + 1 round","5","créature touchée","Aucun","---",258},
    {"Écran",8,"80 pas","V,S","1h/niv","1T","cube 30pied/niv","Spécial","",144},
    {"Emprisonnement de l'âme",8,"10 m","V,S,M","permanente jusqu'à ce que le sort soit brisé","spécial","1 créature","Spécial","spécial",4},
    {"Ensevelissement",8,"10 m/niveau","V,S","spéciale","8","1 créature ou 1 objet, max  27 litres/niveau","Spécial","---",10},
    {"Entrave",8,"10 m","V,S,M","spéciale","spéciale","1 créature","Spécial","spécial",264},
    {"Esprit impénétrable",8,"30 m","V,S","1 jour","1","1 créature","Aucun","---",1},
    {"Exigence",8,"spéciale","V,S,M","spéciale","1 tour","1 créature","Spécial","deux cylindres reliés par un fil de cuivre à une portion de la créature",264},
    {"Imminuté magique de Serten",8,"toucher","V,S,M","1 tour/niveau","1 round/bénéficiaire","créature(s) touchée(s)","Aucun","spécial",1},
    {"Labyrinthe",8,"5 m/niveau","V,S","spéciale","3","1 créature","Aucun","---",4},
    {"Mot de pouvoir : \" Cécité \"",8,"5 m/niveau","V","spéciale","1","Rayon de 4,5 m, créatures de moins de 100 pv","Spécial","---",4},
    {"Mur prismatique",8,"10 m","V,S","1 tour/niveau","7","1,2 m/niveau de large sur 60 cm/niveau de haut","Spécial","---",4},
    {"Métamorphose universelle",8,"5 m/niveau","V,S,M","variable","1 round","spéciale","Spécial","mercure, gomme arabique et fumée",2},
    {"Nuage incendiaire",8,"30 m","V,S,M","4 rounds + 1d6 rounds","2","spéciale","`1/2","source de feu, lambeaux râclés sous un tas de fiente, poussière",258},
    {"Permanence",8,"spéciale","V,S","permanente","2 rounds","spéciale","Aucun","---",2},
    {"Poing serré de Bigby",8,"5 m/niveau","V,S,M","1 round/niveau","8","spéciale","Aucun","un gant de cuir, et 4 anneaux en alliage de cuivre et zinc",256},
    {"Sphère télékinésique d'Otiluke",8,"20 m","V,S,M","2 rounds/niveau","4","Sphère de 30 cm/niveau de diamètre","Annule","diamant et gomme arabique hémisphériques, et deux barres aimantées",258},
    {"Symbole",8,"toucher","V,S,M","spéciale","8","spéciale","Spécial","poudre d'opale noire et poussière de diamant (5000 po chaque)",4},
    {"Verre d'acier",8,"toucher","V,S,M","permanente","8","objet touché","Aucun","un petit morceau de verre et un petit morceau d'acier",2},
    {"Absorption d'énergie",9,"toucher","V,S,M","permanente","3","1 créature","Aucun","essence de spectre ou poussière de vampire",2304},
    {"Arrêt du temps",9,"0","V","Spécial","9","sphère R=15 pieds","Aucun","",2},
    {"Asile",9,"toucher","V,S,M","spéciale","1 à 4 jours","1 individu","Aucun","spécial",10},
    {"Changement de forme",9,"0","V,S,M","1 tour/niveau","9","le lanceur du sort","Aucun","un anneau de jade (5000 po)",2},
    {"Conjuration de monstres 7",9,"Spéciale","V,S,M","8 rounds + 1 round/niveau","9","Rayon de 90 m","Aucun","un petit sac et une fine chandelle",4},
    {"Disjonction de Mordenkainen",9,"0","V","instantanée","9","Rayon de 10 m","Spécial","---",10},
    {"Emprisonnement",9,"toucher","V,S","permanente","9","1 créature","Aucun","---",1},
    {"Ennemi subconscient",9,"30 m","V,S","concentration","9","Rayon de 6 m","Spécial","---",128},
    {"Fragilité de cristal",9,"toucher","V,S","permanente","9","54 litres/niveau","Spécial","---",2},
    {"Main broyante de Bigby",9,"5 m/niveau","V,S,M","1 round/niveau","9","spéciale","Aucun","un gant en peau de serpent et une coquille d'oeuf",256},
    {"Mot de pouvoir : \" Mort \"",9,"5 m/2 niveaux","V","permanente","1","Rayon de 3 m, créatures de moins de 120 pv","Aucun","---",4},
    {"Nuée de météores",9,"40 m + 10 m/niveau","V,S","instantanée","9","spéciale","1/2","---",256},
    {"Seuil",9,"30 m","V,S","spéciale","9","spéciale","Aucun","---",4},
    {"Pressentiment",9,"0","V,S,M","2d4 rounds + 1 round/niveau","1 round","spéciale","Aucun","une plume de colibri",16},
    {"Sort astral",9,"toucher","V,S","spéciale","9","spéciale","Aucun","---",256},
    {"Souhait",9,"illimitée","V","spéciale","spéciale","spéciale","Spécial","spécial",4},
    {"Sphère prismatique",9,"0","V","1 tour/niveau","7","Rayon de 3 m","Spécial","---",5},
    {"Stase temporelle",9,"10 m","V,S,M","permanente","9","Rayon de 4,5 m","Annule","poudre de diamant, émeraude, rubis et saphir (100 po chaque)",2}
};

unsigned short c_poids_taille[80][2]=
{
    {	110	,	625	}	,
    {	109	,	608	}	,
    {	108	,	592	}	,
    {	107	,	575	}	,
    {	106	,	559	}	,
    {	105	,	544	}	,
    {	104	,	528	}	,
    {	103	,	513	}	,
    {	102	,	498	}	,
    {	101	,	484	}	,
    {	100	,	470	}	,
    {	99	,	456	}	,
    {	98	,	442	}	,
    {	97	,	429	}	,
    {	96	,	415	}	,
    {	95	,	403	}	,
    {	94	,	390	}	,
    {	93	,	378	}	,
    {	92	,	366	}	,
    {	91	,	354	}	,
    {	90	,	342	}	,
    {	89	,	331	}	,
    {	88	,	320	}	,
    {	87	,	309	}	,
    {	86	,	299	}	,
    {	85	,	288	}	,
    {	84	,	278	}	,
    {	83	,	268	}	,
    {	82	,	259	}	,
    {	81	,	250	}	,
    {	80	,	240	}	,
    {	79	,	232	}	,
    {	78	,	223	}	,
    {	77	,	214	}	,
    {	76	,	206	}	,
    {	75	,	198	}	,
    {	74	,	190	}	,
    {	73	,	183	}	,
    {	72	,	175	}	,
    {	71	,	168	}	,
    {	70	,	161	}	,
    {	69	,	154	}	,
    {	68	,	148	}	,
    {	67	,	141	}	,
    {	66	,	135	}	,
    {	65	,	129	}	,
    {	64	,	123	}	,
    {	63	,	117	}	,
    {	62	,	112	}	,
    {	61	,	107	}	,
    {	60	,	101	}	,
    {	59	,	96	}	,
    {	58	,	92	}	,
    {	57	,	87	}	,
    {	56	,	82	}	,
    {	55	,	78	}	,
    {	54	,	74	}	,
    {	53	,	70	}	,
    {	52	,	66	}	,
    {	51	,	62	}	,
    {	50	,	59	}	,
    {	49	,	55	}	,
    {	48	,	52	}	,
    {	47	,	49	}	,
    {	46	,	46	}	,
    {	45	,	43	}	,
    {	44	,	40	}	,
    {	43	,	37	}	,
    {	42	,	35	}	,
    {	41	,	32	}	,
    {	40	,	30	}	,
    {	39	,	28	}	,
    {	38	,	26	}	,
    {	37	,	24	}	,
    {	36	,	22	}	,
    {	35	,	20	}	,
    {	34	,	18	}	,
    {	33	,	17	}	,
    {	32	,	15	}	,
    {	31	,	14	}
};

unsigned short taille_race[7][4]=
{
    {	62	,	72	,	57	,	67	},
    {	60	,	60	,	57	,	57	},
    {	61	,	66	,	57	,	62	},
    {	48	,	48	,	46	,	46	},
    {	42	,	42	,	40	,	40	},
    {	42	,	42	,	40	,	40	},
    {	61	,	66	,	58	,	63	}
};

float poids_race[7]={1	,0.94	,0.97	,1.9	,1.9	,1.5	,1.1	};

unsigned short v_poids_taille[9]={6	,26	,151	,351	,651	,851	,976	,996	, 1}; /* affichage de 000 pour la valeur -1 au dernier */

float force_taille[16]={-0.09	,-0.06	,-0.03	,0.00	,0.00	,0.00	,0.00	,0.00	,0.00	,0.00	,0.00	,0.00	,0.00	,0.03	,0.06	,0.09	};

float force_poids[16]={-0.200	,-0.160	,-0.120	,-0.080	,-0.040	,0.00	,0.00	,0.00	,0.00	,0.00	,0.00	,0.040	,0.080	,0.120	,0.160	,0.200	};

gint hiatus[9][20]=
{
    {-1,-1,-1,-1,-1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1 ,1, 1, 1},
    {-1,-1,-1,-1,-1,-1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1},
    {-2,-1,-1,-1,-1,-1,-1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 2},
    {-2,-2,-1,-1,-1,-1,-1,-1, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 2, 2},
    {-3,-2,-2,-1,-1,-1,-1,-1,-1, 0, 0, 1, 1, 1, 1, 1, 1, 2, 2, 3},
    {-3,-3,-2,-2,-2,-1,-1,-1,-1, 0, 0, 1, 1, 1, 1, 2, 2, 2, 3, 3},
    {-4,-3,-3,-2,-2,-1,-1,-1,-1, 0, 0, 1, 1, 1, 1, 2, 2, 3, 3, 4},
    {-4,-4,-3,-3,-2,-2,-1,-1,-1, 0, 0, 1, 1, 1, 2, 2, 3, 3, 4, 4},
    {-5,-4,-4,-3,-3,-2,-2,-1,-1, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 5}
};
