/*
    Génération de feuille de personnage complète AD&D 1 et 2
    Génération aléatoire de personnage

    Copyright (C) 2011 Bernard SIAUD

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <time.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include "include.h"

unsigned short tirage_3D6();
unsigned short tirage_4D6();
unsigned short tirage_5D6();
unsigned short tirage_3D6x6();
unsigned short tirage_4D5p3();
unsigned short * tirage_pdv_(unsigned short *caract,liste_classe * metier,unsigned short version_dd,gpointer param,unsigned short (*pf)(unsigned short));
unsigned short max_2d(unsigned short);
unsigned short max_1d(unsigned short);
unsigned short max_max(unsigned short);
unsigned char trouve_methode_pdv(GList * k);
unsigned char trouve_niveau(GList * k);
void annule_t(GtkWidget *wid, gpointer param);
unsigned short armes_classe(struct_classe * l_c,unsigned short niv,unsigned short version_dd);
/*unsigned short nouv_metier(liste_classe * metier,signed short ch);*/

signed short calc_age(char * ch);

signed short calc_age(char * ch)
{
    unsigned short base,nb_des,de,nb;
    signed short age=-1;

    if (ch==NULL) return -1;

    nb=sscanf(ch,"%hu+%hud%hu",&base,&nb_des,&de);
    if (nb>0)
    {
        age=base;
        if (nb==3)
        {
            for(;nb_des>0;nb_des--)
            {
                age+=rand()%de+1;
            }
        }
    }

    return age;
}


signed short tirage_age(liste_classe_race * l_c_r,liste_classe * l_c,unsigned short version_)
{
    liste_classe_race *tmp_lcr;
    signed short age=-1;

    if(version_==ADD1)
    {
        for (tmp_lcr=l_c_r;tmp_lcr!=NULL;tmp_lcr=tmp_lcr->suiv)
            if (tmp_lcr->age!=NULL && compare_sans_casse(l_c->nom,l_c_r->classe->nom))
                age=max(calc_age(tmp_lcr->age),age);
    }
    else
        for (tmp_lcr=l_c_r;tmp_lcr!=NULL;tmp_lcr=tmp_lcr->suiv)
            if (tmp_lcr->age!=NULL)
                age=max(calc_age(tmp_lcr->age),age);

    return age;
}

unsigned short armes_classe(struct_classe * s_c,unsigned short niv,unsigned short version_dd)
{
    if (version_dd==ADD1)
        return s_c->add1.nb_arme[0]+niv/s_c->add1.nb_arme[2];
    return s_c->add2.nb_arme[0]+niv/s_c->add2.nb_arme[2];
}



GtkWidget * nouv_ouv(GtkWidget *wid, gpointer param,unsigned char quoi)
{
//g_debug (G_STRLOC);
  unsigned short * caract=(unsigned short *)malloc(9*sizeof(unsigned short)); /* il faut allouer la mémoire aux informations à passer aux fonctions callback */
  unsigned char sexe=HOMME;
  unsigned short race=0;
  liste_classe * metier=NULL;
  unsigned short * nb_armes=(unsigned short *)malloc(sizeof(unsigned short));    /* pour mémoriser */
  unsigned short * nv_armes=(unsigned short *)malloc(sizeof(unsigned short));
  unsigned short * num_armes=(unsigned short *)malloc(sizeof(unsigned short));
  signed short * mag_armes=(signed short *)malloc(sizeof(signed short));
  unsigned short * nb_pdv=(unsigned short *)malloc(sizeof(unsigned short));    /* pour mémoriser */
  unsigned short * num_pdv=(unsigned short *)malloc(sizeof(unsigned short));
  unsigned short * nb_comp=(unsigned short *)malloc(sizeof(unsigned short));    /* pour mémoriser */
  unsigned short * nv_comp=(unsigned short *)malloc(sizeof(unsigned short));
  unsigned short * num_comp=(unsigned short *)malloc(sizeof(unsigned short));

  return affichage_perso(race,sexe,quoi,caract,metier,nb_armes,nv_armes,num_armes,mag_armes,nb_pdv,num_pdv,nb_comp,nv_comp,num_comp,NULL,param);

  (void)wid;
}

unsigned short * tirage_pdv_(unsigned short *caract,liste_classe * metier,unsigned short version_dd,gpointer param,unsigned short (*pf)(unsigned short))
{
  unsigned short constit=0,constitg=0,niveau,nb,de,nb_des,b_constit_add2=0,i;
  unsigned short nb_metier, * pdv=NULL;
  liste_classe * tmp_lc;
  struct_classe ** l_c;
  constitg=caract[CONSTITUTION];
  char * ch,c;

    if (constitg>16) /* lire le nombre entre parenthèse après le +2 */
    {
      sscanf(tabl_constit[constitg-1][0],"+2(%hd)",&constit); /* si pas de sortie alors 0 */
      constitg=constit;
      constit=2;
    }
    else
    {
      sscanf(tabl_constit[constitg-1][0],"%hd",&constit);
      constitg=constit;
    }

    nb_metier=0;
    for (tmp_lc=metier;tmp_lc!=NULL;tmp_lc=tmp_lc->suiv)
        nb_metier++;

    pdv=(unsigned short *)malloc(metier->niveau*sizeof(unsigned short));
    l_c=(struct_classe **)malloc(nb_metier*sizeof(struct_classe *));

    i=0;
    for (tmp_lc=metier;tmp_lc!=NULL;tmp_lc=tmp_lc->suiv)
    {
        l_c[i]=trouve_classe(tmp_lc->nom,((struct_classe **)param)[MAIN_CLASSE]);
        i++;
    }

    for(niveau=0;niveau<metier->niveau;niveau++)
    {
        pdv[niveau]=0;
        i=0;
        for (tmp_lc=metier;tmp_lc!=NULL;tmp_lc=tmp_lc->suiv)
        {
            if (version_dd==ADD1 || l_c[i]->add2.nom==NULL)
                ch=l_c[i]->add1.pdv[min_(niveau,19)];
            else
                ch=l_c[i]->add2.pdv[min_(niveau,19)];

            nb=sscanf(ch,"%huD%hu+%c",&nb_des,&de,&c);
            if (nb==1)
                pdv[niveau]+=nb_des;
            if (nb>1)
            {
                for(;nb_des>0;nb_des--)
                    pdv[niveau]+=pf(de);
                if(nb==3)
                {
                    if (version_dd==ADD1) /* b : cas du barbare */
                        pdv[niveau]+=(c=='b'?constitg*2:(c=='n'?constit:constitg));
                    else
                        b_constit_add2=max(b_constit_add2,(c=='b'?constitg*2:(c=='n'?constit:constitg)));
                }
            }
            i++;
        }
        pdv[niveau]=pdv[niveau]/nb_metier+b_constit_add2;
    }

    return pdv;
}

unsigned short max_2d(unsigned short des)
{
    unsigned short i=rand()%des,j=rand()%des;
    if (i>j) return i+1;
    return j+1;
}
unsigned short max_1d(unsigned short des)
{
    return rand()%des+1;
}
unsigned short max_max(unsigned short des)
{
    return des;
}

void caract_voleur(gpointer param)
{
  /*signed short j,k;
  signed short * comp=NULL;

  for (k=0;k<((unsigned short **)param)[NB_METIER][0];k++)
     if (((unsigned short **)param)[METIER][k]==VOLEUR || ((unsigned short **)param)[METIER][k]==ASSASSIN|| ((unsigned short **)param)[METIER][k]==MOINE)
     {
         if (comp==NULL)
         {
            comp=cal_caract_voleur(((unsigned short **)param)[CARACT][DEXTERITE],((unsigned short **)param)[METIER][k],((unsigned short **)param)[NV_METIER][k],((unsigned short **)param)[RACE][0],((unsigned short **)param)[VERSION][0]);
            for(j=0;j<8;j++)
             ((unsigned short **)param)[C_VOLEUR][j]=comp[j];
         }
         else
         {
            free(comp);
            comp=cal_caract_voleur(((unsigned short **)param)[CARACT][DEXTERITE],((unsigned short **)param)[METIER][k],((unsigned short **)param)[NV_METIER][k],((unsigned short **)param)[RACE][0],((unsigned short **)param)[VERSION][0]);
            for(j=0;j<8;j++)
             ((unsigned short **)param)[C_VOLEUR][j]=max(comp[j],((unsigned short **)param)[C_VOLEUR][j]);
         }
     }
  if (comp!=NULL) free(comp);*/
  (void) param;
}

/*unsigned short nouv_metier(liste_classe * metier,signed short ch)
{
   (*nb_metier)++;
   *metier=(unsigned short *)realloc(*metier,*nb_metier*sizeof(unsigned short));
   (*metier)[*nb_metier-1]=ch;
   *nv_metier=realloc(*nv_metier,*nb_metier*sizeof(signed short));
   (*nv_metier)[*nb_metier-1]=1;

   return *nb_metier;
}*/

void annule_t(GtkWidget *wid, gpointer param)
{
 gtk_widget_destroy(((GtkWidget **)param)[FENETRE]);
 ((GtkWidget **)param)[FENETRE] = NULL;

 (void)wid;
}

void tirage (GtkWidget *wid, gpointer param)
{
  unsigned short * caract,caract_min[8]={3,3,3,3,3,3,3,3},caract_pref[8]={0,3,4,2,1,5,9,9},caract_max[9]={18,18,18,18,18,18,18,18,100};
  GtkActionGroup *act_gr = *((GtkActionGroup **)param+3);
  GList * gl=gtk_action_group_list_actions (act_gr),*k;
  char *action_name;
  gint action_active;
  GtkAction *action;
  gchar caracteristique;
  unsigned char pl_num;
  unsigned char methode=_4D6;
  unsigned char version_dd=trouve_version(gl);
  unsigned char sexe=trouve_sexe(gl);;
  unsigned short race=donne_race(((struct_race **)param)[MAIN_RACE],((unsigned short **)param)[MAIN_NB_RACE][0]);
  unsigned short * nb_metier=NULL;
  unsigned short * nb_armes=(unsigned short *)malloc(sizeof(unsigned short));    /* pour mémoriser */
  signed short * mag_armes;
  unsigned short * nv_armes, *num_armes;
  unsigned short i,j;
  unsigned short * nb_pdv=(unsigned short *)malloc(sizeof(unsigned short));      /* pour mémoriser */
  unsigned short * num_pdv=(unsigned short *)malloc(sizeof(unsigned short));
  unsigned short * nb_comp=(unsigned short *)malloc(sizeof(unsigned short));     /* pour mémoriser */
  unsigned short * nv_comp=(unsigned short *)malloc(sizeof(unsigned short));
  unsigned short * num_comp=(unsigned short *)malloc(sizeof(unsigned short));
  unsigned short (*tirage_pdv)(unsigned short)=NULL;
  char * age=NULL;
  liste_classe * metier=trouve_liste_classe_menu(param), * tmp_lc;

 if (metier==NULL) return ;

  *nb_pdv=1;
  *num_pdv=1;
  *nb_comp=1;
  *nv_comp=1;
  *num_comp=1;

  *nb_armes=1;
  caract=(unsigned short *)malloc(9*sizeof(unsigned short)); /* il faut allouer la mémoire aux informations à passer aux fonctions callback */
  nb_metier=(unsigned short *)malloc(sizeof(unsigned short)); /* il faut allouer la mémoire aux informations à passer aux fonctions callback */
  *nb_metier=0;

  switch (trouve_methode_pdv(gl))
  {
      case PDV_1D  : tirage_pdv=&max_1d ;break;
      case PDV_2D  : tirage_pdv=&max_2d ;break;
      case PDV_MAX : tirage_pdv=&max_max;break;
      default      : break;
  }


  for (k = gl; k != NULL; k = g_list_next(k))
  {

                action = GTK_ACTION(k->data);
                g_object_get(action,"name", &action_name,NULL);
                if (strcmp(action_name,"_3D6")==0) /* on va vérifier tous les états du menu un à un */
                {
                    g_object_get(action,"active",&action_active,NULL);
                    if (action_active)
                      methode=_3D6;
                }
                else if (strcmp(action_name,"_4D6")==0)
                {
                    g_object_get(action,"active",&action_active,NULL);
                    if (action_active)
                      methode=_4D6;
                }
                else if (strcmp(action_name,"_5D6")==0)
                {
                    g_object_get(action,"active",&action_active,NULL);
                    if (action_active)
                      methode=_5D6;
                }
                else if (strcmp(action_name,"_3D6x6")==0)
                {
                    g_object_get(action,"active",&action_active,NULL);
                    if (action_active)
                      methode=_3D6x6;
                }
                else if (strcmp(action_name,"_4D5p3")==0)
                {
                    g_object_get(action,"active",&action_active,NULL);
                    if (action_active)
                      methode=_4D5p3;
                }
                else if (strcmp(action_name,"homme")==0)
                {
                    g_object_get(action,"active",&action_active,NULL);
                    if (action_active)
                      sexe=HOMME;
                }
                else if (strcmp(action_name,"femme")==0)
                {
                    g_object_get(action,"active",&action_active,NULL);
                    if (action_active)
                      sexe=FEMME;
                }
                /*else  caractéristique */
                {
                    pl_num=0;
                    caracteristique=10;
                    switch (action_name[0])
                    {
                        case 'f' : caracteristique=FORCE;
                                   pl_num=1;
                                   break;
                        case 'i' : caracteristique=INTELLIGENCE;
                                   pl_num=1;
                                   break;
                        case 's' : caracteristique=SAGESSE;
                                   pl_num=1;
                                   break;
                        case 'd' : caracteristique=DEXTERITE;
                                   pl_num=1;
                                   break;
                        case 'h' : caracteristique=HUMOUR;
                                   if (action_name[1]>'0' && action_name[1]<'9')
                                       pl_num=1;
                                   else if (strcmp(action_name+1,"im")==0)
                                       caract_pref[HUMOUR]=9;
                                   break;
                        case 'b' : caracteristique=BEAUTE;
                                   if (action_name[1]>'0' && action_name[1]<'9')
                                       pl_num=1;
                                   else if (strcmp(action_name+1,"im")==0)
                                       caract_pref[BEAUTE]=9;
                                   break;
                        case 'c' : if (action_name[1]=='o')
                                   {
                                       caracteristique=CONSTITUTION;
                                       pl_num=2;
                                   }
                                   else if (action_name[1]=='h')
                                   {
                                       caracteristique=CHARISME;
                                       pl_num=2;
                                   }
                                   break;
                        default :
                                   break;
                    }
                    if (pl_num!=0 &&
                         caracteristique!=10 &&
                         action_name[pl_num]>'0' &&
                        action_name[pl_num]<'9')
                    {
                         g_object_get(action,"active",&action_active,NULL);
                         if (action_active)
                         {
                            caract_pref[action_name[pl_num]-'1']=caracteristique;
                         }
                    }
                }

                g_free(action_name);
  }

  j=trouve_niveau(gl);

  i=0;
  *nb_armes=0;
  for(tmp_lc=metier;tmp_lc!=NULL;tmp_lc=tmp_lc->suiv)
  {
        i++;
        tmp_lc->niveau=j;
        *nb_armes=max(armes_classe(trouve_classe(tmp_lc->nom,((struct_classe**)param)[MAIN_CLASSE]),j,version_dd),*nb_armes);
  }

  nv_armes=(unsigned short *)malloc(*nb_armes*sizeof(unsigned short));
  num_armes=(unsigned short *)malloc(*nb_armes*sizeof(unsigned short));
  mag_armes=(signed short *)malloc(*nb_armes*sizeof(signed short));
  *nb_metier=i;


  // metier + niv => nb_armes


  /* gestion des armes */
  for (i=0;i<*nb_armes;i++)
  { /* initialisation : armes départ */
      nv_armes[i]=1;
      mag_armes[i]=0;
      num_armes[i]=i;
  }
   /* choix des armes pour le débutant */





  tirage_perso(methode,race,metier,version_dd,caract, caract_min,caract_max,caract_pref,param);

  caract[POURCENTAGE]=rand()%100+1;
  if (metier->niveau>0)
  {
      *nb_pdv=metier->niveau;
      num_pdv=tirage_pdv_(caract,metier,version_dd,param,tirage_pdv);
  }
  else
    *nb_pdv=0;
  /* tirage de l'âge */

  if (version_dd==ADD1)
    j=tirage_age(((struct_race **)param)[MAIN_RACE]->add1.liste_classe,metier,version_dd);
  else
    j=tirage_age(((struct_race **)param)[MAIN_RACE]->add2.liste_classe,metier,version_dd);

  age=(char *)malloc(8);
  sprintf(age,"%hu ans",j);

  affichage_perso(race,sexe,version_dd,caract,metier,nb_armes,nv_armes,num_armes,mag_armes,nb_pdv,num_pdv,nb_comp,nv_comp,num_comp,age,param);

  (void)wid;
}


GtkWidget * affichage_perso(unsigned short race,unsigned char sexe,unsigned char version_dd,unsigned short * caract,liste_classe * metier,unsigned short * nb_armes,unsigned short * nv_armes,unsigned short * num_armes,signed short * mag_armes,unsigned short * nb_pdv,unsigned short * num_pdv,unsigned short * nb_comp,unsigned short * nv_comp,unsigned short * num_comp,char * ch_age,gpointer param)
{
  GtkWidget * button = NULL;
  GtkWidget * win = NULL;
  GtkWidget * hbox2 = NULL,* vbox1 = NULL, * vbox2 = NULL, * vbox_vol;
  GError * error;
  void ** param_t, ** tmp;
  signed short i,j;
  gchar affichage[LONG];
  GMarkupDomNode *node=NULL;
  char * tmpo=NULL, *tmp1=NULL;
  GtkWidget ** texte=(GtkWidget **)malloc(3*sizeof(GtkWidget *));
  unsigned short * c_voleur=(unsigned short *)malloc(8*sizeof(unsigned short));  /* pour mémoriser */
  unsigned short * p_version=(unsigned short *)malloc(sizeof(unsigned short));  /* pour mémoriser */
  unsigned short * p_race=(unsigned short *)malloc(sizeof(unsigned short));    /* pour mémoriser */
  unsigned short * p_sexe=(unsigned short *)malloc(sizeof(unsigned short));   /* pour mémoriser */
  unsigned short * p_taille=(unsigned short *)malloc(sizeof(unsigned short));/* pour mémoriser */
  unsigned short * p_poids=(unsigned short *)malloc(sizeof(unsigned short));/* pour mémoriser */
  unsigned long * xp_classe;                                               /* pour mémoriser */
  char ** nomf=(char **)malloc(sizeof(char *));                           /* pour mémoriser */
  char ** chemin=(char **)malloc(sizeof(char *));                        /* pour mémoriser */
  char ** dieu=(char **)malloc(sizeof(char *));                         /* pour mémoriser */
  char ** pantheon=(char **)malloc(sizeof(char *));                    /* pour mémoriser */
  char * joueur=NULL;                                                 /* pour mémoriser */
  char * perso=NULL;                                                 /* pour mémoriser */
  char * classe_sociale=NULL;                                       /* pour mémoriser */
  char * couleur_cheveux=NULL;                                     /* pour mémoriser */
  char * couleur_yeux=NULL;                                       /* pour mémoriser */
  char * couleur_peau=NULL;                                      /* pour mémoriser */
  char * age=NULL;                                              /* pour mémoriser */
  char * armure1=NULL;
  char * armure2=NULL;
  signed short * mag_armure1=(signed short *)malloc(sizeof(signed short));
  signed short * mag_armure2=(signed short *)malloc(sizeof(signed short));
  signed short * bouclier=(signed short *)malloc(sizeof(signed short));
  signed short * mag_bouclier=(signed short *)malloc(sizeof(signed short));
  signed short * bonus_ca=(signed short *)malloc(sizeof(signed short));
  signed short * modif=(signed short *)malloc(sizeof(signed short));
  char *** sort_mag=(char ***)malloc(9*sizeof(char**));
  unsigned char ** sort_mag_mait=(unsigned char **)malloc(9*sizeof(unsigned char*)); /* c'est une bétise d'avoir mis un char au milieu des short pour mémoriser un nombre ! */
  unsigned short * nb_sort_mag=(unsigned short *)malloc(9*sizeof(unsigned short));
  unsigned short deja_ouvert=0;
  unsigned short * alignement=(unsigned short *)malloc(sizeof(unsigned short));
  liste_classe * tmp_lc;
  unsigned short nb_metier=0;
  FILE * fp;
  unsigned short algt=65535;
  struct_classe * s_c;

  *nomf=NULL;
  *chemin=NULL;
  *pantheon=NULL;
  *dieu=NULL;
  *p_taille=1;
  *p_poids=1;
  *mag_armure1=0;
  *mag_armure2=0;
  *bouclier=0;
  *mag_bouclier=0;
  *bonus_ca=0;
  *modif=1;
  *alignement=4;

  age=ch_age;

  param_t=(void **)malloc(MAX_TIRAGE*sizeof(void *));
  for (i=0;i<9;i++)
  {
      sort_mag[i]=NULL;
      sort_mag_mait[i]=NULL;
      nb_sort_mag[i]=0;
  }
  /* 0 : texte */
  ((void **)param_t)[1]=(void *)caract;
  ((void **)param_t)[2]=(void *)(p_version);
  ((void **)param_t)[3]=NULL; /* place du fils "modifier" */
  ((void **)param_t)[4]=NULL; /* 4 la fenêtre */
  ((void **)param_t)[5]=(void *)(p_race);
  ((void **)param_t)[6]=(void *)(p_sexe);
  ((void **)param_t)[METIER]=(void *)(metier);
  ((void **)param_t)[10]=(void *)(nb_armes);
  ((void **)param_t)[11]=(void *)(nv_armes);
  ((void **)param_t)[12]=(void *)(num_armes);
  ((void **)param_t)[13]=(void *)(nb_pdv);
  ((void **)param_t)[14]=(void *)(num_pdv);
  ((void **)param_t)[15]=(void *)(nb_comp);
  ((void **)param_t)[16]=(void *)(nv_comp);
  ((void **)param_t)[17]=(void *)(num_comp);
  ((void **)param_t)[18]=(void *)(nomf);
  ((void **)param_t)[19]=(void *)(chemin);
  ((void **)param_t)[20]=(void *)(c_voleur);
  ((void **)param_t)[22]=(void *)(pantheon);
  ((void **)param_t)[23]=(void *)(dieu);
  ((void **)param_t)[24]=NULL; /* pas de commentaires pour le moment */
  ((void **)param_t)[25]=(void *)(sort_mag);
  ((void **)param_t)[26]=(void *)(nb_sort_mag);
  ((void **)param_t)[27]=(void *)(sort_mag_mait);
  ((void **)param_t)[28]=(void *)(p_taille);
  ((void **)param_t)[29]=(void *)(p_poids);
  ((void **)param_t)[30]=(void *)(mag_armes);
  ((void **)param_t)[31]=(void *)(joueur);
  ((void **)param_t)[32]=(void *)(perso);
  ((void **)param_t)[33]=(void *)(classe_sociale);
  ((void **)param_t)[34]=(void *)(couleur_cheveux);
  ((void **)param_t)[35]=(void *)(couleur_peau);
  ((void **)param_t)[36]=(void *)(couleur_yeux);
  ((void **)param_t)[37]=(void *)(age);
  ((void **)param_t)[38]=(void *)(armure1);
  ((void **)param_t)[39]=(void *)(mag_armure1);
  ((void **)param_t)[40]=(void *)(armure2);
  ((void **)param_t)[41]=(void *)(mag_armure2);
  ((void **)param_t)[42]=(void *)(bouclier);
  ((void **)param_t)[43]=(void *)(mag_bouclier);
  ((void **)param_t)[44]=(void *)(bonus_ca);
  ((void **)param_t)[45]=(void *)(modif);
  ((void **)param_t)[46]=(void *)(param);
  ((void **)param_t)[47]=(void *)(alignement);



  *p_version=version_dd;
  *p_race=race;
  *p_sexe=sexe;
  for (i=0;i<8;i++)
   c_voleur[i]=0;


  win = gtk_window_new (GTK_WINDOW_TOPLEVEL); /* déclaration d'une fenêtre complète */
  gtk_window_set_position (GTK_WINDOW (win), GTK_WIN_POS_MOUSE); /* aucune position */
  ((void **)param_t)[FENETRE]=(void *)win;
  *texte = gtk_label_new (NULL);
  ((void **)param_t)[TEXTE]=(void *)texte;

  /* Create the main window */
  gtk_container_set_border_width (GTK_CONTAINER (win), 8);
  gtk_window_set_title (GTK_WINDOW (win), "Résumé d'un personnage");
  gtk_window_set_position (GTK_WINDOW (win), GTK_WIN_POS_NONE);
  gtk_widget_realize (win);

  /* icone */
  tmpo=chemin_exe();
  sprintf(affichage,"%s%cfeuille.png",tmpo,SEPARATEUR);
  free(tmpo);
  if (!gtk_window_set_icon_from_file(GTK_WINDOW (win),affichage,&error))
  {                                                                  /* met une icone à la fenêtre */
   traite_erreur(error);
   g_error_free(error);
  }

  /* Create a vertical box with buttons */
  hbox2 = gtk_hbox_new (FALSE, 6); /* premier paramètre à false pour avoir des boutons de taille réduite */
  vbox1 = gtk_vbox_new (FALSE, 6); /* premier paramètre à false pour avoir des boutons de taille réduite */
  vbox_vol = gtk_vbox_new (FALSE, 6); /* premier paramètre à false pour avoir des boutons de taille réduite */
  vbox2 = gtk_vbox_new (FALSE, 6); /* premier paramètre à false pour avoir des boutons de taille réduite */
  gtk_container_add (GTK_CONTAINER (win), hbox2);
  gtk_box_pack_start (GTK_BOX (hbox2),vbox1 , FALSE ,FALSE, 0);
  gtk_box_pack_start (GTK_BOX (hbox2),vbox_vol , FALSE ,FALSE, 0);
  gtk_box_pack_start (GTK_BOX (hbox2),vbox2 , FALSE ,FALSE, 0);

  button = gtk_button_new_from_stock (GTK_STOCK_SAVE); /*GTK_STOCK_DIALOG_INFO);*/
  g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (sauvegarde_perso), (gpointer) param_t);
  gtk_box_pack_start (GTK_BOX (vbox1), button, FALSE ,FALSE, 0);

  button = gtk_button_new_from_stock (GTK_STOCK_SAVE_AS); /*GTK_STOCK_DIALOG_INFO);*/
  g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (sauvegarde_perso_sous), (gpointer) param_t);
  gtk_box_pack_start (GTK_BOX (vbox1), button, FALSE ,FALSE, 0);

  texte[1] = gtk_label_new (affichage);
  texte[2] = gtk_label_new (affichage);
  gtk_label_set_justify(GTK_LABEL(texte[2]),GTK_JUSTIFY_CENTER); /* centrer la ligne */
  gtk_box_pack_start (GTK_BOX (vbox1), *texte, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (vbox_vol), texte[2], TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (vbox2), texte[1], TRUE, TRUE, 0);
  g_signal_connect (G_OBJECT (win),"destroy",G_CALLBACK (fin_perso), (gpointer) param_t);

  /*button = gtk_button_new_from_stock (GTK_STOCK_OPEN);
  g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (ouvrir_fichier), (gpointer) param_t);
  gtk_box_pack_start (GTK_BOX (vbox2), button, FALSE, FALSE, 1);*/

  button = gtk_button_new_from_stock (GTK_STOCK_EDIT); /*GTK_STOCK_DIALOG_INFO);*/
  g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (modifier_caract), (gpointer) param_t);
  gtk_box_pack_start (GTK_BOX (vbox2), button, FALSE, FALSE, 1);

  button = gtk_button_new_from_stock (GTK_STOCK_CLOSE);
  g_signal_connect (G_OBJECT(button), "clicked", G_CALLBACK (annule_t), (gpointer) param_t);
  gtk_box_pack_start (GTK_BOX (vbox2), button, FALSE, FALSE, 1);

  if (*p_version==OUVRIR || *p_version==NOUVEAU || *p_version==GROUPE || *p_version==OUV_HIST)
  {
      *nb_pdv=1;
      *num_pdv=7;
      *nb_comp=1;
      *nv_comp=1;
      *num_comp=1;
      for (i=0;i<9;i++)caract[i]=10;
      ((liste_classe **)param_t)[METIER]=(liste_classe *)malloc(sizeof(liste_classe));
      ((liste_classe **)param_t)[METIER]->nom=g_strdup("Guerrier");
      ((liste_classe **)param_t)[METIER]->suiv=NULL;
      ((liste_classe **)param_t)[METIER]->niveau=1;
      ((liste_classe **)param_t)[METIER]->xp=0;
      *nb_armes=1;   /* une seule arme              */
      *nv_armes=1;   /* arme maîtrisée normalement */
      *mag_armes=0;  /* arme non magique          */
      *num_armes=16; /* épée longue              */
      xp_classe=(unsigned long *)malloc(sizeof(unsigned long));
      ((void **)param_t)[21]=(void *)(xp_classe);
      *xp_classe=0;
      caract_voleur(param_t); /* calcul des capacités de voleur version AD&D1 */
      if (*p_version==NOUVEAU)
      {
        *p_version=ADD2;
        modifier_caract(win,param_t);
      }
      else if (*p_version==GROUPE || *p_version==OUV_HIST) /* attention modification de paramètres */
      {
        if (*p_version==GROUPE) ((gpointer *)param_t)[MENU]=((gpointer *)param)[8];
        *p_version=ADD2;
        if (deja_edite(((char **)param)[9])!=NULL)
        {
            ((GtkWidget **)param)[FENETRE]=deja_edite(((char **)param)[9]);
            deja_ouvert=4;
            *modif=2;
        }
        else
        {
            node = g_markup_dom_new (((char **)param)[9],&error); /* pas besoin de vérifier, on sait que c'est bon */
            sprintf(affichage,"%s.lock",((char **)param)[9]);
            fp = fopen(affichage, "w");
            fprintf(fp,"%ld %p",(signed long)getpid(),((GtkWindow **)param_t)[FENETRE]);
            fclose(fp);
            for(tmpo=((char **)param)[9];*tmpo;tmpo++);
            for(;(*tmpo!=SEPARATEUR && *tmpo!='/') && tmpo!=((char **)param)[9];tmpo--) if (*tmpo=='.') tmp1=tmpo;
            if (tmpo!=((char **)param)[9])
            {
                // if (tmpo)
                 *tmpo=0;
                ((char **)param_t)[CHEMIN]=g_strdup(((char **)param)[9]);
                tmpo++;
            }
            else
            {
                ((char **)param_t)[CHEMIN]=g_strdup(".");
            }
            if (tmp1)
            {
                *tmp1=0;
                ((char **)param_t)[NOM]=g_strdup(tmpo);
                *tmp1='.';
            }
            else
            {
                 ((char **)param_t)[NOM]=g_strdup(tmpo);
            }
            affiche_caract(node,param_t);
            g_markup_dom_free(node);
            *modif=0;
            if (((char**)param_t)[PERSO]!=NULL)
              gtk_window_set_title (GTK_WINDOW (win), ((char**)param_t)[PERSO]);
            else
              gtk_window_set_title (GTK_WINDOW (win), (char *)param);
        }
      }
      else /* (*p_version==OUVRIR) */
      {
        *p_version=ADD2; /* version par défaut si rien n'est choisit */
        if ((deja_ouvert=ouvrir_fichier(win,param_t)))
            *modif=2; /* ne rien ouvrir si ne propose pas un bon fichier */
        else
            *modif=0;
      }
      if (((char **)param_t)[CHEMIN]!=NULL && ((char **)param_t)[CHEMIN][0]=='.')
      {
          tmp1=(char *)malloc(LONG);
          getcwd(tmp1,LONG-1);
          for(tmpo=tmp1;*tmpo!=0;tmpo++);
          i=1;
          while ( ((char **)param_t)[CHEMIN][i]=='.' && (((char **)param_t)[CHEMIN][i+1]==SEPARATEUR || (((char **)param_t)[CHEMIN][i+1]==0)) && tmpo>tmp1)
          {
              i+=3;
              for(;*tmpo!=SEPARATEUR && tmpo>=tmp1;tmpo--);
              tmpo--;
          }
          if (tmpo>tmp1) *tmpo=0;
          if (((char **)param_t)[CHEMIN][i]==SEPARATEUR)
            i++;
          tmpo=(char *)malloc(strlen(tmp1)+strlen(((char **)param_t)[CHEMIN]+i)+2);
          sprintf(tmpo,"%s%c%s",tmp1,SEPARATEUR,((char **)param_t)[CHEMIN]+i);
          free(((char **)param_t)[CHEMIN]);
          free(tmp1);
          ((char **)param_t)[CHEMIN]=tmpo;
      }
  }
  else
  {
    /* alignement */

    for (tmp_lc=metier;tmp_lc!=NULL;tmp_lc=tmp_lc->suiv)
    {
        nb_metier++;
        s_c=trouve_classe(tmp_lc->nom,((struct_classe **)param)[MAIN_CLASSE]);
        if (version_dd==ADD1 || s_c->add2.nom==NULL)
            algt&=s_c->add1.alignement;
        else
            algt&=s_c->add1.alignement;
    }
    j=0;
    for (i=0;i<9;i++) /* trouver l'alignement médian */
     if (algt&(1<<i))
        j++;

    j=j>>1;
    for (i=0;i<9;i++) /* trouver l'alignement médian */
     if (algt&(1<<i))
     {
        if (j==0)
        {
            *alignement=i;
            i=9;
        }
        else j--;
     }

    xp_classe=(unsigned long *)malloc(nb_metier*sizeof(unsigned long));
    ((void **)param_t)[21]=(void *)(xp_classe);
    for (i=0;i<nb_metier;i++) xp_classe[i]=0;
    caract_voleur(param_t); /* calcul des capacités de voleur version AD&D1 */
    tmp=modifier_caract(win,param_t);
    if (tmp!=NULL)
    {
        tire_taille_poids(NULL,tmp);
        *p_taille=gtk_spin_button_get_value(GTK_SPIN_BUTTON(((GtkWidget **)tmp)[M_C_TAILLE]));
        *p_poids=gtk_spin_button_get_value(GTK_SPIN_BUTTON(((GtkWidget **)tmp)[M_C_POIDS]));
    }
  }

  if (*modif==2)
  { /* pour fermer en cas d'ouverture de fichiers non valides */
      *modif=0;
      gtk_widget_destroy(win); /* doit tout effacer et vider la mémoire*/
      if (deja_ouvert==4)
      {
          return ((GtkWidget **)param)[FENETRE];
      }
      else
        return NULL;
  }
  else
  { /* Enter the main loop */
    caract_label(param_t);
    gtk_widget_show_all (win);
    return win;
  }
}

int tirage_perso(char methode, unsigned char race,liste_classe * metier,unsigned char version_dd,unsigned short * caract, unsigned short * caract_min, unsigned short * caract_max, unsigned short * caract_pref,gpointer param)
{
/* caract_min : caractéristiques minimales souhaitées (pour une classe par exemple                                               */
/* caract_pref : ordre de préférence personnel des caractéristiques, 8 pour les deux dernières et dire qu'elles sont inamovibles */
    signed short pl_c_min_max[8]={0,1,2,3,4,5,6,7},pl_tr[8]={0,1,2,3,4,5,6,7};
    signed short i,j,max_c,m,im,t,tmp;
    unsigned short (*pf)(); /* pointeur sur la fonction de tirage de dès */
    liste_classe * tmp_lc;
    struct_classe * s_c;

    srand((unsigned int)time(0));

    if (version_dd==ADD1 || ((struct_race **)param)[MAIN_RACE][race].add2.nom==NULL)
    {
        caract_min[0]=((struct_race **)param)[MAIN_RACE][race].add1.min_f;
        caract_min[1]=((struct_race **)param)[MAIN_RACE][race].add1.min_i;
        caract_min[2]=((struct_race **)param)[MAIN_RACE][race].add1.min_s;
        caract_min[3]=((struct_race **)param)[MAIN_RACE][race].add1.min_d;
        caract_min[4]=((struct_race **)param)[MAIN_RACE][race].add1.min_co;
        caract_min[5]=((struct_race **)param)[MAIN_RACE][race].add1.min_ch;
    }
    else
    {
        caract_min[0]=((struct_race **)param)[MAIN_RACE][race].add2.min_f;
        caract_min[1]=((struct_race **)param)[MAIN_RACE][race].add2.min_i;
        caract_min[2]=((struct_race **)param)[MAIN_RACE][race].add2.min_s;
        caract_min[3]=((struct_race **)param)[MAIN_RACE][race].add2.min_d;
        caract_min[4]=((struct_race **)param)[MAIN_RACE][race].add2.min_co;
        caract_min[5]=((struct_race **)param)[MAIN_RACE][race].add2.min_ch;
    }

    for(tmp_lc=metier;tmp_lc!=NULL;tmp_lc=tmp_lc->suiv)
    {
        s_c=trouve_classe(tmp_lc->nom,((struct_classe **)param)[MAIN_CLASSE]);
        if (version_dd==ADD1 || s_c->add2.nom==NULL)
        {
            caract_min[0]=max(caract_min[0],s_c->add1.min_f);
            caract_min[1]=max(caract_min[1],s_c->add1.min_i);
            caract_min[2]=max(caract_min[2],s_c->add1.min_s);
            caract_min[3]=max(caract_min[3],s_c->add1.min_d);
            caract_min[4]=max(caract_min[4],s_c->add1.min_co);
            caract_min[5]=max(caract_min[5],s_c->add1.min_ch);
        }
        else
        {
            caract_min[0]=max(caract_min[0],s_c->add2.min_f);
            caract_min[1]=max(caract_min[1],s_c->add2.min_i);
            caract_min[2]=max(caract_min[2],s_c->add2.min_s);
            caract_min[3]=max(caract_min[3],s_c->add2.min_d);
            caract_min[4]=max(caract_min[4],s_c->add2.min_co);
            caract_min[5]=max(caract_min[5],s_c->add2.min_ch);
        }
    }

    if (version_dd==ADD1 || ((struct_race **)param)[MAIN_RACE][race].add2.nom==NULL)
    {
        caract_min[0]-=((struct_race **)param)[MAIN_RACE][race].add1.modif_f;
        caract_min[1]-=((struct_race **)param)[MAIN_RACE][race].add1.modif_i;
        caract_min[2]-=((struct_race **)param)[MAIN_RACE][race].add1.modif_s;
        caract_min[3]-=((struct_race **)param)[MAIN_RACE][race].add1.modif_d;
        caract_min[4]-=((struct_race **)param)[MAIN_RACE][race].add1.modif_co;
        caract_min[5]-=((struct_race **)param)[MAIN_RACE][race].add1.modif_ch;
    }
    else
    {
        caract_min[0]-=((struct_race **)param)[MAIN_RACE][race].add2.modif_f;
        caract_min[1]-=((struct_race **)param)[MAIN_RACE][race].add2.modif_i;
        caract_min[2]-=((struct_race **)param)[MAIN_RACE][race].add2.modif_s;
        caract_min[3]-=((struct_race **)param)[MAIN_RACE][race].add2.modif_d;
        caract_min[4]-=((struct_race **)param)[MAIN_RACE][race].add2.modif_co;
        caract_min[5]-=((struct_race **)param)[MAIN_RACE][race].add2.modif_ch;
    }

    for(max_c=0;max_c<8 && caract_pref[max_c]<9;max_c++); /* recherhe du max (Humour et Beauté non prise en compte) */
    for(i=0;i<max_c;i++) /* utilisation du tableau caract comme tableau temporaire */
    {                  /* avant sa véritable affectation                         */
        caract[i]=caract_min[i];
    }
    for(i=1;i<max_c;i++)
    {                   /* on classe les minima dans l'ordre croissant */
         m=caract[i-1]; /* l'ordre sera mémorisé dans pl_c_min_max     */
         im=i-1;
         for(j=i;j<max_c;j++)
         {
             if (m<caract[j])
             {
                 im=j;
                 m=caract[j];
             }
         }
         caract[im]=caract[i-1];
         caract[i-1]=m;
         tmp=pl_c_min_max[i-1];
         pl_c_min_max[i-1]=pl_c_min_max[im];
         pl_c_min_max[im]=tmp;
    }

    switch(methode)
    {
        case _4D6   : pf=&tirage_4D6;
                      break;
        case _4D5p3 : pf=&tirage_4D5p3;
                      break;
        case _5D6   : pf=&tirage_5D6;
                      break;
        case _3D6x6 : pf=&tirage_3D6x6;
                      break;
        default :     pf=&tirage_3D6;
    }

    for (i=0;i<8;i++) /* tirage aléatoire des caractèristiqus */
        caract[i]=(*pf)();

    for(i=1;i<max_c;i++) /* on classe les caractéristiques suivant les préférances */
    {
         m=caract[caract_pref[i-1]];
         im=i-1;
         for(j=i;j<max_c;j++)
         {
             if (m<caract[caract_pref[j]])
             {
                 im=j;
                 m=caract[caract_pref[j]];
             }
         }
         caract[caract_pref[im]]=caract[caract_pref[i-1]];
         caract[caract_pref[i-1]]=m;
         m=pl_tr[caract_pref[im]];
         pl_tr[caract_pref[im]]=pl_tr[caract_pref[i-1]];
         pl_tr[caract_pref[i-1]]=m;
    }

    for(i=0;i<max_c;i++)
    {  /* parcours par ordre d'importance de la caractéristique */
       if (caract[pl_c_min_max[i]]<caract_min[pl_c_min_max[i]])
       { /* si une caractéristique n'est pas suffisante avec l'ordre de préférence */
           if (caract_pref[0]!=pl_c_min_max[i])
           { /* si la caractéristique n'est pas la préférée */
               for(j=0;caract_pref[j]!=pl_c_min_max[i];j++);
               /* trouver l'ordre de préféence de la caractéristique*/
               im=j;
               while ((caract_min[caract_pref[j]]>caract_min[pl_c_min_max[i]] || caract[caract_pref[j]]<caract_min[pl_c_min_max[i]]) && j>=0) /* est-ce que celui d'avant à une meilleur priorité ? */
               {
                  j--;
               }
               if (j>=0) /* il y en a un avant dont la priorité est inférieur */
               {         /* on les décale tous d'un rang */
                   tmp=caract[caract_pref[im]];
                   caract[caract_pref[im]]=caract[caract_pref[j]];
                   for(;i<im;im--)
                   {
                       if (caract_min[caract_pref[im]]<caract_min[pl_c_min_max[i]])
                       { /* ne prendre en compte que ceux dont la priorité est inférieure */
                        t=tmp;
                        tmp=caract[caract_pref[im]];
                        caract[caract_pref[im]]=t;
                       }
                   }
               }
           }
       }
    }

    for(i=0;i<max_c;i++) /* gérer les max */
    {  /* parcours par ordre d'importance de la caractéristique */
       if (caract[caract_pref[i]]>caract_max[caract_pref[i]])
       { /* si une caractéristique est forte avec l'ordre de préférence */
           for(j=i+1;j<max_c && caract[caract_pref[j]]<caract_max[caract_pref[i]];j++);
           while((caract[caract_pref[j]]<caract_min[caract_pref[i]]) && j>i) j--;
           /* décaler les i d'une place et 'mettre j à la place de i */
           tmp=caract[caract_pref[j]];
           while (j>i)
           {
               caract[caract_pref[j]]=caract[caract_pref[j-1]];
               j--;
           }
           caract[caract_pref[i]]=tmp;
       }
    }

    if (version_dd==ADD1 || ((struct_race **)param)[MAIN_RACE][race].add2.nom==NULL)
    {
        caract[0]+=((struct_race **)param)[MAIN_RACE][race].add1.modif_f;
        caract[1]+=((struct_race **)param)[MAIN_RACE][race].add1.modif_i;
        caract[2]+=((struct_race **)param)[MAIN_RACE][race].add1.modif_s;
        caract[3]+=((struct_race **)param)[MAIN_RACE][race].add1.modif_d;
        caract[4]+=((struct_race **)param)[MAIN_RACE][race].add1.modif_co;
        caract[5]+=((struct_race **)param)[MAIN_RACE][race].add1.modif_ch;
    }
    else
    {
        caract[0]+=((struct_race **)param)[MAIN_RACE][race].add2.modif_f;
        caract[1]+=((struct_race **)param)[MAIN_RACE][race].add2.modif_i;
        caract[2]+=((struct_race **)param)[MAIN_RACE][race].add2.modif_s;
        caract[3]+=((struct_race **)param)[MAIN_RACE][race].add2.modif_d;
        caract[4]+=((struct_race **)param)[MAIN_RACE][race].add2.modif_co;
        caract[5]+=((struct_race **)param)[MAIN_RACE][race].add2.modif_ch;
    }

    return 0;
}

unsigned short tirage_4D6()
{
    unsigned short t,min,i,d;


    t= rand() % 6;
    min=t;

    for (i=1;i<4;i++)
    {
        d= rand() % 6;
        t+=d;
        if (d<min)
            min=d;
    }
    t-=min-3;

    return t;
}

unsigned short tirage_4D5p3()
{
    unsigned short t,min,i,d;

    t= rand() % 5;
    min=t;

    for (i=1;i<4;i++)
    {
        d= rand() % 5;
        t+=d;
        if (d<min)
            min=d;
    }
    t-=min-6;

    return t;
}

unsigned short tirage_3D6()
{
    unsigned short t,i;


    t= rand() % 6 +3;

    for (i=1;i<3;i++)
    {
        t+=rand() % 6;
    }

    return t;
}

unsigned short tirage_3D6x6()
{
    unsigned short tmax=0,t,j,i;

    for(j=0;j<6;j++)
    {
        t= rand() % 6+3;
        for (i=1;i<3;i++)
        {
            t+=rand() % 6;
        }
        if (tmax<t) tmax=t;
    }

    return tmax;
}

unsigned short tirage_5D6()
{
    unsigned short t,tt,i,d,dd;

    t= rand() % 6;
    d= rand() % 6;
    if (d>t)
    {
        dd=t;
    }
    else
    {
        dd=d;
        d=t;
    }
    t=d+dd+3;
    for (i=0;i<3;i++)
    {

        tt=rand() % 6;
        t+=tt;
        if (tt<d)
        {
            if (tt<dd)
            {
                d=dd;
                dd=tt;
            }
            else
                d=tt;
        }
    }
    t-=(dd+d);

    return t;
}

unsigned char trouve_version(GList * k)
{

  gchar *action_name;
  gint action_active;
  GtkAction *action;


  for (; k != NULL; k = g_list_next(k))
  {

                action = GTK_ACTION(k->data);
                g_object_get(action,
                             "name",     &action_name,
                             NULL);
                if (strcmp(action_name,"dd")==0)
                {
                    g_object_get(action,"active",&action_active,NULL);
                    if (action_active)
                    {
                        g_free(action_name);
                        return DD;
                    }
                }
                else if (strcmp(action_name,"add1")==0)
                {
                    g_object_get(action,"active",&action_active,NULL);
                    if (action_active)
                    {
                        g_free(action_name);
                        return ADD1;
                    }
                }
                else if (strcmp(action_name,"add2")==0)
                {
                    g_object_get(action,"active",&action_active,NULL);
                    if (action_active)
                    {
                        g_free(action_name);
                        return ADD2;
                    }
                }
                g_free(action_name);
  }

  return ADD2; /* sortie par défaut */
}

unsigned char trouve_sexe(GList * k)
{

  gchar *action_name;
  gint action_active;
  GtkAction *action;


  for (; k != NULL; k = g_list_next(k))
  {

                action = GTK_ACTION(k->data);
                g_object_get(action,
                             "name",     &action_name,
                             NULL);
                if (strcmp(action_name,"femme")==0)
                {
                    g_object_get(action,"active",&action_active,NULL);
                    g_free(action_name);
                    if (action_active)
                    {
                        return FEMME;
                    }
                    else return HOMME;
                }
                else if (strcmp(action_name,"homme")==0)
                {
                    g_object_get(action,"active",&action_active,NULL);
                    g_free(action_name);
                    if (action_active)
                    {
                        return HOMME;
                    }
                    else return FEMME;
                }
                g_free(action_name);
  }

  return HOMME; /* sortie par défaut */
}

unsigned char trouve_methode_pdv(GList * k)
{

  gchar *action_name=NULL;
  gint action_active;
  GtkAction *action;


  for (; k != NULL; k = g_list_next(k))
  {

                action = GTK_ACTION(k->data);
                g_object_get(action,
                             "name",     &action_name,
                             NULL);
                if (strcmp(action_name,"pdv_1d")==0)
                {
                    g_object_get(action,"active",&action_active,NULL);
                    g_free(action_name);
                    action_name=NULL;
                    if (action_active)
                    {
                        return PDV_1D;
                    }
                }
                else if (strcmp(action_name,"pdv_2d")==0)
                {
                    g_object_get(action,"active",&action_active,NULL);
                    g_free(action_name);
                    action_name=NULL;
                    if (action_active)
                    {
                        return PDV_2D;
                    }
                }
                else if (strcmp(action_name,"pdv_max")==0)
                {
                    g_object_get(action,"active",&action_active,NULL);
                    g_free(action_name);
                    action_name=NULL;
                    if (action_active)
                    {
                        return PDV_MAX;
                    }
                }
                if (action_name)
                {
                    g_free(action_name);
                    action_name=NULL;
                }
  }

  return PDV_2D; /* sortie par défaut */
}

unsigned char trouve_niveau(GList * k)
{

  gchar *action_name=NULL;
  gint action_active;
  GtkAction *action;
  char ch[8];
  unsigned short j,nb_item=0;


  for (; k != NULL && nb_item<=20; k = g_list_next(k))
  {

        action = GTK_ACTION(k->data);
        g_object_get(action,
                     "name",     &action_name,
                     NULL);

        for (j=0;j<=20;j++)
        {
            sprintf(ch,"n%hu",j); /* fabrication du nom du bouton cherché */
            if (action_name && strcmp(action_name,ch)==0)
            {
                g_object_get(action,"active",&action_active,NULL);
                g_free(action_name);
                action_name=NULL;
                if (action_active)
                {
                    return j;
                }
                j=20; /* on a trouvé le bouton, mais, il n'est pas ssélectionné => on passe à l'item suivant */
                nb_item++; /* il n'y a que 21 item à chercher : si même le 21ème n'est pas bon, on sort */
            }
        }
  }

  return 1; /* sortie par défaut */
}

