/******************************************************************************
 *    Copyright (C) 2006 by JOSEPH Nicolas                                    *
 *    gege2061@redaction-developpez.com                                       *
 *    Copyright (C) 2010-2011 by SIAUD Bernard                                *
 *    troumad@libertysurf.fr                                                  *
 *                                                                            *
 *    This program is free software; you can redistribute it and/or modify    *
 *    it under the terms of the GNU General Public License as published by    *
 *    the Free Software Foundation; either version 2 of the License, or       *
 *    (at your option) any later version.                                     *
 *                                                                            *
 *    This program is distributed in the hope that it will be useful,         *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
 *    GNU General Public License for more details.                            *
 *                                                                            *
 *    You should have received a copy of the GNU General Public License       *
 *    along with this program; if not, write to the                           *
 *    Free Software Foundation, Inc.,                                         *
 *    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.               *
 ******************************************************************************/

#include "include.h"

#include <ctype.h>

/*#include <glib/gfileutils.h>
#include <glib/gmarkup.h>
#include <glib/gmem.h>
#include <glib/gmessages.h>
#include <glib/gstrfuncs.h>*/
#include <glib.h>
#include <malloc.h>
#include <string.h>



void xml_start_element (GMarkupParseContext *context, const gchar *element_name,
                        const gchar **attribute_names,
                        const gchar **attribute_values, gpointer user_data,
                        GError **error);
void xml_end_element (GMarkupParseContext *context,
                             const gchar *element_name, gpointer user_data,
                             GError **error);
void xml_com (GMarkupParseContext *context, const gchar *text,gsize text_len, gpointer user_data, GError **error);
void xml_text (GMarkupParseContext *context, const gchar *text,gsize text_len, gpointer user_data, GError **error);


/* macros =================================================================== */
/* constants ================================================================ */


/* private variables ======================================================== */
/* private functions ======================================================== */
gchar * mintexte(gchar * s)
{
  gchar * c;

  for (; *s && (*s==' ' || *s=='\t' || *s=='\n'); s++);
  c=s;
  while(*c)
   c++;
  c--;
  while (*c==' ' || *c=='\t' || *c=='\n')
   c--;
  *(c+1)=0;

  return s;
}



int str_isspace (const gchar *s)
{
  if (!s) return 1;
  for (; *s && (*s==' ' || *s=='\t' || *s=='\n'); s++);
  return !*s;
}


void dom_print (GMarkupDomNode *root,FILE * sortie,gint pos)
{
#define INDENT(niv,sortie) \
  do                                \
  {                                 \
    guint ii;                         \
                                    \
    for (ii = 1; ii < (niv) - 1; ii++) \
    {                               \
      fprintf(sortie,"\t");         \
    }                               \
  } while (0)
/*      g_print("\t");                \*/

  guint texte=0;
  guint fils=0;
  guint com=0;
  guint i;

  if (root != NULL)
  {

    if (root->level!=0)
    {
      i = 0;

      INDENT (root->level,sortie);
      fprintf(sortie,"<%s", root->name);
      //g_print("<%s", root->name);

      while (root->nb_att>i)
      {
        fprintf(sortie," %s=\"%s\"", root->attributs[i].name,
                               root->attributs[i].value);
        //g_print(" %s=\"%s\"", root->attributs[i].name,root->attributs[i].value);
        i++;
      }
    }
    if (root->fils+root->texte+root->nb_com!=0)
    {
      if (root->level!=0) fprintf(sortie,">\n");
      while (texte<root->texte || fils<root->fils || com<root->nb_com)
      {
        if (root->nb_com>com) if (root->com[com].item==(texte+fils+com))
        {
            INDENT (root->level + 1,sortie);
            fprintf(sortie,"%s\n", root->com[com].texte);
            //g_print("%s\n", root->com[com].texte);
            com++;
        }
        if (root->texte>texte) if (root->content[texte].item==(texte+fils+com))
        {
            INDENT (root->level + 1,sortie);
            for (i=0;root->content[texte].texte[i];i++)
            {
                if (root->content[texte].texte[i]=='&')
                  fprintf(sortie,"&amp;");
                else if (root->content[texte].texte[i]=='<')
                  fprintf(sortie,"&lt;");
                else if (root->content[texte].texte[i]=='>')
                  fprintf(sortie,"&gt;");
                else
                fputc(root->content[texte].texte[i],sortie);
            }
            fputc('\n',sortie);
            //g_print("%s\n", root->content[texte].texte);
            texte++;
        }
        if (root->fils>fils) if (root->child[fils].item==(fils+texte+com))
        {
            dom_print (root->child+fils,sortie,pos+1);
            fils++;
        }
      }
      if (root->level)
      {
       INDENT (root->level,sortie);
       fprintf(sortie,"</%s>\n", root->name);
       //g_print("</%s>\n", root->name);
      }
    }
    else
      if (root->level)
      {
        fprintf(sortie,"/>\n");
        //g_print("/>\n");
      }
  }
  #undef INDENT
}

void xml_start_element (GMarkupParseContext *context, const gchar *element_name,
                        const gchar **attribute_names,
                        const gchar **attribute_values, gpointer user_data,
                        GError **error)
{
  guint i,j;
  GMarkupDomContext *dom_context = user_data;
  GMarkupDomNode *node = NULL, * parent;

  g_return_if_fail (dom_context != NULL); /* déclaration et initialisation du nouveau élément  */

 /* déclaration et initialisation du nouveau élément  */

  if (dom_context->root) /* si ce n'est pas la première node, la node mère du système */
  {
      parent=dom_context->current;
      //for (parent=dom_context->current;dom_context->level<parent->level;parent=parent->parent);
      parent->fils++;                 /* un for car il est possible qu'on vienne de descendre de niveaux */
      parent->child=realloc(parent->child,sizeof (*node)*parent->fils); /* on rajoute un fils au père     */
      for (i=0;i<parent->fils-1;i++)  /* ne pas oublié que tous les fils ont changé d'adresse            */
        for (j=0;j<parent->child[i].fils;j++)
            parent->child[i].child[j].parent=parent->child+i;
      node=parent->child+parent->fils-1; /* on récupère le lien vers la nouvelle node crée chez le père  */
      node->parent=parent;            /* j'informe sur le parent de cette node                           */
      node->item=dom_context->item;   /* j'informe sur l'ordre de cet élément dans l'ensemble des        */
  }                                   /* éléments (texte, node et commntaires) du père                   */
  else /* si c'est le premier élément */
  {
    node = g_malloc (sizeof (*node));
    dom_context->root = node;
    node->item=0;
    node->parent=NULL;
  }
  dom_context->current = node;

  /* variable générale de l'état actuel du système  */
  /* la construction d'un nouveau élément est toujours demandé par le père donc on */
  dom_context->level++;          /* vient de monter le niveau de 1 . mise dans  la */
  dom_context->item=0;           /* pas encore d'entrée dans cette node            */


  /* initiaisation de la node */
  node->name = g_strdup (element_name);
  node->content = NULL;
  node->texte   = 0;     /* pas encore de texte        */
  node->com = NULL;
  node->nb_com  = 0;     /* pas encore de commentaires */
  node->child = NULL;
  node->fils=0;          /* pas encore de fils         */
  node->level = dom_context->level; /* niveau du noeud */

  /* Copy attributs */
  for (i = 0; attribute_names[i] != NULL; i++); /* on compte le nombre d'attributs */
  if (i!=0 ) node->attributs = g_malloc (sizeof (*node->attributs)*i);
  else       node->attributs = NULL;

  node->nb_att=i;
  for (i = 0; attribute_names[i] != NULL; i++) /* on parcourt les attributs        */
  {
                                            /* on informe leur nom et valeur       */
    node->attributs[i].name = g_strdup (attribute_names[i]);
    node->attributs[i].value = g_strdup (attribute_values[i]);
  }

  /* Unused parameters */
  (void)context;
  (void)error;
}

void xml_end_element (GMarkupParseContext *context,
                             const gchar *element_name, gpointer user_data,
                             GError **error)
{
  GMarkupDomContext *dom_context = user_data;

  g_return_if_fail (dom_context != NULL);
  g_return_if_fail (dom_context->current != NULL);

  /* je rends la main au père */
  dom_context->item=dom_context->current->item+1;        /* je passe à l'élément suivant du père */
  dom_context->level--;                                  /* le père a un niveau de moins         */
  dom_context->current   = dom_context->current->parent; /* la node courante se ra celle du père */

  /* Unused parameters */
  (void)context;
  (void)element_name;
  (void)error;
}

void xml_text (GMarkupParseContext *context, const gchar *text,gsize text_len, gpointer user_data, GError **error)
{
  GMarkupDomContext *dom_context = user_data;
  gchar * ch=g_strdup (text);

  g_return_if_fail (dom_context != NULL);
  g_return_if_fail (dom_context->current != NULL);

  if (!str_isspace (text))/* si le texte n'est pas vide (saut de ligne ou espace ou tabulation */
  {                       /* on rajoute cet élément (voir rajout d'une node : c'est pareil     */
    dom_context->current->texte++;
    dom_context->current->content=realloc(dom_context->current->content,dom_context->current->texte*sizeof(contenu));
    dom_context->current->content[dom_context->current->texte-1].item=dom_context->item;
    dom_context->item++;
    dom_context->current->content[dom_context->current->texte-1].texte = g_strdup (mintexte(ch));
  }

  free(ch);
  /* Unused parameters */
  (void)context;
  (void)text_len;
  (void)error;
}

void xml_com (GMarkupParseContext *context, const gchar *text,gsize text_len, gpointer user_data, GError **error)
{
  GMarkupDomContext *dom_context = user_data;

  g_return_if_fail (dom_context != NULL);
  g_return_if_fail (dom_context->current != NULL);

  if (!str_isspace (text)) /* si le texte n'est pas vide (saut de ligne ou espace ou tabulation */
  {                        /* on rajoute cet élément (voir rajout d'une node : c'est pareil     */
    dom_context->current->nb_com++;
    dom_context->current->com=realloc(dom_context->current->com,dom_context->current->nb_com*sizeof(contenu));
    dom_context->current->com[dom_context->current->nb_com-1].item=dom_context->item;
    dom_context->item++;
    dom_context->current->com[dom_context->current->nb_com-1].texte = g_strdup (text);
  }

  /* Unused parameters */
  (void)context;
  (void)text_len;
  (void)error;
}



/**
 * g_markup_dom_free:
 * @node: a #GMarkupDomNode.
 *
 * Frees a #GMarkupDomNode.
 **/
void g_markup_dom_free (GMarkupDomNode *node)
{
  if (node != NULL)
  {
    guint i;

    g_free (node->name), node->name = NULL;
    for (i = 0; node->nb_att>i; i++)
    {
      g_free (node->attributs[i].name), node->attributs[i].name = NULL;
      g_free (node->attributs[i].value), node->attributs[i].value = NULL;
    }
    if (node->nb_att>0) g_free (node->attributs), node->attributs = NULL;

    for (i = 0; node->texte>i; i++)
    {
      g_free (node->content[i].texte);
    }
    if (node->texte>0) g_free(node->content);

    for (i = 0; node->nb_com>i; i++)
    {
      g_free (node->com[i].texte);
    }
    if (node->nb_com>0) g_free(node->com);

    for (i = 0; node->fils>i; i++)
    {
      g_markup_dom_free (node->child+i);
    }
    if (node->fils>0) g_free(node->child), node->child = NULL;

    if (node->level==0) g_free(node), node = NULL; /* il faut juste libérer la racine, les autres, sont dans des tableaux */
   }
}

GMarkupDomNode * g_markup_dom_nom (GMarkupDomNode *node,gchar * nom_val,gchar * attr)
{

  GMarkupDomNode * tmp;

  if (node != NULL)                     /* la node existe t'elle vraiment ?                            */
  {
    guint i;

    for (i = 0; node->nb_att>i; i++)    /* parcourt les attributs de cette node                         */
    {                                   /* à la recherche de l'attribut attr dont la valeur est nom_val */
      if (strcmp((node->attributs[i].value),nom_val)==0 && strcmp(node->attributs[i].name,attr)==0)
       return node;                     /* si oui renvoie le pounteur sur la node                       */
    }                                   /* si le couple attribut/valeur n'a pas été trouvé              */
    for (i = 0; node->fils>i; i++)      /* parcourt des nodes filles                                    */
    {                                   /* c'est une procédure récurvive                                */
      if ((tmp=g_markup_dom_nom (node->child+i,nom_val,attr)))  /* si le couple a été trouvé            */
       return tmp;                      /* renvoie de la node qui contient ce couple                    */
    }

  }
  return NULL;                          /* si rien n'a été trouvé dans la node ou parmis ces enfants,   */
}

GMarkupDomNode * g_markup_dom_node (GMarkupDomNode *node,gchar * nom_val)
{

  GMarkupDomNode * tmp=NULL;

  if (node != NULL)                     /* marche comme g_markup_dom_nom, mais plus simplement          */
  {
    guint i;

    if (node->name && strcmp(node->name,nom_val)==0)
       return node;
    for (i = 0; node->fils>i; i++)
    {
      if ((tmp=g_markup_dom_node (node->child+i,nom_val)))
       return tmp;
    }

  }
  return NULL;
}

/* public variables ========================================================= */
GMarkupDomNode *g_markup_dom_new (const gchar *filename, GError **error)
{
  GMarkupParseContext *markup_parse_context;
  GMarkupDomNode * pere = (GMarkupDomNode *)malloc(sizeof(GMarkupDomNode));
   /* pere doit être alloué dynamiquement car il est utilisé par la fonction appelante */
  GMarkupDomContext context={0,0,pere,pere};
   /* ce n'est pas le cas de context qui n'est utilisé que les les fonctions appelées  */

  pere->name=NULL; /* initialisation de la racine du fichier xml */
  pere->level=0;
  pere->item=0;
  pere->content=NULL;
  pere->texte=0;
  pere->attributs=NULL;
  pere->nb_att=0;
  pere->com=NULL;
  pere->nb_com=0;
  pere->parent=NULL;
  pere->child=NULL;
  pere->fils=0;

  g_return_val_if_fail (filename != NULL, context.root);
                  /* sort de la fonction si filename ne pointe pas sur une chaîne de caractères */

  {         /* création du contexte : fonctions à appeler suivant la nature de l'élément traité */
    GMarkupParser markup_parser; /* http://library.gnome.org/devel/glib/stable/glib-Simple-XML-Subset-Parser.html#GMarkupParser */

    markup_parser.start_element = xml_start_element; /* cas : ouverture de balise               */
    markup_parser.end_element = xml_end_element;     /* cas : fermeture de balise               */
    markup_parser.text = xml_text;                   /* cas : texte entre les balises           */
    markup_parser.passthrough = xml_com;             /* cas : commentaires entre les balises    */
    markup_parser.error = NULL;                      /* cas : erreur dans le fichier xml        */
    markup_parse_context = g_markup_parse_context_new (&markup_parser, 0,
                                                       &context, NULL);
  /* http://library.gnome.org/devel/glib/stable/glib-Simple-XML-Subset-Parser.html#g-markup-parse-context-new */
  } /* maintenant, on sait comment parcourir le fichier */
  {
    gchar *text = NULL,*ch,*point=NULL;
    gsize length = -1;

    for (ch=(gchar *)filename;*ch!=0;ch++)
    {
        if (*ch==SEPARATEUR || *ch=='\\') point=NULL;
        else if (*ch=='.') point=ch;
    }

    if (ch-point==4 && strncmp(point,".od",3)==0 && (point[3]=='t' || point[3]=='c' || point[3]=='p' || point[3]=='s') )
    {
        text=content_libo((char *)filename,&length);
    }
    else
        g_file_get_contents (filename, &text, &length, error);
    /* passe tout le fichier filename dans la chaîne de caractères text
                                                        dont la longueur sera dans lenght */
    if (text != NULL) /* si on a récupéré le fichier */
    {
      g_markup_parse_context_parse (markup_parse_context, text, length, error);  /* on lance le parsage du fichier xml */
      g_free (text), text = NULL;                                                /* on lance le parsage du fichier xml */
    }
    g_free (markup_parse_context), markup_parse_context = NULL;
  }
  return pere;
}


void enregistre_xml(char * nom_fic, GMarkupDomNode * ooo)
{
 FILE * sortie=fopen(nom_fic,"w");

 dom_print(ooo,sortie,0);

 fclose(sortie);
}

void copie_node(GMarkupDomNode * arrive,GMarkupDomNode * modele)
{
  guint i;

  if (modele != NULL && arrive!=NULL)
  {
    if (arrive->nb_att>0)
    {
        for (i = 0; arrive->nb_att>i; i++)
        {
            free(arrive->attributs[i].value);
            free(arrive->attributs[i].name);
        }
        free(arrive->attributs);
    }
    arrive->nb_att=modele->nb_att;
    if (arrive->nb_att>0)
        arrive->attributs=malloc(modele->nb_att*sizeof(xml_attr));
    else
        arrive->attributs=NULL;
    for (i = 0; modele->nb_att>i; i++)
    {
        arrive->attributs[i].name=g_strdup( modele->attributs[i].name);
        arrive->attributs[i].value=g_strdup( modele->attributs[i].value);
    }

    if (arrive->texte>0)
    {
        for (i = 0; arrive->texte>i; i++)
        {
            free(arrive->content[i].texte);
        }
        free(arrive->content);
    }
    arrive->texte=modele->texte;
    if (arrive->texte>0)
        arrive->content=(contenu *)malloc(modele->texte*sizeof(contenu));
    else
        arrive->content=NULL;
    for (i = 0; modele->texte>i; i++)
    {
        arrive->content[i].item=modele->content[i].item;
        arrive->content[i].texte=g_strdup(modele->content[i].texte);
    }

    if (arrive->nb_com>0)
    {
        for (i = 0; arrive->nb_com>i; i++)
        {
            free(arrive->com[i].texte);
        }
        free(arrive->com);
    }
    arrive->nb_com=modele->nb_com;
    if (arrive->nb_com>0)
        modele->com=(contenu *)malloc(modele->nb_com*sizeof(contenu));
    else
        modele->com=NULL;
    for (i = 0; modele->nb_com>i; i++)
    {
        arrive->com[i].item=modele->com[i].item;
        arrive->com[i].texte=g_strdup(modele->com[i].texte);
    }

    for (i = 0; arrive->fils>i; i++)
    {
        g_markup_dom_free(arrive->child+i);
    }
    arrive->fils=modele->fils;
    if (arrive->fils>0)
        arrive->child=(GMarkupDomNode *)malloc(modele->fils*sizeof(GMarkupDomNode));
    else
        arrive->child=NULL;
    for (i = 0; modele->fils>i; i++)
    {
      arrive->child[i].fils=0;
      arrive->child[i].nb_att=0;
      arrive->child[i].nb_com=0;
      arrive->child[i].texte=0;
      arrive->child[i].parent=arrive;
      arrive->child[i].level=arrive->level+1;
      arrive->child[i].item=modele->child[i].item;
      arrive->child[i].name=NULL;
      copie_node(arrive->child+i, modele->child+i);
    }

    if (arrive->name!=NULL) free(arrive->name);
    arrive->name=g_strdup(modele->name);
  }
}

void modif_xml(GMarkupDomNode *item,gchar * ch)
{
  if (item)
  {
      if (item->texte==0)                   /* s'il n'y a pas de texte, rajouter un texte à la fin de la node   */
      {
       item->content=(contenu *)malloc(sizeof(contenu));
       item->texte=1;
       item->content[0].item=item->nb_com+item->fils;
      }
      else                                  /* sinon, enlever le texte déjà présent                             */
       free(item->content[0].texte);
      item->content[0].texte=g_strdup(ch);  /* mettre le nouveau texte à la place */
  }
}

void xml_ajoute_fin(GMarkupDomNode * node,gchar * texte) /* mettre une node fille en fin d'une node, le node de la node étant indiqué par le texte */
{
    guint i,j;

    node->child=(GMarkupDomNode *)realloc(node->child,(1+node->fils)*sizeof(GMarkupDomNode));
    node->child[node->fils].item=node->texte+node->nb_com+node->fils;
    /* place de la nouvelle node dans l'ensemble des enfants de la node mère    */
    node->child[node->fils].name=g_strdup(texte);
    /* nom de la nouvelle node                                                  */
    node->child[node->fils].level=node->level+1;
    /* noveau de la nouvellenode                                                */
    node->child[node->fils].content=NULL;
    /* noveau de la nouvellenode                                                */
    node->child[node->fils].texte=0;
    node->child[node->fils].attributs=NULL;
    node->child[node->fils].nb_att=0;
    node->child[node->fils].com=NULL;
    node->child[node->fils].nb_com=0;
    node->child[node->fils].parent=node;
    node->child[node->fils].child=NULL;
    node->child[node->fils].fils=0;
    for (i=0;i<node->fils;i++)
    {   /* mettre à jour les fils du fils à cause du réalloc                    */
        for(j=0;j<node->child[i].fils;j++)
            node->child[i].child[j].parent=node->child+i;
    }
    node->fils++;
    /* la node mère a un enfant de plus                                         */
}

void xml_ajoute_fin_texte(GMarkupDomNode * node) /* rajouter un élément texte en fin d'une node */
{
    node->content=(contenu *)realloc(node->content,(1+node->texte)*sizeof(contenu));
    node->content[node->texte].item=node->texte+node->nb_com+node->fils;
    node->content[node->texte].texte=NULL;
    node->texte++;
}

void xml_ecrit_dernier_texte(GMarkupDomNode * node,char *ch) /* remplace le dernier texte d'une node */
{
    if (node->texte==0) xml_ajoute_fin_texte(node);
    else if (node->content[node->texte-1].texte!=NULL) free(node->content[node->texte-1].texte);
    node->content[node->texte-1].texte=g_strdup(ch);
}

void xml_ajoute_fin_attribut(GMarkupDomNode * node) /* rajouter un élément attribut */
{
    node->attributs=(xml_attr *)realloc(node->attributs,(1+node->nb_att)*sizeof(xml_attr));
    node->attributs[node->nb_att].name=NULL;
    node->attributs[node->nb_att].value=NULL;
    node->nb_att++;
}

void xml_ecrit_dernier_attribut(GMarkupDomNode * node,char * nomm, char * val) /* remplace le dernier attribut */
{
    if (node->attributs[node->nb_att-1].name!=NULL) free(node->attributs[node->nb_att-1].name);     /* libère la place pouvant être occupée par le précédent nom                    */
    if (node->attributs[node->nb_att-1].value!=NULL) free(node->attributs[node->nb_att-1].value);   /* libère la place pouvant être occupée par la valeur de l'attribut précédent   */
    node->attributs[node->nb_att-1].name=g_strdup(nomm);
    node->attributs[node->nb_att-1].value=g_strdup(val);
}

void decale_node(GMarkupDomNode *node,unsigned short i) /* decale les node pour mettre la dernière node à la place i */
{                                                       /* ATTENTION : laisse les textes inchangés */
    gint tmp,tmp1;
    signed short j;                                     /* signed short : pour passer négatif si i=0 */
    GMarkupDomNode tmp_node;


    tmp=node->child[node->fils-1].item;                 /* place actuelle dans la hiérarchie de la dernière node        */
    tmp_node=node->child[node->fils-1];                 /* place actuelle dans la hiérarchie de la dernière node        */

    for(j=node->fils-2;j>=i;j--)                        /* parcourt des node de la future avant dernière à la première  */
    {                                                   /* à être déplacée                                              */
       tmp1=node->child[j].item;                        /* On mémorise la place de la node actuelle                     */
       node->child[j].item=tmp;                         /* On mémorise la place de la node actuelle                     */
       tmp=tmp1;                                        /* on mémorise l'ancienne place de la node actuelle             */
       node->child[j+1]=node->child[j];                 /* On modifie le tableau des nodes filles                       */
    }

    node->child[i]=tmp_node;                            /* la dernière node prend la place de la node i                 */
    node->child[i].item=tmp;                /* numéro de la node dans la liste des enfants des enfants de la node mère  */
}


void supprime_node(GMarkupDomNode * pere,guint i)        /* supprime la ième node                                        */
{                                                       /* Attention : non testé avec les textes et les commentaires    */
    unsigned short j;
    guint tmp=pere->child[i].item;                       /* tmp est l'indice de la node laissée vide                     */

    g_markup_dom_free(pere->child+i);                   /* libère la placé réservée pour la node                        */
    pere->fils--;                                       /* la node mère aura un enfant de moins                         */
    for(j=i;j<pere->fils;j++)
    {
        pere->child[j]=pere->child[j+1];                /* rappratrie le noeud suivant                                  */
        pere->child[j].item--;                          /* décrémenter sa place                                         */

    }
    for (i=0;i>pere->texte;i++)                         /* parcourt des textes                                          */
        if (pere->content[i].item>tmp)                  /* si le texte est après la place laissée libre                 */
            pere->content[i].item--;                    /* décrémenter sa place                                         */
    for (i=0;i>pere->nb_com;i++)                        /* parcourt des commentaires                                    */
        if (pere->com[i].item>tmp)                      /* si le commentaire est après la place laissée libre           */
            pere->com[i].item--;                        /* décrémenter sa place                                         */
}

void xml_sup_node(GMarkupDomNode *node) /* supprime la node passée en paramètre */
{
    if (node==NULL || node->parent==NULL) return;

    supprime_node(node->parent,node-node->parent->child);
}
